import p from "./LineRound.js";
import A from "./LineBezier.js";
import I from "./LineDirect.js";
import { createTransLine as L, transLine as S } from "./LineMode.js";
import { NODE_ID_PREFIX as _ } from "./NodeManager.js";
import { attr as l, createSvgByTag as k, addClass as C } from "./util.js";
var h, y = "fc-line-", T = "Round", B = "Bezier", d = "Direct", P = "Straight", E = {
  width: 1,
  color: "#c2c2c2",
  type: T
}, v = (h = {}, h[T] = p, h[d] = I, h[B] = A, h[P] = p, h), R = ["Direct", "Round", "Straight"], q = /* @__PURE__ */ function() {
  function m(e, t, i, r, n) {
    this.style = void 0, this.lineCreator = void 0, this.direction = void 0, this.data = e, this.option = n, this.tagContainer = i, this.direction = n.direction, this.initColor(n), this.style = Object.assign({}, E, n.lineStyle), this.createLineCreator(t), this.initArrow(), this.container = t, this.containerPosn = r, this.getLineAlignStyle(e.edges), this.createLines(e.edges), this.connectVirtualLine(e.edges), this.createTags(e.edges);
  }
  var o = m.prototype;
  return o.initColor = function(t) {
    t.theme && t.theme === "dark" && (E.color = "#ffffff");
  }, o.initArrow = function() {
    var t = document.getElementById("markerArrow"), i = this.style.color || "#c2c2c2";
    l(t, "fill", i);
  }, o.createLineCreator = function(t) {
    this.style.type === P && (this.style.radius = 0);
    var i = v[this.style.type];
    this.lineCreator = new i(this.style, {
      gContainer: t,
      tagContainer: this.tagContainer
    });
  }, o.getLineAlignStyle = function(t) {
    t.forEach(function(i) {
      if (!i.alignType) {
        var r = t.filter(function(n) {
          return n.source === i.source && n !== i;
        });
        r.length > 0 && (i.alignType = "source", r.forEach(function(n) {
          n.alignType = "source";
        }));
      }
    }), t.forEach(function(i) {
      i.alignType || (i.alignType = "target");
    });
  }, o.setData = function(t) {
    var i;
    if (t != null && (i = t.lineStyle) != null && i.type) {
      var r, n = v[t == null || (r = t.lineStyle) == null ? void 0 : r.type], a = new n(t == null ? void 0 : t.lineStyle, {
        gContainer: this.container,
        tagContainer: this.tagContainer
      });
      return a.setData(t, this.data, this.direction);
    } else
      this.lineCreator.setData(t, this.data, this.direction);
    t.offset && t.offset(t);
  }, o.setPath = function(t) {
    var i;
    if (t != null && (i = t.lineStyle) != null && i.type) {
      var r, n = v[t == null || (r = t.lineStyle) == null ? void 0 : r.type], a = new n(t == null ? void 0 : t.lineStyle, {
        gContainer: this.container,
        tagContainer: this.tagContainer
      });
      return a.setPath(t);
    } else
      return this.lineCreator.setPath(t);
  }, o.createLines = function(t) {
    var i = this;
    t.forEach(function(r) {
      i.setData(r);
      var n = i.createLine(r);
      i.container.appendChild(n);
    });
  }, o.createLine = function(t) {
    var i, r = k("path"), n = y + t.source + "-to-" + t.target, a = this.setPath(t);
    t.id = n, l(r, "d", a), l(r, "id", n), this.style.color && l(r, "stroke", this.style.color), (this.style.dash || this.style.mode === "dash") && l(r, "stroke-dasharray", 5), t.lineStyle && t.lineStyle.color && l(r, "stroke", t.lineStyle.color), t.lineStyle && (t.lineStyle.dash || t.lineStyle.mode === "dash") && l(r, "stroke-dasharray", 5), t.lineStyle && t.lineStyle.dash === !1 && l(r, "stroke-dasharray", 0), this.style.width && l(r, "stroke-width", this.style.width + "px"), t.lineStyle && t.lineStyle.width && l(r, "stroke-width", t.lineStyle.width + "px"), C(r, "fc-line");
    var c = (t == null || (i = t.lineStyle) == null ? void 0 : i.type) === d || this.style.type === d;
    if (C(r, c ? "fc-noArrow" : ""), this.isTransLine(t)) {
      var s;
      r = L(a, S(t, n, ((s = t.lineStyle) == null ? void 0 : s.transPattern) || this.style.transPattern));
    } else {
      var u = document.getElementById(t.id);
      u && document.getElementById("fc-trans-container").removeChild(u);
    }
    return r;
  }, o.isTransLine = function(t) {
    var i = !1;
    return R.includes(this.style.type) && (this.style.mode === "trans" ? (i = !0, "lineStyle" in t && "mode" in t.lineStyle && t.lineStyle.mode !== "trans" && (i = !1)) : "lineStyle" in t && "mode" in t.lineStyle && t.lineStyle.mode === "trans" && (i = !0)), i;
  }, o.connectVirtualLine = function(t) {
    var i = this, r = t.filter(function(a) {
      return a.target.includes("virtual");
    }), n = t.filter(function(a) {
      return a.source.includes("virtual");
    });
    r.forEach(function(a) {
      var c = n.filter(function(D) {
        return D.source === a.target;
      })[0], s = i.container.querySelector("#" + a.id), u = i.container.querySelector("#" + c.id);
      u.remove();
      var f = s.getAttribute("d") + " L" + u.getAttribute("d").slice(1), w = y + a.source + "-to-" + c.target;
      s.setAttribute("d", f), s.setAttribute("id", w);
    });
  }, o.createTags = function(t) {
    var i = this;
    t.forEach(function(r) {
      i.option.renderTag && i.option.renderTag(i.tagContainer, r);
    });
  }, o.updateLine = function(t) {
    var i = this, r = t == null ? void 0 : t.replace(_, "");
    this.data.edges.forEach(function(n) {
      if (n.source === r || n.target === r) {
        var a;
        i.setData(n);
        var c = y + n.source + "-to-" + n.target;
        if (i.isTransLine(n)) {
          var s, u = document.getElementById("fc-trans-container"), f = document.getElementById(c);
          f && u.removeChild(f), L(i.setPath(n), S(n, c, ((s = n.lineStyle) == null ? void 0 : s.transPattern) || i.style.transPattern));
        }
        (a = document.getElementById(c)) == null || a.setAttribute("d", i.setPath(n));
      }
    });
  }, o.updateAllLine = function() {
    var t = this;
    this.data.nodes.forEach(function(i) {
      var r, n = ((r = i.dom) == null ? void 0 : r.id) || i.id;
      t.updateLine(n);
    });
  }, m;
}();
export {
  q as default
};
