import "../../../../echarts/index.js";
import { extendShape as v } from "../../../../echarts/lib/util/graphic.js";
var d = v({
  type: "ec-liquid-fill",
  shape: {
    waveLength: 0,
    radius: 0,
    radiusY: 0,
    cx: 0,
    cy: 0,
    waterLevel: 0,
    amplitude: 0,
    phase: 0,
    inverse: !1
  },
  buildPath: function(l, r) {
    r.radiusY == null && (r.radiusY = r.radius);
    for (var t = Math.max(Math.ceil(2 * r.radius / r.waveLength * 4) * 2, 8); r.phase < -Math.PI * 2; )
      r.phase += Math.PI * 2;
    for (; r.phase > 0; )
      r.phase -= Math.PI * 2;
    var M = r.phase / Math.PI / 2 * r.waveLength, e = r.cx - r.radius + M - r.radius * 2;
    l.moveTo(e, r.waterLevel);
    for (var a = 0, u = 0; u < t; ++u) {
      var I = u % 4, P = f(u * r.waveLength / 4, I, r.waveLength, r.amplitude);
      l.bezierCurveTo(P[0][0] + e, -P[0][1] + r.waterLevel, P[1][0] + e, -P[1][1] + r.waterLevel, P[2][0] + e, -P[2][1] + r.waterLevel), u === t - 1 && (a = P[2][0]);
    }
    r.inverse ? (l.lineTo(a + e, r.cy - r.radiusY), l.lineTo(e, r.cy - r.radiusY), l.lineTo(e, r.waterLevel)) : (l.lineTo(a + e, r.cy + r.radiusY), l.lineTo(e, r.cy + r.radiusY), l.lineTo(e, r.waterLevel)), l.closePath();
  }
});
function f(i, l, r, t) {
  return l === 0 ? [[i + 1 / 2 * r / Math.PI / 2, t / 2], [i + 1 / 2 * r / Math.PI, t], [i + r / 4, t]] : l === 1 ? [[i + 1 / 2 * r / Math.PI / 2 * (Math.PI - 2), t], [i + 1 / 2 * r / Math.PI / 2 * (Math.PI - 1), t / 2], [i + r / 4, 0]] : l === 2 ? [[i + 1 / 2 * r / Math.PI / 2, -t / 2], [i + 1 / 2 * r / Math.PI, -t], [i + r / 4, -t]] : [[i + 1 / 2 * r / Math.PI / 2 * (Math.PI - 2), -t], [i + 1 / 2 * r / Math.PI / 2 * (Math.PI - 1), -t / 2], [i + r / 4, 0]];
}
export {
  d as default
};
