import e from "../../feature/token/index.js";
import i from "./chartToken.js";
function d() {
  return {
    // 雷达坐标系位置
    center: ["50%", "50%"],
    // 雷达坐标系半径
    radius: "50%",
    // 指示器名称与轴的距离
    axisNameGap: 15,
    // 指示器轴的分割段数
    splitNumber: 4,
    shape: "circle",
    // 坐标轴的标签是否响应和触发鼠标事件
    triggerEvent: !1,
    // 坐标轴射线
    axisLine: {
      lineStyle: {
        color: e.config.radarAxisLineColor,
        width: e.config.radarAxisLineWidth,
        type: e.config.radarAxisLineType
      }
    },
    axisTick: {
      show: !1,
      lineStyle: {
        color: e.config.radarAxisTickLineColor,
        width: e.config.radarAxisTickLineWidth,
        type: e.config.radarAxisTickLineType
      }
    },
    // 坐标轴射线的刻度,只显示一条射线的刻度,其他射线的刻度需要在指示器数据indicator中每项单独配置axisLabel: { show: false }
    axisLabel: {
      show: !1,
      margin: -20,
      color: e.config.radarAxisLabelColor,
      fontSize: e.config.radarAxisLabelFontSize
    },
    // 坐标轴圆环分隔区域填充
    splitArea: {
      show: !1
    },
    // 坐标轴圆环分隔线
    splitLine: {
      lineStyle: {
        color: e.config.radarSplitLineColor,
        width: e.config.radarSplitLineWidth,
        type: e.config.radarSplitLineType
      }
    },
    // 坐标轴数据
    indicator: void 0,
    // 指示器名称样式设置
    axisName: {
      show: !0,
      color: e.config.radarAxisNameColor,
      fontSize: e.config.radarAxisNameFontSize
    }
  };
}
function c() {
  return {
    center: void 0,
    // 阈值线的radius应该是一个百分比，或者是实际的像素值
    radius: void 0,
    splitNumber: 1,
    shape: "circle",
    axisName: {
      show: !1
    },
    axisLine: {
      show: !1
    },
    axisTick: {
      show: !1
    },
    axisLabel: {
      show: !1
    },
    splitArea: {
      show: !1
    },
    splitLine: {
      show: !0,
      lineStyle: {
        width: e.config.radarSplitLineWidth,
        color: e.config.colorState.colorError,
        type: "dashed"
      }
    },
    indicator: void 0
  };
}
function h() {
  return {
    // 雷达位置，保持和初始坐标系一致，
    center: ["50%", "50%"],
    // 雷达半径，保持和初始坐标系一致，
    radius: "50%",
    // 控制指示器名称是否显示
    axisName: {
      show: !1
    },
    startAngle: void 0,
    // 轴线的角度根据需求自己定义,起始点是水平方向
    // 指示器轴的分割段数，和初始坐标轴一致
    splitNumber: 4,
    shape: "circle",
    // 坐标轴圆环分隔区域填充
    splitArea: {
      show: !1
    },
    // 坐标轴射线
    axisLine: {
      show: !1
    },
    axisTick: {
      show: !1
    },
    axisLabel: {
      show: !1
    },
    // 坐标轴圆环分隔线
    splitLine: {
      show: !1
    },
    indicator: void 0
  };
}
function f() {
  return {
    type: "radar",
    name: "data",
    // 使用的雷达坐标系
    radarIndex: 0,
    // 拐点的标记大小(常规减去2是为了阈值状态下hover能盖住原有symbol点)
    symbolSize: i.symbolSize - 2,
    // 拐点样式
    itemStyle: {
      // 常规场景不显示边框
      borderWidth: i.itemBorderWidth,
      // borderWidth常规为0，此处设置borderColor为透明色+是为了避免hover移出symbol瞬间白色闪烁的问题
      borderColor: i.itemBorderColor
    },
    // 填充面积
    areaStyle: {
      opacity: 0.15
    },
    lineStyle: {
      width: i.lineWidth
    },
    // 高亮的样式
    emphasis: {
      focus: "none",
      areaStyle: {
        opacity: 0.3
      },
      itemStyle: {
        color: i.emphasisItemColor,
        borderWidth: i.emphasisItemBorderWidth
        // borderColor颜色在各系列数据中单独设置
      }
    },
    data: void 0
  };
}
function m() {
  return {
    type: "radar",
    symbol: "none",
    // 拐点大小
    symbolSize: i.symbolSize,
    silent: !0,
    // 使用的雷达坐标系的索引
    radarIndex: 1,
    areaStyle: {
      color: i.areaColor
    },
    lineStyle: {
      color: e.config.colorState.colorError,
      width: i.lineWidth,
      type: "dashed"
    },
    data: void 0
  };
}
function p(a, t, l, r) {
  r === void 0 && (r = !1);
  var o = e.config.colorState.colorError;
  return {
    name: "threshold",
    type: "radar",
    // 拐点大小
    symbolSize: i.symbolSize,
    // 图形响应和触发鼠标事件
    silent: !1,
    z: 99,
    // 使用的雷达坐标系的索引
    radarIndex: (r ? 1 : 2) + a,
    // 拐点的样式
    itemStyle: {
      color: o,
      // borderWidth常规为0，此处设置borderColor为透明色是为了避免hover移出symbol瞬间白色闪烁的问题
      borderColor: i.itemBorderColor,
      borderWidth: i.itemBorderWidth
    },
    lineStyle: {
      width: i.thresholdLineWidth
    },
    emphasis: {
      focus: "none",
      itemStyle: {
        color: i.emphasisItemColor,
        borderWidth: i.emphasisItemBorderWidth,
        borderColor: o
      }
    },
    data: [{
      value: t,
      name: l
      // 数据的名称，为了图例的点击消失生效，和系列的名字保持一致
    }]
  };
}
export {
  d as default,
  c as getMarkRadarOption,
  h as getRedPointerRadar,
  f as getSeriesUnit,
  m as getThresholdSeries,
  p as handleRedPointerSeries
};
