import "../../index.js";
import P from "../../../zrender/lib/core/BoundingRect.js";
import { create as d } from "../../../zrender/lib/core/matrix.js";
import { bind as l, map as T, clone as O } from "../../../zrender/lib/core/util.js";
function r(t, o) {
  this._bmap = t, this.dimensions = ["lng", "lat"], this._mapOffset = [0, 0], this._api = o, this._projection = new BMap.MercatorProjection();
}
r.prototype.type = "bmap";
r.prototype.dimensions = ["lng", "lat"];
r.prototype.setZoom = function(t) {
  this._zoom = t;
};
r.prototype.setCenter = function(t) {
  this._center = this._projection.lngLatToPoint(new BMap.Point(t[0], t[1]));
};
r.prototype.setMapOffset = function(t) {
  this._mapOffset = t;
};
r.prototype.getBMap = function() {
  return this._bmap;
};
r.prototype.dataToPoint = function(t) {
  var o = new BMap.Point(t[0], t[1]), e = this._bmap.pointToOverlayPixel(o), i = this._mapOffset;
  return [e.x - i[0], e.y - i[1]];
};
r.prototype.pointToData = function(t) {
  var o = this._mapOffset;
  return t = this._bmap.overlayPixelToPoint({
    x: t[0] + o[0],
    y: t[1] + o[1]
  }), [t.lng, t.lat];
};
r.prototype.getViewRect = function() {
  var t = this._api;
  return new P(0, 0, t.getWidth(), t.getHeight());
};
r.prototype.getRoamTransform = function() {
  return d();
};
r.prototype.prepareCustoms = function() {
  var t = this.getViewRect();
  return {
    coordSys: {
      // The name exposed to user is always 'cartesian2d' but not 'grid'.
      type: "bmap",
      x: t.x,
      y: t.y,
      width: t.width,
      height: t.height
    },
    api: {
      coord: l(this.dataToPoint, this),
      size: l(C, this)
    }
  };
};
r.prototype.convertToPixel = function(t, o, e) {
  return this.dataToPoint(e);
};
r.prototype.convertFromPixel = function(t, o, e) {
  return this.pointToData(e);
};
function C(t, o) {
  return o = o || [0, 0], T([0, 1], function(e) {
    var i = o[e], n = t[e] / 2, f = [], a = [];
    return f[e] = i - n, a[e] = i + n, f[1 - e] = a[1 - e] = o[1 - e], Math.abs(this.dataToPoint(f)[e] - this.dataToPoint(a)[e]);
  }, this);
}
var y;
r.dimensions = r.prototype.dimensions;
function B() {
  function t(o) {
    this._root = o;
  }
  return t.prototype = new BMap.Overlay(), t.prototype.initialize = function(o) {
    return o.getPanes().labelPane.appendChild(this._root), this._root;
  }, t.prototype.draw = function() {
  }, t;
}
r.create = function(t, o) {
  var e, i = o.getDom();
  return t.eachComponent("bmap", function(n) {
    var f = o.getZr().painter, a = f.getViewportRoot();
    if (typeof BMap > "u")
      throw new Error("BMap api is not loaded");
    if (y = y || B(), e)
      throw new Error("Only one bmap component can exist");
    var p;
    if (!n.__bmap) {
      var s = i.querySelector(".ec-extension-bmap");
      s && (a.style.left = "0px", a.style.top = "0px", i.removeChild(s)), s = document.createElement("div"), s.className = "ec-extension-bmap", s.style.cssText = "position:absolute;width:100%;height:100%", i.appendChild(s);
      var c = n.get("mapOptions");
      c && (c = O(c), delete c.mapType), p = n.__bmap = new BMap.Map(s, c);
      var m = new y(a);
      p.addOverlay(m), f.getViewportRootOffset = function() {
        return {
          offsetLeft: 0,
          offsetTop: 0
        };
      };
    }
    p = n.__bmap;
    var h = n.get("center"), u = n.get("zoom");
    if (h && u) {
      var v = p.getCenter(), g = p.getZoom(), _ = n.centerOrZoomChanged([v.lng, v.lat], g);
      if (_) {
        var w = new BMap.Point(h[0], h[1]);
        p.centerAndZoom(w, u);
      }
    }
    e = new r(p, o), e.setMapOffset(n.__mapOffset || [0, 0]), e.setZoom(u), e.setCenter(h), n.coordinateSystem = e;
  }), t.eachSeries(function(n) {
    n.get("coordinateSystem") === "bmap" && (n.coordinateSystem = e);
  }), e && [e];
};
export {
  r as default
};
