import { makeInner as M, normalizeToArray as I } from "../util/model.js";
import { keys as x, reduce as b, each as Y, extend as D, hasOwn as A, indexOf as C, isArrayLike as G, bind as U } from "../../../zrender/lib/core/util.js";
import { cloneValue as _ } from "../../../zrender/lib/animation/Animator.js";
import w from "../../../zrender/lib/graphic/Displayable.js";
import { getAnimationConfig as X } from "./basicTransition.js";
import "../util/graphic.js";
import { TRANSFORMABLE_PROPS as T } from "../../../zrender/lib/core/Transformable.js";
import z from "../../../zrender/lib/graphic/Path.js";
var F = {
  position: ["x", "y"],
  scale: ["scaleX", "scaleY"],
  origin: ["originX", "originY"]
}, L = x(F);
b(T, function(r, a) {
  return r[a] = 1, r;
}, {});
T.join(", ");
var m = ["", "style", "shape", "extra"], d = M();
function P(r, a, n, t, v) {
  var i = r + "Animation", e = X(r, t, v) || {}, f = d(a).userDuring;
  return e.duration > 0 && (e.during = f ? U(V, {
    el: a,
    userDuring: f
  }) : null, e.setToFinal = !0, e.scope = r), D(e, n[i]), e;
}
function ir(r, a, n, t) {
  t = t || {};
  var v = t.dataIndex, i = t.isInit, e = t.clearStyle, f = n.isAnimationEnabled(), l = d(r), o = a.style;
  l.userDuring = a.during;
  var u = {}, s = {};
  if (Z(r, a, s), B("shape", a, s), B("extra", a, s), !i && f && (W(r, a, u), R("shape", r, a, u), R("extra", r, a, u), $(r, a, o, u)), s.style = o, q(r, s, e), J(r, a), f)
    if (i) {
      var c = {};
      Y(m, function(g) {
        var E = g ? a[g] : a;
        E && E.enterFrom && (g && (c[g] = c[g] || {}), D(g ? c[g] : c, E.enterFrom));
      });
      var S = P("enter", r, a, n, v);
      S.duration > 0 && r.animateFrom(c, S);
    } else
      H(r, a, v || 0, n, u);
  j(r, a), o ? r.dirty() : r.markRedraw();
}
function j(r, a) {
  for (var n = d(r).leaveToProps, t = 0; t < m.length; t++) {
    var v = m[t], i = v ? a[v] : a;
    i && i.leaveTo && (n || (n = d(r).leaveToProps = {}), v && (n[v] = n[v] || {}), D(v ? n[v] : n, i.leaveTo));
  }
}
function er(r, a, n, t) {
  if (r) {
    var v = r.parent, i = d(r).leaveToProps;
    if (i) {
      var e = P("update", r, a, n, 0);
      e.done = function() {
        v.remove(r), t && t();
      }, r.animateTo(i, e);
    } else
      v.remove(r), t && t();
  }
}
function y(r) {
  return r === "all";
}
function q(r, a, n) {
  var t = a.style;
  if (!r.isGroup && t) {
    if (n) {
      r.useStyle({});
      for (var v = r.animators, i = 0; i < v.length; i++) {
        var e = v[i];
        e.targetName === "style" && e.changeTarget(r.style);
      }
    }
    r.setStyle(t);
  }
  a && (a.style = null, a && r.attr(a), a.style = t);
}
function H(r, a, n, t, v) {
  if (v) {
    var i = P("update", r, a, t, n);
    i.duration > 0 && r.animateFrom(v, i);
  }
}
function J(r, a) {
  A(a, "silent") && (r.silent = a.silent), A(a, "ignore") && (r.ignore = a.ignore), r instanceof w && A(a, "invisible") && (r.invisible = a.invisible), r instanceof z && A(a, "autoBatch") && (r.autoBatch = a.autoBatch);
}
var h = {}, Q = {
  // Usually other props do not need to be changed in animation during.
  setTransform: function(r, a) {
    return h.el[r] = a, this;
  },
  getTransform: function(r) {
    return h.el[r];
  },
  setShape: function(r, a) {
    var n = h.el, t = n.shape || (n.shape = {});
    return t[r] = a, n.dirtyShape && n.dirtyShape(), this;
  },
  getShape: function(r) {
    var a = h.el.shape;
    if (a)
      return a[r];
  },
  setStyle: function(r, a) {
    var n = h.el, t = n.style;
    return t && (t[r] = a, n.dirtyStyle && n.dirtyStyle()), this;
  },
  getStyle: function(r) {
    var a = h.el.style;
    if (a)
      return a[r];
  },
  setExtra: function(r, a) {
    var n = h.el.extra || (h.el.extra = {});
    return n[r] = a, this;
  },
  getExtra: function(r) {
    var a = h.el.extra;
    if (a)
      return a[r];
  }
};
function V() {
  var r = this, a = r.el;
  if (a) {
    var n = d(a).userDuring, t = r.userDuring;
    if (n !== t) {
      r.el = r.userDuring = null;
      return;
    }
    h.el = a, t(Q);
  }
}
function R(r, a, n, t) {
  var v = n[r];
  if (v) {
    var i = a[r], e;
    if (i) {
      var f = n.transition, l = v.transition;
      if (l)
        if (!e && (e = t[r] = {}), y(l))
          D(e, i);
        else
          for (var o = I(l), u = 0; u < o.length; u++) {
            var s = o[u], c = i[s];
            e[s] = c;
          }
      else if (y(f) || C(f, r) >= 0) {
        !e && (e = t[r] = {});
        for (var S = x(i), u = 0; u < S.length; u++) {
          var s = S[u], c = i[s];
          p(v[s], c) && (e[s] = c);
        }
      }
    }
  }
}
function B(r, a, n) {
  var t = a[r];
  if (t)
    for (var v = n[r] = {}, i = x(t), e = 0; e < i.length; e++) {
      var f = i[e];
      v[f] = _(t[f]);
    }
}
function W(r, a, n) {
  for (var t = a.transition, v = y(t) ? T : I(t || []), i = 0; i < v.length; i++) {
    var e = v[i];
    if (!(e === "style" || e === "shape" || e === "extra")) {
      var f = r[e];
      n[e] = f;
    }
  }
}
function Z(r, a, n) {
  for (var t = 0; t < L.length; t++) {
    var v = L[t], i = F[v], e = a[v];
    e && (n[i[0]] = e[0], n[i[1]] = e[1]);
  }
  for (var t = 0; t < T.length; t++) {
    var f = T[t];
    a[f] != null && (n[f] = a[f]);
  }
}
function $(r, a, n, t) {
  if (n) {
    var v = r.style, i;
    if (v) {
      var e = n.transition, f = a.transition;
      if (e && !y(e)) {
        var l = I(e);
        !i && (i = t.style = {});
        for (var o = 0; o < l.length; o++) {
          var u = l[o], s = v[u];
          i[u] = s;
        }
      } else if (r.getAnimationStyleProps && (y(f) || y(e) || C(f, "style") >= 0)) {
        var c = r.getAnimationStyleProps(), S = c ? c.style : null;
        if (S) {
          !i && (i = t.style = {});
          for (var g = x(n), o = 0; o < g.length; o++) {
            var u = g[o];
            if (S[u]) {
              var s = v[u];
              i[u] = s;
            }
          }
        }
      }
    }
  }
}
function p(r, a) {
  return G(r) ? r !== a : r != null && isFinite(r);
}
export {
  m as ELEMENT_ANIMATABLE_PROPS,
  er as applyLeaveTransition,
  ir as applyUpdateTransition,
  y as isTransitionAll,
  j as updateLeaveTo
};
