import { __extends as H } from "../../../../tslib/tslib.es6.js";
import he from "../../../../zrender/lib/graphic/Path.js";
import pe from "../../../../zrender/lib/graphic/Group.js";
import { map as ue, extend as ee, each as ge } from "../../../../zrender/lib/core/util.js";
import { traverseElements as de } from "../../util/graphic.js";
import { getECData as W } from "../../util/innerStore.js";
import { toggleHoverEmphasis as fe, setStatesStylesFromModel as ce } from "../../util/states.js";
import { labelInner as ve, getLabelStatesModels as le, setLabelStyle as me, setLabelValueAnimation as _e } from "../../label/labelStyle.js";
import { throttle as be } from "../../util/throttle.js";
import { createClipPath as Ae } from "../helper/createClipPathFromCoordSys.js";
import X from "../../util/shape/sausage.js";
import xe from "../../view/Chart.js";
import { isCoordinateSystemType as te } from "../../coord/CoordinateSystem.js";
import { getDefaultLabel as ye, getDefaultInterpolatedLabel as Se } from "../helper/labelHelper.js";
import { createSectorCalculateTextPosition as we, setSectorTextRotation as De } from "../../label/sectorLabel.js";
import { initProps as P, updateProps as L, saveOldStyle as Le, removeElementWithFadeOut as z } from "../../animation/basicTransition.js";
import { getSectorCornerRadius as Ce } from "../helper/sectorHelper.js";
import re from "../../../../zrender/lib/graphic/shape/Rect.js";
import ae from "../../../../zrender/lib/graphic/shape/Sector.js";
var R = Math.max, E = Math.min;
function Ie(i, r) {
  var e = i.getArea && i.getArea();
  if (te(i, "cartesian2d")) {
    var t = i.getBaseAxis();
    if (t.type !== "category" || !t.onBand) {
      var a = r.getLayout("bandWidth");
      t.isHorizontal() ? (e.x -= a, e.width += a * 2) : (e.y -= a, e.height += a * 2);
    }
  }
  return e;
}
var Pe = (
  /** @class */
  function(i) {
    H(r, i);
    function r() {
      var e = i.call(this) || this;
      return e.type = r.type, e._isFirstFrame = !0, e;
    }
    return r.prototype.render = function(e, t, a, n) {
      this._model = e, this._removeOnRenderedListener(a), this._updateDrawMode(e);
      var o = e.get("coordinateSystem");
      (o === "cartesian2d" || o === "polar") && (this._progressiveEls = null, this._isLargeDraw ? this._renderLarge(e, t, a) : this._renderNormal(e, t, a, n));
    }, r.prototype.incrementalPrepareRender = function(e) {
      this._clear(), this._updateDrawMode(e), this._updateLargeClip(e);
    }, r.prototype.incrementalRender = function(e, t) {
      this._progressiveEls = [], this._incrementalRenderLarge(e, t);
    }, r.prototype.eachRendered = function(e) {
      de(this._progressiveEls || this.group, e);
    }, r.prototype._updateDrawMode = function(e) {
      var t = e.pipelineContext.large;
      (this._isLargeDraw == null || t !== this._isLargeDraw) && (this._isLargeDraw = t, this._clear());
    }, r.prototype._renderNormal = function(e, t, a, n) {
      var o = this.group, s = e.getData(), u = this._data, h = e.coordinateSystem, p = h.getBaseAxis(), g;
      h.type === "cartesian2d" ? g = p.isHorizontal() : h.type === "polar" && (g = p.dim === "angle");
      var m = e.isAnimationEnabled() ? e : null, f = ke(e, h);
      f && this._enableRealtimeSort(f, s, a);
      var x = e.get("clip", !0) || f, w = Ie(h, s);
      o.removeClipPath();
      var y = e.get("roundCap", !0), S = e.get("showBackground", !0), A = e.getModel("backgroundStyle"), C = A.get("borderRadius") || 0, D = [], B = this._backgroundEls, F = n && n.isInitSort, G = n && n.type === "changeAxisOrder";
      function T(d) {
        var _ = I[h.type](s, d), c = Be(h, g, _);
        return c.useStyle(A.getItemStyle()), h.type === "cartesian2d" ? c.setShape("r", C) : c.setShape("cornerRadius", C), D[d] = c, c;
      }
      s.diff(u).add(function(d) {
        var _ = s.getItemModel(d), c = I[h.type](s, d, _);
        if (S && T(d), !(!s.hasValue(d) || !j[h.type](c))) {
          var b = !1;
          x && (b = U[h.type](w, c));
          var v = Y[h.type](e, s, d, c, g, m, p.model, !1, y);
          f && (v.forceLabelAnimation = !0), q(v, s, d, _, c, e, g, h.type === "polar"), F ? v.attr({
            shape: c
          }) : f ? Z(f, m, v, c, d, g, !1, !1) : P(v, {
            shape: c
          }, e, d), s.setItemGraphicEl(d, v), o.add(v), v.ignore = b;
        }
      }).update(function(d, _) {
        var c = s.getItemModel(d), b = I[h.type](s, d, c);
        if (S) {
          var v = void 0;
          B.length === 0 ? v = T(_) : (v = B[_], v.useStyle(A.getItemStyle()), h.type === "cartesian2d" ? v.setShape("r", C) : v.setShape("cornerRadius", C), D[d] = v);
          var se = I[h.type](s, d), oe = ne(g, se, h);
          L(v, {
            shape: oe
          }, m, d);
        }
        var l = u.getItemGraphicEl(_);
        if (!s.hasValue(d) || !j[h.type](b)) {
          o.remove(l);
          return;
        }
        var O = !1;
        if (x && (O = U[h.type](w, b), O && o.remove(l)), l ? Le(l) : l = Y[h.type](e, s, d, b, g, m, p.model, !!l, y), f && (l.forceLabelAnimation = !0), G) {
          var M = l.getTextContent();
          if (M) {
            var N = ve(M);
            N.prevValue != null && (N.prevValue = N.value);
          }
        } else
          q(l, s, d, c, b, e, g, h.type === "polar");
        F ? l.attr({
          shape: b
        }) : f ? Z(f, m, l, b, d, g, !0, G) : L(l, {
          shape: b
        }, e, d, null), s.setItemGraphicEl(d, l), l.ignore = O, o.add(l);
      }).remove(function(d) {
        var _ = u.getItemGraphicEl(d);
        _ && z(_, e, d);
      }).execute();
      var k = this._backgroundGroup || (this._backgroundGroup = new pe());
      k.removeAll();
      for (var V = 0; V < D.length; ++V)
        k.add(D[V]);
      o.add(k), this._backgroundEls = D, this._data = s;
    }, r.prototype._renderLarge = function(e, t, a) {
      this._clear(), K(e, this.group), this._updateLargeClip(e);
    }, r.prototype._incrementalRenderLarge = function(e, t) {
      this._removeBackground(), K(t, this.group, this._progressiveEls, !0);
    }, r.prototype._updateLargeClip = function(e) {
      var t = e.get("clip", !0) && Ae(e.coordinateSystem, !1, e), a = this.group;
      t ? a.setClipPath(t) : a.removeClipPath();
    }, r.prototype._enableRealtimeSort = function(e, t, a) {
      var n = this;
      if (t.count()) {
        var o = e.baseAxis;
        if (this._isFirstFrame)
          this._dispatchInitSort(t, e, a), this._isFirstFrame = !1;
        else {
          var s = function(u) {
            var h = t.getItemGraphicEl(u), p = h && h.shape;
            return p && // The result should be consistent with the initial sort by data value.
            // Do not support the case that both positive and negative exist.
            Math.abs(o.isHorizontal() ? p.height : p.width) || 0;
          };
          this._onRendered = function() {
            n._updateSortWithinSameData(t, s, o, a);
          }, a.getZr().on("rendered", this._onRendered);
        }
      }
    }, r.prototype._dataSort = function(e, t, a) {
      var n = [];
      return e.each(e.mapDimension(t.dim), function(o, s) {
        var u = a(s);
        u = u ?? NaN, n.push({
          dataIndex: s,
          mappedValue: u,
          ordinalNumber: o
        });
      }), n.sort(function(o, s) {
        return s.mappedValue - o.mappedValue;
      }), {
        ordinalNumbers: ue(n, function(o) {
          return o.ordinalNumber;
        })
      };
    }, r.prototype._isOrderChangedWithinSameData = function(e, t, a) {
      for (var n = a.scale, o = e.mapDimension(a.dim), s = Number.MAX_VALUE, u = 0, h = n.getOrdinalMeta().categories.length; u < h; ++u) {
        var p = e.rawIndexOf(o, n.getRawOrdinalNumber(u)), g = p < 0 ? Number.MIN_VALUE : t(e.indexOfRawIndex(p));
        if (g > s)
          return !0;
        s = g;
      }
      return !1;
    }, r.prototype._isOrderDifferentInView = function(e, t) {
      for (var a = t.scale, n = a.getExtent(), o = Math.max(0, n[0]), s = Math.min(n[1], a.getOrdinalMeta().categories.length - 1); o <= s; ++o)
        if (e.ordinalNumbers[o] !== a.getRawOrdinalNumber(o))
          return !0;
    }, r.prototype._updateSortWithinSameData = function(e, t, a, n) {
      if (this._isOrderChangedWithinSameData(e, t, a)) {
        var o = this._dataSort(e, a, t);
        this._isOrderDifferentInView(o, a) && (this._removeOnRenderedListener(n), n.dispatchAction({
          type: "changeAxisOrder",
          componentType: a.dim + "Axis",
          axisId: a.index,
          sortInfo: o
        }));
      }
    }, r.prototype._dispatchInitSort = function(e, t, a) {
      var n = t.baseAxis, o = this._dataSort(e, n, function(s) {
        return e.get(e.mapDimension(t.otherAxis.dim), s);
      });
      a.dispatchAction({
        type: "changeAxisOrder",
        componentType: n.dim + "Axis",
        isInitSort: !0,
        axisId: n.index,
        sortInfo: o
      });
    }, r.prototype.remove = function(e, t) {
      this._clear(this._model), this._removeOnRenderedListener(t);
    }, r.prototype.dispose = function(e, t) {
      this._removeOnRenderedListener(t);
    }, r.prototype._removeOnRenderedListener = function(e) {
      this._onRendered && (e.getZr().off("rendered", this._onRendered), this._onRendered = null);
    }, r.prototype._clear = function(e) {
      var t = this.group, a = this._data;
      e && e.isAnimationEnabled() && a && !this._isLargeDraw ? (this._removeBackground(), this._backgroundEls = [], a.eachItemGraphicEl(function(n) {
        z(n, e, W(n).dataIndex);
      })) : t.removeAll(), this._data = null, this._isFirstFrame = !0;
    }, r.prototype._removeBackground = function() {
      this.group.remove(this._backgroundGroup), this._backgroundGroup = null;
    }, r.type = "bar", r;
  }(xe)
), U = {
  cartesian2d: function(i, r) {
    var e = r.width < 0 ? -1 : 1, t = r.height < 0 ? -1 : 1;
    e < 0 && (r.x += r.width, r.width = -r.width), t < 0 && (r.y += r.height, r.height = -r.height);
    var a = i.x + i.width, n = i.y + i.height, o = R(r.x, i.x), s = E(r.x + r.width, a), u = R(r.y, i.y), h = E(r.y + r.height, n), p = s < o, g = h < u;
    return r.x = p && o > a ? s : o, r.y = g && u > n ? h : u, r.width = p ? 0 : s - o, r.height = g ? 0 : h - u, e < 0 && (r.x += r.width, r.width = -r.width), t < 0 && (r.y += r.height, r.height = -r.height), p || g;
  },
  polar: function(i, r) {
    var e = r.r0 <= r.r ? 1 : -1;
    if (e < 0) {
      var t = r.r;
      r.r = r.r0, r.r0 = t;
    }
    var a = E(r.r, i.r), n = R(r.r0, i.r0);
    r.r = a, r.r0 = n;
    var o = a - n < 0;
    if (e < 0) {
      var t = r.r;
      r.r = r.r0, r.r0 = t;
    }
    return o;
  }
}, Y = {
  cartesian2d: function(i, r, e, t, a, n, o, s, u) {
    var h = new re({
      shape: ee({}, t),
      z2: 1
    });
    if (h.__dataIndex = e, h.name = "item", n) {
      var p = h.shape, g = a ? "height" : "width";
      p[g] = 0;
    }
    return h;
  },
  polar: function(i, r, e, t, a, n, o, s, u) {
    var h = !a && u ? X : ae, p = new h({
      shape: t,
      z2: 1
    });
    p.name = "item";
    var g = ie(a);
    if (p.calculateTextPosition = we(g, {
      isRoundCap: h === X
    }), n) {
      var m = p.shape, f = a ? "r" : "endAngle", x = {};
      m[f] = a ? t.r0 : t.startAngle, x[f] = t[f], (s ? L : P)(p, {
        shape: x
        // __value: typeof dataValue === 'string' ? parseInt(dataValue, 10) : dataValue
      }, n);
    }
    return p;
  }
};
function ke(i, r) {
  var e = i.get("realtimeSort", !0), t = r.getBaseAxis();
  if (e && t.type === "category" && r.type === "cartesian2d")
    return {
      baseAxis: t,
      otherAxis: r.getOtherAxis(t)
    };
}
function Z(i, r, e, t, a, n, o, s) {
  var u, h;
  n ? (h = {
    x: t.x,
    width: t.width
  }, u = {
    y: t.y,
    height: t.height
  }) : (h = {
    y: t.y,
    height: t.height
  }, u = {
    x: t.x,
    width: t.width
  }), s || (o ? L : P)(e, {
    shape: u
  }, r, a, null);
  var p = r ? i.baseAxis.model : null;
  (o ? L : P)(e, {
    shape: h
  }, p, a);
}
function $(i, r) {
  for (var e = 0; e < r.length; e++)
    if (!isFinite(i[r[e]]))
      return !0;
  return !1;
}
var Ve = ["x", "y", "width", "height"], Oe = ["cx", "cy", "r", "startAngle", "endAngle"], j = {
  cartesian2d: function(i) {
    return !$(i, Ve);
  },
  polar: function(i) {
    return !$(i, Oe);
  }
}, I = {
  // itemModel is only used to get borderWidth, which is not needed
  // when calculating bar background layout.
  cartesian2d: function(i, r, e) {
    var t = i.getItemLayout(r), a = e ? Re(e, t) : 0, n = t.width > 0 ? 1 : -1, o = t.height > 0 ? 1 : -1;
    return {
      x: t.x + n * a / 2,
      y: t.y + o * a / 2,
      width: t.width - n * a,
      height: t.height - o * a
    };
  },
  polar: function(i, r, e) {
    var t = i.getItemLayout(r);
    return {
      cx: t.cx,
      cy: t.cy,
      r0: t.r0,
      r: t.r,
      startAngle: t.startAngle,
      endAngle: t.endAngle,
      clockwise: t.clockwise
    };
  }
};
function Ne(i) {
  return i.startAngle != null && i.endAngle != null && i.startAngle === i.endAngle;
}
function ie(i) {
  return function(r) {
    var e = r ? "Arc" : "Angle";
    return function(t) {
      switch (t) {
        case "start":
        case "insideStart":
        case "end":
        case "insideEnd":
          return t + e;
        default:
          return t;
      }
    };
  }(i);
}
function q(i, r, e, t, a, n, o, s) {
  var u = r.getItemVisual(e, "style");
  if (s) {
    if (!n.get("roundCap")) {
      var p = i.shape, g = Ce(t.getModel("itemStyle"), p, !0);
      ee(p, g), i.setShape(p);
    }
  } else {
    var h = t.get(["itemStyle", "borderRadius"]) || 0;
    i.setShape("r", h);
  }
  i.useStyle(u);
  var m = t.getShallow("cursor");
  m && i.attr("cursor", m);
  var f = s ? o ? a.r >= a.r0 ? "endArc" : "startArc" : a.endAngle >= a.startAngle ? "endAngle" : "startAngle" : o ? a.height >= 0 ? "bottom" : "top" : a.width >= 0 ? "right" : "left", x = le(t);
  me(i, x, {
    labelFetcher: n,
    labelDataIndex: e,
    defaultText: ye(n.getData(), e),
    inheritColor: u.fill,
    defaultOpacity: u.opacity,
    defaultOutsidePosition: f
  });
  var w = i.getTextContent();
  if (s && w) {
    var y = t.get(["label", "position"]);
    i.textConfig.inside = y === "middle" ? !0 : null, De(i, y === "outside" ? f : y, ie(o), t.get(["label", "rotate"]));
  }
  _e(w, x, n.getRawValue(e), function(A) {
    return Se(r, A);
  });
  var S = t.getModel(["emphasis"]);
  fe(i, S.get("focus"), S.get("blurScope"), S.get("disabled")), ce(i, t), Ne(a) && (i.style.fill = "none", i.style.stroke = "none", ge(i.states, function(A) {
    A.style && (A.style.fill = A.style.stroke = "none");
  }));
}
function Re(i, r) {
  var e = i.get(["itemStyle", "borderColor"]);
  if (!e || e === "none")
    return 0;
  var t = i.get(["itemStyle", "borderWidth"]) || 0, a = isNaN(r.width) ? Number.MAX_VALUE : Math.abs(r.width), n = isNaN(r.height) ? Number.MAX_VALUE : Math.abs(r.height);
  return Math.min(t, a, n);
}
var Ee = (
  /** @class */
  function() {
    function i() {
    }
    return i;
  }()
), J = (
  /** @class */
  function(i) {
    H(r, i);
    function r(e) {
      var t = i.call(this, e) || this;
      return t.type = "largeBar", t;
    }
    return r.prototype.getDefaultShape = function() {
      return new Ee();
    }, r.prototype.buildPath = function(e, t) {
      for (var a = t.points, n = this.baseDimIdx, o = 1 - this.baseDimIdx, s = [], u = [], h = this.barWidth, p = 0; p < a.length; p += 3)
        u[n] = h, u[o] = a[p + 2], s[n] = a[p + n], s[o] = a[p + o], e.rect(s[0], s[1], u[0], u[1]);
    }, r;
  }(he)
);
function K(i, r, e, t) {
  var a = i.getData(), n = a.getLayout("valueAxisHorizontal") ? 1 : 0, o = a.getLayout("largeDataIndices"), s = a.getLayout("size"), u = i.getModel("backgroundStyle"), h = a.getLayout("largeBackgroundPoints");
  if (h) {
    var p = new J({
      shape: {
        points: h
      },
      incremental: !!t,
      silent: !0,
      z2: 0
    });
    p.baseDimIdx = n, p.largeDataIndices = o, p.barWidth = s, p.useStyle(u.getItemStyle()), r.add(p), e && e.push(p);
  }
  var g = new J({
    shape: {
      points: a.getLayout("largePoints")
    },
    incremental: !!t,
    ignoreCoarsePointer: !0,
    z2: 1
  });
  g.baseDimIdx = n, g.largeDataIndices = o, g.barWidth = s, r.add(g), g.useStyle(a.getVisual("style")), g.style.stroke = null, W(g).seriesIndex = i.seriesIndex, i.get("silent") || (g.on("mousedown", Q), g.on("mousemove", Q)), e && e.push(g);
}
var Q = be(function(i) {
  var r = this, e = We(r, i.offsetX, i.offsetY);
  W(r).dataIndex = e >= 0 ? e : null;
}, 30, !1);
function We(i, r, e) {
  for (var t = i.baseDimIdx, a = 1 - t, n = i.shape.points, o = i.largeDataIndices, s = [], u = [], h = i.barWidth, p = 0, g = n.length / 3; p < g; p++) {
    var m = p * 3;
    if (u[t] = h, u[a] = n[m + 2], s[t] = n[m + t], s[a] = n[m + a], u[a] < 0 && (s[a] += u[a], u[a] = -u[a]), r >= s[0] && r <= s[0] + u[0] && e >= s[1] && e <= s[1] + u[1])
      return o[p];
  }
  return -1;
}
function ne(i, r, e) {
  if (te(e, "cartesian2d")) {
    var t = r, a = e.getArea();
    return {
      x: i ? t.x : a.x,
      y: i ? a.y : t.y,
      width: i ? t.width : a.width,
      height: i ? a.height : t.height
    };
  } else {
    var a = e.getArea(), n = r;
    return {
      cx: a.cx,
      cy: a.cy,
      r0: i ? a.r0 : n.r0,
      r: i ? a.r : n.r,
      startAngle: i ? n.startAngle : 0,
      endAngle: i ? n.endAngle : Math.PI * 2
    };
  }
}
function Be(i, r, e) {
  var t = i.type === "polar" ? ae : re;
  return new t({
    shape: ne(r, e, i),
    silent: !0,
    z2: 0
  });
}
const at = Pe;
export {
  at as default
};
