import { __extends as Cr } from "../../../../tslib/tslib.es6.js";
import { defaults as E, retrieve2 as Sr, retrieve3 as Pr, hasOwn as P, each as br, indexOf as Lr, isString as Dr } from "../../../../zrender/lib/core/util.js";
import { traverseElements as dr, makePath as Ar, getShapeClass as wr } from "../../util/graphic.js";
import { toggleHoverEmphasis as Tr, setDefaultStateProxy as _r } from "../../util/states.js";
import { createTextStyle as j, createTextConfig as O, getFont as Fr } from "../../label/labelStyle.js";
import { getDefaultLabel as I } from "../helper/labelHelper.js";
import { getLayoutOnAxis as Rr } from "../../layout/barGrid.js";
import Mr from "../../data/DataDiffer.js";
import Er from "../../view/Chart.js";
import { createClipPath as Ur } from "../helper/createClipPathFromCoordSys.js";
import zr from "../../coord/cartesian/prepareCustom.js";
import Gr from "../../coord/geo/prepareCustom.js";
import Zr from "../../coord/single/prepareCustom.js";
import Vr from "../../coord/polar/prepareCustom.js";
import Hr from "../../coord/calendar/prepareCustom.js";
import kr from "../../../../zrender/lib/graphic/Displayable.js";
import { convertToEC4StyleForCustomSerise as rr, isEC4CompatibleStyle as Br, convertFromEC4CompatibleStyle as Yr } from "../../util/styleCompat.js";
import { throwError as Kr } from "../../util/log.js";
import { createOrUpdatePatternFromDecal as Nr } from "../../util/decal.js";
import { customInnerStore as d, STYLE_VISUAL_TYPE as er, NON_STYLE_VISUAL_PROPS as Wr } from "./CustomSeries.js";
import { applyLeaveTransition as H, applyUpdateTransition as $r } from "../../animation/customGraphicTransition.js";
import { stopPreviousKeyframeAnimationAndRestore as Xr, applyKeyframeAnimation as qr } from "../../animation/customGraphicKeyframeAnimation.js";
import Jr from "../../../../zrender/lib/graphic/Image.js";
import Qr from "../../../../zrender/lib/graphic/Text.js";
import xr from "../../../../zrender/lib/graphic/Group.js";
import jr from "../../../../zrender/lib/graphic/Path.js";
var b = "emphasis", D = "normal", k = "blur", B = "select", A = [D, b, k, B], U = {
  normal: ["itemStyle"],
  emphasis: [b, "itemStyle"],
  blur: [k, "itemStyle"],
  select: [B, "itemStyle"]
}, z = {
  normal: ["label"],
  emphasis: [b, "label"],
  blur: [k, "label"],
  select: [B, "label"]
}, Or = ["x", "y"], Ir = "e\0\0", C = {
  normal: {},
  emphasis: {},
  blur: {},
  select: {}
}, re = {
  cartesian2d: zr,
  geo: Gr,
  single: Zr,
  polar: Vr,
  calendar: Hr
};
function Z(e) {
  return e instanceof jr;
}
function V(e) {
  return e instanceof kr;
}
function ee(e, r) {
  r.copyTransform(e), V(r) && V(e) && (r.setStyle(e.style), r.z = e.z, r.z2 = e.z2, r.zlevel = e.zlevel, r.invisible = e.invisible, r.ignore = e.ignore, Z(r) && Z(e) && r.setShape(e.shape));
}
var te = (
  /** @class */
  function(e) {
    Cr(r, e);
    function r() {
      var t = e !== null && e.apply(this, arguments) || this;
      return t.type = r.type, t;
    }
    return r.prototype.render = function(t, n, i, l) {
      this._progressiveEls = null;
      var o = this._data, v = t.getData(), p = this.group, u = tr(t, v, n, i);
      o || p.removeAll(), v.diff(o).add(function(c) {
        G(i, null, c, u(c, l), t, p, v);
      }).remove(function(c) {
        var g = o.getItemGraphicEl(c);
        g && H(g, d(g).option, t);
      }).update(function(c, g) {
        var h = o.getItemGraphicEl(g);
        G(i, h, c, u(c, l), t, p, v);
      }).execute();
      var m = t.get("clip", !0) ? Ur(t.coordinateSystem, !1, t) : null;
      m ? p.setClipPath(m) : p.removeClipPath(), this._data = v;
    }, r.prototype.incrementalPrepareRender = function(t, n, i) {
      this.group.removeAll(), this._data = null;
    }, r.prototype.incrementalRender = function(t, n, i, l, o) {
      var v = n.getData(), p = tr(n, v, i, l), u = this._progressiveEls = [];
      function m(h) {
        h.isGroup || (h.incremental = !0, h.ensureState("emphasis").hoverLayer = !0);
      }
      for (var c = t.start; c < t.end; c++) {
        var g = G(null, null, c, p(c, o), n, this.group, v);
        g && (g.traverse(m), u.push(g));
      }
    }, r.prototype.eachRendered = function(t) {
      dr(this._progressiveEls || this.group, t);
    }, r.prototype.filterForExposedEvent = function(t, n, i, l) {
      var o = n.element;
      if (o == null || i.name === o)
        return !0;
      for (; (i = i.__hostTarget || i.parent) && i !== this.group; )
        if (i.name === o)
          return !0;
      return !1;
    }, r.type = "custom", r;
  }(Er)
);
const ke = te;
function Y(e) {
  var r = e.type, t;
  if (r === "path") {
    var n = e.shape, i = n.width != null && n.height != null ? {
      x: n.x || 0,
      y: n.y || 0,
      width: n.width,
      height: n.height
    } : null, l = ur(n);
    t = Ar(l, null, i, n.layout || "center"), d(t).customPathData = l;
  } else if (r === "image")
    t = new Jr({}), d(t).customImagePath = e.style.image;
  else if (r === "text")
    t = new Qr({});
  else if (r === "group")
    t = new xr();
  else {
    if (r === "compoundPath")
      throw new Error('"compoundPath" is not supported yet.');
    var o = wr(r);
    if (!o) {
      var v = "";
      Kr(v);
    }
    t = new o();
  }
  return d(t).customGraphicType = r, t.name = e.name, t.z2EmphasisLift = 1, t.z2SelectLift = 1, t;
}
function K(e, r, t, n, i, l, o) {
  Xr(r);
  var v = i && i.normal.cfg;
  v && r.setTextConfig(v), n && n.transition == null && (n.transition = Or);
  var p = n && n.style;
  if (p) {
    if (r.type === "text") {
      var u = p;
      P(u, "textFill") && (u.fill = u.textFill), P(u, "textStroke") && (u.stroke = u.textStroke);
    }
    var m = void 0, c = Z(r) ? p.decal : null;
    e && c && (c.dirty = !0, m = Nr(c, e)), p.__decalPattern = m;
  }
  if (V(r) && p) {
    var m = p.__decalPattern;
    m && (p.decal = m);
  }
  $r(r, n, l, {
    dataIndex: t,
    isInit: o,
    clearStyle: !0
  }), qr(r, n.keyframeAnimation, l);
}
function ir(e, r, t, n, i) {
  var l = r.isGroup ? null : r, o = i && i[e].cfg;
  if (l) {
    var v = l.ensureState(e);
    if (n === !1) {
      var p = l.getState(e);
      p && (p.style = null);
    } else
      v.style = n || null;
    o && (v.textConfig = o), _r(l);
  }
}
function ne(e, r, t) {
  if (!e.isGroup) {
    var n = e, i = t.currentZ, l = t.currentZLevel;
    n.z = i, n.zlevel = l;
    var o = r.z2;
    o != null && (n.z2 = o || 0);
    for (var v = 0; v < A.length; v++)
      le(n, r, A[v]);
  }
}
function le(e, r, t) {
  var n = t === D, i = n ? r : F(r, t), l = i ? i.z2 : null, o;
  l != null && (o = n ? e : e.ensureState(t), o.z2 = l || 0);
}
function tr(e, r, t, n) {
  var i = e.get("renderItem"), l = e.coordinateSystem, o = {};
  l && (o = l.prepareCustoms ? l.prepareCustoms(l) : re[l.type](l));
  for (var v = E({
    getWidth: n.getWidth,
    getHeight: n.getHeight,
    getZr: n.getZr,
    getDevicePixelRatio: n.getDevicePixelRatio,
    value: fr,
    style: mr,
    ordinalRawValue: vr,
    styleEmphasis: pr,
    visual: cr,
    barLayout: gr,
    currentSeriesIndices: sr,
    font: hr
  }, o.api || {}), p = {
    // The life cycle of context: current round of rendering.
    // The global life cycle is probably not necessary, because
    // user can store global status by themselves.
    context: {},
    seriesId: e.id,
    seriesName: e.name,
    seriesIndex: e.seriesIndex,
    coordSys: o.coordSys,
    dataInsideLength: r.count(),
    encode: oe(e.getData())
  }, u, m, c = {}, g = {}, h = {}, w = {}, R = 0; R < A.length; R++) {
    var T = A[R];
    h[T] = e.getModel(U[T]), w[T] = e.getModel(z[T]);
  }
  function _(f) {
    return f === u ? m || (m = r.getItemModel(f)) : r.getItemModel(f);
  }
  function $(f, a) {
    return r.hasItemOption ? f === u ? c[a] || (c[a] = _(f).getModel(U[a])) : _(f).getModel(U[a]) : h[a];
  }
  function X(f, a) {
    return r.hasItemOption ? f === u ? g[a] || (g[a] = _(f).getModel(z[a])) : _(f).getModel(z[a]) : w[a];
  }
  return function(f, a) {
    return u = f, m = null, c = {}, g = {}, i && i(E({
      dataIndexInside: f,
      dataIndex: r.getRawIndex(f),
      // Can be used for optimization when zoom or roam.
      actionType: a ? a.type : null
    }, p), v);
  };
  function fr(f, a) {
    return a == null && (a = u), r.getStore().get(r.getDimensionIndex(f || 0), a);
  }
  function vr(f, a) {
    a == null && (a = u), f = f || 0;
    var s = r.getDimensionInfo(f);
    if (!s) {
      var S = r.getDimensionIndex(f);
      return S >= 0 ? r.getStore().get(S, a) : void 0;
    }
    var L = r.get(s.name, a), y = s && s.ordinalMeta;
    return y ? y.categories[L] : L;
  }
  function mr(f, a) {
    a == null && (a = u);
    var s = r.getItemVisual(a, "style"), S = s && s.fill, L = s && s.opacity, y = $(a, D).getItemStyle();
    S != null && (y.fill = S), L != null && (y.opacity = L);
    var Q = {
      inheritColor: Dr(S) ? S : "#000"
    }, M = X(a, D), x = j(M, null, Q, !1, !0);
    x.text = M.getShallow("show") ? Sr(e.getFormattedLabel(a, D), I(r, a)) : null;
    var yr = O(M, Q, !1);
    return J(f, y), y = rr(y, x, yr), f && q(y, f), y.legacy = !0, y;
  }
  function pr(f, a) {
    a == null && (a = u);
    var s = $(a, b).getItemStyle(), S = X(a, b), L = j(S, null, null, !0, !0);
    L.text = S.getShallow("show") ? Pr(e.getFormattedLabel(a, b), e.getFormattedLabel(a, D), I(r, a)) : null;
    var y = O(S, null, !0);
    return J(f, s), s = rr(s, L, y), f && q(s, f), s.legacy = !0, s;
  }
  function q(f, a) {
    for (var s in a)
      P(a, s) && (f[s] = a[s]);
  }
  function J(f, a) {
    f && (f.textFill && (a.textFill = f.textFill), f.textPosition && (a.textPosition = f.textPosition));
  }
  function cr(f, a) {
    if (a == null && (a = u), P(er, f)) {
      var s = r.getItemVisual(a, "style");
      return s ? s[er[f]] : null;
    }
    if (P(Wr, f))
      return r.getItemVisual(a, f);
  }
  function gr(f) {
    if (l.type === "cartesian2d") {
      var a = l.getBaseAxis();
      return Rr(E({
        axis: a
      }, f));
    }
  }
  function sr() {
    return t.getCurrentSeriesIndices();
  }
  function hr(f) {
    return Fr(f, t);
  }
}
function oe(e) {
  var r = {};
  return br(e.dimensions, function(t) {
    var n = e.getDimensionInfo(t);
    if (!n.isExtraCoord) {
      var i = n.coordDim, l = r[i] = r[i] || [];
      l[n.coordDimIndex] = e.getDimensionIndex(t);
    }
  }), r;
}
function G(e, r, t, n, i, l, o) {
  if (!n) {
    l.remove(r);
    return;
  }
  var v = N(e, r, t, n, i, l);
  return v && o.setItemGraphicEl(t, v), v && Tr(v, n.focus, n.blurScope, n.emphasisDisabled), v;
}
function N(e, r, t, n, i, l) {
  var o = -1, v = r;
  r && ar(r, n, i) && (o = Lr(l.childrenRef(), r), r = null);
  var p = !r, u = r;
  u ? u.clearStates() : (u = Y(n), v && ee(v, u)), n.morph === !1 ? u.disableMorphing = !0 : u.disableMorphing && (u.disableMorphing = !1), C.normal.cfg = C.normal.conOpt = C.emphasis.cfg = C.emphasis.conOpt = C.blur.cfg = C.blur.conOpt = C.select.cfg = C.select.conOpt = null, C.isLegacy = !1, ae(u, t, n, i, p, C), ie(u, t, n, i, p), K(e, u, t, n, C, i, p), P(n, "info") && (d(u).info = n.info);
  for (var m = 0; m < A.length; m++) {
    var c = A[m];
    if (c !== D) {
      var g = F(n, c), h = W(n, g, c);
      ir(c, u, g, h, C);
    }
  }
  return ne(u, n, i), n.type === "group" && ue(e, u, t, n, i), o >= 0 ? l.replaceAt(u, o) : l.add(u), u;
}
function ar(e, r, t) {
  var n = d(e), i = r.type, l = r.shape, o = r.style;
  return (
    // Always create new if universal transition is enabled.
    // Because we do transition after render. It needs to know what old element is. Replacement will loose it.
    t.isUniversalTransitionEnabled() || i != null && i !== n.customGraphicType || i === "path" && pe(l) && ur(l) !== n.customPathData || i === "image" && P(o, "image") && o.image !== n.customImagePath
  );
}
function ie(e, r, t, n, i) {
  var l = t.clipPath;
  if (l === !1)
    e && e.getClipPath() && e.removeClipPath();
  else if (l) {
    var o = e.getClipPath();
    o && ar(o, l, n) && (o = null), o || (o = Y(l), e.setClipPath(o)), K(null, o, r, l, null, n, i);
  }
}
function ae(e, r, t, n, i, l) {
  if (!e.isGroup) {
    nr(t, null, l), nr(t, b, l);
    var o = l.normal.conOpt, v = l.emphasis.conOpt, p = l.blur.conOpt, u = l.select.conOpt;
    if (o != null || v != null || u != null || p != null) {
      var m = e.getTextContent();
      if (o === !1)
        m && e.removeTextContent();
      else {
        o = l.normal.conOpt = o || {
          type: "text"
        }, m ? m.clearStates() : (m = Y(o), e.setTextContent(m)), K(null, m, r, o, null, n, i);
        for (var c = o && o.style, g = 0; g < A.length; g++) {
          var h = A[g];
          if (h !== D) {
            var w = l[h].conOpt;
            ir(h, m, w, W(o, w, h), null);
          }
        }
        c ? m.dirty() : m.markRedraw();
      }
    }
  }
}
function nr(e, r, t) {
  var n = r ? F(e, r) : e, i = r ? W(e, n, b) : e.style, l = e.type, o = n ? n.textConfig : null, v = e.textContent, p = v ? r ? F(v, r) : v : null;
  if (i && // Because emphasis style has little info to detect legacy,
  // if normal is legacy, emphasis is trade as legacy.
  (t.isLegacy || Br(i, l, !!o, !!p))) {
    t.isLegacy = !0;
    var u = Yr(i, l, !r);
    !o && u.textConfig && (o = u.textConfig), !p && u.textContent && (p = u.textContent);
  }
  if (!r && p) {
    var m = p;
    !m.type && (m.type = "text");
  }
  var c = r ? t[r] : t.normal;
  c.cfg = o, c.conOpt = p;
}
function F(e, r) {
  return r ? e ? e[r] : null : e;
}
function W(e, r, t) {
  var n = r && r.style;
  return n == null && t === b && e && (n = e.styleEmphasis), n;
}
function ue(e, r, t, n, i) {
  var l = n.children, o = l ? l.length : 0, v = n.$mergeChildren, p = v === "byName" || n.diffChildrenByName, u = v === !1;
  if (!(!o && !p && !u)) {
    if (p) {
      ve({
        api: e,
        oldChildren: r.children() || [],
        newChildren: l || [],
        dataIndex: t,
        seriesModel: i,
        group: r
      });
      return;
    }
    u && r.removeAll();
    for (var m = 0; m < o; m++) {
      var c = l[m], g = r.childAt(m);
      c ? (c.ignore == null && (c.ignore = !1), N(e, g, t, c, i, r)) : g.ignore = !0;
    }
    for (var h = r.childCount() - 1; h >= m; h--) {
      var w = r.childAt(h);
      fe(r, w, i);
    }
  }
}
function fe(e, r, t) {
  r && H(r, d(e).option, t);
}
function ve(e) {
  new Mr(e.oldChildren, e.newChildren, lr, lr, e).add(or).update(or).remove(me).execute();
}
function lr(e, r) {
  var t = e && e.name;
  return t ?? Ir + r;
}
function or(e, r) {
  var t = this.context, n = e != null ? t.newChildren[e] : null, i = r != null ? t.oldChildren[r] : null;
  N(t.api, i, t.dataIndex, n, t.seriesModel, t.group);
}
function me(e) {
  var r = this.context, t = r.oldChildren[e];
  t && H(t, d(t).option, r.seriesModel);
}
function ur(e) {
  return e && (e.pathData || e.d);
}
function pe(e) {
  return e && (P(e, "pathData") || P(e, "d"));
}
export {
  ke as default
};
