import { __extends as R } from "../../../../tslib/tslib.es6.js";
import T from "../helper/SymbolDraw.js";
import k from "../helper/LineDraw.js";
import C from "../../component/helper/RoamController.js";
import { updateViewOnPan as V, updateViewOnZoom as z } from "../../component/helper/roamHelper.js";
import { onIrrelevantElement as N } from "../../component/helper/cursorHelper.js";
import v from "./adjustEdge.js";
import { getNodeGlobalScale as g } from "./graphHelper.js";
import X from "../../view/Chart.js";
import { getECData as b } from "../../util/innerStore.js";
import { simpleLayoutEdge as Y } from "./simpleLayoutHelper.js";
import { circularLayout as j, rotateNodeLabel as F } from "./circularLayoutHelper.js";
import { updateProps as H } from "../../animation/basicTransition.js";
function x(y) {
  return y.type === "view";
}
var Z = (
  /** @class */
  function(y) {
    R(u, y);
    function u() {
      var t = y !== null && y.apply(this, arguments) || this;
      return t.type = u.type, t;
    }
    return u.prototype.init = function(t, l) {
      var o = new T(), r = new k(), a = this.group;
      this._controller = new C(l.getZr()), this._controllerHost = {
        target: a
      }, a.add(o.group), a.add(r.group), this._symbolDraw = o, this._lineDraw = r, this._firstRender = !0;
    }, u.prototype.render = function(t, l, o) {
      var r = this, a = t.coordinateSystem;
      this._model = t;
      var f = this._symbolDraw, s = this._lineDraw, e = this.group;
      if (x(a)) {
        var d = {
          x: a.x,
          y: a.y,
          scaleX: a.scaleX,
          scaleY: a.scaleY
        };
        this._firstRender ? e.attr(d) : H(e, d, t);
      }
      v(t.getGraph(), g(t));
      var c = t.getData();
      f.updateData(c);
      var h = t.getEdgeData();
      s.updateData(h), this._updateNodeAndLinkScale(), this._updateController(t, l, o), clearTimeout(this._layoutTimeout);
      var m = t.forceLayout, L = t.get(["force", "layoutAnimation"]);
      m && this._startForceLayoutIteration(m, L);
      var I = t.get("layout");
      c.graph.eachNode(function(i) {
        var p = i.dataIndex, n = i.getGraphicEl(), _ = i.getModel();
        if (n) {
          n.off("drag").off("dragend");
          var w = _.get("draggable");
          w && n.on("drag", function(D) {
            switch (I) {
              case "force":
                m.warmUp(), !r._layouting && r._startForceLayoutIteration(m, L), m.setFixed(p), c.setItemLayout(p, [n.x, n.y]);
                break;
              case "circular":
                c.setItemLayout(p, [n.x, n.y]), i.setLayout({
                  fixed: !0
                }, !0), j(t, "symbolSize", i, [D.offsetX, D.offsetY]), r.updateLayout(t);
                break;
              case "none":
              default:
                c.setItemLayout(p, [n.x, n.y]), Y(t.getGraph(), t), r.updateLayout(t);
                break;
            }
          }).on("dragend", function() {
            m && m.setUnfixed(p);
          }), n.setDraggable(w, !!_.get("cursor"));
          var A = _.get(["emphasis", "focus"]);
          A === "adjacency" && (b(n).focus = i.getAdjacentDataIndices());
        }
      }), c.graph.eachEdge(function(i) {
        var p = i.getGraphicEl(), n = i.getModel().get(["emphasis", "focus"]);
        p && n === "adjacency" && (b(p).focus = {
          edge: [i.dataIndex],
          node: [i.node1.dataIndex, i.node2.dataIndex]
        });
      });
      var S = t.get("layout") === "circular" && t.get(["circular", "rotateLabel"]), G = c.getLayout("cx"), E = c.getLayout("cy");
      c.graph.eachNode(function(i) {
        F(i, S, G, E);
      }), this._firstRender = !1;
    }, u.prototype.dispose = function() {
      this.remove(), this._controller && this._controller.dispose(), this._controllerHost = null;
    }, u.prototype._startForceLayoutIteration = function(t, l) {
      var o = this;
      (function r() {
        t.step(function(a) {
          o.updateLayout(o._model), (o._layouting = !a) && (l ? o._layoutTimeout = setTimeout(r, 16) : r());
        });
      })();
    }, u.prototype._updateController = function(t, l, o) {
      var r = this, a = this._controller, f = this._controllerHost, s = this.group;
      if (a.setPointerChecker(function(e, d, c) {
        var h = s.getBoundingRect();
        return h.applyTransform(s.transform), h.contain(d, c) && !N(e, o, t);
      }), !x(t.coordinateSystem)) {
        a.disable();
        return;
      }
      a.enable(t.get("roam")), f.zoomLimit = t.get("scaleLimit"), f.zoom = t.coordinateSystem.getZoom(), a.off("pan").off("zoom").on("pan", function(e) {
        V(f, e.dx, e.dy), o.dispatchAction({
          seriesId: t.id,
          type: "graphRoam",
          dx: e.dx,
          dy: e.dy
        });
      }).on("zoom", function(e) {
        z(f, e.scale, e.originX, e.originY), o.dispatchAction({
          seriesId: t.id,
          type: "graphRoam",
          zoom: e.scale,
          originX: e.originX,
          originY: e.originY
        }), r._updateNodeAndLinkScale(), v(t.getGraph(), g(t)), r._lineDraw.updateLayout(), o.updateLabelLayout();
      });
    }, u.prototype._updateNodeAndLinkScale = function() {
      var t = this._model, l = t.getData(), o = g(t);
      l.eachItemGraphicEl(function(r, a) {
        r && r.setSymbolScale(o);
      });
    }, u.prototype.updateLayout = function(t) {
      v(t.getGraph(), g(t)), this._symbolDraw.updateLayout(), this._lineDraw.updateLayout();
    }, u.prototype.remove = function() {
      clearTimeout(this._layoutTimeout), this._layouting = !1, this._layoutTimeout = null, this._symbolDraw && this._symbolDraw.remove(), this._lineDraw && this._lineDraw.remove();
    }, u.type = "graph", u;
  }(X)
);
const ot = Z;
export {
  ot as default
};
