import { __extends as k } from "../../../../tslib/tslib.es6.js";
import { traverseElements as B } from "../../util/graphic.js";
import { toggleHoverEmphasis as F } from "../../util/states.js";
import Z from "./HeatmapLayer.js";
import { map as $ } from "../../../../zrender/lib/core/util.js";
import j from "../../view/Chart.js";
import { isCoordinateSystemType as q } from "../../coord/CoordinateSystem.js";
import { getLabelStatesModels as G, setLabelStyle as J } from "../../label/labelStyle.js";
import L from "../../../../zrender/lib/graphic/shape/Rect.js";
import K from "../../../../zrender/lib/graphic/Image.js";
function Q(m, e, t) {
  var n = m[1] - m[0];
  e = $(e, function(r) {
    return {
      interval: [(r.interval[0] - m[0]) / n, (r.interval[1] - m[0]) / n]
    };
  });
  var i = e.length, g = 0;
  return function(r) {
    var a;
    for (a = g; a < i; a++) {
      var s = e[a].interval;
      if (s[0] <= r && r <= s[1]) {
        g = a;
        break;
      }
    }
    if (a === i)
      for (a = g - 1; a >= 0; a--) {
        var s = e[a].interval;
        if (s[0] <= r && r <= s[1]) {
          g = a;
          break;
        }
      }
    return a >= 0 && a < i && t[a];
  };
}
function U(m, e) {
  var t = m[1] - m[0];
  return e = [(e[0] - m[0]) / t, (e[1] - m[0]) / t], function(n) {
    return n >= e[0] && n <= e[1];
  };
}
function W(m) {
  var e = m.dimensions;
  return e[0] === "lng" && e[1] === "lat";
}
var X = (
  /** @class */
  function(m) {
    k(e, m);
    function e() {
      var t = m !== null && m.apply(this, arguments) || this;
      return t.type = e.type, t;
    }
    return e.prototype.render = function(t, n, i) {
      var g;
      n.eachComponent("visualMap", function(a) {
        a.eachTargetSeries(function(s) {
          s === t && (g = a);
        });
      }), this._progressiveEls = null, this.group.removeAll();
      var r = t.coordinateSystem;
      r.type === "cartesian2d" || r.type === "calendar" ? this._renderOnCartesianAndCalendar(t, i, 0, t.getData().count()) : W(r) && this._renderOnGeo(r, t, g, i);
    }, e.prototype.incrementalPrepareRender = function(t, n, i) {
      this.group.removeAll();
    }, e.prototype.incrementalRender = function(t, n, i, g) {
      var r = n.coordinateSystem;
      r && (W(r) ? this.render(n, i, g) : (this._progressiveEls = [], this._renderOnCartesianAndCalendar(n, g, t.start, t.end, !0)));
    }, e.prototype.eachRendered = function(t) {
      B(this._progressiveEls || this.group, t);
    }, e.prototype._renderOnCartesianAndCalendar = function(t, n, i, g, r) {
      var a = t.coordinateSystem, s = q(a, "cartesian2d"), v, u, c, y;
      if (s) {
        var f = a.getAxis("x"), I = a.getAxis("y");
        v = f.getBandWidth() + 0.5, u = I.getBandWidth() + 0.5, c = f.scale.getExtent(), y = I.scale.getExtent();
      }
      for (var E = this.group, o = t.getData(), S = t.getModel(["emphasis", "itemStyle"]).getItemStyle(), O = t.getModel(["blur", "itemStyle"]).getItemStyle(), w = t.getModel(["select", "itemStyle"]).getItemStyle(), d = t.get(["itemStyle", "borderRadius"]), C = G(t), b = t.getModel("emphasis"), _ = b.get("focus"), N = b.get("blurScope"), T = b.get("disabled"), h = s ? [o.mapDimension("x"), o.mapDimension("y"), o.mapDimension("value")] : [o.mapDimension("time"), o.mapDimension("value")], l = i; l < g; l++) {
        var p = void 0, x = o.getItemVisual(l, "style");
        if (s) {
          var V = o.get(h[0], l), A = o.get(h[1], l);
          if (isNaN(o.get(h[2], l)) || isNaN(V) || isNaN(A) || V < c[0] || V > c[1] || A < y[0] || A > y[1])
            continue;
          var H = a.dataToPoint([V, A]);
          p = new L({
            shape: {
              x: H[0] - v / 2,
              y: H[1] - u / 2,
              width: v,
              height: u
            },
            style: x
          });
        } else {
          if (isNaN(o.get(h[1], l)))
            continue;
          p = new L({
            z2: 1,
            shape: a.dataToRect([o.get(h[0], l)]).contentShape,
            style: x
          });
        }
        if (o.hasItemOption) {
          var R = o.getItemModel(l), D = R.getModel("emphasis");
          S = D.getModel("itemStyle").getItemStyle(), O = R.getModel(["blur", "itemStyle"]).getItemStyle(), w = R.getModel(["select", "itemStyle"]).getItemStyle(), d = R.get(["itemStyle", "borderRadius"]), _ = D.get("focus"), N = D.get("blurScope"), T = D.get("disabled"), C = G(R);
        }
        p.shape.r = d;
        var z = t.getRawValue(l), P = "-";
        z && z[2] != null && (P = z[2] + ""), J(p, C, {
          labelFetcher: t,
          labelDataIndex: l,
          defaultOpacity: x.opacity,
          defaultText: P
        }), p.ensureState("emphasis").style = S, p.ensureState("blur").style = O, p.ensureState("select").style = w, F(p, _, N, T), p.incremental = r, r && (p.states.emphasis.hoverLayer = !0), E.add(p), o.setItemGraphicEl(l, p), this._progressiveEls && this._progressiveEls.push(p);
      }
    }, e.prototype._renderOnGeo = function(t, n, i, g) {
      var r = i.targetVisuals.inRange, a = i.targetVisuals.outOfRange, s = n.getData(), v = this._hmLayer || this._hmLayer || new Z();
      v.blurSize = n.get("blurSize"), v.pointSize = n.get("pointSize"), v.minOpacity = n.get("minOpacity"), v.maxOpacity = n.get("maxOpacity");
      var u = t.getViewRect().clone(), c = t.getRoamTransform();
      u.applyTransform(c);
      var y = Math.max(u.x, 0), f = Math.max(u.y, 0), I = Math.min(u.width + u.x, g.getWidth()), E = Math.min(u.height + u.y, g.getHeight()), o = I - y, S = E - f, O = [s.mapDimension("lng"), s.mapDimension("lat"), s.mapDimension("value")], w = s.mapArray(O, function(_, N, T) {
        var h = t.dataToPoint([_, N]);
        return h[0] -= y, h[1] -= f, h.push(T), h;
      }), d = i.getExtent(), C = i.type === "visualMap.continuous" ? U(d, i.option.range) : Q(d, i.getPieceList(), i.option.selected);
      v.update(w, o, S, r.color.getNormalizer(), {
        inRange: r.color.getColorMapper(),
        outOfRange: a.color.getColorMapper()
      }, C);
      var b = new K({
        style: {
          width: o,
          height: S,
          x: y,
          y: f,
          image: v.canvas
        },
        silent: !0
      });
      this.group.add(b);
    }, e.type = "heatmap", e;
  }(j)
);
const mt = X;
export {
  mt as default
};
