import { __extends as V } from "../../../../tslib/tslib.es6.js";
import { createSymbol as E, normalizeSymbolOffset as w, normalizeSymbolSize as x } from "../../util/symbol.js";
import { getECData as N } from "../../util/innerStore.js";
import { enterEmphasis as R, leaveEmphasis as Z, toggleHoverEmphasis as F } from "../../util/states.js";
import { getDefaultLabel as k } from "./labelHelper.js";
import { extend as D } from "../../../../zrender/lib/core/util.js";
import { getLabelStatesModels as B, setLabelStyle as G } from "../../label/labelStyle.js";
import H from "../../../../zrender/lib/graphic/Image.js";
import { updateProps as K, saveOldStyle as $, initProps as j, removeElement as T } from "../../animation/basicTransition.js";
import q from "../../../../zrender/lib/graphic/Group.js";
var J = (
  /** @class */
  function(g) {
    V(o, g);
    function o(t, a, i, l) {
      var s = g.call(this) || this;
      return s.updateData(t, a, i, l), s;
    }
    return o.prototype._createSymbol = function(t, a, i, l, s) {
      this.removeAll();
      var e = E(t, -1, -1, 2, 2, null, s);
      e.attr({
        z2: 100,
        culling: !0,
        scaleX: l[0] / 2,
        scaleY: l[1] / 2
      }), e.drift = Q, this._symbolType = t, this.add(e);
    }, o.prototype.stopSymbolAnimation = function(t) {
      this.childAt(0).stopAnimation(null, t);
    }, o.prototype.getSymbolType = function() {
      return this._symbolType;
    }, o.prototype.getSymbolPath = function() {
      return this.childAt(0);
    }, o.prototype.highlight = function() {
      R(this.childAt(0));
    }, o.prototype.downplay = function() {
      Z(this.childAt(0));
    }, o.prototype.setZ = function(t, a) {
      var i = this.childAt(0);
      i.zlevel = t, i.z = a;
    }, o.prototype.setDraggable = function(t, a) {
      var i = this.childAt(0);
      i.draggable = t, i.cursor = !a && t ? "move" : i.cursor;
    }, o.prototype.updateData = function(t, a, i, l) {
      this.silent = !1;
      var s = t.getItemVisual(a, "symbol") || "circle", e = t.hostModel, m = o.getSymbolSize(t, a), h = s !== this._symbolType, y = l && l.disableAnimation;
      if (h) {
        var c = t.getItemVisual(a, "symbolKeepAspect");
        this._createSymbol(s, t, a, m, c);
      } else {
        var r = this.childAt(0);
        r.silent = !1;
        var n = {
          scaleX: m[0] / 2,
          scaleY: m[1] / 2
        };
        y ? r.attr(n) : K(r, n, e, a), $(r);
      }
      if (this._updateCommon(t, a, m, i, l), h) {
        var r = this.childAt(0);
        if (!y) {
          var n = {
            scaleX: this._sizeX,
            scaleY: this._sizeY,
            style: {
              // Always fadeIn. Because it has fadeOut animation when symbol is removed..
              opacity: r.style.opacity
            }
          };
          r.scaleX = r.scaleY = 0, r.style.opacity = 0, j(r, n, e, a);
        }
      }
      y && this.childAt(0).stopAnimation("leave");
    }, o.prototype._updateCommon = function(t, a, i, l, s) {
      var e = this.childAt(0), m = t.hostModel, h, y, c, r, n, d, I, u, S;
      if (l && (h = l.emphasisItemStyle, y = l.blurItemStyle, c = l.selectItemStyle, r = l.focus, n = l.blurScope, I = l.labelStatesModels, u = l.hoverScale, S = l.cursorStyle, d = l.emphasisDisabled), !l || t.hasItemOption) {
        var f = l && l.itemModel ? l.itemModel : t.getItemModel(a), v = f.getModel("emphasis");
        h = v.getModel("itemStyle").getItemStyle(), c = f.getModel(["select", "itemStyle"]).getItemStyle(), y = f.getModel(["blur", "itemStyle"]).getItemStyle(), r = v.get("focus"), n = v.get("blurScope"), d = v.get("disabled"), I = B(f), u = v.getShallow("scale"), S = f.getShallow("cursor");
      }
      var L = t.getItemVisual(a, "symbolRotate");
      e.attr("rotation", (L || 0) * Math.PI / 180 || 0);
      var z = w(t.getItemVisual(a, "symbolOffset"), i);
      z && (e.x = z[0], e.y = z[1]), S && e.attr("cursor", S);
      var b = t.getItemVisual(a, "style"), O = b.fill;
      if (e instanceof H) {
        var p = e.style;
        e.useStyle(D({
          // TODO other properties like x, y ?
          image: p.image,
          x: p.x,
          y: p.y,
          width: p.width,
          height: p.height
        }, b));
      } else
        e.__isEmptyBrush ? e.useStyle(D({}, b)) : e.useStyle(b), e.style.decal = null, e.setColor(O, s && s.symbolInnerColor), e.style.strokeNoScale = !0;
      var Y = t.getItemVisual(a, "liftZ"), _ = this._z2;
      Y != null ? _ == null && (this._z2 = e.z2, e.z2 += Y) : _ != null && (e.z2 = _, this._z2 = null);
      var M = s && s.useNameLabel;
      G(e, I, {
        labelFetcher: m,
        labelDataIndex: a,
        defaultText: P,
        inheritColor: O,
        defaultOpacity: b.opacity
      });
      function P(X) {
        return M ? t.getName(X) : k(t, X);
      }
      this._sizeX = i[0] / 2, this._sizeY = i[1] / 2;
      var A = e.ensureState("emphasis");
      A.style = h, e.ensureState("select").style = c, e.ensureState("blur").style = y;
      var C = u == null || u === !0 ? Math.max(1.1, 3 / this._sizeY) : isFinite(u) && u > 0 ? +u : 1;
      A.scaleX = this._sizeX * C, A.scaleY = this._sizeY * C, this.setSymbolScale(1), F(this, r, n, d);
    }, o.prototype.setSymbolScale = function(t) {
      this.scaleX = this.scaleY = t;
    }, o.prototype.fadeOut = function(t, a, i) {
      var l = this.childAt(0), s = N(this).dataIndex, e = i && i.animation;
      if (this.silent = l.silent = !0, i && i.fadeLabel) {
        var m = l.getTextContent();
        m && T(m, {
          style: {
            opacity: 0
          }
        }, a, {
          dataIndex: s,
          removeOpt: e,
          cb: function() {
            l.removeTextContent();
          }
        });
      } else
        l.removeTextContent();
      T(l, {
        style: {
          opacity: 0
        },
        scaleX: 0,
        scaleY: 0
      }, a, {
        dataIndex: s,
        cb: t,
        removeOpt: e
      });
    }, o.getSymbolSize = function(t, a) {
      return x(t.getItemVisual(a, "symbolSize"));
    }, o;
  }(q)
);
function Q(g, o) {
  this.parent.drift(g, o);
}
const mt = J;
export {
  mt as default
};
