import { __extends as ht } from "../../../../tslib/tslib.es6.js";
import { bind as ut, defaults as Z, isFunction as T, isNumber as ft, map as pt, each as it } from "../../../../zrender/lib/core/util.js";
import gt from "../helper/SymbolDraw.js";
import ot from "../helper/Symbol.js";
import mt from "./lineAnimationDiff.js";
import { queryDataIndex as q, interpolateRawValues as ct } from "../../util/model.js";
import { ECPolyline as yt, ECPolygon as dt } from "./poly.js";
import F from "../../view/Chart.js";
import { prepareDataCoordInfo as _t, getStackedOnPoint as St } from "./helper.js";
import { createGridClipPath as bt, createPolarClipPath as xt } from "../helper/createClipPathFromCoordSys.js";
import { isCoordinateSystemType as It } from "../../coord/CoordinateSystem.js";
import { setStatesStylesFromModel as $, toggleHoverEmphasis as j, setStatesFlag as K, SPECIAL_STATES as Q } from "../../util/states.js";
import { setLabelStyle as wt, getLabelStatesModels as Pt, labelInner as Lt } from "../../label/labelStyle.js";
import { getDefaultInterpolatedLabel as Dt, getDefaultLabel as At } from "../helper/labelHelper.js";
import { getECData as V } from "../../util/innerStore.js";
import { createFloat32Array as Ct } from "../../util/vendor.js";
import { convertToColorString as Y } from "../../util/format.js";
import { lerp as Nt } from "../../../../zrender/lib/tool/color.js";
import kt from "../../../../zrender/lib/graphic/Group.js";
import { initProps as Et, updateProps as M } from "../../animation/basicTransition.js";
import Ot from "../../../../zrender/lib/graphic/Text.js";
import Gt from "../../../../zrender/lib/graphic/LinearGradient.js";
function tt(s, l) {
  if (s.length === l.length) {
    for (var t = 0; t < s.length; t++)
      if (s[t] !== l[t])
        return;
    return !0;
  }
}
function et(s) {
  for (var l = 1 / 0, t = 1 / 0, o = -1 / 0, n = -1 / 0, e = 0; e < s.length; ) {
    var a = s[e++], i = s[e++];
    isNaN(a) || (l = Math.min(a, l), o = Math.max(a, o)), isNaN(i) || (t = Math.min(i, t), n = Math.max(i, n));
  }
  return [[l, t], [o, n]];
}
function at(s, l) {
  var t = et(s), o = t[0], n = t[1], e = et(l), a = e[0], i = e[1];
  return Math.max(Math.abs(o[0] - a[0]), Math.abs(o[1] - a[1]), Math.abs(n[0] - i[0]), Math.abs(n[1] - i[1]));
}
function rt(s) {
  return ft(s) ? s : s ? 0.5 : 0;
}
function Tt(s, l, t) {
  if (!t.valueDim)
    return [];
  for (var o = l.count(), n = Ct(o * 2), e = 0; e < o; e++) {
    var a = St(t, s, l, e);
    n[e * 2] = a[0], n[e * 2 + 1] = a[1];
  }
  return n;
}
function N(s, l, t, o, n) {
  var e = t.getBaseAxis(), a = e.dim === "x" || e.dim === "radius" ? 0 : 1, i = [], h = 0, r = [], v = [], f = [], u = [];
  if (n) {
    for (h = 0; h < s.length; h += 2) {
      var g = l || s;
      !isNaN(g[h]) && !isNaN(g[h + 1]) && u.push(s[h], s[h + 1]);
    }
    s = u;
  }
  for (h = 0; h < s.length - 2; h += 2)
    switch (f[0] = s[h + 2], f[1] = s[h + 3], v[0] = s[h], v[1] = s[h + 1], i.push(v[0], v[1]), o) {
      case "end":
        r[a] = f[a], r[1 - a] = v[1 - a], i.push(r[0], r[1]);
        break;
      case "middle":
        var m = (v[a] + f[a]) / 2, p = [];
        r[a] = p[a] = m, r[1 - a] = v[1 - a], p[1 - a] = f[1 - a], i.push(r[0], r[1]), i.push(p[0], p[1]);
        break;
      default:
        r[a] = v[a], r[1 - a] = f[1 - a], i.push(r[0], r[1]);
    }
  return i.push(s[h++], s[h++]), i;
}
function Ft(s, l) {
  var t = [], o = s.length, n, e;
  function a(v, f, u) {
    var g = v.coord, m = (u - g) / (f.coord - g), p = Nt(m, [v.color, f.color]);
    return {
      coord: u,
      color: p
    };
  }
  for (var i = 0; i < o; i++) {
    var h = s[i], r = h.coord;
    if (r < 0)
      n = h;
    else if (r > l) {
      e ? t.push(a(e, h, l)) : n && t.push(a(n, h, 0), a(n, h, l));
      break;
    } else
      n && (t.push(a(n, h, 0)), n = null), t.push(h), e = h;
  }
  return t;
}
function Vt(s, l, t) {
  var o = s.getVisual("visualMeta");
  if (!(!o || !o.length || !s.count()) && l.type === "cartesian2d") {
    for (var n, e, a = o.length - 1; a >= 0; a--) {
      var i = s.getDimensionInfo(o[a].dimension);
      if (n = i && i.coordDim, n === "x" || n === "y") {
        e = o[a];
        break;
      }
    }
    if (e) {
      var h = l.getAxis(n), r = pt(e.stops, function(c) {
        return {
          coord: h.toGlobalCoord(h.dataToCoord(c.value)),
          color: c.color
        };
      }), v = r.length, f = e.outerColors.slice();
      v && r[0].coord > r[v - 1].coord && (r.reverse(), f.reverse());
      var u = Ft(r, n === "x" ? t.getWidth() : t.getHeight()), g = u.length;
      if (!g && v)
        return r[0].coord < 0 ? f[1] ? f[1] : r[v - 1].color : f[0] ? f[0] : r[0].color;
      var m = 10, p = u[0].coord - m, S = u[g - 1].coord + m, d = S - p;
      if (d < 1e-3)
        return "transparent";
      it(u, function(c) {
        c.offset = (c.coord - p) / d;
      }), u.push({
        // NOTE: inRangeStopLen may still be 0 if stoplen is zero.
        offset: g ? u[g - 1].offset : 0.5,
        color: f[1] || "transparent"
      }), u.unshift({
        offset: g ? u[0].offset : 0.5,
        color: f[0] || "transparent"
      });
      var y = new Gt(0, 0, 0, 0, u, !0);
      return y[n] = p, y[n + "2"] = S, y;
    }
  }
}
function zt(s, l, t) {
  var o = s.get("showAllSymbol"), n = o === "auto";
  if (!(o && !n)) {
    var e = t.getAxesByScale("ordinal")[0];
    if (e && !(n && Ht(e, l))) {
      var a = l.mapDimension(e.dim), i = {};
      return it(e.getViewLabels(), function(h) {
        var r = e.scale.getRawOrdinalNumber(h.tickValue);
        i[r] = 1;
      }), function(h) {
        return !i.hasOwnProperty(l.get(a, h));
      };
    }
  }
}
function Ht(s, l) {
  var t = s.getExtent(), o = Math.abs(t[1] - t[0]) / s.scale.count();
  isNaN(o) && (o = 0);
  for (var n = l.count(), e = Math.max(1, Math.round(n / 5)), a = 0; a < n; a += e)
    if (ot.getSymbolSize(
      l,
      a
      // Only for cartesian, where `isHorizontal` exists.
    )[s.isHorizontal() ? 1 : 0] * 1.5 > o)
      return !1;
  return !0;
}
function Bt(s, l) {
  return isNaN(s) || isNaN(l);
}
function Rt(s) {
  for (var l = s.length / 2; l > 0 && Bt(s[l * 2 - 2], s[l * 2 - 1]); l--)
    ;
  return l - 1;
}
function nt(s, l) {
  return [s[l * 2], s[l * 2 + 1]];
}
function Xt(s, l, t) {
  for (var o = s.length / 2, n = t === "x" ? 0 : 1, e, a, i = 0, h = -1, r = 0; r < o; r++)
    if (a = s[r * 2 + n], !(isNaN(a) || isNaN(s[r * 2 + 1 - n]))) {
      if (r === 0) {
        e = a;
        continue;
      }
      if (e <= l && a >= l || e >= l && a <= l) {
        h = r;
        break;
      }
      i = r, e = a;
    }
  return {
    range: [i, h],
    t: (l - e) / (a - e)
  };
}
function lt(s) {
  if (s.get(["endLabel", "show"]))
    return !0;
  for (var l = 0; l < Q.length; l++)
    if (s.get([Q[l], "endLabel", "show"]))
      return !0;
  return !1;
}
function z(s, l, t, o) {
  if (It(l, "cartesian2d")) {
    var n = o.getModel("endLabel"), e = n.get("valueAnimation"), a = o.getData(), i = {
      lastFrameIndex: 0
    }, h = lt(o) ? function(g, m) {
      s._endLabelOnDuring(g, m, a, i, e, n, l);
    } : null, r = l.getBaseAxis().isHorizontal(), v = bt(l, t, o, function() {
      var g = s._endLabel;
      g && t && i.originalX != null && g.attr({
        x: i.originalX,
        y: i.originalY
      });
    }, h);
    if (!o.get("clip", !0)) {
      var f = v.shape, u = Math.max(f.width, f.height);
      r ? (f.y -= u, f.height += u * 2) : (f.x -= u, f.width += u * 2);
    }
    return h && h(1, v), v;
  } else
    return xt(l, t, o);
}
function Ut(s, l) {
  var t = l.getBaseAxis(), o = t.isHorizontal(), n = t.inverse, e = o ? n ? "right" : "left" : "center", a = o ? "middle" : n ? "top" : "bottom";
  return {
    normal: {
      align: s.get("align") || e,
      verticalAlign: s.get("verticalAlign") || a
    }
  };
}
var Wt = (
  /** @class */
  function(s) {
    ht(l, s);
    function l() {
      return s !== null && s.apply(this, arguments) || this;
    }
    return l.prototype.init = function() {
      var t = new kt(), o = new gt();
      this.group.add(o.group), this._symbolDraw = o, this._lineGroup = t, this._changePolyState = ut(this._changePolyState, this);
    }, l.prototype.render = function(t, o, n) {
      var e = t.coordinateSystem, a = this.group, i = t.getData(), h = t.getModel("lineStyle"), r = t.getModel("areaStyle"), v = i.getLayout("points") || [], f = e.type === "polar", u = this._coordSys, g = this._symbolDraw, m = this._polyline, p = this._polygon, S = this._lineGroup, d = !o.ssr && t.get("animation"), y = !r.isEmpty(), c = r.get("origin"), L = _t(e, i, c), _ = y && Tt(e, i, L), x = t.get("showSymbol"), P = t.get("connectNulls"), A = x && !f && zt(t, i, e), b = this._data;
      b && b.eachItemGraphicEl(function(C, vt) {
        C.__temp && (a.remove(C), b.setItemGraphicEl(vt, null));
      }), x || g.remove(), a.add(S);
      var I = f ? !1 : t.get("step"), w;
      e && e.getArea && t.get("clip", !0) && (w = e.getArea(), w.width != null ? (w.x -= 0.1, w.y -= 0.1, w.width += 0.2, w.height += 0.2) : w.r0 && (w.r0 -= 0.5, w.r += 0.5)), this._clipShapeForSymbol = w;
      var D = Vt(i, e, n) || i.getVisual("style")[i.getVisual("drawType")];
      if (!(m && u.type === e.type && I === this._step))
        x && g.updateData(i, {
          isIgnore: A,
          clipShape: w,
          disableAnimation: !0,
          getSymbolPoint: function(C) {
            return [v[C * 2], v[C * 2 + 1]];
          }
        }), d && this._initSymbolLabelAnimation(i, e, w), I && (_ && (_ = N(_, v, e, I, P)), v = N(v, null, e, I, P)), m = this._newPolyline(v), y ? p = this._newPolygon(v, _) : p && (S.remove(p), p = this._polygon = null), f || this._initOrUpdateEndLabel(t, e, Y(D)), S.setClipPath(z(this, e, !0, t));
      else {
        y && !p ? p = this._newPolygon(v, _) : p && !y && (S.remove(p), p = this._polygon = null), f || this._initOrUpdateEndLabel(t, e, Y(D));
        var O = S.getClipPath();
        if (O) {
          var G = z(this, e, !1, t);
          Et(O, {
            shape: G.shape
          }, t);
        } else
          S.setClipPath(z(this, e, !0, t));
        x && g.updateData(i, {
          isIgnore: A,
          clipShape: w,
          disableAnimation: !0,
          getSymbolPoint: function(C) {
            return [v[C * 2], v[C * 2 + 1]];
          }
        }), (!tt(this._stackedOnPoints, _) || !tt(this._points, v)) && (d ? this._doUpdateAnimation(i, _, e, n, I, c, P) : (I && (_ && (_ = N(_, v, e, I, P)), v = N(v, null, e, I, P)), m.setShape({
          points: v
        }), p && p.setShape({
          points: v,
          stackedOnPoints: _
        })));
      }
      var k = t.getModel("emphasis"), E = k.get("focus"), H = k.get("blurScope"), B = k.get("disabled");
      if (m.useStyle(Z(
        // Use color in lineStyle first
        h.getLineStyle(),
        {
          fill: "none",
          stroke: D,
          lineJoin: "bevel"
        }
      )), $(m, t, "lineStyle"), m.style.lineWidth > 0 && t.get(["emphasis", "lineStyle", "width"]) === "bolder") {
        var st = m.getState("emphasis").style;
        st.lineWidth = +m.style.lineWidth + 1;
      }
      V(m).seriesIndex = t.seriesIndex, j(m, E, H, B);
      var R = rt(t.get("smooth")), X = t.get("smoothMonotone");
      if (m.setShape({
        smooth: R,
        smoothMonotone: X,
        connectNulls: P
      }), p) {
        var U = i.getCalculationInfo("stackedOnSeries"), W = 0;
        p.useStyle(Z(r.getAreaStyle(), {
          fill: D,
          opacity: 0.7,
          lineJoin: "bevel",
          decal: i.getVisual("style").decal
        })), U && (W = rt(U.get("smooth"))), p.setShape({
          smooth: R,
          stackedOnSmooth: W,
          smoothMonotone: X,
          connectNulls: P
        }), $(p, t, "areaStyle"), V(p).seriesIndex = t.seriesIndex, j(p, E, H, B);
      }
      var J = this._changePolyState;
      i.eachItemGraphicEl(function(C) {
        C && (C.onHoverStateChange = J);
      }), this._polyline.onHoverStateChange = J, this._data = i, this._coordSys = e, this._stackedOnPoints = _, this._points = v, this._step = I, this._valueOrigin = c, t.get("triggerLineEvent") && (this.packEventData(t, m), p && this.packEventData(t, p));
    }, l.prototype.packEventData = function(t, o) {
      V(o).eventData = {
        componentType: "series",
        componentSubType: "line",
        componentIndex: t.componentIndex,
        seriesIndex: t.seriesIndex,
        seriesName: t.name,
        seriesType: "line"
      };
    }, l.prototype.highlight = function(t, o, n, e) {
      var a = t.getData(), i = q(a, e);
      if (this._changePolyState("emphasis"), !(i instanceof Array) && i != null && i >= 0) {
        var h = a.getLayout("points"), r = a.getItemGraphicEl(i);
        if (!r) {
          var v = h[i * 2], f = h[i * 2 + 1];
          if (isNaN(v) || isNaN(f) || this._clipShapeForSymbol && !this._clipShapeForSymbol.contain(v, f))
            return;
          var u = t.get("zlevel") || 0, g = t.get("z") || 0;
          r = new ot(a, i), r.x = v, r.y = f, r.setZ(u, g);
          var m = r.getSymbolPath().getTextContent();
          m && (m.zlevel = u, m.z = g, m.z2 = this._polyline.z2 + 1), r.__temp = !0, a.setItemGraphicEl(i, r), r.stopSymbolAnimation(!0), this.group.add(r);
        }
        r.highlight();
      } else
        F.prototype.highlight.call(this, t, o, n, e);
    }, l.prototype.downplay = function(t, o, n, e) {
      var a = t.getData(), i = q(a, e);
      if (this._changePolyState("normal"), i != null && i >= 0) {
        var h = a.getItemGraphicEl(i);
        h && (h.__temp ? (a.setItemGraphicEl(i, null), this.group.remove(h)) : h.downplay());
      } else
        F.prototype.downplay.call(this, t, o, n, e);
    }, l.prototype._changePolyState = function(t) {
      var o = this._polygon;
      K(this._polyline, t), o && K(o, t);
    }, l.prototype._newPolyline = function(t) {
      var o = this._polyline;
      return o && this._lineGroup.remove(o), o = new yt({
        shape: {
          points: t
        },
        segmentIgnoreThreshold: 2,
        z2: 10
      }), this._lineGroup.add(o), this._polyline = o, o;
    }, l.prototype._newPolygon = function(t, o) {
      var n = this._polygon;
      return n && this._lineGroup.remove(n), n = new dt({
        shape: {
          points: t,
          stackedOnPoints: o
        },
        segmentIgnoreThreshold: 2
      }), this._lineGroup.add(n), this._polygon = n, n;
    }, l.prototype._initSymbolLabelAnimation = function(t, o, n) {
      var e, a, i = o.getBaseAxis(), h = i.inverse;
      o.type === "cartesian2d" ? (e = i.isHorizontal(), a = !1) : o.type === "polar" && (e = i.dim === "angle", a = !0);
      var r = t.hostModel, v = r.get("animationDuration");
      T(v) && (v = v(null));
      var f = r.get("animationDelay") || 0, u = T(f) ? f(null) : f;
      t.eachItemGraphicEl(function(g, m) {
        var p = g;
        if (p) {
          var S = [g.x, g.y], d = void 0, y = void 0, c = void 0;
          if (n)
            if (a) {
              var L = n, _ = o.pointToCoord(S);
              e ? (d = L.startAngle, y = L.endAngle, c = -_[1] / 180 * Math.PI) : (d = L.r0, y = L.r, c = _[0]);
            } else {
              var x = n;
              e ? (d = x.x, y = x.x + x.width, c = g.x) : (d = x.y + x.height, y = x.y, c = g.y);
            }
          var P = y === d ? 0 : (c - d) / (y - d);
          h && (P = 1 - P);
          var A = T(f) ? f(m) : v * P + u, b = p.getSymbolPath(), I = b.getTextContent();
          p.attr({
            scaleX: 0,
            scaleY: 0
          }), p.animateTo({
            scaleX: 1,
            scaleY: 1
          }, {
            duration: 200,
            setToFinal: !0,
            delay: A
          }), I && I.animateFrom({
            style: {
              opacity: 0
            }
          }, {
            duration: 300,
            delay: A
          }), b.disableLabelAnimation = !0;
        }
      });
    }, l.prototype._initOrUpdateEndLabel = function(t, o, n) {
      var e = t.getModel("endLabel");
      if (lt(t)) {
        var a = t.getData(), i = this._polyline, h = a.getLayout("points");
        if (!h) {
          i.removeTextContent(), this._endLabel = null;
          return;
        }
        var r = this._endLabel;
        r || (r = this._endLabel = new Ot({
          z2: 200
          // should be higher than item symbol
        }), r.ignoreClip = !0, i.setTextContent(this._endLabel), i.disableLabelAnimation = !0);
        var v = Rt(h);
        v >= 0 && (wt(i, Pt(t, "endLabel"), {
          inheritColor: n,
          labelFetcher: t,
          labelDataIndex: v,
          defaultText: function(f, u, g) {
            return g != null ? Dt(a, g) : At(a, f);
          },
          enableTextSetter: !0
        }, Ut(e, o)), i.textConfig.position = null);
      } else
        this._endLabel && (this._polyline.removeTextContent(), this._endLabel = null);
    }, l.prototype._endLabelOnDuring = function(t, o, n, e, a, i, h) {
      var r = this._endLabel, v = this._polyline;
      if (r) {
        t < 1 && e.originalX == null && (e.originalX = r.x, e.originalY = r.y);
        var f = n.getLayout("points"), u = n.hostModel, g = u.get("connectNulls"), m = i.get("precision"), p = i.get("distance") || 0, S = h.getBaseAxis(), d = S.isHorizontal(), y = S.inverse, c = o.shape, L = y ? d ? c.x : c.y + c.height : d ? c.x + c.width : c.y, _ = (d ? p : 0) * (y ? -1 : 1), x = (d ? 0 : -p) * (y ? -1 : 1), P = d ? "x" : "y", A = Xt(f, L, P), b = A.range, I = b[1] - b[0], w = void 0;
        if (I >= 1) {
          if (I > 1 && !g) {
            var D = nt(f, b[0]);
            r.attr({
              x: D[0] + _,
              y: D[1] + x
            }), a && (w = u.getRawValue(b[0]));
          } else {
            var D = v.getPointOn(L, P);
            D && r.attr({
              x: D[0] + _,
              y: D[1] + x
            });
            var O = u.getRawValue(b[0]), G = u.getRawValue(b[1]);
            a && (w = ct(n, m, O, G, A.t));
          }
          e.lastFrameIndex = b[0];
        } else {
          var k = t === 1 || e.lastFrameIndex > 0 ? b[0] : 0, D = nt(f, k);
          a && (w = u.getRawValue(k)), r.attr({
            x: D[0] + _,
            y: D[1] + x
          });
        }
        if (a) {
          var E = Lt(r);
          typeof E.setLabelText == "function" && E.setLabelText(w);
        }
      }
    }, l.prototype._doUpdateAnimation = function(t, o, n, e, a, i, h) {
      var r = this._polyline, v = this._polygon, f = t.hostModel, u = mt(this._data, t, this._stackedOnPoints, o, this._coordSys, n, this._valueOrigin), g = u.current, m = u.stackedOnCurrent, p = u.next, S = u.stackedOnNext;
      if (a && (m = N(u.stackedOnCurrent, u.current, n, a, h), g = N(u.current, null, n, a, h), S = N(u.stackedOnNext, u.next, n, a, h), p = N(u.next, null, n, a, h)), at(g, p) > 3e3 || v && at(m, S) > 3e3) {
        r.stopAnimation(), r.setShape({
          points: p
        }), v && (v.stopAnimation(), v.setShape({
          points: p,
          stackedOnPoints: S
        }));
        return;
      }
      r.shape.__points = u.current, r.shape.points = g;
      var d = {
        shape: {
          points: p
        }
      };
      u.current !== g && (d.shape.__points = u.next), r.stopAnimation(), M(r, d, f), v && (v.setShape({
        // Reuse the points with polyline.
        points: g,
        stackedOnPoints: m
      }), v.stopAnimation(), M(v, {
        shape: {
          stackedOnPoints: S
        }
      }, f), r.shape.points !== v.shape.points && (v.shape.points = r.shape.points));
      for (var y = [], c = u.status, L = 0; L < c.length; L++) {
        var _ = c[L].cmd;
        if (_ === "=") {
          var x = t.getItemGraphicEl(c[L].idx1);
          x && y.push({
            el: x,
            ptIdx: L
            // Index of points
          });
        }
      }
      r.animators && r.animators.length && r.animators[0].during(function() {
        v && v.dirtyShape();
        for (var P = r.shape.__points, A = 0; A < y.length; A++) {
          var b = y[A].el, I = y[A].ptIdx * 2;
          b.x = P[I], b.y = P[I + 1], b.markRedraw();
        }
      });
    }, l.prototype.remove = function(t) {
      var o = this.group, n = this._data;
      this._lineGroup.removeAll(), this._symbolDraw.remove(!0), n && n.eachItemGraphicEl(function(e, a) {
        e.__temp && (o.remove(e), n.setItemGraphicEl(a, null));
      }), this._polyline = this._polygon = this._coordSys = this._points = this._stackedOnPoints = this._endLabel = this._data = null;
    }, l.type = "line", l;
  }(F)
);
const pe = Wt;
export {
  pe as default
};
