import { __extends as c } from "../../../../tslib/tslib.es6.js";
import m from "../../model/Series.js";
import C from "../../data/SeriesData.js";
import { concatArray as g, isNumber as _, map as A, mergeAll as M } from "../../../../zrender/lib/core/util.js";
import { createTooltipMarkup as w } from "../../component/tooltip/tooltipMarkup.js";
var F = typeof Uint32Array > "u" ? Array : Uint32Array, I = typeof Float64Array > "u" ? Array : Float64Array;
function u(l) {
  var o = l.data;
  o && o[0] && o[0][0] && o[0][0].coord && (l.data = A(o, function(t) {
    var e = [t[0].coord, t[1].coord], a = {
      coords: e
    };
    return t[0].name && (a.fromName = t[0].name), t[1].name && (a.toName = t[1].name), M([a, t[0], t[1]]);
  }));
}
var O = (
  /** @class */
  function(l) {
    c(o, l);
    function o() {
      var t = l !== null && l.apply(this, arguments) || this;
      return t.type = o.type, t.visualStyleAccessPath = "lineStyle", t.visualDrawType = "stroke", t;
    }
    return o.prototype.init = function(t) {
      t.data = t.data || [], u(t);
      var e = this._processFlatCoordsArray(t.data);
      this._flatCoords = e.flatCoords, this._flatCoordsOffset = e.flatCoordsOffset, e.flatCoords && (t.data = new Float32Array(e.count)), l.prototype.init.apply(this, arguments);
    }, o.prototype.mergeOption = function(t) {
      if (u(t), t.data) {
        var e = this._processFlatCoordsArray(t.data);
        this._flatCoords = e.flatCoords, this._flatCoordsOffset = e.flatCoordsOffset, e.flatCoords && (t.data = new Float32Array(e.count));
      }
      l.prototype.mergeOption.apply(this, arguments);
    }, o.prototype.appendData = function(t) {
      var e = this._processFlatCoordsArray(t.data);
      e.flatCoords && (this._flatCoords ? (this._flatCoords = g(this._flatCoords, e.flatCoords), this._flatCoordsOffset = g(this._flatCoordsOffset, e.flatCoordsOffset)) : (this._flatCoords = e.flatCoords, this._flatCoordsOffset = e.flatCoordsOffset), t.data = new Float32Array(e.count)), this.getRawData().appendData(t.data);
    }, o.prototype._getCoordsFromItemModel = function(t) {
      var e = this.getData().getItemModel(t), a = e.option instanceof Array ? e.option : e.getShallow("coords");
      return a;
    }, o.prototype.getLineCoordsCount = function(t) {
      return this._flatCoordsOffset ? this._flatCoordsOffset[t * 2 + 1] : this._getCoordsFromItemModel(t).length;
    }, o.prototype.getLineCoords = function(t, e) {
      if (this._flatCoordsOffset) {
        for (var a = this._flatCoordsOffset[t * 2], n = this._flatCoordsOffset[t * 2 + 1], r = 0; r < n; r++)
          e[r] = e[r] || [], e[r][0] = this._flatCoords[a + r * 2], e[r][1] = this._flatCoords[a + r * 2 + 1];
        return n;
      } else {
        for (var s = this._getCoordsFromItemModel(t), r = 0; r < s.length; r++)
          e[r] = e[r] || [], e[r][0] = s[r][0], e[r][1] = s[r][1];
        return s.length;
      }
    }, o.prototype._processFlatCoordsArray = function(t) {
      var e = 0;
      if (this._flatCoords && (e = this._flatCoords.length), _(t[0])) {
        for (var a = t.length, n = new F(a), r = new I(a), s = 0, f = 0, i = 0, d = 0; d < a; ) {
          i++;
          var h = t[d++];
          n[f++] = s + e, n[f++] = h;
          for (var p = 0; p < h; p++) {
            var y = t[d++], v = t[d++];
            r[s++] = y, r[s++] = v;
          }
        }
        return {
          flatCoordsOffset: new Uint32Array(n.buffer, 0, f),
          flatCoords: r,
          count: i
        };
      }
      return {
        flatCoordsOffset: null,
        flatCoords: null,
        count: t.length
      };
    }, o.prototype.getInitialData = function(t, e) {
      var a = new C(["value"], this);
      return a.hasItemOption = !1, a.initData(t.data, [], function(n, r, s, f) {
        if (n instanceof Array)
          return NaN;
        a.hasItemOption = !0;
        var i = n.value;
        if (i != null)
          return i instanceof Array ? i[f] : i;
      }), a;
    }, o.prototype.formatTooltip = function(t, e, a) {
      var n = this.getData(), r = n.getItemModel(t), s = r.get("name");
      if (s)
        return s;
      var f = r.get("fromName"), i = r.get("toName"), d = [];
      return f != null && d.push(f), i != null && d.push(i), w("nameValue", {
        name: d.join(" > ")
      });
    }, o.prototype.preventIncremental = function() {
      return !!this.get(["effect", "show"]);
    }, o.prototype.getProgressive = function() {
      var t = this.option.progressive;
      return t ?? (this.option.large ? 1e4 : this.get("progressive"));
    }, o.prototype.getProgressiveThreshold = function() {
      var t = this.option.progressiveThreshold;
      return t ?? (this.option.large ? 2e4 : this.get("progressiveThreshold"));
    }, o.prototype.getZLevelKey = function() {
      var t = this.getModel("effect"), e = t.get("trailLength");
      return this.getData().count() > this.getProgressiveThreshold() ? this.id : t.get("show") && e > 0 ? e + "" : "";
    }, o.type = "series.lines", o.dependencies = ["grid", "polar", "geo", "calendar"], o.defaultOption = {
      coordinateSystem: "geo",
      // zlevel: 0,
      z: 2,
      legendHoverLink: !0,
      // Cartesian coordinate system
      xAxisIndex: 0,
      yAxisIndex: 0,
      symbol: ["none", "none"],
      symbolSize: [10, 10],
      // Geo coordinate system
      geoIndex: 0,
      effect: {
        show: !1,
        period: 4,
        constantSpeed: 0,
        symbol: "circle",
        symbolSize: 3,
        loop: !0,
        trailLength: 0.2
      },
      large: !1,
      // Available when large is true
      largeThreshold: 2e3,
      polyline: !1,
      clip: !0,
      label: {
        show: !1,
        position: "end"
        // distance: 5,
        // formatter: 标签文本格式器，同Tooltip.formatter，不支持异步回调
      },
      lineStyle: {
        opacity: 0.5
      }
    }, o;
  }(m)
);
const b = O;
export {
  b as default
};
