import { __extends as y } from "../../../../tslib/tslib.es6.js";
import { curry as h, createHashMap as v, each as S, merge as M } from "../../../../zrender/lib/core/util.js";
import D from "../helper/createSeriesDataSimply.js";
import b from "../../model/Series.js";
import N from "../../coord/geo/geoSourceManager.js";
import { makeSeriesEncodeForNameBased as w } from "../../data/helper/sourceHelper.js";
import { createTooltipMarkup as f } from "../../component/tooltip/tooltipMarkup.js";
import { createSymbol as x } from "../../util/symbol.js";
var I = (
  /** @class */
  function(d) {
    y(o, d);
    function o() {
      var e = d !== null && d.apply(this, arguments) || this;
      return e.type = o.type, e.needsDrawMap = !1, e.seriesGroup = [], e.getTooltipPosition = function(t) {
        if (t != null) {
          var a = this.getData().getName(t), i = this.coordinateSystem, r = i.getRegion(a);
          return r && i.dataToPoint(r.getCenter());
        }
      }, e;
    }
    return o.prototype.getInitialData = function(e) {
      for (var t = D(this, {
        coordDimensions: ["value"],
        encodeDefaulter: h(w, this)
      }), a = v(), i = [], r = 0, p = t.count(); r < p; r++) {
        var l = t.getName(r);
        a.set(l, r);
      }
      var s = N.load(this.getMapType(), this.option.nameMap, this.option.nameProperty);
      return S(s.regions, function(n) {
        var m = n.name, u = a.get(m), g = n.properties && n.properties.echartsStyle, c;
        u == null ? (c = {
          name: m
        }, i.push(c)) : c = t.getRawDataItem(u), g && M(c, g);
      }), t.appendData(i), t;
    }, o.prototype.getHostGeoModel = function() {
      var e = this.option.geoIndex;
      return e != null ? this.ecModel.getComponent("geo", e) : null;
    }, o.prototype.getMapType = function() {
      return (this.getHostGeoModel() || this).option.map;
    }, o.prototype.getRawValue = function(e) {
      var t = this.getData();
      return t.get(t.mapDimension("value"), e);
    }, o.prototype.getRegionModel = function(e) {
      var t = this.getData();
      return t.getItemModel(t.indexOfName(e));
    }, o.prototype.formatTooltip = function(e, t, a) {
      for (var i = this.getData(), r = this.getRawValue(e), p = i.getName(e), l = this.seriesGroup, s = [], n = 0; n < l.length; n++) {
        var m = l[n].originalData.indexOfName(p), u = i.mapDimension("value");
        isNaN(l[n].originalData.get(u, m)) || s.push(l[n].name);
      }
      return f("section", {
        header: s.join(", "),
        noHeader: !s.length,
        blocks: [f("nameValue", {
          name: p,
          value: r
        })]
      });
    }, o.prototype.setZoom = function(e) {
      this.option.zoom = e;
    }, o.prototype.setCenter = function(e) {
      this.option.center = e;
    }, o.prototype.getLegendIcon = function(e) {
      var t = e.icon || "roundRect", a = x(t, 0, 0, e.itemWidth, e.itemHeight, e.itemStyle.fill);
      return a.setStyle(e.itemStyle), a.style.stroke = "none", t.indexOf("empty") > -1 && (a.style.stroke = a.style.fill, a.style.fill = "#fff", a.style.lineWidth = 2), a;
    }, o.type = "series.map", o.dependencies = ["geo"], o.layoutMode = "box", o.defaultOption = {
      // 一级层叠
      // zlevel: 0,
      // 二级层叠
      z: 2,
      coordinateSystem: "geo",
      // map should be explicitly specified since ec3.
      map: "",
      // If `geoIndex` is not specified, a exclusive geo will be
      // created. Otherwise use the specified geo component, and
      // `map` and `mapType` are ignored.
      // geoIndex: 0,
      // 'center' | 'left' | 'right' | 'x%' | {number}
      left: "center",
      // 'center' | 'top' | 'bottom' | 'x%' | {number}
      top: "center",
      // right
      // bottom
      // width:
      // height
      // Aspect is width / height. Inited to be geoJson bbox aspect
      // This parameter is used for scale this aspect
      // Default value:
      // for geoSVG source: 1,
      // for geoJSON source: 0.75.
      aspectScale: null,
      // Layout with center and size
      // If you want to put map in a fixed size box with right aspect ratio
      // This two properties may be more convenient.
      // layoutCenter: [50%, 50%]
      // layoutSize: 100
      showLegendSymbol: !0,
      // Define left-top, right-bottom coords to control view
      // For example, [ [180, 90], [-180, -90] ],
      // higher priority than center and zoom
      boundingCoords: null,
      // Default on center of map
      center: null,
      zoom: 1,
      scaleLimit: null,
      selectedMode: !0,
      label: {
        show: !1,
        color: "#000"
      },
      // scaleLimit: null,
      itemStyle: {
        borderWidth: 0.5,
        borderColor: "#444",
        areaColor: "#eee"
      },
      emphasis: {
        label: {
          show: !0,
          color: "rgb(100,0,0)"
        },
        itemStyle: {
          areaColor: "rgba(255,215,0,0.8)"
        }
      },
      select: {
        label: {
          show: !0,
          color: "rgb(100,0,0)"
        },
        itemStyle: {
          color: "rgba(255,215,0,0.8)"
        }
      },
      nameProperty: "name"
    }, o;
  }(b)
);
const z = I;
export {
  z as default
};
