import { linearMap as K, parsePercent as L } from "../../util/number.js";
import { getLayoutRect as O } from "../../util/layout.js";
import { isArray as j } from "../../../../zrender/lib/core/util.js";
import { normalizeArcAngles as Q } from "../../../../zrender/lib/core/PathProxy.js";
import { makeInner as U } from "../../util/model.js";
var q = Math.PI * 2, B = Math.PI / 180;
function F(h, s) {
  return O(h.getBoxLayoutParams(), {
    width: s.getWidth(),
    height: s.getHeight()
  });
}
function X(h, s) {
  var u = F(h, s), a = h.get("center"), r = h.get("radius");
  j(r) || (r = [0, r]);
  var c = L(u.width, s.getWidth()), R = L(u.height, s.getHeight()), y = Math.min(c, R), x = L(r[0], y / 2), k = L(r[1], y / 2), A, N, t = h.coordinateSystem;
  if (t) {
    var g = t.dataToPoint(a);
    A = g[0] || 0, N = g[1] || 0;
  } else
    j(a) || (a = [a, a]), A = L(a[0], c) + u.x, N = L(a[1], R) + u.y;
  return {
    cx: A,
    cy: N,
    r0: x,
    r: k
  };
}
function ra(h, s, u) {
  s.eachSeriesByType(h, function(a) {
    var r = a.getData(), c = r.mapDimension("value"), R = F(a, u), y = X(a, u), x = y.cx, k = y.cy, A = y.r, N = y.r0, t = -a.get("startAngle") * B, g = a.get("endAngle"), p = a.get("padAngle") * B;
    g = g === "auto" ? t - q : -g * B;
    var G = a.get("minAngle") * B, I = G + p, P = 0;
    r.each(c, function(v) {
      !isNaN(v) && P++;
    });
    var b = r.getSum(c), S = Math.PI / (b || P) * 2, d = a.get("clockwise"), z = a.get("roseType"), J = a.get("stillShowZeroSum"), C = r.getDataExtent(c);
    C[0] = 0;
    var o = d ? 1 : -1, H = [t, g], l = o * p / 2;
    Q(H, !d), t = H[0], g = H[1];
    var W = Y(a);
    W.startAngle = t, W.endAngle = g, W.clockwise = d;
    var Z = Math.abs(g - t), T = Z, V = 0, m = t;
    if (r.setLayout({
      viewRect: R,
      r: A
    }), r.each(c, function(v, f) {
      var e;
      if (isNaN(v)) {
        r.setItemLayout(f, {
          angle: NaN,
          startAngle: NaN,
          endAngle: NaN,
          clockwise: d,
          cx: x,
          cy: k,
          r0: N,
          r: z ? NaN : A
        });
        return;
      }
      z !== "area" ? e = b === 0 && J ? S : v * S : e = Z / P, e < I ? (e = I, T -= I) : V += v;
      var i = m + o * e, n = 0, w = 0;
      p > e ? (n = m + o * e / 2, w = n) : (n = m + l, w = i - l), r.setItemLayout(f, {
        angle: e,
        startAngle: n,
        endAngle: w,
        clockwise: d,
        cx: x,
        cy: k,
        r0: N,
        r: z ? K(v, C, [N, A]) : A
      }), m = i;
    }), T < q && P)
      if (T <= 1e-3) {
        var D = Z / P;
        r.each(c, function(v, f) {
          if (!isNaN(v)) {
            var e = r.getItemLayout(f);
            e.angle = D;
            var i = 0, n = 0;
            D < p ? (i = t + o * (f + 1 / 2) * D, n = i) : (i = t + o * f * D + l, n = t + o * (f + 1) * D - l), e.startAngle = i, e.endAngle = n;
          }
        });
      } else
        S = T / V, m = t, r.each(c, function(v, f) {
          if (!isNaN(v)) {
            var e = r.getItemLayout(f), i = e.angle === I ? I : v * S, n = 0, w = 0;
            i < p ? (n = m + o * i / 2, w = n) : (n = m + l, w = m + o * i - l), e.startAngle = n, e.endAngle = w, m += o * i;
          }
        });
  });
}
var Y = U();
export {
  ra as default,
  X as getBasicPieLayout,
  Y as getSeriesLayoutData
};
