import { __extends as z } from "../../../../tslib/tslib.es6.js";
import { concatArray as H, defaults as F } from "../../../../zrender/lib/core/util.js";
import { getECData as U } from "../../util/innerStore.js";
import $ from "../helper/Symbol.js";
import { radialCoordinate as P } from "./layoutHelper.js";
import { fromPoints as j } from "../../../../zrender/lib/core/bbox.js";
import q from "../../coord/View.js";
import { updateViewOnPan as J, updateViewOnZoom as K } from "../../component/helper/roamHelper.js";
import Q from "../../component/helper/RoamController.js";
import { onIrrelevantElement as W } from "../../component/helper/cursorHelper.js";
import { parsePercent as b } from "../../util/number.js";
import M from "../../view/Chart.js";
import tt from "../../../../zrender/lib/graphic/Path.js";
import { HOVER_STATE_BLUR as et, setStatesFlag as at, setStatesStylesFromModel as rt, setDefaultStateProxy as nt } from "../../util/states.js";
import ot from "../../../../zrender/lib/graphic/Group.js";
import { updateProps as I, removeElement as T } from "../../animation/basicTransition.js";
import it from "../../../../zrender/lib/graphic/shape/BezierCurve.js";
var ct = (
  /** @class */
  function() {
    function c() {
      this.parentPoint = [], this.childPoints = [];
    }
    return c;
  }()
), lt = (
  /** @class */
  function(c) {
    z(a, c);
    function a(t) {
      return c.call(this, t) || this;
    }
    return a.prototype.getDefaultStyle = function() {
      return {
        stroke: "#000",
        fill: null
      };
    }, a.prototype.getDefaultShape = function() {
      return new ct();
    }, a.prototype.buildPath = function(t, i) {
      var l = i.childPoints, f = l.length, e = i.parentPoint, o = l[0], v = l[f - 1];
      if (f === 1) {
        t.moveTo(e[0], e[1]), t.lineTo(o[0], o[1]);
        return;
      }
      var n = i.orient, r = n === "TB" || n === "BT" ? 0 : 1, u = 1 - r, p = b(i.forkPosition, 1), d = [];
      d[r] = e[r], d[u] = e[u] + (v[u] - e[u]) * p, t.moveTo(e[0], e[1]), t.lineTo(d[0], d[1]), t.moveTo(o[0], o[1]), d[r] = o[r], t.lineTo(d[0], d[1]), d[r] = v[r], t.lineTo(d[0], d[1]), t.lineTo(v[0], v[1]);
      for (var m = 1; m < f - 1; m++) {
        var h = l[m];
        t.moveTo(h[0], h[1]), d[r] = h[r], t.lineTo(d[0], d[1]);
      }
    }, a;
  }(tt)
), pt = (
  /** @class */
  function(c) {
    z(a, c);
    function a() {
      var t = c !== null && c.apply(this, arguments) || this;
      return t.type = a.type, t._mainGroup = new ot(), t;
    }
    return a.prototype.init = function(t, i) {
      this._controller = new Q(i.getZr()), this._controllerHost = {
        target: this.group
      }, this.group.add(this._mainGroup);
    }, a.prototype.render = function(t, i, l) {
      var f = t.getData(), e = t.layoutInfo, o = this._mainGroup, v = t.get("layout");
      v === "radial" ? (o.x = e.x + e.width / 2, o.y = e.y + e.height / 2) : (o.x = e.x, o.y = e.y), this._updateViewCoordSys(t, l), this._updateController(t, i, l);
      var n = this._data;
      f.diff(n).add(function(r) {
        A(f, r) && O(f, r, null, o, t);
      }).update(function(r, u) {
        var p = n.getItemGraphicEl(u);
        if (!A(f, r)) {
          p && B(n, u, p, o, t);
          return;
        }
        O(f, r, p, o, t);
      }).remove(function(r) {
        var u = n.getItemGraphicEl(r);
        u && B(n, r, u, o, t);
      }).execute(), this._nodeScaleRatio = t.get("nodeScaleRatio"), this._updateNodeAndLinkScale(t), t.get("expandAndCollapse") === !0 && f.eachItemGraphicEl(function(r, u) {
        r.off("click").on("click", function() {
          l.dispatchAction({
            type: "treeExpandAndCollapse",
            seriesId: t.id,
            dataIndex: u
          });
        });
      }), this._data = f;
    }, a.prototype._updateViewCoordSys = function(t, i) {
      var l = t.getData(), f = [];
      l.each(function(u) {
        var p = l.getItemLayout(u);
        p && !isNaN(p.x) && !isNaN(p.y) && f.push([+p.x, +p.y]);
      });
      var e = [], o = [];
      j(f, e, o);
      var v = this._min, n = this._max;
      o[0] - e[0] === 0 && (e[0] = v ? v[0] : e[0] - 1, o[0] = n ? n[0] : o[0] + 1), o[1] - e[1] === 0 && (e[1] = v ? v[1] : e[1] - 1, o[1] = n ? n[1] : o[1] + 1);
      var r = t.coordinateSystem = new q();
      r.zoomLimit = t.get("scaleLimit"), r.setBoundingRect(e[0], e[1], o[0] - e[0], o[1] - e[1]), r.setCenter(t.get("center"), i), r.setZoom(t.get("zoom")), this.group.attr({
        x: r.x,
        y: r.y,
        scaleX: r.scaleX,
        scaleY: r.scaleY
      }), this._min = e, this._max = o;
    }, a.prototype._updateController = function(t, i, l) {
      var f = this, e = this._controller, o = this._controllerHost, v = this.group;
      e.setPointerChecker(function(n, r, u) {
        var p = v.getBoundingRect();
        return p.applyTransform(v.transform), p.contain(r, u) && !W(n, l, t);
      }), e.enable(t.get("roam")), o.zoomLimit = t.get("scaleLimit"), o.zoom = t.coordinateSystem.getZoom(), e.off("pan").off("zoom").on("pan", function(n) {
        J(o, n.dx, n.dy), l.dispatchAction({
          seriesId: t.id,
          type: "treeRoam",
          dx: n.dx,
          dy: n.dy
        });
      }).on("zoom", function(n) {
        K(o, n.scale, n.originX, n.originY), l.dispatchAction({
          seriesId: t.id,
          type: "treeRoam",
          zoom: n.scale,
          originX: n.originX,
          originY: n.originY
        }), f._updateNodeAndLinkScale(t), l.updateLabelLayout();
      });
    }, a.prototype._updateNodeAndLinkScale = function(t) {
      var i = t.getData(), l = this._getNodeGlobalScale(t);
      i.eachItemGraphicEl(function(f, e) {
        f.setSymbolScale(l);
      });
    }, a.prototype._getNodeGlobalScale = function(t) {
      var i = t.coordinateSystem;
      if (i.type !== "view")
        return 1;
      var l = this._nodeScaleRatio, f = i.scaleX || 1, e = i.getZoom(), o = (e - 1) * l + 1;
      return o / f;
    }, a.prototype.dispose = function() {
      this._controller && this._controller.dispose(), this._controllerHost = null;
    }, a.prototype.remove = function() {
      this._mainGroup.removeAll(), this._data = null;
    }, a.type = "tree", a;
  }(M)
);
function A(c, a) {
  var t = c.getItemLayout(a);
  return t && !isNaN(t.x) && !isNaN(t.y);
}
function O(c, a, t, i, l) {
  var f = !t, e = c.tree.getNodeByDataIndex(a), o = e.getModel(), v = e.getVisual("style").fill, n = e.isExpand === !1 && e.children.length !== 0 ? v : "#fff", r = c.tree.root, u = e.parentNode === r ? e : e.parentNode || e, p = c.getItemGraphicEl(u.dataIndex), d = u.getLayout(), m = p ? {
    x: p.__oldX,
    y: p.__oldY,
    rawX: p.__radialOldRawX,
    rawY: p.__radialOldRawY
  } : d, h = e.getLayout();
  f ? (t = new $(c, a, null, {
    symbolInnerColor: n,
    useNameLabel: !0
  }), t.x = m.x, t.y = m.y) : t.updateData(c, a, null, {
    symbolInnerColor: n,
    useNameLabel: !0
  }), t.__radialOldRawX = t.__radialRawX, t.__radialOldRawY = t.__radialRawY, t.__radialRawX = h.rawX, t.__radialRawY = h.rawY, i.add(t), c.setItemGraphicEl(a, t), t.__oldX = t.x, t.__oldY = t.y, I(t, {
    x: h.x,
    y: h.y
  }, l);
  var s = t.getSymbolPath();
  if (l.get("layout") === "radial") {
    var _ = r.children[0], y = _.getLayout(), S = _.children.length, g = void 0, x = void 0;
    if (h.x === y.x && e.isExpand === !0 && _.children.length) {
      var w = {
        x: (_.children[0].getLayout().x + _.children[S - 1].getLayout().x) / 2,
        y: (_.children[0].getLayout().y + _.children[S - 1].getLayout().y) / 2
      };
      g = Math.atan2(w.y - y.y, w.x - y.x), g < 0 && (g = Math.PI * 2 + g), x = w.x < y.x, x && (g = g - Math.PI);
    } else
      g = Math.atan2(h.y - y.y, h.x - y.x), g < 0 && (g = Math.PI * 2 + g), e.children.length === 0 || e.children.length !== 0 && e.isExpand === !1 ? (x = h.x < y.x, x && (g = g - Math.PI)) : (x = h.x > y.x, x || (g = g - Math.PI));
    var E = x ? "left" : "right", D = o.getModel("label"), G = D.get("rotate"), Z = G * (Math.PI / 180), R = s.getTextContent();
    R && (s.setTextConfig({
      position: D.get("position") || E,
      rotation: G == null ? -g : Z,
      origin: "center"
    }), R.setStyle("verticalAlign", "middle"));
  }
  var N = o.get(["emphasis", "focus"]), X = N === "relative" ? H(e.getAncestorsIndices(), e.getDescendantIndices()) : N === "ancestor" ? e.getAncestorsIndices() : N === "descendant" ? e.getDescendantIndices() : null;
  X && (U(t).focus = X), ut(l, e, r, t, m, d, h, i), t.__edge && (t.onHoverStateChange = function(Y) {
    if (Y !== "blur") {
      var k = e.parentNode && c.getItemGraphicEl(e.parentNode.dataIndex);
      k && k.hoverState === et || at(t.__edge, Y);
    }
  });
}
function ut(c, a, t, i, l, f, e, o) {
  var v = a.getModel(), n = c.get("edgeShape"), r = c.get("layout"), u = c.getOrient(), p = c.get(["lineStyle", "curveness"]), d = c.get("edgeForkPosition"), m = v.getModel("lineStyle").getLineStyle(), h = i.__edge;
  if (n === "curve")
    a.parentNode && a.parentNode !== t && (h || (h = i.__edge = new it({
      shape: C(r, u, p, l, l)
    })), I(h, {
      shape: C(r, u, p, f, e)
    }, c));
  else if (n === "polyline" && r === "orthogonal" && a !== t && a.children && a.children.length !== 0 && a.isExpand === !0) {
    for (var s = a.children, _ = [], y = 0; y < s.length; y++) {
      var S = s[y].getLayout();
      _.push([S.x, S.y]);
    }
    h || (h = i.__edge = new lt({
      shape: {
        parentPoint: [e.x, e.y],
        childPoints: [[e.x, e.y]],
        orient: u,
        forkPosition: d
      }
    })), I(h, {
      shape: {
        parentPoint: [e.x, e.y],
        childPoints: _
      }
    }, c);
  }
  h && !(n === "polyline" && !a.isExpand) && (h.useStyle(F({
    strokeNoScale: !0,
    fill: null
  }, m)), rt(h, v, "lineStyle"), nt(h), o.add(h));
}
function V(c, a, t, i, l) {
  var f = a.tree.root, e = L(f, c), o = e.source, v = e.sourceLayout, n = a.getItemGraphicEl(c.dataIndex);
  if (n) {
    var r = a.getItemGraphicEl(o.dataIndex), u = r.__edge, p = n.__edge || (o.isExpand === !1 || o.children.length === 1 ? u : void 0), d = i.get("edgeShape"), m = i.get("layout"), h = i.get("orient"), s = i.get(["lineStyle", "curveness"]);
    p && (d === "curve" ? T(p, {
      shape: C(m, h, s, v, v),
      style: {
        opacity: 0
      }
    }, i, {
      cb: function() {
        t.remove(p);
      },
      removeOpt: l
    }) : d === "polyline" && i.get("layout") === "orthogonal" && T(p, {
      shape: {
        parentPoint: [v.x, v.y],
        childPoints: [[v.x, v.y]]
      },
      style: {
        opacity: 0
      }
    }, i, {
      cb: function() {
        t.remove(p);
      },
      removeOpt: l
    }));
  }
}
function L(c, a) {
  for (var t = a.parentNode === c ? a : a.parentNode || a, i; i = t.getLayout(), i == null; )
    t = t.parentNode === c ? t : t.parentNode || t;
  return {
    source: t,
    sourceLayout: i
  };
}
function B(c, a, t, i, l) {
  var f = c.tree.getNodeByDataIndex(a), e = c.tree.root, o = L(e, f).sourceLayout, v = {
    duration: l.get("animationDurationUpdate"),
    easing: l.get("animationEasingUpdate")
  };
  T(t, {
    x: o.x + 1,
    y: o.y + 1
  }, l, {
    cb: function() {
      i.remove(t), c.setItemGraphicEl(a, null);
    },
    removeOpt: v
  }), t.fadeOut(null, c.hostModel, {
    fadeLabel: !0,
    animation: v
  }), f.children.forEach(function(n) {
    V(n, c, i, l, v);
  }), V(f, c, i, l, v);
}
function C(c, a, t, i, l) {
  var f, e, o, v, n, r, u, p;
  if (c === "radial") {
    n = i.rawX, u = i.rawY, r = l.rawX, p = l.rawY;
    var d = P(n, u), m = P(n, u + (p - u) * t), h = P(r, p + (u - p) * t), s = P(r, p);
    return {
      x1: d.x || 0,
      y1: d.y || 0,
      x2: s.x || 0,
      y2: s.y || 0,
      cpx1: m.x || 0,
      cpy1: m.y || 0,
      cpx2: h.x || 0,
      cpy2: h.y || 0
    };
  } else
    n = i.x, u = i.y, r = l.x, p = l.y, (a === "LR" || a === "RL") && (f = n + (r - n) * t, e = u, o = r + (n - r) * t, v = p), (a === "TB" || a === "BT") && (f = n, e = u + (p - u) * t, o = r, v = p + (u - p) * t);
  return {
    x1: n,
    y1: u,
    x2: r,
    y2: p,
    cpx1: f,
    cpy1: e,
    cpx2: o,
    cpy2: v
  };
}
const Dt = pt;
export {
  Dt as default
};
