import { extend as q, retrieve as U, each as C, filter as S } from "../../../../zrender/lib/core/util.js";
import D from "../../../../zrender/lib/core/BoundingRect.js";
import { parsePercent as A, MAX_SAFE_INTEGER as N } from "../../util/number.js";
import { getLayoutRect as z } from "../../util/layout.js";
import { retrieveTargetInfo as B, getPathToRoot as Z } from "../helper/treeHelper.js";
var I = Math.max, P = Math.min, M = U, E = C, b = ["itemStyle", "borderWidth"], G = ["itemStyle", "gapWidth"], X = ["upperLabel", "show"], $ = ["upperLabel", "height"];
const it = {
  seriesType: "treemap",
  reset: function(a, i, r, v) {
    var u = r.getWidth(), n = r.getHeight(), e = a.option, t = z(a.getBoxLayoutParams(), {
      width: r.getWidth(),
      height: r.getHeight()
    }), g = e.size || [], f = A(M(t.width, g[0]), u), h = A(M(t.height, g[1]), n), l = v && v.type, x = ["treemapZoomToNode", "treemapRootToNode"], w = B(v, x, a), s = l === "treemapRender" || l === "treemapMove" ? v.rootRect : null, o = a.getViewRoot(), y = Z(o);
    if (l !== "treemapMove") {
      var L = l === "treemapZoomToNode" ? Y(a, w, o, f, h) : s ? [s.width, s.height] : [f, h], p = e.sort;
      p && p !== "asc" && p !== "desc" && (p = "desc");
      var m = {
        squareRatio: e.squareRatio,
        sort: p,
        leafDepth: e.leafDepth
      };
      o.hostTree.clearLayouts();
      var c = {
        x: 0,
        y: 0,
        width: L[0],
        height: L[1],
        area: L[0] * L[1]
      };
      o.setLayout(c), O(o, m, !1, 0), c = o.getLayout(), E(y, function(R, T) {
        var H = (y[T + 1] || o).getValue();
        R.setLayout(q({
          dataExtent: [H, H],
          borderWidth: 0,
          upperHeight: 0
        }, c));
      });
    }
    var V = a.getData().tree.root;
    V.setLayout(F(t, s, w), !0), a.setLayoutInfo(t), W(
      V,
      // Transform to base element coordinate system.
      new D(-t.x, -t.y, u, n),
      y,
      o,
      0
    );
  }
};
function O(a, i, r, v) {
  var u, n;
  if (!a.isRemoved()) {
    var e = a.getLayout();
    u = e.width, n = e.height;
    var t = a.getModel(), g = t.get(b), f = t.get(G) / 2, h = _(t), l = Math.max(g, h), x = g - f, w = l - f;
    a.setLayout({
      borderWidth: g,
      upperHeight: l,
      upperLabelHeight: h
    }, !0), u = I(u - 2 * x, 0), n = I(n - x - w, 0);
    var s = u * n, o = j(a, t, s, i, r, v);
    if (o.length) {
      var y = {
        x,
        y: w,
        width: u,
        height: n
      }, L = P(u, n), p = 1 / 0, m = [];
      m.area = 0;
      for (var c = 0, V = o.length; c < V; ) {
        var R = o[c];
        m.push(R), m.area += R.getLayout().area;
        var T = Q(m, L, i.squareRatio);
        T <= p ? (c++, p = T) : (m.area -= m.pop().getLayout().area, d(m, L, y, f, !1), L = P(y.width, y.height), m.length = m.area = 0, p = 1 / 0);
      }
      if (m.length && d(m, L, y, f, !0), !r) {
        var H = t.get("childrenVisibleMin");
        H != null && s < H && (r = !0);
      }
      for (var c = 0, V = o.length; c < V; c++)
        O(o[c], i, r, v + 1);
    }
  }
}
function j(a, i, r, v, u, n) {
  var e = a.children || [], t = v.sort;
  t !== "asc" && t !== "desc" && (t = null);
  var g = v.leafDepth != null && v.leafDepth <= n;
  if (u && !g)
    return a.viewChildren = [];
  e = S(e, function(w) {
    return !w.isRemoved();
  }), J(e, t);
  var f = K(i, e, t);
  if (f.sum === 0)
    return a.viewChildren = [];
  if (f.sum = k(i, r, f.sum, t, e), f.sum === 0)
    return a.viewChildren = [];
  for (var h = 0, l = e.length; h < l; h++) {
    var x = e[h].getValue() / f.sum * r;
    e[h].setLayout({
      area: x
    });
  }
  return g && (e.length && a.setLayout({
    isLeafRoot: !0
  }, !0), e.length = 0), a.viewChildren = e, a.setLayout({
    dataExtent: f.dataExtent
  }, !0), e;
}
function k(a, i, r, v, u) {
  if (!v)
    return r;
  for (var n = a.get("visibleMin"), e = u.length, t = e, g = e - 1; g >= 0; g--) {
    var f = u[v === "asc" ? e - g - 1 : g].getValue();
    f / r * i < n && (t = g, r -= f);
  }
  return v === "asc" ? u.splice(0, e - t) : u.splice(t, e - t), r;
}
function J(a, i) {
  return i && a.sort(function(r, v) {
    var u = i === "asc" ? r.getValue() - v.getValue() : v.getValue() - r.getValue();
    return u === 0 ? i === "asc" ? r.dataIndex - v.dataIndex : v.dataIndex - r.dataIndex : u;
  }), a;
}
function K(a, i, r) {
  for (var v = 0, u = 0, n = i.length; u < n; u++)
    v += i[u].getValue();
  var e = a.get("visualDimension"), t;
  return !i || !i.length ? t = [NaN, NaN] : e === "value" && r ? (t = [i[i.length - 1].getValue(), i[0].getValue()], r === "asc" && t.reverse()) : (t = [1 / 0, -1 / 0], E(i, function(g) {
    var f = g.getValue(e);
    f < t[0] && (t[0] = f), f > t[1] && (t[1] = f);
  })), {
    sum: v,
    dataExtent: t
  };
}
function Q(a, i, r) {
  for (var v = 0, u = 1 / 0, n = 0, e = void 0, t = a.length; n < t; n++)
    e = a[n].getLayout().area, e && (e < u && (u = e), e > v && (v = e));
  var g = a.area * a.area, f = i * i * r;
  return g ? I(f * v / g, g / (f * u)) : 1 / 0;
}
function d(a, i, r, v, u) {
  var n = i === r.width ? 0 : 1, e = 1 - n, t = ["x", "y"], g = ["width", "height"], f = r[t[n]], h = i ? a.area / i : 0;
  (u || h > r[g[e]]) && (h = r[g[e]]);
  for (var l = 0, x = a.length; l < x; l++) {
    var w = a[l], s = {}, o = h ? w.getLayout().area / h : 0, y = s[g[e]] = I(h - 2 * v, 0), L = r[t[n]] + r[g[n]] - f, p = l === x - 1 || L < o ? L : o, m = s[g[n]] = I(p - 2 * v, 0);
    s[t[e]] = r[t[e]] + P(v, y / 2), s[t[n]] = f + P(v, m / 2), f += p, w.setLayout(s, !0);
  }
  r[t[e]] += h, r[g[e]] -= h;
}
function Y(a, i, r, v, u) {
  var n = (i || {}).node, e = [v, u];
  if (!n || n === r)
    return e;
  for (var t, g = v * u, f = g * a.option.zoomToNodeRatio; t = n.parentNode; ) {
    for (var h = 0, l = t.children, x = 0, w = l.length; x < w; x++)
      h += l[x].getValue();
    var s = n.getValue();
    if (s === 0)
      return e;
    f *= h / s;
    var o = t.getModel(), y = o.get(b), L = Math.max(y, _(o));
    f += 4 * y * y + (3 * y + L) * Math.pow(f, 0.5), f > N && (f = N), n = t;
  }
  f < g && (f = g);
  var p = Math.pow(f / g, 0.5);
  return [v * p, u * p];
}
function F(a, i, r) {
  if (i)
    return {
      x: i.x,
      y: i.y
    };
  var v = {
    x: 0,
    y: 0
  };
  if (!r)
    return v;
  var u = r.node, n = u.getLayout();
  if (!n)
    return v;
  for (var e = [n.width / 2, n.height / 2], t = u; t; ) {
    var g = t.getLayout();
    e[0] += g.x, e[1] += g.y, t = t.parentNode;
  }
  return {
    x: a.width / 2 - e[0],
    y: a.height / 2 - e[1]
  };
}
function W(a, i, r, v, u) {
  var n = a.getLayout(), e = r[u], t = e && e === a;
  if (!(e && !t || u === r.length && a !== v)) {
    a.setLayout({
      // isInView means: viewRoot sub tree + viewAbovePath
      isInView: !0,
      // invisible only means: outside view clip so that the node can not
      // see but still layout for animation preparation but not render.
      invisible: !t && !i.intersect(n),
      isAboveViewRoot: t
    }, !0);
    var g = new D(i.x - n.x, i.y - n.y, i.width, i.height);
    E(a.viewChildren || [], function(f) {
      W(f, g, r, v, u + 1);
    });
  }
}
function _(a) {
  return a.get(X) ? a.get($) : 0;
}
export {
  it as default
};
