import { __extends as B } from "../../../../tslib/tslib.es6.js";
import { map as P, clone as D, each as R, defaults as L, isObject as N } from "../../../../zrender/lib/core/util.js";
import * as O from "../../util/graphic.js";
import { mergePath as x } from "../../util/graphic.js";
import { createTextStyle as j } from "../../label/labelStyle.js";
import Z from "../../model/Model.js";
import _ from "./AxisView.js";
import C from "./AxisBuilder.js";
import { getECData as $ } from "../../util/innerStore.js";
import q from "../../../../zrender/lib/graphic/shape/Ring.js";
import A from "../../../../zrender/lib/graphic/shape/Line.js";
import F from "../../../../zrender/lib/graphic/Text.js";
import G from "../../../../zrender/lib/graphic/shape/Sector.js";
var H = ["axisLine", "axisLabel", "axisTick", "minorTick", "splitLine", "minorSplitLine", "splitArea"];
function M(n, e, t) {
  e[1] > e[0] && (e = e.slice().reverse());
  var g = n.coordToPoint([e[0], t]), l = n.coordToPoint([e[1], t]);
  return {
    x1: g[0],
    y1: g[1],
    x2: l[0],
    y2: l[1]
  };
}
function k(n) {
  var e = n.getRadiusAxis();
  return e.inverse ? 0 : 1;
}
function V(n) {
  var e = n[0], t = n[n.length - 1];
  e && t && Math.abs(Math.abs(e.coord - t.coord) - 360) < 1e-4 && n.pop();
}
var J = (
  /** @class */
  function(n) {
    B(e, n);
    function e() {
      var t = n !== null && n.apply(this, arguments) || this;
      return t.type = e.type, t.axisPointerClass = "PolarAxisPointer", t;
    }
    return e.prototype.render = function(t, g) {
      if (this.group.removeAll(), !!t.get("show")) {
        var l = t.axis, s = l.polar, v = s.getRadiusAxis().getExtent(), c = l.getTicksCoords(), i = l.getMinorTicksCoords(), o = P(l.getViewLabels(), function(r) {
          r = D(r);
          var a = l.scale, d = a.type === "ordinal" ? a.getRawOrdinalNumber(r.tickValue) : r.tickValue;
          return r.coord = l.dataToCoord(d), r;
        });
        V(o), V(c), R(H, function(r) {
          t.get([r, "show"]) && (!l.scale.isBlank() || r === "axisLine") && K[r](this.group, t, s, c, i, v, o);
        }, this);
      }
    }, e.type = "angleAxis", e;
  }(_)
), K = {
  axisLine: function(n, e, t, g, l, s) {
    var v = e.getModel(["axisLine", "lineStyle"]), c = t.getAngleAxis(), i = Math.PI / 180, o = c.getExtent(), r = k(t), a = r ? 0 : 1, d, u = Math.abs(o[1] - o[0]) === 360 ? "Circle" : "Arc";
    s[a] === 0 ? d = new O[u]({
      shape: {
        cx: t.cx,
        cy: t.cy,
        r: s[r],
        startAngle: -o[0] * i,
        endAngle: -o[1] * i,
        clockwise: c.inverse
      },
      style: v.getLineStyle(),
      z2: 1,
      silent: !0
    }) : d = new q({
      shape: {
        cx: t.cx,
        cy: t.cy,
        r: s[r],
        r0: s[a]
      },
      style: v.getLineStyle(),
      z2: 1,
      silent: !0
    }), d.style.fill = null, n.add(d);
  },
  axisTick: function(n, e, t, g, l, s) {
    var v = e.getModel("axisTick"), c = (v.get("inside") ? -1 : 1) * v.get("length"), i = s[k(t)], o = P(g, function(r) {
      return new A({
        shape: M(t, [i, i + c], r.coord)
      });
    });
    n.add(x(o, {
      style: L(v.getModel("lineStyle").getLineStyle(), {
        stroke: e.get(["axisLine", "lineStyle", "color"])
      })
    }));
  },
  minorTick: function(n, e, t, g, l, s) {
    if (l.length) {
      for (var v = e.getModel("axisTick"), c = e.getModel("minorTick"), i = (v.get("inside") ? -1 : 1) * c.get("length"), o = s[k(t)], r = [], a = 0; a < l.length; a++)
        for (var d = 0; d < l[a].length; d++)
          r.push(new A({
            shape: M(t, [o, o + i], l[a][d].coord)
          }));
      n.add(x(r, {
        style: L(c.getModel("lineStyle").getLineStyle(), L(v.getLineStyle(), {
          stroke: e.get(["axisLine", "lineStyle", "color"])
        }))
      }));
    }
  },
  axisLabel: function(n, e, t, g, l, s, v) {
    var c = e.getCategories(!0), i = e.getModel("axisLabel"), o = i.get("margin"), r = e.get("triggerEvent");
    R(v, function(a, d) {
      var u = i, S = a.tickValue, h = s[k(t)], f = t.coordToPoint([h + o, a.coord]), y = t.cx, p = t.cy, m = Math.abs(f[0] - y) / h < 0.3 ? "center" : f[0] > y ? "left" : "right", z = Math.abs(f[1] - p) / h < 0.3 ? "middle" : f[1] > p ? "top" : "bottom";
      if (c && c[S]) {
        var w = c[S];
        N(w) && w.textStyle && (u = new Z(w.textStyle, i, i.ecModel));
      }
      var b = new F({
        silent: C.isLabelSilent(e),
        style: j(u, {
          x: f[0],
          y: f[1],
          fill: u.getTextColor() || e.get(["axisLine", "lineStyle", "color"]),
          text: a.formattedLabel,
          align: m,
          verticalAlign: z
        })
      });
      if (n.add(b), r) {
        var T = C.makeAxisEventDataBase(e);
        T.targetType = "axisLabel", T.value = a.rawLabel, $(b).eventData = T;
      }
    }, this);
  },
  splitLine: function(n, e, t, g, l, s) {
    var v = e.getModel("splitLine"), c = v.getModel("lineStyle"), i = c.get("color"), o = 0;
    i = i instanceof Array ? i : [i];
    for (var r = [], a = 0; a < g.length; a++) {
      var d = o++ % i.length;
      r[d] = r[d] || [], r[d].push(new A({
        shape: M(t, s, g[a].coord)
      }));
    }
    for (var a = 0; a < r.length; a++)
      n.add(x(r[a], {
        style: L({
          stroke: i[a % i.length]
        }, c.getLineStyle()),
        silent: !0,
        z: e.get("z")
      }));
  },
  minorSplitLine: function(n, e, t, g, l, s) {
    if (l.length) {
      for (var v = e.getModel("minorSplitLine"), c = v.getModel("lineStyle"), i = [], o = 0; o < l.length; o++)
        for (var r = 0; r < l[o].length; r++)
          i.push(new A({
            shape: M(t, s, l[o][r].coord)
          }));
      n.add(x(i, {
        style: c.getLineStyle(),
        silent: !0,
        z: e.get("z")
      }));
    }
  },
  splitArea: function(n, e, t, g, l, s) {
    if (g.length) {
      var v = e.getModel("splitArea"), c = v.getModel("areaStyle"), i = c.get("color"), o = 0;
      i = i instanceof Array ? i : [i];
      for (var r = [], a = Math.PI / 180, d = -g[0].coord * a, u = Math.min(s[0], s[1]), S = Math.max(s[0], s[1]), h = e.get("clockwise"), f = 1, y = g.length; f <= y; f++) {
        var p = f === y ? g[0].coord : g[f].coord, m = o++ % i.length;
        r[m] = r[m] || [], r[m].push(new G({
          shape: {
            cx: t.cx,
            cy: t.cy,
            r0: u,
            r: S,
            startAngle: d,
            endAngle: -p * a,
            clockwise: h
          },
          silent: !0
        })), d = -p * a;
      }
      for (var f = 0; f < r.length; f++)
        n.add(x(r[f], {
          style: L({
            fill: i[f % i.length]
          }, c.getAreaStyle()),
          silent: !0
        }));
    }
  }
};
const ne = J;
export {
  ne as default
};
