import { defaults as B, extend as et, isString as W, each as E, map as at, retrieve as D, isObject as rt, retrieve2 as C, isFunction as nt, isNumber as it } from "../../../../zrender/lib/core/util.js";
import { subPixelOptimizeLine as j, setTooltipConfig as z } from "../../util/graphic.js";
import { getECData as Z } from "../../util/innerStore.js";
import { createTextStyle as q } from "../../label/labelStyle.js";
import lt from "../../model/Model.js";
import { remRadian as $, isRadianAroundZero as R } from "../../util/number.js";
import { normalizeSymbolOffset as ot, createSymbol as st } from "../../util/symbol.js";
import { identity as vt, rotate as gt, mul as I } from "../../../../zrender/lib/core/matrix.js";
import { applyTransform as O } from "../../../../zrender/lib/core/vector.js";
import { shouldShowAllLabels as ft } from "../../coord/axisHelper.js";
import { prepareLayoutList as ut, hideOverlap as ct } from "../../label/labelLayoutHelper.js";
import P from "../../../../zrender/lib/graphic/Group.js";
import J from "../../../../zrender/lib/graphic/shape/Line.js";
import K from "../../../../zrender/lib/graphic/Text.js";
var A = Math.PI, S = (
  /** @class */
  function() {
    function a(t, e) {
      this.group = new P(), this.opt = e, this.axisModel = t, B(e, {
        labelOffset: 0,
        nameDirection: 1,
        tickDirection: 1,
        labelDirection: 1,
        silent: !0,
        handleAutoShown: function() {
          return !0;
        }
      });
      var i = new P({
        x: e.position[0],
        y: e.position[1],
        rotation: e.rotation
      });
      i.updateTransform(), this._transformGroup = i;
    }
    return a.prototype.hasBuilder = function(t) {
      return !!_[t];
    }, a.prototype.add = function(t) {
      _[t](this.opt, this.axisModel, this.group, this._transformGroup);
    }, a.prototype.getGroup = function() {
      return this.group;
    }, a.innerTextLayout = function(t, e, i) {
      var r = $(e - t), l, n;
      return R(r) ? (n = i > 0 ? "top" : "bottom", l = "center") : R(r - A) ? (n = i > 0 ? "bottom" : "top", l = "center") : (n = "middle", r > 0 && r < A ? l = i > 0 ? "right" : "left" : l = i > 0 ? "left" : "right"), {
        rotation: r,
        textAlign: l,
        textVerticalAlign: n
      };
    }, a.makeAxisEventDataBase = function(t) {
      var e = {
        componentType: t.mainType,
        componentIndex: t.componentIndex
      };
      return e[t.mainType + "Index"] = t.componentIndex, e;
    }, a.isLabelSilent = function(t) {
      var e = t.get("tooltip");
      return t.get("silent") || !(t.get("triggerEvent") || e && e.show);
    }, a;
  }()
), _ = {
  axisLine: function(a, t, e, i) {
    var r = t.get(["axisLine", "show"]);
    if (r === "auto" && a.handleAutoShown && (r = a.handleAutoShown("axisLine")), !!r) {
      var l = t.axis.getExtent(), n = i.transform, o = [l[0], 0], s = [l[1], 0], f = o[0] > s[0];
      n && (O(o, o, n), O(s, s, n));
      var v = et({
        lineCap: "round"
      }, t.getModel(["axisLine", "lineStyle"]).getLineStyle()), u = new J({
        shape: {
          x1: o[0],
          y1: o[1],
          x2: s[0],
          y2: s[1]
        },
        style: v,
        strokeContainThreshold: a.strokeContainThreshold || 5,
        silent: !0,
        z2: 1
      });
      j(u.shape, u.style.lineWidth), u.anid = "line", e.add(u);
      var g = t.get(["axisLine", "symbol"]);
      if (g != null) {
        var c = t.get(["axisLine", "symbolSize"]);
        W(g) && (g = [g, g]), (W(c) || it(c)) && (c = [c, c]);
        var p = ot(t.get(["axisLine", "symbolOffset"]) || 0, c), y = c[0], L = c[1];
        E([{
          rotate: a.rotation + Math.PI / 2,
          offset: p[0],
          r: 0
        }, {
          rotate: a.rotation - Math.PI / 2,
          offset: p[1],
          r: Math.sqrt((o[0] - s[0]) * (o[0] - s[0]) + (o[1] - s[1]) * (o[1] - s[1]))
        }], function(d, T) {
          if (g[T] !== "none" && g[T] != null) {
            var h = st(g[T], -y / 2, -L / 2, y, L, v.stroke, !0), m = d.r + d.offset, w = f ? s : o;
            h.attr({
              rotation: d.rotate,
              x: w[0] + m * Math.cos(a.rotation),
              y: w[1] - m * Math.sin(a.rotation),
              silent: !0,
              z2: 11
            }), e.add(h);
          }
        });
      }
    }
  },
  axisTickLabel: function(a, t, e, i) {
    var r = Lt(e, i, t, a), l = pt(e, i, t, a);
    if (ht(t, l, r), dt(e, i, t, a.tickDirection), t.get(["axisLabel", "hideOverlap"])) {
      var n = ut(at(l, function(o) {
        return {
          label: o,
          priority: o.z2,
          defaultAttr: {
            ignore: o.ignore
          }
        };
      }));
      ct(n);
    }
  },
  axisName: function(a, t, e, i) {
    var r = D(a.axisName, t.get("name"));
    if (r) {
      var l = t.get("nameLocation"), n = a.nameDirection, o = t.getModel("nameTextStyle"), s = t.get("nameGap") || 0, f = t.axis.getExtent(), v = f[0] > f[1] ? -1 : 1, u = [
        l === "start" ? f[0] - v * s : l === "end" ? f[1] + v * s : (f[0] + f[1]) / 2,
        // Reuse labelOffset.
        G(l) ? a.labelOffset + n * s : 0
      ], g, c = t.get("nameRotate");
      c != null && (c = c * A / 180);
      var p;
      G(l) ? g = S.innerTextLayout(
        a.rotation,
        c ?? a.rotation,
        // Adapt to axis.
        n
      ) : (g = mt(a.rotation, l, c || 0, f), p = a.axisNameAvailableWidth, p != null && (p = Math.abs(p / Math.sin(g.rotation)), !isFinite(p) && (p = null)));
      var y = o.getFont(), L = t.get("nameTruncate", !0) || {}, d = L.ellipsis, T = D(a.nameTruncateMaxWidth, L.maxWidth, p), h = new K({
        x: u[0],
        y: u[1],
        rotation: g.rotation,
        silent: S.isLabelSilent(t),
        style: q(o, {
          text: r,
          font: y,
          overflow: "truncate",
          width: T,
          ellipsis: d,
          fill: o.getTextColor() || t.get(["axisLine", "lineStyle", "color"]),
          align: o.get("align") || g.textAlign,
          verticalAlign: o.get("verticalAlign") || g.textVerticalAlign
        }),
        z2: 1
      });
      if (z({
        el: h,
        componentModel: t,
        itemName: r
      }), h.__fullText = r, h.anid = "name", t.get("triggerEvent")) {
        var m = S.makeAxisEventDataBase(t);
        m.targetType = "axisName", m.name = r, Z(h).eventData = m;
      }
      i.add(h), h.updateTransform(), e.add(h), h.decomposeTransform();
    }
  }
};
function mt(a, t, e, i) {
  var r = $(e - a), l, n, o = i[0] > i[1], s = t === "start" && !o || t !== "start" && o;
  return R(r - A / 2) ? (n = s ? "bottom" : "top", l = "center") : R(r - A * 1.5) ? (n = s ? "top" : "bottom", l = "center") : (n = "middle", r < A * 1.5 && r > A / 2 ? l = s ? "left" : "right" : l = s ? "right" : "left"), {
    rotation: r,
    textAlign: l,
    textVerticalAlign: n
  };
}
function ht(a, t, e) {
  if (!ft(a.axis)) {
    var i = a.get(["axisLabel", "showMinLabel"]), r = a.get(["axisLabel", "showMaxLabel"]);
    t = t || [], e = e || [];
    var l = t[0], n = t[1], o = t[t.length - 1], s = t[t.length - 2], f = e[0], v = e[1], u = e[e.length - 1], g = e[e.length - 2];
    i === !1 ? (x(l), x(f)) : F(l, n) && (i ? (x(n), x(v)) : (x(l), x(f))), r === !1 ? (x(o), x(u)) : F(s, o) && (r ? (x(s), x(g)) : (x(o), x(u)));
  }
}
function x(a) {
  a && (a.ignore = !0);
}
function F(a, t) {
  var e = a && a.getBoundingRect().clone(), i = t && t.getBoundingRect().clone();
  if (!(!e || !i)) {
    var r = vt([]);
    return gt(r, r, -a.rotation), e.applyTransform(I([], r, a.getLocalTransform())), i.applyTransform(I([], r, t.getLocalTransform())), e.intersect(i);
  }
}
function G(a) {
  return a === "middle" || a === "center";
}
function Q(a, t, e, i, r) {
  for (var l = [], n = [], o = [], s = 0; s < a.length; s++) {
    var f = a[s].coord;
    n[0] = f, n[1] = 0, o[0] = f, o[1] = e, t && (O(n, n, t), O(o, o, t));
    var v = new J({
      shape: {
        x1: n[0],
        y1: n[1],
        x2: o[0],
        y2: o[1]
      },
      style: i,
      z2: 2,
      autoBatch: !0,
      silent: !0
    });
    j(v.shape, v.style.lineWidth), v.anid = r + "_" + a[s].tickValue, l.push(v);
  }
  return l;
}
function Lt(a, t, e, i) {
  var r = e.axis, l = e.getModel("axisTick"), n = l.get("show");
  if (n === "auto" && i.handleAutoShown && (n = i.handleAutoShown("axisTick")), !(!n || r.scale.isBlank())) {
    for (var o = l.getModel("lineStyle"), s = i.tickDirection * l.get("length"), f = r.getTicksCoords(), v = Q(f, t.transform, s, B(o.getLineStyle(), {
      stroke: e.get(["axisLine", "lineStyle", "color"])
    }), "ticks"), u = 0; u < v.length; u++)
      a.add(v[u]);
    return v;
  }
}
function dt(a, t, e, i) {
  var r = e.axis, l = e.getModel("minorTick");
  if (!(!l.get("show") || r.scale.isBlank())) {
    var n = r.getMinorTicksCoords();
    if (n.length)
      for (var o = l.getModel("lineStyle"), s = i * l.get("length"), f = B(o.getLineStyle(), B(e.getModel("axisTick").getLineStyle(), {
        stroke: e.get(["axisLine", "lineStyle", "color"])
      })), v = 0; v < n.length; v++)
        for (var u = Q(n[v], t.transform, s, f, "minorticks_" + v), g = 0; g < u.length; g++)
          a.add(u[g]);
  }
}
function pt(a, t, e, i) {
  var r = e.axis, l = D(i.axisLabelShow, e.get(["axisLabel", "show"]));
  if (!(!l || r.scale.isBlank())) {
    var n = e.getModel("axisLabel"), o = n.get("margin"), s = r.getViewLabels(), f = (D(i.labelRotate, n.get("rotate")) || 0) * A / 180, v = S.innerTextLayout(i.rotation, f, i.labelDirection), u = e.getCategories && e.getCategories(!0), g = [], c = S.isLabelSilent(e), p = e.get("triggerEvent");
    return E(s, function(y, L) {
      var d = r.scale.type === "ordinal" ? r.scale.getRawOrdinalNumber(y.tickValue) : y.tickValue, T = y.formattedLabel, h = y.rawLabel, m = n;
      if (u && u[d]) {
        var w = u[d];
        rt(w) && w.textStyle && (m = new lt(w.textStyle, n, e.ecModel));
      }
      var V = m.getTextColor() || e.get(["axisLine", "lineStyle", "color"]), U = r.dataToCoord(d), N = m.getShallow("align", !0) || v.textAlign, X = C(m.getShallow("alignMinLabel", !0), N), Y = C(m.getShallow("alignMaxLabel", !0), N), M = m.getShallow("verticalAlign", !0) || m.getShallow("baseline", !0) || v.textVerticalAlign, H = C(m.getShallow("verticalAlignMinLabel", !0), M), tt = C(m.getShallow("verticalAlignMaxLabel", !0), M), b = new K({
        x: U,
        y: i.labelOffset + i.labelDirection * o,
        rotation: v.rotation,
        silent: c,
        z2: 10 + (y.level || 0),
        style: q(m, {
          text: T,
          align: L === 0 ? X : L === s.length - 1 ? Y : N,
          verticalAlign: L === 0 ? H : L === s.length - 1 ? tt : M,
          fill: nt(V) ? V(
            // (1) In category axis with data zoom, tick is not the original
            // index of axis.data. So tick should not be exposed to user
            // in category axis.
            // (2) Compatible with previous version, which always use formatted label as
            // input. But in interval scale the formatted label is like '223,445', which
            // maked user replace ','. So we modify it to return original val but remain
            // it as 'string' to avoid error in replacing.
            r.type === "category" ? h : r.type === "value" ? d + "" : d,
            L
          ) : V
        })
      });
      if (b.anid = "label_" + d, z({
        el: b,
        componentModel: e,
        itemName: T,
        formatterParamsExtra: {
          isTruncated: function() {
            return b.isTruncated;
          },
          value: h,
          tickIndex: L
        }
      }), p) {
        var k = S.makeAxisEventDataBase(e);
        k.targetType = "axisLabel", k.value = h, k.tickIndex = L, r.type === "category" && (k.dataIndex = d), Z(b).eventData = k;
      }
      t.add(b), b.updateTransform(), g.push(b), a.add(b), b.decomposeTransform();
    }), g;
  }
}
const Nt = S;
export {
  Nt as default
};
