import { __extends as c } from "../../../../tslib/tslib.es6.js";
import { extend as V, each as S, isArray as _, defaults as M } from "../../../../zrender/lib/core/util.js";
import { groupTransition as R, subPixelOptimizeLine as L } from "../../util/graphic.js";
import T from "./AxisBuilder.js";
import z from "./AxisView.js";
import { layout as H } from "../../coord/cartesian/cartesianAxisHelper.js";
import { rectCoordAxisHandleRemove as b, rectCoordAxisBuildSplitArea as O } from "./axisSplitHelper.js";
import { isIntervalOrLogScale as I } from "../../scale/helper.js";
import P from "../../../../zrender/lib/graphic/Group.js";
import C from "../../../../zrender/lib/graphic/shape/Line.js";
var W = ["axisLine", "axisTickLabel", "axisName"], X = ["splitArea", "splitLine", "minorSplitLine"], G = (
  /** @class */
  function(r) {
    c(e, r);
    function e() {
      var t = r !== null && r.apply(this, arguments) || this;
      return t.type = e.type, t.axisPointerClass = "CartesianAxisPointer", t;
    }
    return e.prototype.render = function(t, v, h, s) {
      this.group.removeAll();
      var x = this._axisGroup;
      if (this._axisGroup = new P(), this.group.add(this._axisGroup), !!t.get("show")) {
        var i = t.getCoordSysModel(), g = H(i, t), l = new T(t, V({
          handleAutoShown: function(o) {
            for (var f = i.coordinateSystem.getCartesians(), a = 0; a < f.length; a++)
              if (I(f[a].getOtherAxis(t.axis).scale))
                return !0;
            return !1;
          }
        }, g));
        S(W, l.add, l), this._axisGroup.add(l.getGroup()), S(X, function(o) {
          t.get([o, "show"]) && Y[o](this, this._axisGroup, t, i);
        }, this);
        var n = s && s.type === "changeAxisOrder" && s.isInitSort;
        n || R(x, this._axisGroup, t), r.prototype.render.call(this, t, v, h, s);
      }
    }, e.prototype.remove = function() {
      b(this);
    }, e.type = "cartesianAxis", e;
  }(z)
), Y = {
  splitLine: function(r, e, t, v) {
    var h = t.axis;
    if (!h.scale.isBlank()) {
      var s = t.getModel("splitLine"), x = s.getModel("lineStyle"), i = x.get("color"), g = s.get("showMinLine") !== !1, l = s.get("showMaxLine") !== !1;
      i = _(i) ? i : [i];
      for (var n = v.coordinateSystem.getRect(), o = h.isHorizontal(), f = 0, a = h.getTicksCoords({
        tickModel: s
      }), u = [], p = [], y = x.getLineStyle(), d = 0; d < a.length; d++) {
        var m = h.toGlobalCoord(a[d].coord);
        if (!(d === 0 && !g || d === a.length - 1 && !l)) {
          var A = a[d].tickValue;
          o ? (u[0] = m, u[1] = n.y, p[0] = m, p[1] = n.y + n.height) : (u[0] = n.x, u[1] = m, p[0] = n.x + n.width, p[1] = m);
          var B = f++ % i.length, w = new C({
            anid: A != null ? "line_" + A : null,
            autoBatch: !0,
            shape: {
              x1: u[0],
              y1: u[1],
              x2: p[0],
              y2: p[1]
            },
            style: M({
              stroke: i[B]
            }, y),
            silent: !0
          });
          L(w.shape, y.lineWidth), e.add(w);
        }
      }
    }
  },
  minorSplitLine: function(r, e, t, v) {
    var h = t.axis, s = t.getModel("minorSplitLine"), x = s.getModel("lineStyle"), i = v.coordinateSystem.getRect(), g = h.isHorizontal(), l = h.getMinorTicksCoords();
    if (l.length)
      for (var n = [], o = [], f = x.getLineStyle(), a = 0; a < l.length; a++)
        for (var u = 0; u < l[a].length; u++) {
          var p = h.toGlobalCoord(l[a][u].coord);
          g ? (n[0] = p, n[1] = i.y, o[0] = p, o[1] = i.y + i.height) : (n[0] = i.x, n[1] = p, o[0] = i.x + i.width, o[1] = p);
          var y = new C({
            anid: "minor_line_" + l[a][u].tickValue,
            autoBatch: !0,
            shape: {
              x1: n[0],
              y1: n[1],
              x2: o[0],
              y2: o[1]
            },
            style: f,
            silent: !0
          });
          L(y.shape, f.lineWidth), e.add(y);
        }
  },
  splitArea: function(r, e, t, v) {
    O(r, e, t, v);
  }
}, E = (
  /** @class */
  function(r) {
    c(e, r);
    function e() {
      var t = r !== null && r.apply(this, arguments) || this;
      return t.type = e.type, t;
    }
    return e.type = "xAxis", e;
  }(G)
), U = (
  /** @class */
  function(r) {
    c(e, r);
    function e() {
      var t = r !== null && r.apply(this, arguments) || this;
      return t.type = E.type, t;
    }
    return e.type = "yAxis", e;
  }(G)
);
export {
  E as CartesianXAxisView,
  U as CartesianYAxisView,
  G as default
};
