import { __extends as N } from "../../../../tslib/tslib.es6.js";
import { isString as w, isFunction as O, extend as L, map as z } from "../../../../zrender/lib/core/util.js";
import { createTextStyle as P } from "../../label/labelStyle.js";
import { formatTplSimple as W } from "../../util/format.js";
import { parsePercent as R } from "../../util/number.js";
import A from "../../view/Component.js";
import { getLocaleModel as M } from "../../core/locale.js";
import I from "../../../../zrender/lib/graphic/shape/Rect.js";
import D from "../../../../zrender/lib/graphic/shape/Polyline.js";
import T from "../../../../zrender/lib/graphic/Text.js";
var E = (
  /** @class */
  function(x) {
    N(f, x);
    function f() {
      var e = x !== null && x.apply(this, arguments) || this;
      return e.type = f.type, e;
    }
    return f.prototype.render = function(e, r, l) {
      var i = this.group;
      i.removeAll();
      var t = e.coordinateSystem, a = t.getRangeInfo(), o = t.getOrient(), n = r.getLocaleModel();
      this._renderDayRect(e, a, i), this._renderLines(e, a, o, i), this._renderYearText(e, a, o, i), this._renderMonthText(e, n, o, i), this._renderWeekText(e, n, a, o, i);
    }, f.prototype._renderDayRect = function(e, r, l) {
      for (var i = e.coordinateSystem, t = e.getModel("itemStyle").getItemStyle(), a = i.getCellWidth(), o = i.getCellHeight(), n = r.start.time; n <= r.end.time; n = i.getNextNDay(n, 1).time) {
        var s = i.dataToRect([n], !1).tl, v = new I({
          shape: {
            x: s[0],
            y: s[1],
            width: a,
            height: o
          },
          cursor: "default",
          style: t
        });
        l.add(v);
      }
    }, f.prototype._renderLines = function(e, r, l, i) {
      var t = this, a = e.coordinateSystem, o = e.getModel(["splitLine", "lineStyle"]).getLineStyle(), n = e.get(["splitLine", "show"]), s = o.lineWidth;
      this._tlpoints = [], this._blpoints = [], this._firstDayOfMonth = [], this._firstDayPoints = [];
      for (var v = r.start, h = 0; v.time <= r.end.time; h++) {
        p(v.formatedDate), h === 0 && (v = a.getDateInfo(r.start.y + "-" + r.start.m));
        var m = v.date;
        m.setMonth(m.getMonth() + 1), v = a.getDateInfo(m);
      }
      p(a.getNextNDay(r.end.time, 1).formatedDate);
      function p(g) {
        t._firstDayOfMonth.push(a.getDateInfo(g)), t._firstDayPoints.push(a.dataToRect([g], !1).tl);
        var y = t._getLinePointsOfOneWeek(e, g, l);
        t._tlpoints.push(y[0]), t._blpoints.push(y[y.length - 1]), n && t._drawSplitline(y, o, i);
      }
      n && this._drawSplitline(t._getEdgesPoints(t._tlpoints, s, l), o, i), n && this._drawSplitline(t._getEdgesPoints(t._blpoints, s, l), o, i);
    }, f.prototype._getEdgesPoints = function(e, r, l) {
      var i = [e[0].slice(), e[e.length - 1].slice()], t = l === "horizontal" ? 0 : 1;
      return i[0][t] = i[0][t] - r / 2, i[1][t] = i[1][t] + r / 2, i;
    }, f.prototype._drawSplitline = function(e, r, l) {
      var i = new D({
        z2: 20,
        shape: {
          points: e
        },
        style: r
      });
      l.add(i);
    }, f.prototype._getLinePointsOfOneWeek = function(e, r, l) {
      for (var i = e.coordinateSystem, t = i.getDateInfo(r), a = [], o = 0; o < 7; o++) {
        var n = i.getNextNDay(t.time, o), s = i.dataToRect([n.time], !1);
        a[2 * n.day] = s.tl, a[2 * n.day + 1] = s[l === "horizontal" ? "bl" : "tr"];
      }
      return a;
    }, f.prototype._formatterLabel = function(e, r) {
      return w(e) && e ? W(e, r) : O(e) ? e(r) : r.nameMap;
    }, f.prototype._yearTextPositionControl = function(e, r, l, i, t) {
      var a = r[0], o = r[1], n = ["center", "bottom"];
      i === "bottom" ? (o += t, n = ["center", "top"]) : i === "left" ? a -= t : i === "right" ? (a += t, n = ["center", "top"]) : o -= t;
      var s = 0;
      return (i === "left" || i === "right") && (s = Math.PI / 2), {
        rotation: s,
        x: a,
        y: o,
        style: {
          align: n[0],
          verticalAlign: n[1]
        }
      };
    }, f.prototype._renderYearText = function(e, r, l, i) {
      var t = e.getModel("yearLabel");
      if (t.get("show")) {
        var a = t.get("margin"), o = t.get("position");
        o || (o = l !== "horizontal" ? "top" : "left");
        var n = [this._tlpoints[this._tlpoints.length - 1], this._blpoints[0]], s = (n[0][0] + n[1][0]) / 2, v = (n[0][1] + n[1][1]) / 2, h = l === "horizontal" ? 0 : 1, m = {
          top: [s, n[h][1]],
          bottom: [s, n[1 - h][1]],
          left: [n[1 - h][0], v],
          right: [n[h][0], v]
        }, p = r.start.y;
        +r.end.y > +r.start.y && (p = p + "-" + r.end.y);
        var g = t.get("formatter"), y = {
          start: r.start.y,
          end: r.end.y,
          nameMap: p
        }, c = this._formatterLabel(g, y), d = new T({
          z2: 30,
          style: P(t, {
            text: c
          }),
          silent: t.get("silent")
        });
        d.attr(this._yearTextPositionControl(d, m[o], l, o, a)), i.add(d);
      }
    }, f.prototype._monthTextPositionControl = function(e, r, l, i, t) {
      var a = "left", o = "top", n = e[0], s = e[1];
      return l === "horizontal" ? (s = s + t, r && (a = "center"), i === "start" && (o = "bottom")) : (n = n + t, r && (o = "middle"), i === "start" && (a = "right")), {
        x: n,
        y: s,
        align: a,
        verticalAlign: o
      };
    }, f.prototype._renderMonthText = function(e, r, l, i) {
      var t = e.getModel("monthLabel");
      if (t.get("show")) {
        var a = t.get("nameMap"), o = t.get("margin"), n = t.get("position"), s = t.get("align"), v = [this._tlpoints, this._blpoints];
        (!a || w(a)) && (a && (r = M(a) || r), a = r.get(["time", "monthAbbr"]) || []);
        var h = n === "start" ? 0 : 1, m = l === "horizontal" ? 0 : 1;
        o = n === "start" ? -o : o;
        for (var p = s === "center", g = t.get("silent"), y = 0; y < v[h].length - 1; y++) {
          var c = v[h][y].slice(), d = this._firstDayOfMonth[y];
          if (p) {
            var u = this._firstDayPoints[y];
            c[m] = (u[m] + v[0][y + 1][m]) / 2;
          }
          var _ = t.get("formatter"), b = a[+d.m - 1], S = {
            yyyy: d.y,
            yy: (d.y + "").slice(2),
            MM: d.m,
            M: +d.m,
            nameMap: b
          }, C = this._formatterLabel(_, S), k = new T({
            z2: 30,
            style: L(P(t, {
              text: C
            }), this._monthTextPositionControl(c, p, l, n, o)),
            silent: g
          });
          i.add(k);
        }
      }
    }, f.prototype._weekTextPositionControl = function(e, r, l, i, t) {
      var a = "center", o = "middle", n = e[0], s = e[1], v = l === "start";
      return r === "horizontal" ? (n = n + i + (v ? 1 : -1) * t[0] / 2, a = v ? "right" : "left") : (s = s + i + (v ? 1 : -1) * t[1] / 2, o = v ? "bottom" : "top"), {
        x: n,
        y: s,
        align: a,
        verticalAlign: o
      };
    }, f.prototype._renderWeekText = function(e, r, l, i, t) {
      var a = e.getModel("dayLabel");
      if (a.get("show")) {
        var o = e.coordinateSystem, n = a.get("position"), s = a.get("nameMap"), v = a.get("margin"), h = o.getFirstDayOfWeek();
        if (!s || w(s)) {
          s && (r = M(s) || r);
          var m = r.get(["time", "dayOfWeekShort"]);
          s = m || z(r.get(["time", "dayOfWeekAbbr"]), function(S) {
            return S[0];
          });
        }
        var p = o.getNextNDay(l.end.time, 7 - l.lweek).time, g = [o.getCellWidth(), o.getCellHeight()];
        v = R(v, Math.min(g[1], g[0])), n === "start" && (p = o.getNextNDay(l.start.time, -(7 + l.fweek)).time, v = -v);
        for (var y = a.get("silent"), c = 0; c < 7; c++) {
          var d = o.getNextNDay(p, c), u = o.dataToRect([d.time], !1).center, _ = c;
          _ = Math.abs((c + h) % 7);
          var b = new T({
            z2: 30,
            style: L(P(a, {
              text: s[_]
            }), this._weekTextPositionControl(u, i, n, v, g)),
            silent: y
          });
          t.add(b);
        }
      }
    }, f.type = "calendar", f;
  }(A)
);
const J = E;
export {
  J as default
};
