import { __extends as M } from "../../../../tslib/tslib.es6.js";
import { createHashMap as $, each as N, indexOf as Q, hasOwn as Z, retrieve2 as X, isFunction as Y, keys as k, extend as P } from "../../../../zrender/lib/core/util.js";
import O from "../../../../zrender/lib/graphic/Displayable.js";
import { convertOptionIdName as z, makeInner as tt } from "../../util/model.js";
import { setTooltipConfig as et, getShapeClass as rt } from "../../util/graphic.js";
import { positionElement as at, LOCATION_PARAMS as nt } from "../../util/layout.js";
import { parsePercent as F } from "../../util/number.js";
import it from "../../view/Component.js";
import { getECData as W } from "../../util/innerStore.js";
import { isEC4CompatibleStyle as ot, convertFromEC4CompatibleStyle as vt } from "../../util/styleCompat.js";
import { applyUpdateTransition as V, updateLeaveTo as ft, isTransitionAll as mt, applyLeaveTransition as st } from "../../animation/customGraphicTransition.js";
import { updateProps as ut } from "../../animation/basicTransition.js";
import { stopPreviousKeyframeAnimationAndRestore as pt, applyKeyframeAnimation as B } from "../../animation/customGraphicKeyframeAnimation.js";
import H from "../../../../zrender/lib/graphic/Text.js";
import lt from "../../../../zrender/lib/graphic/Group.js";
import dt from "../../../../zrender/lib/graphic/Image.js";
var R = {
  // Reserved but not supported in graphic component.
  path: null,
  compoundPath: null,
  // Supported in graphic component.
  group: lt,
  image: dt,
  text: H
}, u = tt(), Lt = (
  /** @class */
  function(t) {
    M(a, t);
    function a() {
      var e = t !== null && t.apply(this, arguments) || this;
      return e.type = a.type, e;
    }
    return a.prototype.init = function() {
      this._elMap = $();
    }, a.prototype.render = function(e, i, r) {
      e !== this._lastGraphicModel && this._clear(), this._lastGraphicModel = e, this._updateElements(e), this._relocate(e, r);
    }, a.prototype._updateElements = function(e) {
      var i = e.useElOptionsToUpdate();
      if (i) {
        var r = this._elMap, f = this.group, b = e.get("z"), G = e.get("zlevel");
        N(i, function(n) {
          var C = z(n.id, null), s = C != null ? r.get(C) : null, l = z(n.parentId, null), y = l != null ? r.get(l) : f, o = n.type, m = n.style;
          o === "text" && m && n.hv && n.hv[1] && (m.textVerticalAlign = m.textBaseline = m.verticalAlign = m.align = null);
          var d = n.textContent, c = n.textConfig;
          if (m && ot(m, o, !!c, !!d)) {
            var h = vt(m, o, !0);
            !c && h.textConfig && (c = n.textConfig = h.textConfig), !d && h.textContent && (d = h.textContent);
          }
          var _ = ht(n), w = n.$action || "merge", T = w === "merge", A = w === "replace";
          if (T) {
            var g = !s, p = s;
            g ? p = j(C, y, n.type, r) : (p && (u(p).isNew = !1), pt(p)), p && (V(p, _, e, {
              isInit: g
            }), q(p, n, b, G));
          } else if (A) {
            D(s, n, r, e);
            var x = j(C, y, n.type, r);
            x && (V(x, _, e, {
              isInit: !0
            }), q(x, n, b, G));
          } else
            w === "remove" && (ft(s, n), D(s, n, r, e));
          var v = r.get(C);
          if (v && d)
            if (T) {
              var U = v.getTextContent();
              U ? U.attr(d) : v.setTextContent(new H(d));
            } else
              A && v.setTextContent(new H(d));
          if (v) {
            var I = n.clipPath;
            if (I) {
              var S = I.type, E = void 0, g = !1;
              if (T) {
                var L = v.getClipPath();
                g = !L || u(L).type !== S, E = g ? K(S) : L;
              } else
                A && (g = !0, E = K(S));
              v.setClipPath(E), V(E, I, e, {
                isInit: g
              }), B(E, I.keyframeAnimation, e);
            }
            var J = u(v);
            v.setTextConfig(c), J.option = n, gt(v, e, n), et({
              el: v,
              componentModel: e,
              itemName: v.name,
              itemTooltipOption: n.tooltip
            }), B(v, n.keyframeAnimation, e);
          }
        });
      }
    }, a.prototype._relocate = function(e, i) {
      for (var r = e.option.elements, f = this.group, b = this._elMap, G = i.getWidth(), n = i.getHeight(), C = ["x", "y"], s = 0; s < r.length; s++) {
        var l = r[s], y = z(l.id, null), o = y != null ? b.get(y) : null;
        if (!(!o || !o.isGroup)) {
          var m = o.parent, d = m === f, c = u(o), h = u(m);
          c.width = F(c.option.width, d ? G : h.width) || 0, c.height = F(c.option.height, d ? n : h.height) || 0;
        }
      }
      for (var s = r.length - 1; s >= 0; s--) {
        var l = r[s], y = z(l.id, null), o = y != null ? b.get(y) : null;
        if (o) {
          var m = o.parent, h = u(m), _ = m === f ? {
            width: G,
            height: n
          } : {
            width: h.width,
            height: h.height
          }, w = {}, T = at(o, l, _, null, {
            hv: l.hv,
            boundingMode: l.bounding
          }, w);
          if (!u(o).isNew && T) {
            for (var A = l.transition, g = {}, p = 0; p < C.length; p++) {
              var x = C[p], v = w[x];
              A && (mt(A) || Q(A, x) >= 0) ? g[x] = v : o[x] = v;
            }
            ut(o, g, e, 0);
          } else
            o.attr(w);
        }
      }
    }, a.prototype._clear = function() {
      var e = this, i = this._elMap;
      i.each(function(r) {
        D(r, u(r).option, i, e._lastGraphicModel);
      }), this._elMap = $();
    }, a.prototype.dispose = function() {
      this._clear();
    }, a.type = "graphic", a;
  }(it)
);
function K(t) {
  var a = Z(R, t) ? R[t] : rt(t), e = new a({});
  return u(e).type = t, e;
}
function j(t, a, e, i) {
  var r = K(e);
  return a.add(r), i.set(t, r), u(r).id = t, u(r).isNew = !0, r;
}
function D(t, a, e, i) {
  var r = t && t.parent;
  r && (t.type === "group" && t.traverse(function(f) {
    D(f, a, e, i);
  }), st(t, a, i), e.removeKey(u(t).id));
}
function q(t, a, e, i) {
  t.isGroup || N([
    ["cursor", O.prototype.cursor],
    // We should not support configure z and zlevel in the element level.
    // But seems we didn't limit it previously. So here still use it to avoid breaking.
    ["zlevel", i || 0],
    ["z", e || 0],
    // z2 must not be null/undefined, otherwise sort error may occur.
    ["z2", 0]
  ], function(r) {
    var f = r[0];
    Z(a, f) ? t[f] = X(a[f], r[1]) : t[f] == null && (t[f] = r[1]);
  }), N(k(a), function(r) {
    if (r.indexOf("on") === 0) {
      var f = a[r];
      t[r] = Y(f) ? f : null;
    }
  }), Z(a, "draggable") && (t.draggable = a.draggable), a.name != null && (t.name = a.name), a.id != null && (t.id = a.id);
}
function ht(t) {
  return t = P({}, t), N(["id", "parentId", "$action", "hv", "bounding", "textContent", "clipPath"].concat(nt), function(a) {
    delete t[a];
  }), t;
}
function gt(t, a, e) {
  var i = W(t).eventData;
  !t.silent && !t.ignore && !i && (i = W(t).eventData = {
    componentType: "graphic",
    componentIndex: a.componentIndex,
    name: t.name
  }), i && (i.info = e.info);
}
export {
  Lt as GraphicComponentView,
  u as inner
};
