import { curry as f, map as l, each as d, indexOf as v, createHashMap as N } from "../../../../zrender/lib/core/util.js";
import { getTransform as P } from "../../util/graphic.js";
import { makeRectPanelClipPath as _, makeRectIsTargetByCursor as B, makeLinearBrushOtherExtent as L } from "./brushHelper.js";
import { parseFinder as D } from "../../util/model.js";
var R = ["grid", "xAxis", "yAxis", "geo", "graph", "polar", "radiusAxis", "angleAxis", "bmap"], b = (
  /** @class */
  function() {
    function i(e, n, t) {
      var r = this;
      this._targetInfoList = [];
      var s = h(n, e);
      d(E, function(o, a) {
        (!t || !t.include || v(t.include, a) >= 0) && o(s, r._targetInfoList);
      });
    }
    return i.prototype.setOutputRanges = function(e, n) {
      return this.matchOutputRanges(e, n, function(t, r, s) {
        if ((t.coordRanges || (t.coordRanges = [])).push(r), !t.coordRange) {
          t.coordRange = r;
          var o = y[t.brushType](0, s, r);
          t.__rangeOffset = {
            offset: I[t.brushType](o.values, t.range, [1, 1]),
            xyMinMax: o.xyMinMax
          };
        }
      }), e;
    }, i.prototype.matchOutputRanges = function(e, n, t) {
      d(e, function(r) {
        var s = this.findTargetInfo(r, n);
        s && s !== !0 && d(s.coordSyses, function(o) {
          var a = y[r.brushType](1, o, r.range, !0);
          t(r, a.values, o, n);
        });
      }, this);
    }, i.prototype.setInputRanges = function(e, n) {
      d(e, function(t) {
        var r = this.findTargetInfo(t, n);
        if (t.range = t.range || [], r && r !== !0) {
          t.panelId = r.panelId;
          var s = y[t.brushType](0, r.coordSys, t.coordRange), o = t.__rangeOffset;
          t.range = o ? I[t.brushType](s.values, o.offset, k(s.xyMinMax, o.xyMinMax)) : s.values;
        }
      }, this);
    }, i.prototype.makePanelOpts = function(e, n) {
      return l(this._targetInfoList, function(t) {
        var r = t.getPanelRect();
        return {
          panelId: t.panelId,
          defaultBrushType: n ? n(t) : null,
          clipPath: _(r),
          isTargetByCursor: B(r, e, t.coordSysModel),
          getLinearBrushOtherExtent: L(r)
        };
      });
    }, i.prototype.controlSeries = function(e, n, t) {
      var r = this.findTargetInfo(e, t);
      return r === !0 || r && v(r.coordSyses, n.coordinateSystem) >= 0;
    }, i.prototype.findTargetInfo = function(e, n) {
      for (var t = this._targetInfoList, r = h(n, e), s = 0; s < t.length; s++) {
        var o = t[s], a = e.panelId;
        if (a) {
          if (o.panelId === a)
            return o;
        } else
          for (var u = 0; u < M.length; u++)
            if (M[u](r, o))
              return o;
      }
      return !0;
    }, i;
  }()
);
function x(i) {
  return i[0] > i[1] && i.reverse(), i;
}
function h(i, e) {
  return D(i, e, {
    includeMainTypes: R
  });
}
var E = {
  grid: function(i, e) {
    var n = i.xAxisModels, t = i.yAxisModels, r = i.gridModels, s = N(), o = {}, a = {};
    !n && !t && !r || (d(n, function(u) {
      var c = u.axis.grid.model;
      s.set(c.id, c), o[c.id] = !0;
    }), d(t, function(u) {
      var c = u.axis.grid.model;
      s.set(c.id, c), a[c.id] = !0;
    }), d(r, function(u) {
      s.set(u.id, u), o[u.id] = !0, a[u.id] = !0;
    }), s.each(function(u) {
      var c = u.coordinateSystem, p = [];
      d(c.getCartesians(), function(g, F) {
        (v(n, g.getAxis("x").model) >= 0 || v(t, g.getAxis("y").model) >= 0) && p.push(g);
      }), e.push({
        panelId: "grid--" + u.id,
        gridModel: u,
        coordSysModel: u,
        // Use the first one as the representitive coordSys.
        coordSys: p[0],
        coordSyses: p,
        getPanelRect: T.grid,
        xAxisDeclared: o[u.id],
        yAxisDeclared: a[u.id]
      });
    }));
  },
  geo: function(i, e) {
    d(i.geoModels, function(n) {
      var t = n.coordinateSystem;
      e.push({
        panelId: "geo--" + n.id,
        geoModel: n,
        coordSysModel: n,
        coordSys: t,
        coordSyses: [t],
        getPanelRect: T.geo
      });
    });
  }
}, M = [
  // grid
  function(i, e) {
    var n = i.xAxisModel, t = i.yAxisModel, r = i.gridModel;
    return !r && n && (r = n.axis.grid.model), !r && t && (r = t.axis.grid.model), r && r === e.gridModel;
  },
  // geo
  function(i, e) {
    var n = i.geoModel;
    return n && n === e.geoModel;
  }
], T = {
  grid: function() {
    return this.coordSys.master.getRect().clone();
  },
  geo: function() {
    var i = this.coordSys, e = i.getBoundingRect().clone();
    return e.applyTransform(P(i)), e;
  }
}, y = {
  lineX: f(m, 0),
  lineY: f(m, 1),
  rect: function(i, e, n, t) {
    var r = i ? e.pointToData([n[0][0], n[1][0]], t) : e.dataToPoint([n[0][0], n[1][0]], t), s = i ? e.pointToData([n[0][1], n[1][1]], t) : e.dataToPoint([n[0][1], n[1][1]], t), o = [x([r[0], s[0]]), x([r[1], s[1]])];
    return {
      values: o,
      xyMinMax: o
    };
  },
  polygon: function(i, e, n, t) {
    var r = [[1 / 0, -1 / 0], [1 / 0, -1 / 0]], s = l(n, function(o) {
      var a = i ? e.pointToData(o, t) : e.dataToPoint(o, t);
      return r[0][0] = Math.min(r[0][0], a[0]), r[1][0] = Math.min(r[1][0], a[1]), r[0][1] = Math.max(r[0][1], a[0]), r[1][1] = Math.max(r[1][1], a[1]), a;
    });
    return {
      values: s,
      xyMinMax: r
    };
  }
};
function m(i, e, n, t) {
  var r = n.getAxis(["x", "y"][i]), s = x(l([0, 1], function(a) {
    return e ? r.coordToData(r.toLocalCoord(t[a]), !0) : r.toGlobalCoord(r.dataToCoord(t[a]));
  })), o = [];
  return o[i] = s, o[1 - i] = [NaN, NaN], {
    values: s,
    xyMinMax: o
  };
}
var I = {
  lineX: f(A, 0),
  lineY: f(A, 1),
  rect: function(i, e, n) {
    return [[i[0][0] - n[0] * e[0][0], i[0][1] - n[0] * e[0][1]], [i[1][0] - n[1] * e[1][0], i[1][1] - n[1] * e[1][1]]];
  },
  polygon: function(i, e, n) {
    return l(i, function(t, r) {
      return [t[0] - n[0] * e[r][0], t[1] - n[1] * e[r][1]];
    });
  }
};
function A(i, e, n, t) {
  return [e[0] - t[i] * n[0], e[1] - t[i] * n[1]];
}
function k(i, e) {
  var n = S(i), t = S(e), r = [n[0] / t[0], n[1] / t[1]];
  return isNaN(r[0]) && (r[0] = 1), isNaN(r[1]) && (r[1] = 1), r;
}
function S(i) {
  return i ? [i[0][1] - i[0][0], i[1][1] - i[1][0]] : [NaN, NaN];
}
const $ = b;
export {
  $ as default
};
