import { createHashMap as G, each as S, extend as L } from "../../../../zrender/lib/core/util.js";
import Z from "./RoamController.js";
import { updateViewOnPan as U, updateViewOnZoom as $ } from "./roamHelper.js";
import { onIrrelevantElement as q } from "./cursorHelper.js";
import { setTooltipConfig as K } from "../../util/graphic.js";
import { setDefaultStateProxy as x, toggleHoverEmphasis as Q, enableComponentHighDownFeatures as W } from "../../util/states.js";
import A from "../../coord/geo/geoSourceManager.js";
import { getUID as C } from "../../util/component.js";
import { setLabelStyle as B, getLabelStatesModels as ee } from "../../label/labelStyle.js";
import { getECData as te } from "../../util/innerStore.js";
import { createOrUpdatePatternFromDecal as oe } from "../../util/decal.js";
import F from "../../../../zrender/lib/graphic/Displayable.js";
import { makeInner as re } from "../../util/model.js";
import D from "../../../../zrender/lib/graphic/Group.js";
import { updateProps as ae } from "../../animation/basicTransition.js";
import ne from "../../../../zrender/lib/graphic/shape/Polygon.js";
import ie from "../../../../zrender/lib/graphic/shape/Polyline.js";
import se from "../../../../zrender/lib/graphic/CompoundPath.js";
var b = ["rect", "circle", "line", "ellipse", "polygon", "polyline", "path"], le = G(b), ue = G(b.concat(["g"])), pe = G(b.concat(["g"])), X = re();
function I(u) {
  var e = u.getItemStyle(), t = u.get("areaColor");
  return t != null && (e.fill = t), e;
}
function w(u) {
  var e = u.style;
  e && (e.stroke = e.stroke || e.fill, e.fill = null);
}
var fe = (
  /** @class */
  function() {
    function u(e) {
      var t = new D();
      this.uid = C("ec_map_draw"), this._controller = new Z(e.getZr()), this._controllerHost = {
        target: t
      }, this.group = t, t.add(this._regionsGroup = new D()), t.add(this._svgGroup = new D());
    }
    return u.prototype.draw = function(e, t, o, l, r) {
      var i = e.mainType === "geo", n = e.getData && e.getData();
      i && t.eachComponent({
        mainType: "series",
        subType: "map"
      }, function(h) {
        !n && h.getHostGeoModel() === e && (n = h.getData());
      });
      var p = e.coordinateSystem, a = this._regionsGroup, c = this.group, g = p.getTransformInfo(), v = g.raw, s = g.roam, f = !a.childAt(0) || r;
      f ? (c.x = s.x, c.y = s.y, c.scaleX = s.scaleX, c.scaleY = s.scaleY, c.dirty()) : ae(c, s, e);
      var m = n && n.getVisual("visualMeta") && n.getVisual("visualMeta").length > 0, d = {
        api: o,
        geo: p,
        mapOrGeoModel: e,
        data: n,
        isVisualEncodedByVisualMap: m,
        isGeo: i,
        transformInfoRaw: v
      };
      p.resourceType === "geoJSON" ? this._buildGeoJSON(d) : p.resourceType === "geoSVG" && this._buildSVG(d), this._updateController(e, t, o), this._updateMapSelectHandler(e, a, o, l);
    }, u.prototype._buildGeoJSON = function(e) {
      var t = this._regionsGroupByName = G(), o = G(), l = this._regionsGroup, r = e.transformInfoRaw, i = e.mapOrGeoModel, n = e.data, p = e.geo.projection, a = p && p.stream;
      function c(s, f) {
        return f && (s = f(s)), s && [s[0] * r.scaleX + r.x, s[1] * r.scaleY + r.y];
      }
      function g(s) {
        for (var f = [], m = !a && p && p.project, d = 0; d < s.length; ++d) {
          var h = c(s[d], m);
          h && f.push(h);
        }
        return f;
      }
      function v(s) {
        return {
          shape: {
            points: g(s)
          }
        };
      }
      l.removeAll(), S(e.geo.regions, function(s) {
        var f = s.name, m = t.get(f), d = o.get(f) || {}, h = d.dataIdx, M = d.regionModel;
        if (!m) {
          m = t.set(f, new D()), l.add(m), h = n ? n.indexOfName(f) : null, M = e.isGeo ? i.getRegionModel(f) : n ? n.getItemModel(h) : null;
          var V = M.get("silent", !0);
          V != null && (m.silent = V), o.set(f, {
            dataIdx: h,
            regionModel: M
          });
        }
        var N = [], P = [];
        S(s.geometries, function(_) {
          if (_.type === "polygon") {
            var T = [_.exterior].concat(_.interiors || []);
            a && (T = j(T, a)), S(T, function(R) {
              N.push(new ne(v(R)));
            });
          } else {
            var y = _.points;
            a && (y = j(y, a, !0)), S(y, function(R) {
              P.push(new ie(v(R)));
            });
          }
        });
        var J = c(s.getCenter(), p && p.project);
        function E(_, T) {
          if (_.length) {
            var y = new se({
              culling: !0,
              segmentIgnoreThreshold: 1,
              shape: {
                paths: _
              }
            });
            m.add(y), H(e, y, h, M), k(e, y, f, M, i, h, J), T && (w(y), S(y.states, w));
          }
        }
        E(N), E(P, !0);
      }), t.each(function(s, f) {
        var m = o.get(f), d = m.dataIdx, h = m.regionModel;
        O(e, s, f, h, i, d), z(e, s, f, h, i), Y(e, s, f, h, i);
      }, this);
    }, u.prototype._buildSVG = function(e) {
      var t = e.geo.map, o = e.transformInfoRaw;
      this._svgGroup.x = o.x, this._svgGroup.y = o.y, this._svgGroup.scaleX = o.scaleX, this._svgGroup.scaleY = o.scaleY, this._svgResourceChanged(t) && (this._freeSVG(), this._useSVG(t));
      var l = this._svgDispatcherMap = G(), r = !1;
      S(this._svgGraphicRecord.named, function(i) {
        var n = i.name, p = e.mapOrGeoModel, a = e.data, c = i.svgNodeTagLower, g = i.el, v = a ? a.indexOfName(n) : null, s = p.getRegionModel(n);
        le.get(c) != null && g instanceof F && H(e, g, v, s), g instanceof F && (g.culling = !0);
        var f = s.get("silent", !0);
        if (f != null && (g.silent = f), g.z2EmphasisLift = 0, !i.namedFrom && (pe.get(c) != null && k(e, g, n, s, p, v, null), O(e, g, n, s, p, v), z(e, g, n, s, p), ue.get(c) != null)) {
          var m = Y(e, g, n, s, p);
          m === "self" && (r = !0);
          var d = l.get(n) || l.set(n, []);
          d.push(g);
        }
      }, this), this._enableBlurEntireSVG(r, e);
    }, u.prototype._enableBlurEntireSVG = function(e, t) {
      if (e && t.isGeo) {
        var o = t.mapOrGeoModel.getModel(["blur", "itemStyle"]).getItemStyle(), l = o.opacity;
        this._svgGraphicRecord.root.traverse(function(r) {
          if (!r.isGroup) {
            x(r);
            var i = r.ensureState("blur").style || {};
            i.opacity == null && l != null && (i.opacity = l), r.ensureState("emphasis");
          }
        });
      }
    }, u.prototype.remove = function() {
      this._regionsGroup.removeAll(), this._regionsGroupByName = null, this._svgGroup.removeAll(), this._freeSVG(), this._controller.dispose(), this._controllerHost = null;
    }, u.prototype.findHighDownDispatchers = function(e, t) {
      if (e == null)
        return [];
      var o = t.coordinateSystem;
      if (o.resourceType === "geoJSON") {
        var l = this._regionsGroupByName;
        if (l) {
          var r = l.get(e);
          return r ? [r] : [];
        }
      } else if (o.resourceType === "geoSVG")
        return this._svgDispatcherMap && this._svgDispatcherMap.get(e) || [];
    }, u.prototype._svgResourceChanged = function(e) {
      return this._svgMapName !== e;
    }, u.prototype._useSVG = function(e) {
      var t = A.getGeoResource(e);
      if (t && t.type === "geoSVG") {
        var o = t.useGraphic(this.uid);
        this._svgGroup.add(o.root), this._svgGraphicRecord = o, this._svgMapName = e;
      }
    }, u.prototype._freeSVG = function() {
      var e = this._svgMapName;
      if (e != null) {
        var t = A.getGeoResource(e);
        t && t.type === "geoSVG" && t.freeGraphic(this.uid), this._svgGraphicRecord = null, this._svgDispatcherMap = null, this._svgGroup.removeAll(), this._svgMapName = null;
      }
    }, u.prototype._updateController = function(e, t, o) {
      var l = e.coordinateSystem, r = this._controller, i = this._controllerHost;
      i.zoomLimit = e.get("scaleLimit"), i.zoom = l.getZoom(), r.enable(e.get("roam") || !1);
      var n = e.mainType;
      function p() {
        var a = {
          type: "geoRoam",
          componentType: n
        };
        return a[n + "Id"] = e.id, a;
      }
      r.off("pan").on("pan", function(a) {
        this._mouseDownFlag = !1, U(i, a.dx, a.dy), o.dispatchAction(L(p(), {
          dx: a.dx,
          dy: a.dy,
          animation: {
            duration: 0
          }
        }));
      }, this), r.off("zoom").on("zoom", function(a) {
        this._mouseDownFlag = !1, $(i, a.scale, a.originX, a.originY), o.dispatchAction(L(p(), {
          totalZoom: i.zoom,
          zoom: a.scale,
          originX: a.originX,
          originY: a.originY,
          animation: {
            duration: 0
          }
        }));
      }, this), r.setPointerChecker(function(a, c, g) {
        return l.containPoint([c, g]) && !q(a, o, e);
      });
    }, u.prototype.resetForLabelLayout = function() {
      this.group.traverse(function(e) {
        var t = e.getTextContent();
        t && (t.ignore = X(t).ignore);
      });
    }, u.prototype._updateMapSelectHandler = function(e, t, o, l) {
      var r = this;
      t.off("mousedown"), t.off("click"), e.get("selectedMode") && (t.on("mousedown", function() {
        r._mouseDownFlag = !0;
      }), t.on("click", function(i) {
        r._mouseDownFlag && (r._mouseDownFlag = !1);
      }));
    }, u;
  }()
);
function H(u, e, t, o) {
  var l = o.getModel("itemStyle"), r = o.getModel(["emphasis", "itemStyle"]), i = o.getModel(["blur", "itemStyle"]), n = o.getModel(["select", "itemStyle"]), p = I(l), a = I(r), c = I(n), g = I(i), v = u.data;
  if (v) {
    var s = v.getItemVisual(t, "style"), f = v.getItemVisual(t, "decal");
    u.isVisualEncodedByVisualMap && s.fill && (p.fill = s.fill), f && (p.decal = oe(f, u.api));
  }
  e.setStyle(p), e.style.strokeNoScale = !0, e.ensureState("emphasis").style = a, e.ensureState("select").style = c, e.ensureState("blur").style = g, x(e);
}
function k(u, e, t, o, l, r, i) {
  var n = u.data, p = u.isGeo, a = n && isNaN(n.get(n.mapDimension("value"), r)), c = n && n.getItemLayout(r);
  if (p || a || c && c.showLabel) {
    var g = p ? t : r, v = void 0;
    (!n || r >= 0) && (v = l);
    var s = i ? {
      normal: {
        align: "center",
        verticalAlign: "middle"
      }
    } : null;
    B(e, ee(o), {
      labelFetcher: v,
      labelDataIndex: g,
      defaultText: t
    }, s);
    var f = e.getTextContent();
    if (f && (X(f).ignore = f.ignore, e.textConfig && i)) {
      var m = e.getBoundingRect().clone();
      e.textConfig.layoutRect = m, e.textConfig.position = [(i[0] - m.x) / m.width * 100 + "%", (i[1] - m.y) / m.height * 100 + "%"];
    }
    e.disableLabelAnimation = !0;
  } else
    e.removeTextContent(), e.removeTextConfig(), e.disableLabelAnimation = null;
}
function O(u, e, t, o, l, r) {
  u.data ? u.data.setItemGraphicEl(r, e) : te(e).eventData = {
    componentType: "geo",
    componentIndex: l.componentIndex,
    geoIndex: l.componentIndex,
    name: t,
    region: o && o.option || {}
  };
}
function z(u, e, t, o, l) {
  u.data || K({
    el: e,
    componentModel: l,
    itemName: t,
    // @ts-ignore FIXME:TS fix the "compatible with each other"?
    itemTooltipOption: o.get("tooltip")
  });
}
function Y(u, e, t, o, l) {
  e.highDownSilentOnTouch = !!l.get("selectedMode");
  var r = o.getModel("emphasis"), i = r.get("focus");
  return Q(e, i, r.get("blurScope"), r.get("disabled")), u.isGeo && W(e, l, t), i;
}
function j(u, e, t) {
  var o = [], l;
  function r() {
    l = [];
  }
  function i() {
    l.length && (o.push(l), l = []);
  }
  var n = e({
    polygonStart: r,
    polygonEnd: i,
    lineStart: r,
    lineEnd: i,
    point: function(p, a) {
      isFinite(p) && isFinite(a) && l.push([p, a]);
    },
    sphere: function() {
    }
  });
  return !t && n.polygonStart(), S(u, function(p) {
    n.lineStart();
    for (var a = 0; a < p.length; a++)
      n.point(p[a][0], p[a][1]);
    n.lineEnd();
  }), !t && n.polygonEnd(), o;
}
const Pe = fe;
export {
  Pe as default
};
