import { __extends as X } from "../../../../tslib/tslib.es6.js";
import { defaults as j, createHashMap as q, extend as O, isFunction as P, isString as J, curry as Q, each as Y } from "../../../../zrender/lib/core/util.js";
import { parse as N, stringify as M } from "../../../../zrender/lib/tool/color.js";
import { setTooltipConfig as tt } from "../../util/graphic.js";
import { enableHoverEmphasis as E } from "../../util/states.js";
import { setLabelStyle as et, createTextStyle as it } from "../../label/labelStyle.js";
import { makeBackground as rt } from "../helper/listComponent.js";
import { getLayoutRect as K, box as V } from "../../util/layout.js";
import nt from "../../view/Component.js";
import { createSymbol as at } from "../../util/symbol.js";
import { createOrUpdatePatternFromDecal as ot } from "../../util/decal.js";
import { getECData as $ } from "../../util/innerStore.js";
import z from "../../../../zrender/lib/graphic/Text.js";
import st from "../../../../zrender/lib/graphic/shape/Rect.js";
import lt from "../../../../zrender/lib/graphic/Group.js";
var L = Q, B = Y, H = lt, ct = (
  /** @class */
  function(a) {
    X(r, a);
    function r() {
      var t = a !== null && a.apply(this, arguments) || this;
      return t.type = r.type, t.newlineDisabled = !1, t;
    }
    return r.prototype.init = function() {
      this.group.add(this._contentGroup = new H()), this.group.add(this._selectorGroup = new H()), this._isFirstRender = !0;
    }, r.prototype.getContentGroup = function() {
      return this._contentGroup;
    }, r.prototype.getSelectorGroup = function() {
      return this._selectorGroup;
    }, r.prototype.render = function(t, e, h) {
      var c = this._isFirstRender;
      if (this._isFirstRender = !1, this.resetInner(), !!t.get("show", !0)) {
        var f = t.get("align"), m = t.get("orient");
        (!f || f === "auto") && (f = t.get("left") === "right" && m === "vertical" ? "right" : "left");
        var v = t.get("selector", !0), i = t.get("selectorPosition", !0);
        v && (!i || i === "auto") && (i = m === "horizontal" ? "end" : "start"), this.renderInner(f, t, e, h, v, m, i);
        var s = t.getBoxLayoutParams(), u = {
          width: h.getWidth(),
          height: h.getHeight()
        }, o = t.get("padding"), l = K(s, u, o), g = this.layoutInner(t, f, l, c, v, i), n = K(j({
          width: g.width,
          height: g.height
        }, s), u, o);
        this.group.x = n.x - g.x, this.group.y = n.y - g.y, this.group.markRedraw(), this.group.add(this._backgroundEl = rt(g, t));
      }
    }, r.prototype.resetInner = function() {
      this.getContentGroup().removeAll(), this._backgroundEl && this.group.remove(this._backgroundEl), this.getSelectorGroup().removeAll();
    }, r.prototype.renderInner = function(t, e, h, c, f, m, v) {
      var i = this.getContentGroup(), s = q(), u = e.get("selectedMode"), o = [];
      h.eachRawSeries(function(l) {
        !l.get("legendHoverLink") && o.push(l.id);
      }), B(e.getData(), function(l, g) {
        var n = l.get("name");
        if (!this.newlineDisabled && (n === "" || n === `
`)) {
          var y = new H();
          y.newline = !0, i.add(y);
          return;
        }
        var p = h.getSeriesByName(n)[0];
        if (!s.get(n))
          if (p) {
            var x = p.getData(), d = x.getVisual("legendLineStyle") || {}, C = x.getVisual("legendIcon"), S = x.getVisual("style"), _ = this._createItem(p, n, g, l, e, t, d, S, C, u, c);
            _.on("click", L(U, n, null, c, o)).on("mouseover", L(F, p.name, null, c, o)).on("mouseout", L(I, p.name, null, c, o)), h.ssr && _.eachChild(function(k) {
              var w = $(k);
              w.seriesIndex = p.seriesIndex, w.dataIndex = g, w.ssrType = "legend";
            }), s.set(n, !0);
          } else
            h.eachRawSeries(function(k) {
              if (!s.get(n) && k.legendVisualProvider) {
                var w = k.legendVisualProvider;
                if (!w.containName(n))
                  return;
                var D = w.indexOfName(n), b = w.getItemVisual(D, "style"), W = w.getItemVisual(D, "legendIcon"), R = N(b.fill);
                R && R[3] === 0 && (R[3] = 0.2, b = O(O({}, b), {
                  fill: M(R, "rgba")
                }));
                var G = this._createItem(k, n, g, l, e, t, {}, b, W, u, c);
                G.on("click", L(U, null, n, c, o)).on("mouseover", L(F, null, n, c, o)).on("mouseout", L(I, null, n, c, o)), h.ssr && G.eachChild(function(T) {
                  var A = $(T);
                  A.seriesIndex = k.seriesIndex, A.dataIndex = g, A.ssrType = "legend";
                }), s.set(n, !0);
              }
            }, this);
      }, this), f && this._createSelector(f, e, c, m, v);
    }, r.prototype._createSelector = function(t, e, h, c, f) {
      var m = this.getSelectorGroup();
      B(t, function(i) {
        var s = i.type, u = new z({
          style: {
            x: 0,
            y: 0,
            align: "center",
            verticalAlign: "middle"
          },
          onclick: function() {
            h.dispatchAction({
              type: s === "all" ? "legendAllSelect" : "legendInverseSelect",
              legendId: e.id
            });
          }
        });
        m.add(u);
        var o = e.getModel("selectorLabel"), l = e.getModel(["emphasis", "selectorLabel"]);
        et(u, {
          normal: o,
          emphasis: l
        }, {
          defaultText: i.title
        }), E(u);
      });
    }, r.prototype._createItem = function(t, e, h, c, f, m, v, i, s, u, o) {
      var l = t.visualDrawType, g = f.get("itemWidth"), n = f.get("itemHeight"), y = f.isSelected(e), p = c.get("symbolRotate"), x = c.get("symbolKeepAspect"), d = c.get("icon");
      s = d || s || "roundRect";
      var C = ht(s, c, v, i, l, y, o), S = new H(), _ = c.getModel("textStyle");
      if (P(t.getLegendIcon) && (!d || d === "inherit"))
        S.add(t.getLegendIcon({
          itemWidth: g,
          itemHeight: n,
          icon: s,
          iconRotate: p,
          itemStyle: C.itemStyle,
          lineStyle: C.lineStyle,
          symbolKeepAspect: x
        }));
      else {
        var k = d === "inherit" && t.getData().getVisual("symbol") ? p === "inherit" ? t.getData().getVisual("symbolRotate") : p : 0;
        S.add(ut({
          itemWidth: g,
          itemHeight: n,
          icon: s,
          iconRotate: k,
          itemStyle: C.itemStyle,
          lineStyle: C.lineStyle,
          symbolKeepAspect: x
        }));
      }
      var w = m === "left" ? g + 5 : -5, D = m, b = f.get("formatter"), W = e;
      J(b) && b ? W = b.replace("{name}", e ?? "") : P(b) && (W = b(e));
      var R = y ? _.getTextColor() : c.get("inactiveColor");
      S.add(new z({
        style: it(_, {
          text: W,
          x: w,
          y: n / 2,
          fill: R,
          align: D,
          verticalAlign: "middle"
        }, {
          inheritColor: R
        })
      }));
      var G = new st({
        shape: S.getBoundingRect(),
        style: {
          // Cannot use 'invisible' because SVG SSR will miss the node
          fill: "transparent"
        }
      }), T = c.getModel("tooltip");
      return T.get("show") && tt({
        el: G,
        componentModel: f,
        itemName: e,
        itemTooltipOption: T.option
      }), S.add(G), S.eachChild(function(A) {
        A.silent = !0;
      }), G.silent = !u, this.getContentGroup().add(S), E(S), S.__legendDataIndex = h, S;
    }, r.prototype.layoutInner = function(t, e, h, c, f, m) {
      var v = this.getContentGroup(), i = this.getSelectorGroup();
      V(t.get("orient"), v, t.get("itemGap"), h.width, h.height);
      var s = v.getBoundingRect(), u = [-s.x, -s.y];
      if (i.markRedraw(), v.markRedraw(), f) {
        V(
          // Buttons in selectorGroup always layout horizontally
          "horizontal",
          i,
          t.get("selectorItemGap", !0)
        );
        var o = i.getBoundingRect(), l = [-o.x, -o.y], g = t.get("selectorButtonGap", !0), n = t.getOrient().index, y = n === 0 ? "width" : "height", p = n === 0 ? "height" : "width", x = n === 0 ? "y" : "x";
        m === "end" ? l[n] += s[y] + g : u[n] += o[y] + g, l[1 - n] += s[p] / 2 - o[p] / 2, i.x = l[0], i.y = l[1], v.x = u[0], v.y = u[1];
        var d = {
          x: 0,
          y: 0
        };
        return d[y] = s[y] + g + o[y], d[p] = Math.max(s[p], o[p]), d[x] = Math.min(0, o[x] + l[1 - n]), d;
      } else
        return v.x = u[0], v.y = u[1], this.group.getBoundingRect();
    }, r.prototype.remove = function() {
      this.getContentGroup().removeAll(), this._isFirstRender = !0;
    }, r.type = "legend.plain", r;
  }(nt)
);
function ht(a, r, t, e, h, c, f) {
  function m(y, p) {
    y.lineWidth === "auto" && (y.lineWidth = p.lineWidth > 0 ? 2 : 0), B(y, function(x, d) {
      y[d] === "inherit" && (y[d] = p[d]);
    });
  }
  var v = r.getModel("itemStyle"), i = v.getItemStyle(), s = a.lastIndexOf("empty", 0) === 0 ? "fill" : "stroke", u = v.getShallow("decal");
  i.decal = !u || u === "inherit" ? e.decal : ot(u, f), i.fill === "inherit" && (i.fill = e[h]), i.stroke === "inherit" && (i.stroke = e[s]), i.opacity === "inherit" && (i.opacity = (h === "fill" ? e : t).opacity), m(i, e);
  var o = r.getModel("lineStyle"), l = o.getLineStyle();
  if (m(l, t), i.fill === "auto" && (i.fill = e.fill), i.stroke === "auto" && (i.stroke = e.fill), l.stroke === "auto" && (l.stroke = e.fill), !c) {
    var g = r.get("inactiveBorderWidth"), n = i[s];
    i.lineWidth = g === "auto" ? e.lineWidth > 0 && n ? 2 : 0 : i.lineWidth, i.fill = r.get("inactiveColor"), i.stroke = r.get("inactiveBorderColor"), l.stroke = o.get("inactiveColor"), l.lineWidth = o.get("inactiveWidth");
  }
  return {
    itemStyle: i,
    lineStyle: l
  };
}
function ut(a) {
  var r = a.icon || "roundRect", t = at(r, 0, 0, a.itemWidth, a.itemHeight, a.itemStyle.fill, a.symbolKeepAspect);
  return t.setStyle(a.itemStyle), t.rotation = (a.iconRotate || 0) * Math.PI / 180, t.setOrigin([a.itemWidth / 2, a.itemHeight / 2]), r.indexOf("empty") > -1 && (t.style.stroke = t.style.fill, t.style.fill = "#fff", t.style.lineWidth = 2), t;
}
function U(a, r, t, e) {
  I(a, r, t, e), t.dispatchAction({
    type: "legendToggleSelect",
    name: a ?? r
  }), F(a, r, t, e);
}
function Z(a) {
  for (var r = a.getZr().storage.getDisplayList(), t, e = 0, h = r.length; e < h && !(t = r[e].states.emphasis); )
    e++;
  return t && t.hoverLayer;
}
function F(a, r, t, e) {
  Z(t) || t.dispatchAction({
    type: "highlight",
    seriesName: a,
    name: r,
    excludeSeriesId: e
  });
}
function I(a, r, t, e) {
  Z(t) || t.dispatchAction({
    type: "downplay",
    seriesName: a,
    name: r,
    excludeSeriesId: e
  });
}
const Lt = ct;
export {
  Lt as default
};
