import { __extends as B } from "../../../../tslib/tslib.es6.js";
import { modifyAlpha as C } from "../../../../zrender/lib/tool/color.js";
import G from "../../data/SeriesData.js";
import { asc as N, parsePercent as M } from "../../util/number.js";
import { setStatesStylesFromModel as J, toggleHoverEmphasis as Q } from "../../util/states.js";
import { dataTransform as b, zoneFilter as R, dataFilter as w } from "./markerHelper.js";
import U from "./MarkerView.js";
import { map as k, isString as F, extend as L, curry as P, filter as X, retrieve as D, mergeAll as Y } from "../../../../zrender/lib/core/util.js";
import { isCoordinateSystemType as W } from "../../coord/CoordinateSystem.js";
import Z from "./MarkerModel.js";
import { makeInner as _ } from "../../util/model.js";
import { getVisualFromData as V } from "../../visual/helper.js";
import { setLabelStyle as tt, getLabelStatesModels as rt } from "../../label/labelStyle.js";
import { getECData as et } from "../../util/innerStore.js";
import { parseDataValue as T } from "../../data/helper/dataValueHelper.js";
import at from "../../../../zrender/lib/graphic/Group.js";
import H from "../../../../zrender/lib/graphic/shape/Polygon.js";
import { updateProps as ot } from "../../animation/basicTransition.js";
var A = _(), it = function(o, i, t, n) {
  var m = n[0], v = n[1];
  if (!(!m || !v)) {
    var u = b(o, m), f = b(o, v), g = u.coord, l = f.coord;
    g[0] = D(g[0], -1 / 0), g[1] = D(g[1], -1 / 0), l[0] = D(l[0], 1 / 0), l[1] = D(l[1], 1 / 0);
    var e = Y([{}, u, f]);
    return e.coord = [u.coord, f.coord], e.x0 = u.x, e.y0 = u.y, e.x1 = f.x, e.y1 = f.y, e;
  }
};
function E(o) {
  return !isNaN(o) && !isFinite(o);
}
function O(o, i, t, n) {
  var m = 1 - o;
  return E(i[m]) && E(t[m]);
}
function nt(o, i) {
  var t = i.coord[0], n = i.coord[1], m = {
    coord: t,
    x: i.x0,
    y: i.y0
  }, v = {
    coord: n,
    x: i.x1,
    y: i.y1
  };
  return W(o, "cartesian2d") ? t && n && (O(1, t, n) || O(0, t, n)) ? !0 : R(o, m, v) : w(o, m) || w(o, v);
}
function z(o, i, t, n, m) {
  var v = n.coordinateSystem, u = o.getItemModel(i), f, g = M(u.get(t[0]), m.getWidth()), l = M(u.get(t[1]), m.getHeight());
  if (!isNaN(g) && !isNaN(l))
    f = [g, l];
  else {
    if (n.getMarkerPosition) {
      var e = o.getValues(["x0", "y0"], i), a = o.getValues(["x1", "y1"], i), r = v.clampData(e), p = v.clampData(a), s = [];
      t[0] === "x0" ? s[0] = r[0] > p[0] ? a[0] : e[0] : s[0] = r[0] > p[0] ? e[0] : a[0], t[1] === "y0" ? s[1] = r[1] > p[1] ? a[1] : e[1] : s[1] = r[1] > p[1] ? e[1] : a[1], f = n.getMarkerPosition(s, t, !0);
    } else {
      var y = o.get(t[0], i), h = o.get(t[1], i), x = [y, h];
      v.clampData && v.clampData(x, x), f = v.dataToPoint(x, !0);
    }
    if (W(v, "cartesian2d")) {
      var I = v.getAxis("x"), d = v.getAxis("y"), y = o.get(t[0], i), h = o.get(t[1], i);
      E(y) ? f[0] = I.toGlobalCoord(I.getExtent()[t[0] === "x0" ? 0 : 1]) : E(h) && (f[1] = d.toGlobalCoord(d.getExtent()[t[1] === "y0" ? 0 : 1]));
    }
    isNaN(g) || (f[0] = g), isNaN(l) || (f[1] = l);
  }
  return f;
}
var K = [["x0", "y0"], ["x1", "y0"], ["x1", "y1"], ["x0", "y1"]], ft = (
  /** @class */
  function(o) {
    B(i, o);
    function i() {
      var t = o !== null && o.apply(this, arguments) || this;
      return t.type = i.type, t;
    }
    return i.prototype.updateTransform = function(t, n, m) {
      n.eachSeries(function(v) {
        var u = Z.getMarkerModelFromSeries(v, "markArea");
        if (u) {
          var f = u.getData();
          f.each(function(g) {
            var l = k(K, function(a) {
              return z(f, g, a, v, m);
            });
            f.setItemLayout(g, l);
            var e = f.getItemGraphicEl(g);
            e.setShape("points", l);
          });
        }
      }, this);
    }, i.prototype.renderSeries = function(t, n, m, v) {
      var u = t.coordinateSystem, f = t.id, g = t.getData(), l = this.markerGroupMap, e = l.get(f) || l.set(f, {
        group: new at()
      });
      this.group.add(e.group), this.markKeep(e);
      var a = lt(u, t, n);
      n.setData(a), a.each(function(r) {
        var p = k(K, function(q) {
          return z(a, r, q, t, v);
        }), s = u.getAxis("x").scale, y = u.getAxis("y").scale, h = s.getExtent(), x = y.getExtent(), I = [s.parse(a.get("x0", r)), s.parse(a.get("x1", r))], d = [y.parse(a.get("y0", r)), y.parse(a.get("y1", r))];
        N(I), N(d);
        var $ = !(h[0] > I[1] || h[1] < I[0] || x[0] > d[1] || x[1] < d[0]), j = !$;
        a.setItemLayout(r, {
          points: p,
          allClipped: j
        });
        var c = a.getItemModel(r).getModel("itemStyle").getItemStyle(), S = V(g, "color");
        c.fill || (c.fill = S, F(c.fill) && (c.fill = C(c.fill, 0.4))), c.stroke || (c.stroke = S), a.setItemVisual(r, "style", c);
      }), a.diff(A(e).data).add(function(r) {
        var p = a.getItemLayout(r);
        if (!p.allClipped) {
          var s = new H({
            shape: {
              points: p.points
            }
          });
          a.setItemGraphicEl(r, s), e.group.add(s);
        }
      }).update(function(r, p) {
        var s = A(e).data.getItemGraphicEl(p), y = a.getItemLayout(r);
        y.allClipped ? s && e.group.remove(s) : (s ? ot(s, {
          shape: {
            points: y.points
          }
        }, n, r) : s = new H({
          shape: {
            points: y.points
          }
        }), a.setItemGraphicEl(r, s), e.group.add(s));
      }).remove(function(r) {
        var p = A(e).data.getItemGraphicEl(r);
        e.group.remove(p);
      }).execute(), a.eachItemGraphicEl(function(r, p) {
        var s = a.getItemModel(p), y = a.getItemVisual(p, "style");
        r.useStyle(a.getItemVisual(p, "style")), tt(r, rt(s), {
          labelFetcher: n,
          labelDataIndex: p,
          defaultText: a.getName(p) || "",
          inheritColor: F(y.fill) ? C(y.fill, 1) : "#000"
        }), J(r, s), Q(r, null, null, s.get(["emphasis", "disabled"])), et(r).dataModel = n;
      }), A(e).data = a, e.group.silent = n.get("silent") || t.get("silent");
    }, i.type = "markArea", i;
  }(U)
);
function lt(o, i, t) {
  var n, m, v = ["x0", "y0", "x1", "y1"];
  if (o) {
    var u = k(o && o.dimensions, function(l) {
      var e = i.getData(), a = e.getDimensionInfo(e.mapDimension(l)) || {};
      return L(L({}, a), {
        name: l,
        // DON'T use ordinalMeta to parse and collect ordinal.
        ordinalMeta: null
      });
    });
    m = k(v, function(l, e) {
      return {
        name: l,
        type: u[e % 2].type
      };
    }), n = new G(m, t);
  } else
    m = [{
      name: "value",
      type: "float"
    }], n = new G(m, t);
  var f = k(t.get("data"), P(it, i, o, t));
  o && (f = X(f, P(nt, o)));
  var g = o ? function(l, e, a, r) {
    var p = l.coord[Math.floor(r / 2)][r % 2];
    return T(p, m[r]);
  } : function(l, e, a, r) {
    return T(l.value, m[r]);
  };
  return n.initData(f, null, g), n.hasItemOption = !0, n;
}
const Gt = ft;
export {
  Gt as default,
  K as dimPermutations
};
