import { __extends as q } from "../../../../tslib/tslib.es6.js";
import z from "../../data/SeriesData.js";
import { parsePercent as P } from "../../util/number.js";
import { getAxisInfo as B, numCalculate as J, dataTransform as E, dataFilter as H, createMarkerDimValueGetter as Q } from "./markerHelper.js";
import U from "../../chart/helper/LineDraw.js";
import X from "./MarkerView.js";
import { getStackedDimension as Y } from "../../data/helper/dataStackHelper.js";
import { isCoordinateSystemType as Z } from "../../coord/CoordinateSystem.js";
import { getECData as M } from "../../util/innerStore.js";
import T from "./MarkerModel.js";
import { isArray as h, retrieve2 as A, map as V, extend as G, curry as W, filter as C, retrieve as F, clone as _, isNumber as x, merge as $ } from "../../../../zrender/lib/core/util.js";
import { makeInner as d } from "../../util/model.js";
import { getVisualFromData as tt } from "../../visual/helper.js";
var N = d(), et = function(e, a, r, t) {
  var y = e.getData(), i;
  if (h(t))
    i = t;
  else {
    var l = t.type;
    if (l === "min" || l === "max" || l === "average" || l === "median" || t.xAxis != null || t.yAxis != null) {
      var o = void 0, f = void 0;
      if (t.yAxis != null || t.xAxis != null)
        o = a.getAxis(t.yAxis != null ? "y" : "x"), f = F(t.yAxis, t.xAxis);
      else {
        var s = B(t, y, a, e);
        o = s.valueAxis;
        var m = Y(y, s.valueDataDim);
        f = J(y, m, l);
      }
      var c = o.dim === "x" ? 0 : 1, g = 1 - c, u = _(t), v = {
        coord: []
      };
      u.type = null, u.coord = [], u.coord[g] = -1 / 0, v.coord[g] = 1 / 0;
      var D = r.get("precision");
      D >= 0 && x(f) && (f = +f.toFixed(Math.min(D, 20))), u.coord[c] = v.coord[c] = f, i = [u, v, {
        type: l,
        valueIndex: t.valueIndex,
        // Force to use the value of calculated value.
        value: f
      }];
    } else
      i = [];
  }
  var p = [E(e, i[0]), E(e, i[1]), G({}, i[2])];
  return p[2].type = p[2].type || null, $(p[2], p[0]), $(p[2], p[1]), p;
};
function w(e) {
  return !isNaN(e) && !isFinite(e);
}
function j(e, a, r, t) {
  var y = 1 - e, i = t.dimensions[e];
  return w(a[y]) && w(r[y]) && a[e] === r[e] && t.getAxis(i).containData(a[e]);
}
function at(e, a) {
  if (e.type === "cartesian2d") {
    var r = a[0].coord, t = a[1].coord;
    if (r && t && (j(1, r, t, e) || j(0, r, t, e)))
      return !0;
  }
  return H(e, a[0]) && H(e, a[1]);
}
function R(e, a, r, t, y) {
  var i = t.coordinateSystem, l = e.getItemModel(a), o, f = P(l.get("x"), y.getWidth()), s = P(l.get("y"), y.getHeight());
  if (!isNaN(f) && !isNaN(s))
    o = [f, s];
  else {
    if (t.getMarkerPosition)
      o = t.getMarkerPosition(e.getValues(e.dimensions, a));
    else {
      var m = i.dimensions, c = e.get(m[0], a), g = e.get(m[1], a);
      o = i.dataToPoint([c, g]);
    }
    if (Z(i, "cartesian2d")) {
      var u = i.getAxis("x"), v = i.getAxis("y"), m = i.dimensions;
      w(e.get(m[0], a)) ? o[0] = u.toGlobalCoord(u.getExtent()[r ? 0 : 1]) : w(e.get(m[1], a)) && (o[1] = v.toGlobalCoord(v.getExtent()[r ? 0 : 1]));
    }
    isNaN(f) || (o[0] = f), isNaN(s) || (o[1] = s);
  }
  e.setItemLayout(a, o);
}
var rt = (
  /** @class */
  function(e) {
    q(a, e);
    function a() {
      var r = e !== null && e.apply(this, arguments) || this;
      return r.type = a.type, r;
    }
    return a.prototype.updateTransform = function(r, t, y) {
      t.eachSeries(function(i) {
        var l = T.getMarkerModelFromSeries(i, "markLine");
        if (l) {
          var o = l.getData(), f = N(l).from, s = N(l).to;
          f.each(function(m) {
            R(f, m, !0, i, y), R(s, m, !1, i, y);
          }), o.each(function(m) {
            o.setItemLayout(m, [f.getItemLayout(m), s.getItemLayout(m)]);
          }), this.markerGroupMap.get(i.id).updateLayout();
        }
      }, this);
    }, a.prototype.renderSeries = function(r, t, y, i) {
      var l = r.coordinateSystem, o = r.id, f = r.getData(), s = this.markerGroupMap, m = s.get(o) || s.set(o, new U());
      this.group.add(m.group);
      var c = nt(l, r, t), g = c.from, u = c.to, v = c.line;
      N(t).from = g, N(t).to = u, t.setData(v);
      var D = t.get("symbol"), p = t.get("symbolSize"), k = t.get("symbolRotate"), L = t.get("symbolOffset");
      h(D) || (D = [D, D]), h(p) || (p = [p, p]), h(k) || (k = [k, k]), h(L) || (L = [L, L]), c.from.each(function(n) {
        K(g, n, !0), K(u, n, !1);
      }), v.each(function(n) {
        var b = v.getItemModel(n).getModel("lineStyle").getLineStyle();
        v.setItemLayout(n, [g.getItemLayout(n), u.getItemLayout(n)]), b.stroke == null && (b.stroke = g.getItemVisual(n, "style").fill), v.setItemVisual(n, {
          fromSymbolKeepAspect: g.getItemVisual(n, "symbolKeepAspect"),
          fromSymbolOffset: g.getItemVisual(n, "symbolOffset"),
          fromSymbolRotate: g.getItemVisual(n, "symbolRotate"),
          fromSymbolSize: g.getItemVisual(n, "symbolSize"),
          fromSymbol: g.getItemVisual(n, "symbol"),
          toSymbolKeepAspect: u.getItemVisual(n, "symbolKeepAspect"),
          toSymbolOffset: u.getItemVisual(n, "symbolOffset"),
          toSymbolRotate: u.getItemVisual(n, "symbolRotate"),
          toSymbolSize: u.getItemVisual(n, "symbolSize"),
          toSymbol: u.getItemVisual(n, "symbol"),
          style: b
        });
      }), m.updateData(v), c.line.eachItemGraphicEl(function(n) {
        M(n).dataModel = t, n.traverse(function(b) {
          M(b).dataModel = t;
        });
      });
      function K(n, b, S) {
        var I = n.getItemModel(b);
        R(n, b, S, r, i);
        var O = I.getModel("itemStyle").getItemStyle();
        O.fill == null && (O.fill = tt(f, "color")), n.setItemVisual(b, {
          symbolKeepAspect: I.get("symbolKeepAspect"),
          // `0` should be considered as a valid value, so use `retrieve2` instead of `||`
          symbolOffset: A(I.get("symbolOffset", !0), L[S ? 0 : 1]),
          symbolRotate: A(I.get("symbolRotate", !0), k[S ? 0 : 1]),
          // TODO: when 2d array is supported, it should ignore parent
          symbolSize: A(I.get("symbolSize"), p[S ? 0 : 1]),
          symbol: A(I.get("symbol", !0), D[S ? 0 : 1]),
          style: O
        });
      }
      this.markKeep(m), m.group.silent = t.get("silent") || r.get("silent");
    }, a.type = "markLine", a;
  }(X)
);
function nt(e, a, r) {
  var t;
  e ? t = V(e && e.dimensions, function(s) {
    var m = a.getData().getDimensionInfo(a.getData().mapDimension(s)) || {};
    return G(G({}, m), {
      name: s,
      // DON'T use ordinalMeta to parse and collect ordinal.
      ordinalMeta: null
    });
  }) : t = [{
    name: "value",
    type: "float"
  }];
  var y = new z(t, r), i = new z(t, r), l = new z([], r), o = V(r.get("data"), W(et, a, e, r));
  e && (o = C(o, W(at, e)));
  var f = Q(!!e, t);
  return y.initData(V(o, function(s) {
    return s[0];
  }), null, f), i.initData(V(o, function(s) {
    return s[1];
  }), null, f), l.initData(V(o, function(s) {
    return s[2];
  })), l.hasItemOption = !0, {
    from: y,
    to: i,
    line: l
  };
}
const Dt = rt;
export {
  Dt as default
};
