import { __extends as J } from "../../../../tslib/tslib.es6.js";
import { bind as B, each as w, trim as K, extend as z, isString as R, clone as F, isArray as D, isFunction as N, isObject as E } from "../../../../zrender/lib/core/util.js";
import A from "../../../../zrender/lib/core/env.js";
import tt from "./TooltipHTMLContent.js";
import et from "./TooltipRichContent.js";
import { convertToColorString as U, formatTpl as it } from "../../util/format.js";
import { parsePercent as W } from "../../util/number.js";
import "../../util/graphic.js";
import ot from "../axisPointer/findPointFromSeries.js";
import { getLayoutRect as rt } from "../../util/layout.js";
import P from "../../model/Model.js";
import { register as nt, unregister as at } from "../axisPointer/globalListener.js";
import { getAxisRawValue as st } from "../../coord/axisHelper.js";
import { getValueLabel as lt } from "../axisPointer/viewHelper.js";
import { getTooltipRenderMode as ft, preParseFinder as ht, queryReferringComponents as ut } from "../../util/model.js";
import dt from "../../view/Component.js";
import { format as vt } from "../../util/time.js";
import { getECData as S } from "../../util/innerStore.js";
import { shouldTooltipConfine as pt } from "./helper.js";
import { normalizeTooltipFormatResult as q } from "../../model/mixin/dataFormat.js";
import { createTooltipMarkup as j, buildTooltipMarkup as G, TooltipMarkupStyleCreator as Y } from "./tooltipMarkup.js";
import { findEventDispatcher as mt } from "../../util/event.js";
import { createOrUpdate as gt, clear as Q } from "../../util/throttle.js";
import ct from "../../../../zrender/lib/graphic/shape/Rect.js";
import { encodeHTML as _t } from "../../../../zrender/lib/core/dom.js";
var Tt = new ct({
  shape: {
    x: -1,
    y: -1,
    width: 2,
    height: 2
  }
}), xt = (
  /** @class */
  function(v) {
    J(a, v);
    function a() {
      var o = v !== null && v.apply(this, arguments) || this;
      return o.type = a.type, o;
    }
    return a.prototype.init = function(o, r) {
      if (!(A.node || !r.getDom())) {
        var e = o.getComponent("tooltip"), t = this._renderMode = ft(e.get("renderMode"));
        this._tooltipContent = t === "richText" ? new et(r) : new tt(r, {
          appendTo: e.get("appendToBody", !0) ? "body" : e.get("appendTo", !0)
        });
      }
    }, a.prototype.render = function(o, r, e) {
      if (!(A.node || !e.getDom())) {
        this.group.removeAll(), this._tooltipModel = o, this._ecModel = r, this._api = e;
        var t = this._tooltipContent;
        t.update(o), t.setEnterable(o.get("enterable")), this._initGlobalListener(), this._keepShow(), this._renderMode !== "richText" && o.get("transitionDuration") ? gt(this, "_updatePosition", 50, "fixRate") : Q(this, "_updatePosition");
      }
    }, a.prototype._initGlobalListener = function() {
      var o = this._tooltipModel, r = o.get("triggerOn");
      nt("itemTooltip", this._api, B(function(e, t, i) {
        r !== "none" && (r.indexOf(e) >= 0 ? this._tryShow(t, i) : e === "leave" && this._hide(i));
      }, this));
    }, a.prototype._keepShow = function() {
      var o = this._tooltipModel, r = this._ecModel, e = this._api, t = o.get("triggerOn");
      if (this._lastX != null && this._lastY != null && t !== "none" && t !== "click") {
        var i = this;
        clearTimeout(this._refreshUpdateTimeout), this._refreshUpdateTimeout = setTimeout(function() {
          !e.isDisposed() && i.manuallyShowTip(o, r, e, {
            x: i._lastX,
            y: i._lastY,
            dataByCoordSys: i._lastDataByCoordSys
          });
        });
      }
    }, a.prototype.manuallyShowTip = function(o, r, e, t) {
      if (!(t.from === this.uid || A.node || !e.getDom())) {
        var i = Z(t, e);
        this._ticket = "";
        var f = t.dataByCoordSys, n = wt(t, r, e);
        if (n) {
          var s = n.el.getBoundingRect().clone();
          s.applyTransform(n.el.transform), this._tryShow({
            offsetX: s.x + s.width / 2,
            offsetY: s.y + s.height / 2,
            target: n.el,
            position: t.position,
            // When manully trigger, the mouse is not on the el, so we'd better to
            // position tooltip on the bottom of the el and display arrow is possible.
            positionDefault: "bottom"
          }, i);
        } else if (t.tooltip && t.x != null && t.y != null) {
          var l = Tt;
          l.x = t.x, l.y = t.y, l.update(), S(l).tooltipConfig = {
            name: null,
            option: t.tooltip
          }, this._tryShow({
            offsetX: t.x,
            offsetY: t.y,
            target: l
          }, i);
        } else if (f)
          this._tryShow({
            offsetX: t.x,
            offsetY: t.y,
            position: t.position,
            dataByCoordSys: f,
            tooltipOption: t.tooltipOption
          }, i);
        else if (t.seriesIndex != null) {
          if (this._manuallyAxisShowTip(o, r, e, t))
            return;
          var h = ot(t, r), u = h.point[0], d = h.point[1];
          u != null && d != null && this._tryShow({
            offsetX: u,
            offsetY: d,
            target: h.el,
            position: t.position,
            // When manully trigger, the mouse is not on the el, so we'd better to
            // position tooltip on the bottom of the el and display arrow is possible.
            positionDefault: "bottom"
          }, i);
        } else
          t.x != null && t.y != null && (e.dispatchAction({
            type: "updateAxisPointer",
            x: t.x,
            y: t.y
          }), this._tryShow({
            offsetX: t.x,
            offsetY: t.y,
            position: t.position,
            target: e.getZr().findHover(t.x, t.y).target
          }, i));
      }
    }, a.prototype.manuallyHideTip = function(o, r, e, t) {
      var i = this._tooltipContent;
      this._tooltipModel && i.hideLater(this._tooltipModel.get("hideDelay")), this._lastX = this._lastY = this._lastDataByCoordSys = null, t.from !== this.uid && this._hide(Z(t, e));
    }, a.prototype._manuallyAxisShowTip = function(o, r, e, t) {
      var i = t.seriesIndex, f = t.dataIndex, n = r.getComponent("axisPointer").coordSysAxesInfo;
      if (!(i == null || f == null || n == null)) {
        var s = r.getSeriesByIndex(i);
        if (s) {
          var l = s.getData(), h = I([l.getItemModel(f), s, (s.coordinateSystem || {}).model], this._tooltipModel);
          if (h.get("trigger") === "axis")
            return e.dispatchAction({
              type: "updateAxisPointer",
              seriesIndex: i,
              dataIndex: f,
              position: t.position
            }), !0;
        }
      }
    }, a.prototype._tryShow = function(o, r) {
      var e = o.target, t = this._tooltipModel;
      if (t) {
        this._lastX = o.offsetX, this._lastY = o.offsetY;
        var i = o.dataByCoordSys;
        if (i && i.length)
          this._showAxisTooltip(i, o);
        else if (e) {
          var f = S(e);
          if (f.ssrType === "legend")
            return;
          this._lastDataByCoordSys = null;
          var n, s;
          mt(e, function(l) {
            if (S(l).dataIndex != null)
              return n = l, !0;
            if (S(l).tooltipConfig != null)
              return s = l, !0;
          }, !0), n ? this._showSeriesItemTooltip(o, n, r) : s ? this._showComponentItemTooltip(o, s, r) : this._hide(r);
        } else
          this._lastDataByCoordSys = null, this._hide(r);
      }
    }, a.prototype._showOrMove = function(o, r) {
      var e = o.get("showDelay");
      r = B(r, this), clearTimeout(this._showTimout), e > 0 ? this._showTimout = setTimeout(r, e) : r();
    }, a.prototype._showAxisTooltip = function(o, r) {
      var e = this._ecModel, t = this._tooltipModel, i = [r.offsetX, r.offsetY], f = I([r.tooltipOption], t), n = this._renderMode, s = [], l = j("section", {
        blocks: [],
        noHeader: !0
      }), h = [], u = new Y();
      w(o, function(T) {
        w(T.dataByAxis, function(g) {
          var x = e.getComponent(g.axisDim + "Axis", g.axisIndex), C = g.value;
          if (!(!x || C == null)) {
            var M = lt(C, x.axis, e, g.seriesDataIndices, g.valueLabelOpt), k = j("section", {
              header: M,
              noHeader: !K(M),
              sortBlocks: !0,
              blocks: []
            });
            l.blocks.push(k), w(g.seriesDataIndices, function(b) {
              var L = e.getSeriesByIndex(b.seriesIndex), H = b.dataIndexInside, y = L.getDataParams(H);
              if (!(y.dataIndex < 0)) {
                y.axisDim = g.axisDim, y.axisIndex = g.axisIndex, y.axisType = g.axisType, y.axisId = g.axisId, y.axisValue = st(x.axis, {
                  value: C
                }), y.axisValueLabel = M, y.marker = u.makeTooltipMarker("item", U(y.color), n);
                var O = q(L.formatTooltip(H, !0, null)), X = O.frag;
                if (X) {
                  var V = I([L], t).get("valueFormatter");
                  k.blocks.push(V ? z({
                    valueFormatter: V
                  }, X) : X);
                }
                O.text && h.push(O.text), s.push(y);
              }
            });
          }
        });
      }), l.blocks.reverse(), h.reverse();
      var d = r.position, c = f.get("order"), m = G(l, u, n, c, e.get("useUTC"), f.get("textStyle"));
      m && h.unshift(m);
      var _ = n === "richText" ? `

` : "<br/>", p = h.join(_);
      this._showOrMove(f, function() {
        this._updateContentNotChangedOnAxis(o, s) ? this._updatePosition(f, d, i[0], i[1], this._tooltipContent, s) : this._showTooltipContent(f, p, s, Math.random() + "", i[0], i[1], d, null, u);
      });
    }, a.prototype._showSeriesItemTooltip = function(o, r, e) {
      var t = this._ecModel, i = S(r), f = i.seriesIndex, n = t.getSeriesByIndex(f), s = i.dataModel || n, l = i.dataIndex, h = i.dataType, u = s.getData(h), d = this._renderMode, c = o.positionDefault, m = I([u.getItemModel(l), s, n && (n.coordinateSystem || {}).model], this._tooltipModel, c ? {
        position: c
      } : null), _ = m.get("trigger");
      if (!(_ != null && _ !== "item")) {
        var p = s.getDataParams(l, h), T = new Y();
        p.marker = T.makeTooltipMarker("item", U(p.color), d);
        var g = q(s.formatTooltip(l, !1, h)), x = m.get("order"), C = m.get("valueFormatter"), M = g.frag, k = M ? G(C ? z({
          valueFormatter: C
        }, M) : M, T, d, x, t.get("useUTC"), m.get("textStyle")) : g.text, b = "item_" + s.name + "_" + l;
        this._showOrMove(m, function() {
          this._showTooltipContent(m, k, p, b, o.offsetX, o.offsetY, o.position, o.target, T);
        }), e({
          type: "showTip",
          dataIndexInside: l,
          dataIndex: u.getRawIndex(l),
          seriesIndex: f,
          from: this.uid
        });
      }
    }, a.prototype._showComponentItemTooltip = function(o, r, e) {
      var t = this._renderMode === "html", i = S(r), f = i.tooltipConfig, n = f.option || {}, s = n.encodeHTMLContent;
      if (R(n)) {
        var l = n;
        n = {
          content: l,
          // Fixed formatter
          formatter: l
        }, s = !0;
      }
      s && t && n.content && (n = F(n), n.content = _t(n.content));
      var h = [n], u = this._ecModel.getComponent(i.componentMainType, i.componentIndex);
      u && h.push(u), h.push({
        formatter: n.content
      });
      var d = o.positionDefault, c = I(h, this._tooltipModel, d ? {
        position: d
      } : null), m = c.get("content"), _ = Math.random() + "", p = new Y();
      this._showOrMove(c, function() {
        var T = F(c.get("formatterParams") || {});
        this._showTooltipContent(c, m, T, _, o.offsetX, o.offsetY, o.position, r, p);
      }), e({
        type: "showTip",
        from: this.uid
      });
    }, a.prototype._showTooltipContent = function(o, r, e, t, i, f, n, s, l) {
      if (this._ticket = "", !(!o.get("showContent") || !o.get("show"))) {
        var h = this._tooltipContent;
        h.setEnterable(o.get("enterable"));
        var u = o.get("formatter");
        n = n || o.get("position");
        var d = r, c = this._getNearestPoint([i, f], e, o.get("trigger"), o.get("borderColor")), m = c.color;
        if (u)
          if (R(u)) {
            var _ = o.ecModel.get("useUTC"), p = D(e) ? e[0] : e, T = p && p.axisType && p.axisType.indexOf("time") >= 0;
            d = u, T && (d = vt(p.axisValue, d, _)), d = it(d, e, !0);
          } else if (N(u)) {
            var g = B(function(x, C) {
              x === this._ticket && (h.setContent(C, l, o, m, n), this._updatePosition(o, n, i, f, h, e, s));
            }, this);
            this._ticket = t, d = u(e, t, g);
          } else
            d = u;
        h.setContent(d, l, o, m, n), h.show(o, m), this._updatePosition(o, n, i, f, h, e, s);
      }
    }, a.prototype._getNearestPoint = function(o, r, e, t) {
      if (e === "axis" || D(r))
        return {
          color: t || (this._renderMode === "html" ? "#fff" : "none")
        };
      if (!D(r))
        return {
          color: t || r.color || r.borderColor
        };
    }, a.prototype._updatePosition = function(o, r, e, t, i, f, n) {
      var s = this._api.getWidth(), l = this._api.getHeight();
      r = r || o.get("position");
      var h = i.getSize(), u = o.get("align"), d = o.get("verticalAlign"), c = n && n.getBoundingRect().clone();
      if (n && c.applyTransform(n.transform), N(r) && (r = r([e, t], f, i.el, c, {
        viewSize: [s, l],
        contentSize: h.slice()
      })), D(r))
        e = W(r[0], s), t = W(r[1], l);
      else if (E(r)) {
        var m = r;
        m.width = h[0], m.height = h[1];
        var _ = rt(m, {
          width: s,
          height: l
        });
        e = _.x, t = _.y, u = null, d = null;
      } else if (R(r) && n) {
        var p = Mt(r, c, h, o.get("borderWidth"));
        e = p[0], t = p[1];
      } else {
        var p = yt(e, t, i, s, l, u ? null : 20, d ? null : 20);
        e = p[0], t = p[1];
      }
      if (u && (e -= $(u) ? h[0] / 2 : u === "right" ? h[0] : 0), d && (t -= $(d) ? h[1] / 2 : d === "bottom" ? h[1] : 0), pt(o)) {
        var p = Ct(e, t, i, s, l);
        e = p[0], t = p[1];
      }
      i.moveTo(e, t);
    }, a.prototype._updateContentNotChangedOnAxis = function(o, r) {
      var e = this._lastDataByCoordSys, t = this._cbParamsList, i = !!e && e.length === o.length;
      return i && w(e, function(f, n) {
        var s = f.dataByAxis || [], l = o[n] || {}, h = l.dataByAxis || [];
        i = i && s.length === h.length, i && w(s, function(u, d) {
          var c = h[d] || {}, m = u.seriesDataIndices || [], _ = c.seriesDataIndices || [];
          i = i && u.value === c.value && u.axisType === c.axisType && u.axisId === c.axisId && m.length === _.length, i && w(m, function(p, T) {
            var g = _[T];
            i = i && p.seriesIndex === g.seriesIndex && p.dataIndex === g.dataIndex;
          }), t && w(u.seriesDataIndices, function(p) {
            var T = p.seriesIndex, g = r[T], x = t[T];
            g && x && x.data !== g.data && (i = !1);
          });
        });
      }), this._lastDataByCoordSys = o, this._cbParamsList = r, !!i;
    }, a.prototype._hide = function(o) {
      this._lastDataByCoordSys = null, o({
        type: "hideTip",
        from: this.uid
      });
    }, a.prototype.dispose = function(o, r) {
      A.node || !r.getDom() || (Q(this, "_updatePosition"), this._tooltipContent.dispose(), at("itemTooltip", r));
    }, a.type = "tooltip", a;
  }(dt)
);
function I(v, a, o) {
  var r = a.ecModel, e;
  o ? (e = new P(o, r, r), e = new P(a.option, e, r)) : e = a;
  for (var t = v.length - 1; t >= 0; t--) {
    var i = v[t];
    i && (i instanceof P && (i = i.get("tooltip", !0)), R(i) && (i = {
      formatter: i
    }), i && (e = new P(i, e, r)));
  }
  return e;
}
function Z(v, a) {
  return v.dispatchAction || B(a.dispatchAction, a);
}
function yt(v, a, o, r, e, t, i) {
  var f = o.getSize(), n = f[0], s = f[1];
  return t != null && (v + n + t + 2 > r ? v -= n + t : v += t), i != null && (a + s + i > e ? a -= s + i : a += i), [v, a];
}
function Ct(v, a, o, r, e) {
  var t = o.getSize(), i = t[0], f = t[1];
  return v = Math.min(v + i, r) - i, a = Math.min(a + f, e) - f, v = Math.max(v, 0), a = Math.max(a, 0), [v, a];
}
function Mt(v, a, o, r) {
  var e = o[0], t = o[1], i = Math.ceil(Math.SQRT2 * r) + 8, f = 0, n = 0, s = a.width, l = a.height;
  switch (v) {
    case "inside":
      f = a.x + s / 2 - e / 2, n = a.y + l / 2 - t / 2;
      break;
    case "top":
      f = a.x + s / 2 - e / 2, n = a.y - t - i;
      break;
    case "bottom":
      f = a.x + s / 2 - e / 2, n = a.y + l + i;
      break;
    case "left":
      f = a.x - e - i, n = a.y + l / 2 - t / 2;
      break;
    case "right":
      f = a.x + s + i, n = a.y + l / 2 - t / 2;
  }
  return [f, n];
}
function $(v) {
  return v === "center" || v === "middle";
}
function wt(v, a, o) {
  var r = ht(v).queryOptionMap, e = r.keys()[0];
  if (!(!e || e === "series")) {
    var t = ut(a, e, r.get(e), {
      useDefault: !1,
      enableAll: !1,
      enableNone: !1
    }), i = t.models[0];
    if (i) {
      var f = o.getViewOfComponentModel(i), n;
      if (f.group.traverse(function(s) {
        var l = S(s).tooltipConfig;
        if (l && l.name === v.name)
          return n = s, !0;
      }), n)
        return {
          componentMainType: e,
          componentIndex: i.componentIndex,
          el: n
        };
    }
  }
}
const $t = xt;
export {
  $t as default
};
