import { __extends as I } from "../../../../tslib/tslib.es6.js";
import { clone as y, map as M, each as h, isObject as V } from "../../../../zrender/lib/core/util.js";
import m from "./VisualMapModel.js";
import d from "../../visual/VisualMapping.js";
import O from "../../visual/visualDefault.js";
import { reformIntervals as g } from "../../util/number.js";
import { inheritDefaultOption as S } from "../../util/component.js";
var b = (
  /** @class */
  function(l) {
    I(r, l);
    function r() {
      var t = l !== null && l.apply(this, arguments) || this;
      return t.type = r.type, t._pieceList = [], t;
    }
    return r.prototype.optionUpdated = function(t, s) {
      l.prototype.optionUpdated.apply(this, arguments), this.resetExtent();
      var e = this._mode = this._determineMode();
      this._pieceList = [], _[this._mode].call(this, this._pieceList), this._resetSelected(t, s);
      var u = this.option.categories;
      this.resetVisual(function(i, n) {
        e === "categories" ? (i.mappingMethod = "category", i.categories = y(u)) : (i.dataExtent = this.getExtent(), i.mappingMethod = "piecewise", i.pieceList = M(this._pieceList, function(o) {
          return o = y(o), n !== "inRange" && (o.visual = null), o;
        }));
      });
    }, r.prototype.completeVisualOption = function() {
      var t = this.option, s = {}, e = d.listVisualTypes(), u = this.isCategory();
      h(t.pieces, function(n) {
        h(e, function(o) {
          n.hasOwnProperty(o) && (s[o] = 1);
        });
      }), h(s, function(n, o) {
        var p = !1;
        h(this.stateList, function(a) {
          p = p || i(t, a, o) || i(t.target, a, o);
        }, this), !p && h(this.stateList, function(a) {
          (t[a] || (t[a] = {}))[o] = O.get(o, a === "inRange" ? "active" : "inactive", u);
        });
      }, this);
      function i(n, o, p) {
        return n && n[o] && n[o].hasOwnProperty(p);
      }
      l.prototype.completeVisualOption.apply(this, arguments);
    }, r.prototype._resetSelected = function(t, s) {
      var e = this.option, u = this._pieceList, i = (s ? e : t).selected || {};
      if (e.selected = i, h(u, function(o, p) {
        var a = this.getSelectedMapKey(o);
        i.hasOwnProperty(a) || (i[a] = !0);
      }, this), e.selectedMode === "single") {
        var n = !1;
        h(u, function(o, p) {
          var a = this.getSelectedMapKey(o);
          i[a] && (n ? i[a] = !1 : n = !0);
        }, this);
      }
    }, r.prototype.getItemSymbol = function() {
      return this.get("itemSymbol");
    }, r.prototype.getSelectedMapKey = function(t) {
      return this._mode === "categories" ? t.value + "" : t.index + "";
    }, r.prototype.getPieceList = function() {
      return this._pieceList;
    }, r.prototype._determineMode = function() {
      var t = this.option;
      return t.pieces && t.pieces.length > 0 ? "pieces" : this.option.categories ? "categories" : "splitNumber";
    }, r.prototype.setSelected = function(t) {
      this.option.selected = y(t);
    }, r.prototype.getValueState = function(t) {
      var s = d.findPieceIndex(t, this._pieceList);
      return s != null && this.option.selected[this.getSelectedMapKey(this._pieceList[s])] ? "inRange" : "outOfRange";
    }, r.prototype.findTargetDataIndices = function(t) {
      var s = [], e = this._pieceList;
      return this.eachTargetSeries(function(u) {
        var i = [], n = u.getData();
        n.each(this.getDataDimensionIndex(n), function(o, p) {
          var a = d.findPieceIndex(o, e);
          a === t && i.push(p);
        }, this), s.push({
          seriesId: u.id,
          dataIndex: i
        });
      }, this), s;
    }, r.prototype.getRepresentValue = function(t) {
      var s;
      if (this.isCategory())
        s = t.value;
      else if (t.value != null)
        s = t.value;
      else {
        var e = t.interval || [];
        s = e[0] === -1 / 0 && e[1] === 1 / 0 ? 0 : (e[0] + e[1]) / 2;
      }
      return s;
    }, r.prototype.getVisualMeta = function(t) {
      if (this.isCategory())
        return;
      var s = [], e = ["", ""], u = this;
      function i(a, f) {
        var v = u.getRepresentValue({
          interval: a
        });
        f || (f = u.getValueState(v));
        var c = t(v, f);
        a[0] === -1 / 0 ? e[0] = c : a[1] === 1 / 0 ? e[1] = c : s.push({
          value: a[0],
          color: c
        }, {
          value: a[1],
          color: c
        });
      }
      var n = this._pieceList.slice();
      if (!n.length)
        n.push({
          interval: [-1 / 0, 1 / 0]
        });
      else {
        var o = n[0].interval[0];
        o !== -1 / 0 && n.unshift({
          interval: [-1 / 0, o]
        }), o = n[n.length - 1].interval[1], o !== 1 / 0 && n.push({
          interval: [o, 1 / 0]
        });
      }
      var p = -1 / 0;
      return h(n, function(a) {
        var f = a.interval;
        f && (f[0] > p && i([p, f[0]], "outOfRange"), i(f.slice()), p = f[1]);
      }, this), {
        stops: s,
        outerColors: e
      };
    }, r.type = "visualMap.piecewise", r.defaultOption = S(m.defaultOption, {
      selected: null,
      minOpen: !1,
      maxOpen: !1,
      align: "auto",
      itemWidth: 20,
      itemHeight: 14,
      itemSymbol: "roundRect",
      pieces: null,
      categories: null,
      splitNumber: 5,
      selectedMode: "multiple",
      itemGap: 10,
      hoverLink: !0
      // Enable hover highlight.
    }), r;
  }(m)
), _ = {
  splitNumber: function(l) {
    var r = this.option, t = Math.min(r.precision, 20), s = this.getExtent(), e = r.splitNumber;
    e = Math.max(parseInt(e, 10), 1), r.splitNumber = e;
    for (var u = (s[1] - s[0]) / e; +u.toFixed(t) !== u && t < 5; )
      t++;
    r.precision = t, u = +u.toFixed(t), r.minOpen && l.push({
      interval: [-1 / 0, s[0]],
      close: [0, 0]
    });
    for (var i = 0, n = s[0]; i < e; n += u, i++) {
      var o = i === e - 1 ? s[1] : n + u;
      l.push({
        interval: [n, o],
        close: [1, 1]
      });
    }
    r.maxOpen && l.push({
      interval: [s[1], 1 / 0],
      close: [0, 0]
    }), g(l), h(l, function(p, a) {
      p.index = a, p.text = this.formatValueText(p.interval);
    }, this);
  },
  categories: function(l) {
    var r = this.option;
    h(r.categories, function(t) {
      l.push({
        text: this.formatValueText(t, !0),
        value: t
      });
    }, this), x(r, l);
  },
  pieces: function(l) {
    var r = this.option;
    h(r.pieces, function(t, s) {
      V(t) || (t = {
        value: t
      });
      var e = {
        text: "",
        index: s
      };
      if (t.label != null && (e.text = t.label), t.hasOwnProperty("value")) {
        var u = e.value = t.value;
        e.interval = [u, u], e.close = [1, 1];
      } else {
        for (var i = e.interval = [], n = e.close = [0, 0], o = [1, 0, 1], p = [-1 / 0, 1 / 0], a = [], f = 0; f < 2; f++) {
          for (var v = [["gte", "gt", "min"], ["lte", "lt", "max"]][f], c = 0; c < 3 && i[f] == null; c++)
            i[f] = t[v[c]], n[f] = o[c], a[f] = c === 2;
          i[f] == null && (i[f] = p[f]);
        }
        a[0] && i[1] === 1 / 0 && (n[0] = 0), a[1] && i[0] === -1 / 0 && (n[1] = 0), i[0] === i[1] && n[0] && n[1] && (e.value = i[0]);
      }
      e.visual = d.retrieveVisuals(t), l.push(e);
    }, this), x(r, l), g(l), h(l, function(t) {
      var s = t.close, e = [["<", "≤"][s[1]], [">", "≥"][s[0]]];
      t.text = t.text || this.formatValueText(t.value != null ? t.value : t.interval, !1, e);
    }, this);
  }
};
function x(l, r) {
  var t = l.inverse;
  (l.orient === "vertical" ? !t : t) && r.reverse();
}
const T = b;
export {
  T as default
};
