import { __extends as A } from "../../../../tslib/tslib.es6.js";
import { bind as T, each as D, isArray as E, isString as F, isFunction as $, merge as R, clone as I } from "../../../../zrender/lib/core/util.js";
import B from "../../visual/visualDefault.js";
import V from "../../visual/VisualMapping.js";
import { replaceVisualOption as L, createVisualMappings as z } from "../../visual/visualSolution.js";
import { normalizeToArray as w } from "../../util/model.js";
import { asc as W, linearMap as H } from "../../util/number.js";
import K from "../../model/Component.js";
var C = V.mapVisual, P = V.eachVisual, k = E, O = D, G = W, N = H, U = (
  /** @class */
  function(x) {
    A(i, x);
    function i() {
      var t = x !== null && x.apply(this, arguments) || this;
      return t.type = i.type, t.stateList = ["inRange", "outOfRange"], t.replacableOptionKeys = ["inRange", "outOfRange", "target", "controller", "color"], t.layoutMode = {
        type: "box",
        ignoreSize: !0
      }, t.dataBound = [-1 / 0, 1 / 0], t.targetVisuals = {}, t.controllerVisuals = {}, t;
    }
    return i.prototype.init = function(t, e, o) {
      this.mergeDefaultAndTheme(t, o);
    }, i.prototype.optionUpdated = function(t, e) {
      var o = this.option;
      !e && L(o, t, this.replacableOptionKeys), this.textStyleModel = this.getModel("textStyle"), this.resetItemSize(), this.completeVisualOption();
    }, i.prototype.resetVisual = function(t) {
      var e = this.stateList;
      t = T(t, this), this.controllerVisuals = z(this.option.controller, e, t), this.targetVisuals = z(this.option.target, e, t);
    }, i.prototype.getItemSymbol = function() {
      return null;
    }, i.prototype.getTargetSeriesIndices = function() {
      var t = this.option.seriesIndex, e = [];
      return t == null || t === "all" ? this.ecModel.eachSeries(function(o, n) {
        e.push(n);
      }) : e = w(t), e;
    }, i.prototype.eachTargetSeries = function(t, e) {
      D(this.getTargetSeriesIndices(), function(o) {
        var n = this.ecModel.getSeriesByIndex(o);
        n && t.call(e, n);
      }, this);
    }, i.prototype.isTargetSeries = function(t) {
      var e = !1;
      return this.eachTargetSeries(function(o) {
        o === t && (e = !0);
      }), e;
    }, i.prototype.formatValueText = function(t, e, o) {
      var n = this.option, m = n.precision, a = this.dataBound, c = n.formatter, p;
      o = o || ["<", ">"], E(t) && (t = t.slice(), p = !0);
      var s = e ? t : p ? [r(t[0]), r(t[1])] : r(t);
      if (F(c))
        return c.replace("{value}", p ? s[0] : s).replace("{value2}", p ? s[1] : s);
      if ($(c))
        return p ? c(t[0], t[1]) : c(t);
      if (p)
        return t[0] === a[0] ? o[0] + " " + s[1] : t[1] === a[1] ? o[1] + " " + s[0] : s[0] + " - " + s[1];
      return s;
      function r(u) {
        return u === a[0] ? "min" : u === a[1] ? "max" : (+u).toFixed(Math.min(m, 20));
      }
    }, i.prototype.resetExtent = function() {
      var t = this.option, e = G([t.min, t.max]);
      this._dataExtent = e;
    }, i.prototype.getDataDimensionIndex = function(t) {
      var e = this.option.dimension;
      if (e != null)
        return t.getDimensionIndex(e);
      for (var o = t.dimensions, n = o.length - 1; n >= 0; n--) {
        var m = o[n], a = t.getDimensionInfo(m);
        if (!a.isCalculationCoord)
          return a.storeDimIndex;
      }
    }, i.prototype.getExtent = function() {
      return this._dataExtent.slice();
    }, i.prototype.completeVisualOption = function() {
      var t = this.ecModel, e = this.option, o = {
        inRange: e.inRange,
        outOfRange: e.outOfRange
      }, n = e.target || (e.target = {}), m = e.controller || (e.controller = {});
      R(n, o), R(m, o);
      var a = this.isCategory();
      c.call(this, n), c.call(this, m), p.call(this, n, "inRange", "outOfRange"), s.call(this, m);
      function c(r) {
        k(e.color) && !r.inRange && (r.inRange = {
          color: e.color.slice().reverse()
        }), r.inRange = r.inRange || {
          color: t.get("gradientColor")
        };
      }
      function p(r, u, y) {
        var v = r[u], f = r[y];
        v && !f && (f = r[y] = {}, O(v, function(S, h) {
          if (V.isValidType(h)) {
            var g = B.get(h, "inactive", a);
            g != null && (f[h] = g, h === "color" && !f.hasOwnProperty("opacity") && !f.hasOwnProperty("colorAlpha") && (f.opacity = [0, 0]));
          }
        }));
      }
      function s(r) {
        var u = (r.inRange || {}).symbol || (r.outOfRange || {}).symbol, y = (r.inRange || {}).symbolSize || (r.outOfRange || {}).symbolSize, v = this.get("inactiveColor"), f = this.getItemSymbol(), S = f || "roundRect";
        O(this.stateList, function(h) {
          var g = this.itemSize, l = r[h];
          l || (l = r[h] = {
            color: a ? v : [v]
          }), l.symbol == null && (l.symbol = u && I(u) || (a ? S : [S])), l.symbolSize == null && (l.symbolSize = y && I(y) || (a ? g[0] : [g[0], g[0]])), l.symbol = C(l.symbol, function(d) {
            return d === "none" ? S : d;
          });
          var M = l.symbolSize;
          if (M != null) {
            var b = -1 / 0;
            P(M, function(d) {
              d > b && (b = d);
            }), l.symbolSize = C(M, function(d) {
              return N(d, [0, b], [0, g[0]], !0);
            });
          }
        }, this);
      }
    }, i.prototype.resetItemSize = function() {
      this.itemSize = [parseFloat(this.get("itemWidth")), parseFloat(this.get("itemHeight"))];
    }, i.prototype.isCategory = function() {
      return !!this.option.categories;
    }, i.prototype.setSelected = function(t) {
    }, i.prototype.getSelected = function() {
      return null;
    }, i.prototype.getValueState = function(t) {
      return null;
    }, i.prototype.getVisualMeta = function(t) {
      return null;
    }, i.type = "visualMap", i.dependencies = ["series"], i.defaultOption = {
      show: !0,
      // zlevel: 0,
      z: 4,
      seriesIndex: "all",
      min: 0,
      max: 200,
      left: 0,
      right: null,
      top: null,
      bottom: 0,
      itemWidth: null,
      itemHeight: null,
      inverse: !1,
      orient: "vertical",
      backgroundColor: "rgba(0,0,0,0)",
      borderColor: "#ccc",
      contentColor: "#5793f3",
      inactiveColor: "#aaa",
      borderWidth: 0,
      padding: 5,
      // 接受数组分别设定上右下左边距，同css
      textGap: 10,
      precision: 0,
      textStyle: {
        color: "#333"
        // 值域文字颜色
      }
    }, i;
  }(K)
);
const tt = U;
export {
  tt as default
};
