import { map as h, each as T } from "../../../zrender/lib/core/util.js";
import { getPixelPrecision as M, linearMap as v, round as d } from "../util/number.js";
import { createAxisTicks as E, createAxisLabels as b, calculateCategoryInterval as B } from "./axisTickLabelBuilder.js";
var x = [0, 1], L = (
  /** @class */
  function() {
    function i(t, n, e) {
      this.onBand = !1, this.inverse = !1, this.dim = t, this.scale = n, this._extent = e || [0, 0];
    }
    return i.prototype.contain = function(t) {
      var n = this._extent, e = Math.min(n[0], n[1]), r = Math.max(n[0], n[1]);
      return t >= e && t <= r;
    }, i.prototype.containData = function(t) {
      return this.scale.contain(t);
    }, i.prototype.getExtent = function() {
      return this._extent.slice();
    }, i.prototype.getPixelPrecision = function(t) {
      return M(t || this.scale.getExtent(), this._extent);
    }, i.prototype.setExtent = function(t, n) {
      var e = this._extent;
      e[0] = t, e[1] = n;
    }, i.prototype.dataToCoord = function(t, n) {
      var e = this._extent, r = this.scale;
      return t = r.normalize(t), this.onBand && r.type === "ordinal" && (e = e.slice(), g(e, r.count())), v(t, x, e, n);
    }, i.prototype.coordToData = function(t, n) {
      var e = this._extent, r = this.scale;
      this.onBand && r.type === "ordinal" && (e = e.slice(), g(e, r.count()));
      var a = v(t, e, x, n);
      return this.scale.scale(a);
    }, i.prototype.pointToData = function(t, n) {
    }, i.prototype.getTicksCoords = function(t) {
      t = t || {};
      var n = t.tickModel || this.getTickModel(), e = E(this, n), r = e.ticks, a = h(r, function(c) {
        return {
          coord: this.dataToCoord(this.scale.type === "ordinal" ? this.scale.getRawOrdinalNumber(c) : c),
          tickValue: c
        };
      }, this), o = n.get("alignWithLabel");
      return _(this, a, o, t.clamp), a;
    }, i.prototype.getMinorTicksCoords = function() {
      if (this.scale.type === "ordinal")
        return [];
      var t = this.model.getModel("minorTick"), n = t.get("splitNumber");
      n > 0 && n < 100 || (n = 5);
      var e = this.scale.getMinorTicks(n), r = h(e, function(a) {
        return h(a, function(o) {
          return {
            coord: this.dataToCoord(o),
            tickValue: o
          };
        }, this);
      }, this);
      return r;
    }, i.prototype.getViewLabels = function() {
      return b(this).labels;
    }, i.prototype.getLabelModel = function() {
      return this.model.getModel("axisLabel");
    }, i.prototype.getTickModel = function() {
      return this.model.getModel("axisTick");
    }, i.prototype.getBandWidth = function() {
      var t = this._extent, n = this.scale.getExtent(), e = n[1] - n[0] + (this.onBand ? 1 : 0);
      e === 0 && (e = 1);
      var r = Math.abs(t[1] - t[0]);
      return Math.abs(r) / e;
    }, i.prototype.calculateCategoryInterval = function() {
      return B(this);
    }, i;
  }()
);
function g(i, t) {
  var n = i[1] - i[0], e = t, r = n / e / 2;
  i[0] += r, i[1] -= r;
}
function _(i, t, n, e) {
  var r = t.length;
  if (!i.onBand || n || !r)
    return;
  var a = i.getExtent(), o, c;
  if (r === 1)
    t[0].coord = a[0], o = t[1] = {
      coord: a[1],
      tickValue: t[0].tickValue
    };
  else {
    var m = t[r - 1].tickValue - t[0].tickValue, f = (t[r - 1].coord - t[0].coord) / m;
    T(t, function(l) {
      l.coord -= f / 2;
    });
    var p = i.scale.getExtent();
    c = 1 + p[1] - t[r - 1].tickValue, o = {
      coord: t[r - 1].coord + f * c,
      tickValue: p[1] + 1
    }, t.push(o);
  }
  var y = a[0] > a[1];
  s(t[0].coord, a[0]) && (e ? t[0].coord = a[0] : t.shift()), e && s(a[0], t[0].coord) && t.unshift({
    coord: a[0]
  }), s(a[1], o.coord) && (e ? o.coord = a[1] : t.pop()), e && s(o.coord, a[1]) && t.push({
    coord: a[1]
  });
  function s(l, u) {
    return l = d(l), u = d(u), y ? l > u : l < u;
  }
}
const N = L;
export {
  N as default
};
