import { each as m, keys as b, isString as h, isFunction as p } from "../../../zrender/lib/core/util.js";
import M from "../scale/Ordinal.js";
import y from "../scale/Interval.js";
import w from "../scale/Scale.js";
import { prepareLayoutBarSeries as L, makeColumnLayout as d, retrieveColumnLayout as I } from "../layout/barGrid.js";
import E from "../../../zrender/lib/core/BoundingRect.js";
import S from "../scale/Time.js";
import O from "../scale/Log.js";
import { getStackedDimension as C } from "../data/helper/dataStackHelper.js";
import { ensureScaleRawExtentInfo as F } from "./scaleRawExtentInfo.js";
function k(e, t) {
  var a = e.type, r = F(e, t, e.getExtent()).calculate();
  e.setBlank(r.isBlank);
  var n = r.min, i = r.max, u = t.ecModel;
  if (u && a === "time") {
    var o = L("bar", u), l = !1;
    if (m(o, function(g) {
      l = l || g.getBaseAxis() === t.axis;
    }), l) {
      var v = d(o), f = R(n, i, t, v);
      n = f.min, i = f.max;
    }
  }
  return {
    extent: [n, i],
    // "fix" means "fixed", the value should not be
    // changed in the subsequent steps.
    fixMin: r.minFixed,
    fixMax: r.maxFixed
  };
}
function R(e, t, a, r) {
  var n = a.axis.getExtent(), i = Math.abs(n[1] - n[0]), u = I(r, a.axis);
  if (u === void 0)
    return {
      min: e,
      max: t
    };
  var o = 1 / 0;
  m(u, function(c) {
    o = Math.min(c.offset, o);
  });
  var l = -1 / 0;
  m(u, function(c) {
    l = Math.max(c.offset + c.width, l);
  }), o = Math.abs(o), l = Math.abs(l);
  var v = o + l, f = t - e, g = 1 - (o + l) / i, s = f / g - f;
  return t += s * (l / v), e -= s * (o / v), {
    min: e,
    max: t
  };
}
function J(e, t) {
  var a = t, r = k(e, a), n = r.extent, i = a.get("splitNumber");
  e instanceof O && (e.base = a.get("logBase"));
  var u = e.type, o = a.get("interval"), l = u === "interval" || u === "time";
  e.setExtent(n[0], n[1]), e.calcNiceExtent({
    splitNumber: i,
    fixMin: r.fixMin,
    fixMax: r.fixMax,
    minInterval: l ? a.get("minInterval") : null,
    maxInterval: l ? a.get("maxInterval") : null
  }), o != null && e.setInterval && e.setInterval(o);
}
function K(e, t) {
  if (t = t || e.get("type"), t)
    switch (t) {
      case "category":
        return new M({
          ordinalMeta: e.getOrdinalMeta ? e.getOrdinalMeta() : e.getCategories(),
          extent: [1 / 0, -1 / 0]
        });
      case "time":
        return new S({
          locale: e.ecModel.getLocaleModel(),
          useUTC: e.ecModel.get("useUTC")
        });
      default:
        return new (w.getClass(t) || y)();
    }
}
function Q(e) {
  var t = e.scale.getExtent(), a = t[0], r = t[1];
  return !(a > 0 && r > 0 || a < 0 && r < 0);
}
function T(e) {
  var t = e.getLabelModel().get("formatter"), a = e.type === "category" ? e.scale.getExtent()[0] : null;
  return e.scale.type === "time" ? function(r) {
    return function(n, i) {
      return e.scale.getFormattedLabel(n, i, r);
    };
  }(t) : h(t) ? function(r) {
    return function(n) {
      var i = e.scale.getLabel(n), u = r.replace("{value}", i ?? "");
      return u;
    };
  }(t) : p(t) ? function(r) {
    return function(n, i) {
      return a != null && (i = n.value - a), r(D(e, n), i, n.level != null ? {
        level: n.level
      } : null);
    };
  }(t) : function(r) {
    return e.scale.getLabel(r);
  };
}
function D(e, t) {
  return e.type === "category" ? e.scale.getLabel(t) : t.value;
}
function X(e) {
  var t = e.model, a = e.scale;
  if (!(!t.get(["axisLabel", "show"]) || a.isBlank())) {
    var r, n, i = a.getExtent();
    a instanceof M ? n = a.count() : (r = a.getTicks(), n = r.length);
    var u = e.getLabelModel(), o = T(e), l, v = 1;
    n > 40 && (v = Math.ceil(n / 40));
    for (var f = 0; f < n; f += v) {
      var g = r ? r[f] : {
        value: i[0] + f
      }, s = o(g, f), c = u.getTextRect(s), x = N(c, u.get("rotate") || 0);
      l ? l.union(x) : l = x;
    }
    return l;
  }
}
function N(e, t) {
  var a = t * Math.PI / 180, r = e.width, n = e.height, i = r * Math.abs(Math.cos(a)) + Math.abs(n * Math.sin(a)), u = r * Math.abs(Math.sin(a)) + Math.abs(n * Math.cos(a)), o = new E(e.x, e.y, i, u);
  return o;
}
function A(e) {
  var t = e.get("interval");
  return t ?? "auto";
}
function Y(e) {
  return e.type === "category" && A(e.getLabelModel()) === 0;
}
function B(e, t) {
  var a = {};
  return m(e.mapDimensionsAll(t), function(r) {
    a[C(e, r)] = !0;
  }), b(a);
}
function $(e, t, a) {
  t && m(B(t, a), function(r) {
    var n = t.getApproximateExtent(r);
    n[0] < e[0] && (e[0] = n[0]), n[1] > e[1] && (e[1] = n[1]);
  });
}
export {
  K as createScaleByModel,
  X as estimateLabelUnionRect,
  D as getAxisRawValue,
  B as getDataDimensionsOnAxis,
  A as getOptionCategoryInterval,
  k as getScaleExtent,
  Q as ifAxisCrossZero,
  T as makeLabelFormatter,
  J as niceScaleExtent,
  Y as shouldShowAllLabels,
  $ as unionAxisExtentFromData
};
