import { filter as E, map as d, isFunction as A, each as O } from "../../../zrender/lib/core/util.js";
import { getBoundingRect as P } from "../../../zrender/lib/contain/text.js";
import { makeInner as W } from "../util/model.js";
import { makeLabelFormatter as C, getOptionCategoryInterval as V, shouldShowAllLabels as j } from "./axisHelper.js";
var L = W();
function F(t, a) {
  var e = d(a, function(r) {
    return t.scale.parse(r);
  });
  return t.type === "time" && e.length > 0 && (e.sort(), e.unshift(e[0]), e.push(e[e.length - 1])), e;
}
function Z(t) {
  var a = t.getLabelModel().get("customValues");
  if (a) {
    var e = C(t), r = t.scale.getExtent(), o = F(t, a), l = E(o, function(n) {
      return n >= r[0] && n <= r[1];
    });
    return {
      labels: d(l, function(n) {
        var v = {
          value: n
        };
        return {
          formattedLabel: e(v),
          rawLabel: t.scale.getLabel(v),
          tickValue: n
        };
      })
    };
  }
  return t.type === "category" ? G(t) : D(t);
}
function $(t, a) {
  var e = t.getTickModel().get("customValues");
  if (e) {
    var r = t.scale.getExtent(), o = F(t, e);
    return {
      ticks: E(o, function(l) {
        return l >= r[0] && l <= r[1];
      })
    };
  }
  return t.type === "category" ? q(t, a) : {
    ticks: d(t.scale.getTicks(), function(l) {
      return l.value;
    })
  };
}
function G(t) {
  var a = t.getLabelModel(), e = N(t, a);
  return !a.get("show") || t.scale.isBlank() ? {
    labels: [],
    labelCategoryInterval: e.labelCategoryInterval
  } : e;
}
function N(t, a) {
  var e = R(t, "labels"), r = V(a), o = S(e, r);
  if (o)
    return o;
  var l, n;
  return A(r) ? l = z(t, r) : (n = r === "auto" ? J(t) : r, l = H(t, n)), B(e, r, {
    labels: l,
    labelCategoryInterval: n
  });
}
function q(t, a) {
  var e = R(t, "ticks"), r = V(a), o = S(e, r);
  if (o)
    return o;
  var l, n;
  if ((!a.get("show") || t.scale.isBlank()) && (l = []), A(r))
    l = z(t, r, !0);
  else if (r === "auto") {
    var v = N(t, t.getLabelModel());
    n = v.labelCategoryInterval, l = d(v.labels, function(u) {
      return u.tickValue;
    });
  } else
    n = r, l = H(t, n, !0);
  return B(e, r, {
    ticks: l,
    tickCategoryInterval: n
  });
}
function D(t) {
  var a = t.scale.getTicks(), e = C(t);
  return {
    labels: d(a, function(r, o) {
      return {
        level: r.level,
        formattedLabel: e(r, o),
        rawLabel: t.scale.getLabel(r),
        tickValue: r.value
      };
    })
  };
}
function R(t, a) {
  return L(t)[a] || (L(t)[a] = []);
}
function S(t, a) {
  for (var e = 0; e < t.length; e++)
    if (t[e].key === a)
      return t[e].value;
}
function B(t, a, e) {
  return t.push({
    key: a,
    value: e
  }), e;
}
function J(t) {
  var a = L(t).autoInterval;
  return a ?? (L(t).autoInterval = t.calculateCategoryInterval());
}
function _(t) {
  var a = K(t), e = C(t), r = (a.axisRotate - a.labelRotate) / 180 * Math.PI, o = t.scale, l = o.getExtent(), n = o.count();
  if (l[1] - l[0] < 1)
    return 0;
  var v = 1;
  n > 40 && (v = Math.max(1, Math.floor(n / 40)));
  for (var u = l[0], c = t.dataToCoord(u + 1) - t.dataToCoord(u), p = Math.abs(c * Math.cos(r)), M = Math.abs(c * Math.sin(r)), m = 0, h = 0; u <= l[1]; u += v) {
    var s = 0, f = 0, b = P(e({
      value: u
    }), a.font, "center", "top");
    s = b.width * 1.3, f = b.height * 1.3, m = Math.max(m, s, 7), h = Math.max(h, f, 7);
  }
  var g = m / p, T = h / M;
  isNaN(g) && (g = 1 / 0), isNaN(T) && (T = 1 / 0);
  var k = Math.max(0, Math.floor(Math.min(g, T))), i = L(t.model), y = t.getExtent(), I = i.lastAutoInterval, w = i.lastTickCount;
  return I != null && w != null && Math.abs(I - k) <= 1 && Math.abs(w - n) <= 1 && I > k && i.axisExtent0 === y[0] && i.axisExtent1 === y[1] ? k = I : (i.lastTickCount = n, i.lastAutoInterval = k, i.axisExtent0 = y[0], i.axisExtent1 = y[1]), k;
}
function K(t) {
  var a = t.getLabelModel();
  return {
    axisRotate: t.getRotate ? t.getRotate() : t.isHorizontal && !t.isHorizontal() ? 90 : 0,
    labelRotate: a.get("rotate") || 0,
    font: a.getFont()
  };
}
function H(t, a, e) {
  var r = C(t), o = t.scale, l = o.getExtent(), n = t.getLabelModel(), v = [], u = Math.max((a || 0) + 1, 1), c = l[0], p = o.count();
  c !== 0 && u > 1 && p / u > 2 && (c = Math.round(Math.ceil(c / u) * u));
  var M = j(t), m = n.get("showMinLabel") || M, h = n.get("showMaxLabel") || M;
  m && c !== l[0] && f(l[0]);
  for (var s = c; s <= l[1]; s += u)
    f(s);
  h && s - u !== l[1] && f(l[1]);
  function f(b) {
    var g = {
      value: b
    };
    v.push(e ? b : {
      formattedLabel: r(g),
      rawLabel: o.getLabel(g),
      tickValue: b
    });
  }
  return v;
}
function z(t, a, e) {
  var r = t.scale, o = C(t), l = [];
  return O(r.getTicks(), function(n) {
    var v = r.getLabel(n), u = n.value;
    a(n.value, v) && l.push(e ? u : {
      formattedLabel: o(n),
      rawLabel: v,
      tickValue: u
    });
  }), l;
}
export {
  _ as calculateCategoryInterval,
  Z as createAxisLabels,
  $ as createAxisTicks
};
