import { each as m, isArray as g } from "../../../../zrender/lib/core/util.js";
import { getLayoutRect as y } from "../../util/layout.js";
import { parseDate as v } from "../../util/number.js";
var d = 864e5, p = (
  /** @class */
  function() {
    function n(e, t, i) {
      this.type = "calendar", this.dimensions = n.dimensions, this.getDimensionsInfo = n.getDimensionsInfo, this._model = e;
    }
    return n.getDimensionsInfo = function() {
      return [{
        name: "time",
        type: "time"
      }, "value"];
    }, n.prototype.getRangeInfo = function() {
      return this._rangeInfo;
    }, n.prototype.getModel = function() {
      return this._model;
    }, n.prototype.getRect = function() {
      return this._rect;
    }, n.prototype.getCellWidth = function() {
      return this._sw;
    }, n.prototype.getCellHeight = function() {
      return this._sh;
    }, n.prototype.getOrient = function() {
      return this._orient;
    }, n.prototype.getFirstDayOfWeek = function() {
      return this._firstDayOfWeek;
    }, n.prototype.getDateInfo = function(e) {
      e = v(e);
      var t = e.getFullYear(), i = e.getMonth() + 1, r = i < 10 ? "0" + i : "" + i, o = e.getDate(), a = o < 10 ? "0" + o : "" + o, s = e.getDay();
      return s = Math.abs((s + 7 - this.getFirstDayOfWeek()) % 7), {
        y: t + "",
        m: r,
        d: a,
        day: s,
        time: e.getTime(),
        formatedDate: t + "-" + r + "-" + a,
        date: e
      };
    }, n.prototype.getNextNDay = function(e, t) {
      return t = t || 0, t === 0 ? this.getDateInfo(e) : (e = new Date(this.getDateInfo(e).time), e.setDate(e.getDate() + t), this.getDateInfo(e));
    }, n.prototype.update = function(e, t) {
      this._firstDayOfWeek = +this._model.getModel("dayLabel").get("firstDay"), this._orient = this._model.get("orient"), this._lineWidth = this._model.getModel("itemStyle").getItemStyle().lineWidth || 0, this._rangeInfo = this._getRangeInfo(this._initRangeOption());
      var i = this._rangeInfo.weeks || 1, r = ["width", "height"], o = this._model.getCellSize().slice(), a = this._model.getBoxLayoutParams(), s = this._orient === "horizontal" ? [i, 7] : [7, i];
      m([0, 1], function(h) {
        f(o, h) && (a[r[h]] = o[h] * s[h]);
      });
      var l = {
        width: t.getWidth(),
        height: t.getHeight()
      }, u = this._rect = y(a, l);
      m([0, 1], function(h) {
        f(o, h) || (o[h] = u[r[h]] / s[h]);
      });
      function f(h, c) {
        return h[c] != null && h[c] !== "auto";
      }
      this._sw = o[0], this._sh = o[1];
    }, n.prototype.dataToPoint = function(e, t) {
      g(e) && (e = e[0]), t == null && (t = !0);
      var i = this.getDateInfo(e), r = this._rangeInfo, o = i.formatedDate;
      if (t && !(i.time >= r.start.time && i.time < r.end.time + d))
        return [NaN, NaN];
      var a = i.day, s = this._getRangeInfo([r.start.time, o]).nthWeek;
      return this._orient === "vertical" ? [this._rect.x + a * this._sw + this._sw / 2, this._rect.y + s * this._sh + this._sh / 2] : [this._rect.x + s * this._sw + this._sw / 2, this._rect.y + a * this._sh + this._sh / 2];
    }, n.prototype.pointToData = function(e) {
      var t = this.pointToDate(e);
      return t && t.time;
    }, n.prototype.dataToRect = function(e, t) {
      var i = this.dataToPoint(e, t);
      return {
        contentShape: {
          x: i[0] - (this._sw - this._lineWidth) / 2,
          y: i[1] - (this._sh - this._lineWidth) / 2,
          width: this._sw - this._lineWidth,
          height: this._sh - this._lineWidth
        },
        center: i,
        tl: [i[0] - this._sw / 2, i[1] - this._sh / 2],
        tr: [i[0] + this._sw / 2, i[1] - this._sh / 2],
        br: [i[0] + this._sw / 2, i[1] + this._sh / 2],
        bl: [i[0] - this._sw / 2, i[1] + this._sh / 2]
      };
    }, n.prototype.pointToDate = function(e) {
      var t = Math.floor((e[0] - this._rect.x) / this._sw) + 1, i = Math.floor((e[1] - this._rect.y) / this._sh) + 1, r = this._rangeInfo.range;
      return this._orient === "vertical" ? this._getDateByWeeksAndDay(i, t - 1, r) : this._getDateByWeeksAndDay(t, i - 1, r);
    }, n.prototype.convertToPixel = function(e, t, i) {
      var r = _(t);
      return r === this ? r.dataToPoint(i) : null;
    }, n.prototype.convertFromPixel = function(e, t, i) {
      var r = _(t);
      return r === this ? r.pointToData(i) : null;
    }, n.prototype.containPoint = function(e) {
      return console.warn("Not implemented."), !1;
    }, n.prototype._initRangeOption = function() {
      var e = this._model.get("range"), t;
      if (g(e) && e.length === 1 && (e = e[0]), g(e))
        t = e;
      else {
        var i = e.toString();
        if (/^\d{4}$/.test(i) && (t = [i + "-01-01", i + "-12-31"]), /^\d{4}[\/|-]\d{1,2}$/.test(i)) {
          var r = this.getDateInfo(i), o = r.date;
          o.setMonth(o.getMonth() + 1);
          var a = this.getNextNDay(o, -1);
          t = [r.formatedDate, a.formatedDate];
        }
        /^\d{4}[\/|-]\d{1,2}[\/|-]\d{1,2}$/.test(i) && (t = [i, i]);
      }
      if (!t)
        return e;
      var s = this._getRangeInfo(t);
      return s.start.time > s.end.time && t.reverse(), t;
    }, n.prototype._getRangeInfo = function(e) {
      var t = [this.getDateInfo(e[0]), this.getDateInfo(e[1])], i;
      t[0].time > t[1].time && (i = !0, t.reverse());
      var r = Math.floor(t[1].time / d) - Math.floor(t[0].time / d) + 1, o = new Date(t[0].time), a = o.getDate(), s = t[1].date.getDate();
      o.setDate(a + r - 1);
      var l = o.getDate();
      if (l !== s)
        for (var u = o.getTime() - t[1].time > 0 ? 1 : -1; (l = o.getDate()) !== s && (o.getTime() - t[1].time) * u > 0; )
          r -= u, o.setDate(l - u);
      var f = Math.floor((r + t[0].day + 6) / 7), h = i ? -f + 1 : f - 1;
      return i && t.reverse(), {
        range: [t[0].formatedDate, t[1].formatedDate],
        start: t[0],
        end: t[1],
        allDay: r,
        weeks: f,
        // From 0.
        nthWeek: h,
        fweek: t[0].day,
        lweek: t[1].day
      };
    }, n.prototype._getDateByWeeksAndDay = function(e, t, i) {
      var r = this._getRangeInfo(i);
      if (e > r.weeks || e === 0 && t < r.fweek || e === r.weeks && t > r.lweek)
        return null;
      var o = (e - 1) * 7 - r.fweek + t, a = new Date(r.start.time);
      return a.setDate(+r.start.d + o), this.getDateInfo(a);
    }, n.create = function(e, t) {
      var i = [];
      return e.eachComponent("calendar", function(r) {
        var o = new n(r);
        i.push(o), r.coordinateSystem = o;
      }), e.eachSeries(function(r) {
        r.get("coordinateSystem") === "calendar" && (r.coordinateSystem = i[r.get("calendarIndex") || 0]);
      }), i;
    }, n.dimensions = ["time", "value"], n;
  }()
);
function _(n) {
  var e = n.calendarModel, t = n.seriesModel, i = e ? e.coordinateSystem : t ? t.coordinateSystem : null;
  return i;
}
const k = p;
export {
  k as default
};
