import { each as g, isObject as D, indexOf as d, keys as E } from "../../../../zrender/lib/core/util.js";
import { getLayoutRect as I } from "../../util/layout.js";
import { estimateLabelUnionRect as M, createScaleByModel as P, getDataDimensionsOnAxis as Z, ifAxisCrossZero as G, niceScaleExtent as A } from "../axisHelper.js";
import w, { cartesian2DDimensions as _ } from "./Cartesian2D.js";
import R from "./Axis2D.js";
import { SINGLE_REFERRING as C } from "../../util/model.js";
import { isCartesian2DSeries as L, findAxisModels as S } from "./cartesianAxisHelper.js";
import { isIntervalOrLogScale as T } from "../../scale/helper.js";
import { alignScaleTicks as k } from "../axisAlignTicks.js";
var z = (
  /** @class */
  function() {
    function s(e, i, r) {
      this.type = "grid", this._coordsMap = {}, this._coordsList = [], this._axesMap = {}, this._axesList = [], this.axisPointerEnabled = !0, this.dimensions = _, this._initCartesian(e, i, r), this.model = e;
    }
    return s.prototype.getRect = function() {
      return this._rect;
    }, s.prototype.update = function(e, i) {
      var r = this._axesMap;
      this._updateScale(e, this.model);
      function t(o) {
        var f, p = E(o), a = p.length;
        if (a) {
          for (var u = [], c = a - 1; c >= 0; c--) {
            var l = +p[c], h = o[l], x = h.model, v = h.scale;
            // Only value and log axis without interval support alignTicks.
            T(v) && x.get("alignTicks") && x.get("interval") == null ? u.push(h) : (A(v, x), T(v) && (f = h));
          }
          u.length && (f || (f = u.pop(), A(f.scale, f.model)), g(u, function(y) {
            k(y.scale, y.model, f.scale);
          }));
        }
      }
      t(r.x), t(r.y);
      var n = {};
      g(r.x, function(o) {
        b(r, "y", o, n);
      }), g(r.y, function(o) {
        b(r, "x", o, n);
      }), this.resize(this.model, i);
    }, s.prototype.resize = function(e, i, r) {
      var t = e.getBoxLayoutParams(), n = !r && e.get("containLabel"), o = I(t, {
        width: i.getWidth(),
        height: i.getHeight()
      });
      this._rect = o;
      var f = this._axesList;
      p(), n && (g(f, function(a) {
        if (!a.model.get(["axisLabel", "inside"])) {
          var u = M(a);
          if (u) {
            var c = a.isHorizontal() ? "height" : "width", l = a.model.get(["axisLabel", "margin"]);
            o[c] -= u[c] + l, a.position === "top" ? o.y += u.height + l : a.position === "left" && (o.x += u.width + l);
          }
        }
      }), p()), g(this._coordsList, function(a) {
        a.calcAffineTransform();
      });
      function p() {
        g(f, function(a) {
          var u = a.isHorizontal(), c = u ? [0, o.width] : [0, o.height], l = a.inverse ? 1 : 0;
          a.setExtent(c[l], c[1 - l]), H(a, u ? o.x : o.y);
        });
      }
    }, s.prototype.getAxis = function(e, i) {
      var r = this._axesMap[e];
      if (r != null)
        return r[i || 0];
    }, s.prototype.getAxes = function() {
      return this._axesList.slice();
    }, s.prototype.getCartesian = function(e, i) {
      if (e != null && i != null) {
        var r = "x" + e + "y" + i;
        return this._coordsMap[r];
      }
      D(e) && (i = e.yAxisIndex, e = e.xAxisIndex);
      for (var t = 0, n = this._coordsList; t < n.length; t++)
        if (n[t].getAxis("x").index === e || n[t].getAxis("y").index === i)
          return n[t];
    }, s.prototype.getCartesians = function() {
      return this._coordsList.slice();
    }, s.prototype.convertToPixel = function(e, i, r) {
      var t = this._findConvertTarget(i);
      return t.cartesian ? t.cartesian.dataToPoint(r) : t.axis ? t.axis.toGlobalCoord(t.axis.dataToCoord(r)) : null;
    }, s.prototype.convertFromPixel = function(e, i, r) {
      var t = this._findConvertTarget(i);
      return t.cartesian ? t.cartesian.pointToData(r) : t.axis ? t.axis.coordToData(t.axis.toLocalCoord(r)) : null;
    }, s.prototype._findConvertTarget = function(e) {
      var i = e.seriesModel, r = e.xAxisModel || i && i.getReferringComponents("xAxis", C).models[0], t = e.yAxisModel || i && i.getReferringComponents("yAxis", C).models[0], n = e.gridModel, o = this._coordsList, f, p;
      if (i)
        f = i.coordinateSystem, d(o, f) < 0 && (f = null);
      else if (r && t)
        f = this.getCartesian(r.componentIndex, t.componentIndex);
      else if (r)
        p = this.getAxis("x", r.componentIndex);
      else if (t)
        p = this.getAxis("y", t.componentIndex);
      else if (n) {
        var a = n.coordinateSystem;
        a === this && (f = this._coordsList[0]);
      }
      return {
        cartesian: f,
        axis: p
      };
    }, s.prototype.containPoint = function(e) {
      var i = this._coordsList[0];
      if (i)
        return i.containPoint(e);
    }, s.prototype._initCartesian = function(e, i, r) {
      var t = this, n = this, o = {
        left: !1,
        right: !1,
        top: !1,
        bottom: !1
      }, f = {
        x: {},
        y: {}
      }, p = {
        x: 0,
        y: 0
      };
      if (i.eachComponent("xAxis", a("x"), this), i.eachComponent("yAxis", a("y"), this), !p.x || !p.y) {
        this._axesMap = {}, this._axesList = [];
        return;
      }
      this._axesMap = f, g(f.x, function(u, c) {
        g(f.y, function(l, h) {
          var x = "x" + c + "y" + h, v = new w(x);
          v.master = t, v.model = e, t._coordsMap[x] = v, t._coordsList.push(v), v.addAxis(u), v.addAxis(l);
        });
      });
      function a(u) {
        return function(c, l) {
          if (m(c, e)) {
            var h = c.get("position");
            u === "x" ? h !== "top" && h !== "bottom" && (h = o.bottom ? "top" : "bottom") : h !== "left" && h !== "right" && (h = o.left ? "right" : "left"), o[h] = !0;
            var x = new R(u, P(c), [0, 0], c.get("type"), h), v = x.type === "category";
            x.onBand = v && c.get("boundaryGap"), x.inverse = c.get("inverse"), c.axis = x, x.model = c, x.grid = n, x.index = l, n._axesList.push(x), f[u][l] = x, p[u]++;
          }
        };
      }
    }, s.prototype._updateScale = function(e, i) {
      g(this._axesList, function(t) {
        if (t.scale.setExtent(1 / 0, -1 / 0), t.type === "category") {
          var n = t.model.get("categorySortInfo");
          t.scale.setSortInfo(n);
        }
      }), e.eachSeries(function(t) {
        if (L(t)) {
          var n = S(t), o = n.xAxisModel, f = n.yAxisModel;
          if (!m(o, i) || !m(f, i))
            return;
          var p = this.getCartesian(o.componentIndex, f.componentIndex), a = t.getData(), u = p.getAxis("x"), c = p.getAxis("y");
          r(a, u), r(a, c);
        }
      }, this);
      function r(t, n) {
        g(Z(t, n.dim), function(o) {
          n.scale.unionExtentFromData(t, o);
        });
      }
    }, s.prototype.getTooltipAxes = function(e) {
      var i = [], r = [];
      return g(this.getCartesians(), function(t) {
        var n = e != null && e !== "auto" ? t.getAxis(e) : t.getBaseAxis(), o = t.getOtherAxis(n);
        d(i, n) < 0 && i.push(n), d(r, o) < 0 && r.push(o);
      }), {
        baseAxes: i,
        otherAxes: r
      };
    }, s.create = function(e, i) {
      var r = [];
      return e.eachComponent("grid", function(t, n) {
        var o = new s(t, e, i);
        o.name = "grid_" + n, o.resize(t, i, !0), t.coordinateSystem = o, r.push(o);
      }), e.eachSeries(function(t) {
        if (L(t)) {
          var n = S(t), o = n.xAxisModel, f = n.yAxisModel, p = o.getCoordSysModel(), a = p.coordinateSystem;
          t.coordinateSystem = a.getCartesian(o.componentIndex, f.componentIndex);
        }
      }), r;
    }, s.dimensions = _, s;
  }()
);
function m(s, e) {
  return s.getCoordSysModel() === e;
}
function b(s, e, i, r) {
  i.getAxesOnZeroOf = function() {
    return n ? [n] : [];
  };
  var t = s[e], n, o = i.model, f = o.get(["axisLine", "onZero"]), p = o.get(["axisLine", "onZeroAxisIndex"]);
  if (!f)
    return;
  if (p != null)
    O(t[p]) && (n = t[p]);
  else
    for (var a in t)
      if (t.hasOwnProperty(a) && O(t[a]) && !r[u(t[a])]) {
        n = t[a];
        break;
      }
  n && (r[u(n)] = !0);
  function u(c) {
    return c.dim + "_" + c.index;
  }
}
function O(s) {
  return s && s.type !== "category" && s.type !== "time" && G(s);
}
function H(s, e) {
  var i = s.getExtent(), r = i[0] + i[1];
  s.toGlobalCoord = s.dim === "x" ? function(t) {
    return t + e;
  } : function(t) {
    return r - t + e;
  }, s.toLocalCoord = s.dim === "x" ? function(t) {
    return t - e;
  } : function(t) {
    return r - t + e;
  };
}
const Q = z;
export {
  Q as default
};
