import { createHashMap as u } from "../../../../zrender/lib/core/util.js";
import { GeoSVGResource as c } from "./GeoSVGResource.js";
import { GeoJSONResource as g } from "./GeoJSONResource.js";
var t = u();
const f = {
  /**
   * Compatible with previous `echarts.registerMap`.
   *
   * @usage
   * ```js
   *
   * echarts.registerMap('USA', geoJson, specialAreas);
   *
   * echarts.registerMap('USA', {
   *     geoJson: geoJson,
   *     specialAreas: {...}
   * });
   * echarts.registerMap('USA', {
   *     geoJSON: geoJson,
   *     specialAreas: {...}
   * });
   *
   * echarts.registerMap('airport', {
   *     svg: svg
   * }
   * ```
   *
   * Note:
   * Do not support that register multiple geoJSON or SVG
   * one map name. Because different geoJSON and SVG have
   * different unit. It's not easy to make sure how those
   * units are mapping/normalize.
   * If intending to use multiple geoJSON or SVG, we can
   * use multiple geo coordinate system.
   */
  registerMap: function(r, e, s) {
    if (e.svg) {
      var o = new c(r, e.svg);
      t.set(r, o);
    } else {
      var n = e.geoJson || e.geoJSON;
      n && !e.features ? s = e.specialAreas : n = e;
      var o = new g(r, n, s);
      t.set(r, o);
    }
  },
  getGeoResource: function(r) {
    return t.get(r);
  },
  /**
   * Only for exporting to users.
   * **MUST NOT** used internally.
   */
  getMapForUser: function(r) {
    var e = t.get(r);
    return e && e.type === "geoJSON" && e.getMapForUser();
  },
  load: function(r, e, s) {
    var o = t.get(r);
    if (o)
      return o.load(e, s);
  }
};
export {
  f as default
};
