import { createHashMap as M, each as E, clone as b } from "../../../../zrender/lib/core/util.js";
import { rotate as C, translate as P, create as S } from "../../../../zrender/lib/core/matrix.js";
import { getLayoutRect as I } from "../../util/layout.js";
import { createScaleByModel as B, niceScaleExtent as D } from "../axisHelper.js";
import T from "./ParallelAxis.js";
import { applyTransform as k } from "../../util/graphic.js";
import { round as N } from "../../util/number.js";
import F from "../../component/helper/sliderMove.js";
var f = E, _ = Math.min, A = Math.max, g = Math.floor, z = Math.ceil, W = N, $ = Math.PI, H = (
  /** @class */
  function() {
    function l(a, t, p) {
      this.type = "parallel", this._axesMap = M(), this._axesLayout = {}, this.dimensions = a.dimensions, this._model = a, this._init(a, t, p);
    }
    return l.prototype._init = function(a, t, p) {
      var i = a.dimensions, e = a.parallelAxisIndex;
      f(i, function(n, o) {
        var r = e[o], h = t.getComponent("parallelAxis", r), s = this._axesMap.set(n, new T(n, B(h), [0, 0], h.get("type"), r)), d = s.type === "category";
        s.onBand = d && h.get("boundaryGap"), s.inverse = h.get("inverse"), h.axis = s, s.model = h, s.coordinateSystem = h.coordinateSystem = this;
      }, this);
    }, l.prototype.update = function(a, t) {
      this._updateAxesFromSeries(this._model, a);
    }, l.prototype.containPoint = function(a) {
      var t = this._makeLayoutInfo(), p = t.axisBase, i = t.layoutBase, e = t.pixelDimIndex, n = a[1 - e], o = a[e];
      return n >= p && n <= p + t.axisLength && o >= i && o <= i + t.layoutLength;
    }, l.prototype.getModel = function() {
      return this._model;
    }, l.prototype._updateAxesFromSeries = function(a, t) {
      t.eachSeries(function(p) {
        if (a.contains(p, t)) {
          var i = p.getData();
          f(this.dimensions, function(e) {
            var n = this._axesMap.get(e);
            n.scale.unionExtentFromData(i, i.mapDimension(e)), D(n.scale, n.model);
          }, this);
        }
      }, this);
    }, l.prototype.resize = function(a, t) {
      this._rect = I(a.getBoxLayoutParams(), {
        width: t.getWidth(),
        height: t.getHeight()
      }), this._layoutAxes();
    }, l.prototype.getRect = function() {
      return this._rect;
    }, l.prototype._makeLayoutInfo = function() {
      var a = this._model, t = this._rect, p = ["x", "y"], i = ["width", "height"], e = a.get("layout"), n = e === "horizontal" ? 0 : 1, o = t[i[n]], r = [0, o], h = this.dimensions.length, s = c(a.get("axisExpandWidth"), r), d = c(a.get("axisExpandCount") || 0, [0, h]), u = a.get("axisExpandable") && h > 3 && h > d && d > 1 && s > 0 && o > 0, x = a.get("axisExpandWindow"), v;
      if (x)
        v = c(x[1] - x[0], r), x[1] = x[0] + v;
      else {
        v = c(s * (d - 1), r);
        var y = a.get("axisExpandCenter") || g(h / 2);
        x = [s * y - v / 2], x[1] = x[0] + v;
      }
      var m = (o - v) / (h - d);
      m < 3 && (m = 0);
      var L = [g(W(x[0] / s, 1)) + 1, z(W(x[1] / s, 1)) - 1], w = m / s * x[0];
      return {
        layout: e,
        pixelDimIndex: n,
        layoutBase: t[p[n]],
        layoutLength: o,
        axisBase: t[p[1 - n]],
        axisLength: t[i[1 - n]],
        axisExpandable: u,
        axisExpandWidth: s,
        axisCollapseWidth: m,
        axisExpandWindow: x,
        axisCount: h,
        winInnerIndices: L,
        axisExpandWindow0Pos: w
      };
    }, l.prototype._layoutAxes = function() {
      var a = this._rect, t = this._axesMap, p = this.dimensions, i = this._makeLayoutInfo(), e = i.layout;
      t.each(function(n) {
        var o = [0, i.axisLength], r = n.inverse ? 1 : 0;
        n.setExtent(o[r], o[1 - r]);
      }), f(p, function(n, o) {
        var r = (i.axisExpandable ? G : R)(o, i), h = {
          horizontal: {
            x: r.position,
            y: i.axisLength
          },
          vertical: {
            x: 0,
            y: r.position
          }
        }, s = {
          horizontal: $ / 2,
          vertical: 0
        }, d = [h[e].x + a.x, h[e].y + a.y], u = s[e], x = S();
        C(x, x, u), P(x, x, d), this._axesLayout[n] = {
          position: d,
          rotation: u,
          transform: x,
          axisNameAvailableWidth: r.axisNameAvailableWidth,
          axisLabelShow: r.axisLabelShow,
          nameTruncateMaxWidth: r.nameTruncateMaxWidth,
          tickDirection: 1,
          labelDirection: 1
        };
      }, this);
    }, l.prototype.getAxis = function(a) {
      return this._axesMap.get(a);
    }, l.prototype.dataToPoint = function(a, t) {
      return this.axisCoordToPoint(this._axesMap.get(t).dataToCoord(a), t);
    }, l.prototype.eachActiveState = function(a, t, p, i) {
      p == null && (p = 0), i == null && (i = a.count());
      var e = this._axesMap, n = this.dimensions, o = [], r = [];
      E(n, function(m) {
        o.push(a.mapDimension(m)), r.push(e.get(m).model);
      });
      for (var h = this.hasAxisBrushed(), s = p; s < i; s++) {
        var d = void 0;
        if (!h)
          d = "normal";
        else {
          d = "active";
          for (var u = a.getValues(o, s), x = 0, v = n.length; x < v; x++) {
            var y = r[x].getActiveState(u[x]);
            if (y === "inactive") {
              d = "inactive";
              break;
            }
          }
        }
        t(d, s);
      }
    }, l.prototype.hasAxisBrushed = function() {
      for (var a = this.dimensions, t = this._axesMap, p = !1, i = 0, e = a.length; i < e; i++)
        t.get(a[i]).model.getActiveState() !== "normal" && (p = !0);
      return p;
    }, l.prototype.axisCoordToPoint = function(a, t) {
      var p = this._axesLayout[t];
      return k([a, 0], p.transform);
    }, l.prototype.getAxisLayout = function(a) {
      return b(this._axesLayout[a]);
    }, l.prototype.getSlidedAxisExpandWindow = function(a) {
      var t = this._makeLayoutInfo(), p = t.pixelDimIndex, i = t.axisExpandWindow.slice(), e = i[1] - i[0], n = [0, t.axisExpandWidth * (t.axisCount - 1)];
      if (!this.containPoint(a))
        return {
          behavior: "none",
          axisExpandWindow: i
        };
      var o = a[p] - t.layoutBase - t.axisExpandWindow0Pos, r, h = "slide", s = t.axisCollapseWidth, d = this._model.get("axisExpandSlideTriggerArea"), u = d[0] != null;
      if (s)
        u && s && o < e * d[0] ? (h = "jump", r = o - e * d[2]) : u && s && o > e * (1 - d[0]) ? (h = "jump", r = o - e * (1 - d[2])) : (r = o - e * d[1]) >= 0 && (r = o - e * (1 - d[1])) <= 0 && (r = 0), r *= t.axisExpandWidth / s, r ? F(r, i, n, "all") : h = "none";
      else {
        var x = i[1] - i[0], v = n[1] * o / x;
        i = [A(0, v - x / 2)], i[1] = _(n[1], i[0] + x), i[0] = i[1] - x;
      }
      return {
        axisExpandWindow: i,
        behavior: h
      };
    }, l;
  }()
);
function c(l, a) {
  return _(A(l, a[0]), a[1]);
}
function R(l, a) {
  var t = a.layoutLength / (a.axisCount - 1);
  return {
    position: t * l,
    axisNameAvailableWidth: t,
    axisLabelShow: !0
  };
}
function G(l, a) {
  var t = a.layoutLength, p = a.axisExpandWidth, i = a.axisCount, e = a.axisCollapseWidth, n = a.winInnerIndices, o, r = e, h = !1, s;
  return l < n[0] ? (o = l * e, s = e) : l <= n[1] ? (o = a.axisExpandWindow0Pos + l * p - a.axisExpandWindow[0], r = p, h = !0) : (o = t - (i - 1 - l) * e, s = e), {
    position: o,
    axisNameAvailableWidth: r,
    axisLabelShow: h,
    nameTruncateMaxWidth: s
  };
}
const Y = H;
export {
  Y as default
};
