import p from "./RadiusAxis.js";
import g from "./AngleAxis.js";
var v = ["radius", "angle"], y = (
  /** @class */
  function() {
    function e(i) {
      this.dimensions = v, this.type = "polar", this.cx = 0, this.cy = 0, this._radiusAxis = new p(), this._angleAxis = new g(), this.axisPointerEnabled = !0, this.name = i || "", this._radiusAxis.polar = this._angleAxis.polar = this;
    }
    return e.prototype.containPoint = function(i) {
      var t = this.pointToCoord(i);
      return this._radiusAxis.contain(t[0]) && this._angleAxis.contain(t[1]);
    }, e.prototype.containData = function(i) {
      return this._radiusAxis.containData(i[0]) && this._angleAxis.containData(i[1]);
    }, e.prototype.getAxis = function(i) {
      var t = "_" + i + "Axis";
      return this[t];
    }, e.prototype.getAxes = function() {
      return [this._radiusAxis, this._angleAxis];
    }, e.prototype.getAxesByScale = function(i) {
      var t = [], r = this._angleAxis, s = this._radiusAxis;
      return r.scale.type === i && t.push(r), s.scale.type === i && t.push(s), t;
    }, e.prototype.getAngleAxis = function() {
      return this._angleAxis;
    }, e.prototype.getRadiusAxis = function() {
      return this._radiusAxis;
    }, e.prototype.getOtherAxis = function(i) {
      var t = this._angleAxis;
      return i === t ? this._radiusAxis : t;
    }, e.prototype.getBaseAxis = function() {
      return this.getAxesByScale("ordinal")[0] || this.getAxesByScale("time")[0] || this.getAngleAxis();
    }, e.prototype.getTooltipAxes = function(i) {
      var t = i != null && i !== "auto" ? this.getAxis(i) : this.getBaseAxis();
      return {
        baseAxes: [t],
        otherAxes: [this.getOtherAxis(t)]
      };
    }, e.prototype.dataToPoint = function(i, t) {
      return this.coordToPoint([this._radiusAxis.dataToRadius(i[0], t), this._angleAxis.dataToAngle(i[1], t)]);
    }, e.prototype.pointToData = function(i, t) {
      var r = this.pointToCoord(i);
      return [this._radiusAxis.radiusToData(r[0], t), this._angleAxis.angleToData(r[1], t)];
    }, e.prototype.pointToCoord = function(i) {
      var t = i[0] - this.cx, r = i[1] - this.cy, s = this.getAngleAxis(), a = s.getExtent(), o = Math.min(a[0], a[1]), x = Math.max(a[0], a[1]);
      s.inverse ? o = x - 360 : x = o + 360;
      var u = Math.sqrt(t * t + r * r);
      t /= u, r /= u;
      for (var n = Math.atan2(-r, t) / Math.PI * 180, h = n < o ? 1 : -1; n < o || n > x; )
        n += h * 360;
      return [u, n];
    }, e.prototype.coordToPoint = function(i) {
      var t = i[0], r = i[1] / 180 * Math.PI, s = Math.cos(r) * t + this.cx, a = -Math.sin(r) * t + this.cy;
      return [s, a];
    }, e.prototype.getArea = function() {
      var i = this.getAngleAxis(), t = this.getRadiusAxis(), r = t.getExtent().slice();
      r[0] > r[1] && r.reverse();
      var s = i.getExtent(), a = Math.PI / 180, o = 1e-4;
      return {
        cx: this.cx,
        cy: this.cy,
        r0: r[0],
        r: r[1],
        startAngle: -s[0] * a,
        endAngle: -s[1] * a,
        clockwise: i.inverse,
        contain: function(x, u) {
          var n = x - this.cx, h = u - this.cy, c = n * n + h * h, A = this.r, l = this.r0;
          return A !== l && c - o <= A * A && c + o >= l * l;
        }
      };
    }, e.prototype.convertToPixel = function(i, t, r) {
      var s = d(t);
      return s === this ? this.dataToPoint(r) : null;
    }, e.prototype.convertFromPixel = function(i, t, r) {
      var s = d(t);
      return s === this ? this.pointToData(r) : null;
    }, e;
  }()
);
function d(e) {
  var i = e.seriesModel, t = e.polarModel;
  return t && t.coordinateSystem || i && i.coordinateSystem;
}
const M = y;
export {
  M as default,
  v as polarDimensions
};
