import h from "./SingleAxis.js";
import { createScaleByModel as c, niceScaleExtent as u } from "../axisHelper.js";
import { getLayoutRect as g } from "../../util/layout.js";
import { each as p } from "../../../../zrender/lib/core/util.js";
var y = ["single"], x = (
  /** @class */
  function() {
    function n(t, e, i) {
      this.type = "single", this.dimension = "single", this.dimensions = y, this.axisPointerEnabled = !0, this.model = t, this._init(t, e, i);
    }
    return n.prototype._init = function(t, e, i) {
      var o = this.dimension, r = new h(o, c(t), [0, 0], t.get("type"), t.get("position")), s = r.type === "category";
      r.onBand = s && t.get("boundaryGap"), r.inverse = t.get("inverse"), r.orient = t.get("orient"), t.axis = r, r.model = t, r.coordinateSystem = this, this._axis = r;
    }, n.prototype.update = function(t, e) {
      t.eachSeries(function(i) {
        if (i.coordinateSystem === this) {
          var o = i.getData();
          p(o.mapDimensionsAll(this.dimension), function(r) {
            this._axis.scale.unionExtentFromData(o, r);
          }, this), u(this._axis.scale, this._axis.model);
        }
      }, this);
    }, n.prototype.resize = function(t, e) {
      this._rect = g({
        left: t.get("left"),
        top: t.get("top"),
        right: t.get("right"),
        bottom: t.get("bottom"),
        width: t.get("width"),
        height: t.get("height")
      }, {
        width: e.getWidth(),
        height: e.getHeight()
      }), this._adjustAxis();
    }, n.prototype.getRect = function() {
      return this._rect;
    }, n.prototype._adjustAxis = function() {
      var t = this._rect, e = this._axis, i = e.isHorizontal(), o = i ? [0, t.width] : [0, t.height], r = e.inverse ? 1 : 0;
      e.setExtent(o[r], o[1 - r]), this._updateAxisTransform(e, i ? t.x : t.y);
    }, n.prototype._updateAxisTransform = function(t, e) {
      var i = t.getExtent(), o = i[0] + i[1], r = t.isHorizontal();
      t.toGlobalCoord = r ? function(s) {
        return s + e;
      } : function(s) {
        return o - s + e;
      }, t.toLocalCoord = r ? function(s) {
        return s - e;
      } : function(s) {
        return o - s + e;
      };
    }, n.prototype.getAxis = function() {
      return this._axis;
    }, n.prototype.getBaseAxis = function() {
      return this._axis;
    }, n.prototype.getAxes = function() {
      return [this._axis];
    }, n.prototype.getTooltipAxes = function() {
      return {
        baseAxes: [this.getAxis()],
        // Empty otherAxes
        otherAxes: []
      };
    }, n.prototype.containPoint = function(t) {
      var e = this.getRect(), i = this.getAxis(), o = i.orient;
      return o === "horizontal" ? i.contain(i.toLocalCoord(t[0])) && t[1] >= e.y && t[1] <= e.y + e.height : i.contain(i.toLocalCoord(t[1])) && t[0] >= e.y && t[0] <= e.y + e.height;
    }, n.prototype.pointToData = function(t) {
      var e = this.getAxis();
      return [e.coordToData(e.toLocalCoord(t[e.orient === "horizontal" ? 0 : 1]))];
    }, n.prototype.dataToPoint = function(t) {
      var e = this.getAxis(), i = this.getRect(), o = [], r = e.orient === "horizontal" ? 0 : 1;
      return t instanceof Array && (t = t[0]), o[r] = e.toGlobalCoord(e.dataToCoord(+t)), o[1 - r] = r === 0 ? i.y + i.height / 2 : i.x + i.width / 2, o;
    }, n.prototype.convertToPixel = function(t, e, i) {
      var o = a(e);
      return o === this ? this.dataToPoint(i) : null;
    }, n.prototype.convertFromPixel = function(t, e, i) {
      var o = a(e);
      return o === this ? this.pointToData(i) : null;
    }, n;
  }()
);
function a(n) {
  var t = n.seriesModel, e = n.singleAxisModel;
  return e && e.coordinateSystem || t && t.coordinateSystem;
}
export {
  x as default,
  y as singleDimensions
};
