import { noop as I, createHashMap as m, each as _, assert as P, isFunction as C, map as w } from "../../../zrender/lib/core/util.js";
import { createTask as S } from "./task.js";
import { getUID as A } from "../util/component.js";
import B from "../model/Global.js";
import E from "./ExtensionAPI.js";
import { normalizeToArray as O } from "../util/model.js";
var V = (
  /** @class */
  function() {
    function t(e, a, i, r) {
      this._stageTaskMap = m(), this.ecInstance = e, this.api = a, i = this._dataProcessorHandlers = i.slice(), r = this._visualHandlers = r.slice(), this._allHandlers = i.concat(r);
    }
    return t.prototype.restoreData = function(e, a) {
      e.restoreData(a), this._stageTaskMap.each(function(i) {
        var r = i.overallTask;
        r && r.dirty();
      });
    }, t.prototype.getPerformArgs = function(e, a) {
      if (e.__pipeline) {
        var i = this._pipelineMap.get(e.__pipeline.id), r = i.context, s = !a && i.progressiveEnabled && (!r || r.progressiveRender) && e.__idxInPipeline > i.blockIndex, n = s ? i.step : null, l = r && r.modDataCount, p = l != null ? Math.ceil(l / n) : null;
        return {
          step: n,
          modBy: p,
          modDataCount: l
        };
      }
    }, t.prototype.getPipeline = function(e) {
      return this._pipelineMap.get(e);
    }, t.prototype.updateStreamModes = function(e, a) {
      var i = this._pipelineMap.get(e.uid), r = e.getData(), s = r.count(), n = i.progressiveEnabled && a.incrementalPrepareRender && s >= i.threshold, l = e.get("large") && s >= e.get("largeThreshold"), p = e.get("progressiveChunkMode") === "mod" ? s : null;
      e.pipelineContext = i.context = {
        progressiveRender: n,
        modDataCount: p,
        large: l
      };
    }, t.prototype.restorePipelines = function(e) {
      var a = this, i = a._pipelineMap = m();
      e.eachSeries(function(r) {
        var s = r.getProgressive(), n = r.uid;
        i.set(n, {
          id: n,
          head: null,
          tail: null,
          threshold: r.getProgressiveThreshold(),
          progressiveEnabled: s && !(r.preventIncremental && r.preventIncremental()),
          blockIndex: -1,
          step: Math.round(s || 700),
          count: 0
        }), a._pipe(r, r.dataTask);
      });
    }, t.prototype.prepareStageTasks = function() {
      var e = this._stageTaskMap, a = this.api.getModel(), i = this.api;
      _(this._allHandlers, function(r) {
        var s = e.get(r.uid) || e.set(r.uid, {}), n = "";
        P(!(r.reset && r.overallReset), n), r.reset && this._createSeriesStageTask(r, s, a, i), r.overallReset && this._createOverallStageTask(r, s, a, i);
      }, this);
    }, t.prototype.prepareView = function(e, a, i, r) {
      var s = e.renderTask, n = s.context;
      n.model = a, n.ecModel = i, n.api = r, s.__block = !e.incrementalPrepareRender, this._pipe(a, s);
    }, t.prototype.performDataProcessorTasks = function(e, a) {
      this._performStageTasks(this._dataProcessorHandlers, e, a, {
        block: !0
      });
    }, t.prototype.performVisualTasks = function(e, a, i) {
      this._performStageTasks(this._visualHandlers, e, a, i);
    }, t.prototype._performStageTasks = function(e, a, i, r) {
      r = r || {};
      var s = !1, n = this;
      _(e, function(p, v) {
        if (!(r.visualType && r.visualType !== p.visualType)) {
          var f = n._stageTaskMap.get(p.uid), c = f.seriesTaskMap, u = f.overallTask;
          if (u) {
            var h, d = u.agentStubMap;
            d.each(function(o) {
              l(r, o) && (o.dirty(), h = !0);
            }), h && u.dirty(), n.updatePayload(u, i);
            var g = n.getPerformArgs(u, r.block);
            d.each(function(o) {
              o.perform(g);
            }), u.perform(g) && (s = !0);
          } else
            c && c.each(function(o, T) {
              l(r, o) && o.dirty();
              var b = n.getPerformArgs(o, r.block);
              b.skip = !p.performRawSeries && a.isSeriesFiltered(o.context.model), n.updatePayload(o, i), o.perform(b) && (s = !0);
            });
        }
      });
      function l(p, v) {
        return p.setDirty && (!p.dirtyMap || p.dirtyMap.get(v.__pipeline.id));
      }
      this.unfinished = s || this.unfinished;
    }, t.prototype.performSeriesTasks = function(e) {
      var a;
      e.eachSeries(function(i) {
        a = i.dataTask.perform() || a;
      }), this.unfinished = a || this.unfinished;
    }, t.prototype.plan = function() {
      this._pipelineMap.each(function(e) {
        var a = e.tail;
        do {
          if (a.__block) {
            e.blockIndex = a.__idxInPipeline;
            break;
          }
          a = a.getUpstream();
        } while (a);
      });
    }, t.prototype.updatePayload = function(e, a) {
      a !== "remain" && (e.context.payload = a);
    }, t.prototype._createSeriesStageTask = function(e, a, i, r) {
      var s = this, n = a.seriesTaskMap, l = a.seriesTaskMap = m(), p = e.seriesType, v = e.getTargetSeries;
      e.createOnAllSeries ? i.eachRawSeries(f) : p ? i.eachRawSeriesByType(p, f) : v && v(i, r).each(f);
      function f(c) {
        var u = c.uid, h = l.set(u, n && n.get(u) || S({
          plan: z,
          reset: G,
          count: j
        }));
        h.context = {
          model: c,
          ecModel: i,
          api: r,
          // PENDING: `useClearVisual` not used?
          useClearVisual: e.isVisual && !e.isLayout,
          plan: e.plan,
          reset: e.reset,
          scheduler: s
        }, s._pipe(c, h);
      }
    }, t.prototype._createOverallStageTask = function(e, a, i, r) {
      var s = this, n = a.overallTask = a.overallTask || S({
        reset: x
      });
      n.context = {
        ecModel: i,
        api: r,
        overallReset: e.overallReset,
        scheduler: s
      };
      var l = n.agentStubMap, p = n.agentStubMap = m(), v = e.seriesType, f = e.getTargetSeries, c = !0, u = !1, h = "";
      P(!e.createOnAllSeries, h), v ? i.eachRawSeriesByType(v, d) : f ? f(i, r).each(d) : (c = !1, _(i.getSeries(), d));
      function d(g) {
        var o = g.uid, T = p.set(o, l && l.get(o) || // When the result of `getTargetSeries` changed, the overallTask
        // should be set as dirty and re-performed.
        (u = !0, S({
          reset: F,
          onDirty: U
        })));
        T.context = {
          model: g,
          overallProgress: c
          // FIXME:TS never used, so comment it
          // modifyOutputEnd: modifyOutputEnd
        }, T.agent = n, T.__block = c, s._pipe(g, T);
      }
      u && n.dirty();
    }, t.prototype._pipe = function(e, a) {
      var i = e.uid, r = this._pipelineMap.get(i);
      !r.head && (r.head = a), r.tail && r.tail.pipe(a), r.tail = a, a.__idxInPipeline = r.count++, a.__pipeline = r;
    }, t.wrapStageHandler = function(e, a) {
      return C(e) && (e = {
        overallReset: e,
        seriesType: q(e)
      }), e.uid = A("stageHandler"), a && (e.visualType = a), e;
    }, t;
  }()
);
function x(t) {
  t.overallReset(t.ecModel, t.api, t.payload);
}
function F(t) {
  return t.overallProgress && L;
}
function L() {
  this.agent.dirty(), this.getDownstream().dirty();
}
function U() {
  this.agent && this.agent.dirty();
}
function z(t) {
  return t.plan ? t.plan(t.model, t.ecModel, t.api, t.payload) : null;
}
function G(t) {
  t.useClearVisual && t.data.clearAllVisual();
  var e = t.resetDefines = O(t.reset(t.model, t.ecModel, t.api, t.payload));
  return e.length > 1 ? w(e, function(a, i) {
    return M(i);
  }) : $;
}
var $ = M(0);
function M(t) {
  return function(e, a) {
    var i = a.data, r = a.resetDefines[t];
    if (r && r.dataEach)
      for (var s = e.start; s < e.end; s++)
        r.dataEach(i, s);
    else
      r && r.progress && r.progress(e, i);
  };
}
function j(t) {
  return t.data.count();
}
function q(t) {
  k = null;
  try {
    t(y, D);
  } catch {
  }
  return k;
}
var y = {}, D = {}, k;
R(y, B);
R(D, E);
y.eachSeriesByType = y.eachRawSeriesByType = function(t) {
  k = t;
};
y.eachComponent = function(t) {
  t.mainType === "series" && t.subType && (k = t.subType);
};
function R(t, e) {
  for (var a in e.prototype)
    t[a] = I;
}
const Z = V;
export {
  Z as default
};
