import { __extends as _e } from "../../../tslib/tslib.es6.js";
import { init as Oe, registerSSRDataGetter as gt } from "../../../zrender/lib/zrender.js";
import { isObject as H, assert as mt, noop as W, retrieve2 as Me, bind as Ie, clone as Le, setAsPrimitive as St, each as E, extend as U, createHashMap as ee, map as Tt, defaults as Ct, indexOf as Ke, isFunction as $e, isString as yt } from "../../../zrender/lib/core/util.js";
import b from "../../../zrender/lib/core/env.js";
import te from "../../../zrender/lib/core/timsort.js";
import Te from "../../../zrender/lib/core/Eventful.js";
import Rt from "../model/Global.js";
import Et from "./ExtensionAPI.js";
import je from "./CoordinateSystem.js";
import At from "../model/OptionManager.js";
import Je from "../preprocessor/backwardCompat.js";
import Pt from "../processor/dataStack.js";
import xe from "../model/Series.js";
import wt from "../view/Component.js";
import re from "../view/Chart.js";
import { getECData as Z } from "../util/innerStore.js";
import { HIGHLIGHT_ACTION_TYPE as z, DOWNPLAY_ACTION_TYPE as ie, SELECT_ACTION_TYPE as ne, UNSELECT_ACTION_TYPE as ae, TOGGLE_SELECT_ACTION_TYPE as se, isSelectChangePayload as De, isHighDownPayload as Ve, allLeaveBlur as Ot, getAllSelectedIndices as Mt, updateSeriesElementSelection as Ue, HOVER_STATE_EMPHASIS as It, HOVER_STATE_BLUR as Lt, savePathStates as xt, enterEmphasis as ke, leaveEmphasis as ze, enterBlur as Dt, leaveBlur as Vt, enterSelect as Ut, leaveSelect as kt, blurSeriesFromHighlightPayload as zt, findComponentHighDownDispatchers as Ft, blurComponent as bt, toggleSelectionFromPayload as Yt, isHighDownDispatcher as Fe, handleGlobalMouseOverForHighDown as Bt, handleGlobalMouseOutForHighDown as Ht } from "../util/states.js";
import { parseFinder as oe, setAttribute as Qe, preParseFinder as Gt, convertOptionIdName as Nt, normalizeToArray as Wt, getAttribute as Xt } from "../util/model.js";
import { throttle as Zt } from "../util/throttle.js";
import { seriesStyleTask as qt, dataStyleTask as Kt, dataColorPaletteTask as $t } from "../visual/style.js";
import jt from "../loading/default.js";
import et from "./Scheduler.js";
import Jt from "../theme/light.js";
import Qt from "../theme/dark.js";
import { parseClassType as be } from "../util/clazz.js";
import { ECEventProcessor as er } from "../util/ECEventProcessor.js";
import { seriesSymbolTask as tr, dataSymbolTask as rr } from "../visual/symbol.js";
import { getItemVisualFromData as ir, getVisualFromData as nr } from "../visual/helper.js";
import { handleLegacySelectEvents as ar } from "../legacy/dataSelectAction.js";
import { registerExternalTransform as sr } from "../data/helper/transform.js";
import { createLocaleObject as or, SYSTEM_LANG as ur } from "./locale.js";
import { registerLocale as Ii } from "./locale.js";
import { findEventDispatcher as q } from "../util/event.js";
import fr from "../visual/decal.js";
import I from "./lifecycle.js";
import { platformApi as dr } from "../../../zrender/lib/core/platform.js";
import { getImpl as lr } from "./impl.js";
import pr from "../../../zrender/lib/graphic/shape/Rect.js";
import hr from "../../../zrender/lib/graphic/Image.js";
import { isElementRemoved as ue } from "../animation/basicTransition.js";
import cr from "../../../zrender/lib/graphic/Path.js";
var vr = 1, _r = 800, gr = 900, mr = 1e3, Sr = 2e3, Tr = 5e3, tt = 1e3, Cr = 1100, Ce = 2e3, rt = 3e3, yr = 4e3, Q = 4500, Rr = 4600, Er = 5e3, Ar = 6e3, it = 7e3, Ti = {
  PROCESSOR: {
    FILTER: mr,
    SERIES_FILTER: _r,
    STATISTIC: Tr
  },
  VISUAL: {
    LAYOUT: tt,
    PROGRESSIVE_LAYOUT: Cr,
    GLOBAL: Ce,
    CHART: rt,
    POST_CHART_LAYOUT: Rr,
    COMPONENT: yr,
    BRUSH: Er,
    CHART_ITEM: Q,
    ARIA: Ar,
    DECAL: it
  }
}, A = "__flagInMainProcess", P = "__pendingUpdate", fe = "__needsUpdateStatus", Ye = /^[a-zA-Z0-9_]+$/, de = "__connectUpdateStatus", Be = 0, Pr = 1, wr = 2;
function nt(c) {
  return function() {
    for (var u = [], r = 0; r < arguments.length; r++)
      u[r] = arguments[r];
    if (this.isDisposed()) {
      this.id;
      return;
    }
    return st(this, c, u);
  };
}
function at(c) {
  return function() {
    for (var u = [], r = 0; r < arguments.length; r++)
      u[r] = arguments[r];
    return st(this, c, u);
  };
}
function st(c, u, r) {
  return r[0] = r[0] && r[0].toLowerCase(), Te.prototype[u].apply(c, r);
}
var ot = (
  /** @class */
  function(c) {
    _e(u, c);
    function u() {
      return c !== null && c.apply(this, arguments) || this;
    }
    return u;
  }(Te)
), ut = ot.prototype;
ut.on = at("on");
ut.off = at("off");
var k, le, K, V, pe, he, ce, Y, B, He, Ge, ve, Ne, $, We, ft, M, Xe, dt = (
  /** @class */
  function(c) {
    _e(u, c);
    function u(r, s, p) {
      var o = c.call(this, new er()) || this;
      o._chartsViews = [], o._chartsMap = {}, o._componentsViews = [], o._componentsMap = {}, o._pendingActions = [], p = p || {}, yt(s) && (s = lt[s]), o._dom = r;
      var S = "canvas", C = "auto", g = !1;
      p.ssr && gt(function(i) {
        var t = Z(i), n = t.dataIndex;
        if (n != null) {
          var a = ee();
          return a.set("series_index", t.seriesIndex), a.set("data_index", n), t.ssrType && a.set("ssr_type", t.ssrType), a;
        }
      });
      var y = o._zr = Oe(r, {
        renderer: p.renderer || S,
        devicePixelRatio: p.devicePixelRatio,
        width: p.width,
        height: p.height,
        ssr: p.ssr,
        useDirtyRect: Me(p.useDirtyRect, g),
        useCoarsePointer: Me(p.useCoarsePointer, C),
        pointerSize: p.pointerSize
      });
      o._ssr = p.ssr, o._throttledZrFlush = Zt(Ie(y.flush, y), 17), s = Le(s), s && Je(s, !0), o._theme = s, o._locale = or(p.locale || ur), o._coordSysMgr = new je();
      var T = o._api = We(o);
      function e(i, t) {
        return i.__prio - t.__prio;
      }
      return te(J, e), te(ge, e), o._scheduler = new et(o, T, ge, J), o._messageCenter = new ot(), o._initEvents(), o.resize = Ie(o.resize, o), y.animation.on("frame", o._onframe, o), He(y, o), Ge(y, o), St(o), o;
    }
    return u.prototype._onframe = function() {
      if (!this._disposed) {
        Xe(this);
        var r = this._scheduler;
        if (this[P]) {
          var s = this[P].silent;
          this[A] = !0;
          try {
            k(this), V.update.call(this, null, this[P].updateParams);
          } catch (g) {
            throw this[A] = !1, this[P] = null, g;
          }
          this._zr.flush(), this[A] = !1, this[P] = null, Y.call(this, s), B.call(this, s);
        } else if (r.unfinished) {
          var p = vr, o = this._model, S = this._api;
          r.unfinished = !1;
          do {
            var C = +/* @__PURE__ */ new Date();
            r.performSeriesTasks(o), r.performDataProcessorTasks(o), he(this, o), r.performVisualTasks(o), $(this, this._model, S, "remain", {}), p -= +/* @__PURE__ */ new Date() - C;
          } while (p > 0 && r.unfinished);
          r.unfinished || this._zr.flush();
        }
      }
    }, u.prototype.getDom = function() {
      return this._dom;
    }, u.prototype.getId = function() {
      return this.id;
    }, u.prototype.getZr = function() {
      return this._zr;
    }, u.prototype.isSSR = function() {
      return this._ssr;
    }, u.prototype.setOption = function(r, s, p) {
      if (!this[A]) {
        if (this._disposed) {
          this.id;
          return;
        }
        var o, S, C;
        if (H(s) && (p = s.lazyUpdate, o = s.silent, S = s.replaceMerge, C = s.transition, s = s.notMerge), this[A] = !0, !this._model || s) {
          var g = new At(this._api), y = this._theme, T = this._model = new Rt();
          T.scheduler = this._scheduler, T.ssr = this._ssr, T.init(null, null, null, y, this._locale, g);
        }
        this._model.setOption(r, {
          replaceMerge: S
        }, me);
        var e = {
          seriesTransition: C,
          optionChanged: !0
        };
        if (p)
          this[P] = {
            silent: o,
            updateParams: e
          }, this[A] = !1, this.getZr().wakeUp();
        else {
          try {
            k(this), V.update.call(this, null, e);
          } catch (i) {
            throw this[P] = null, this[A] = !1, i;
          }
          this._ssr || this._zr.flush(), this[P] = null, this[A] = !1, Y.call(this, o), B.call(this, o);
        }
      }
    }, u.prototype.setTheme = function() {
    }, u.prototype.getModel = function() {
      return this._model;
    }, u.prototype.getOption = function() {
      return this._model && this._model.getOption();
    }, u.prototype.getWidth = function() {
      return this._zr.getWidth();
    }, u.prototype.getHeight = function() {
      return this._zr.getHeight();
    }, u.prototype.getDevicePixelRatio = function() {
      return this._zr.painter.dpr || b.hasGlobalWindow && window.devicePixelRatio || 1;
    }, u.prototype.getRenderedCanvas = function(r) {
      return this.renderToCanvas(r);
    }, u.prototype.renderToCanvas = function(r) {
      r = r || {};
      var s = this._zr.painter;
      return s.getRenderedCanvas({
        backgroundColor: r.backgroundColor || this._model.get("backgroundColor"),
        pixelRatio: r.pixelRatio || this.getDevicePixelRatio()
      });
    }, u.prototype.renderToSVGString = function(r) {
      r = r || {};
      var s = this._zr.painter;
      return s.renderToString({
        useViewBox: r.useViewBox
      });
    }, u.prototype.getSvgDataURL = function() {
      if (b.svgSupported) {
        var r = this._zr, s = r.storage.getDisplayList();
        return E(s, function(p) {
          p.stopAnimation(null, !0);
        }), r.painter.toDataURL();
      }
    }, u.prototype.getDataURL = function(r) {
      if (this._disposed) {
        this.id;
        return;
      }
      r = r || {};
      var s = r.excludeComponents, p = this._model, o = [], S = this;
      E(s, function(g) {
        p.eachComponent({
          mainType: g
        }, function(y) {
          var T = S._componentsMap[y.__viewId];
          T.group.ignore || (o.push(T), T.group.ignore = !0);
        });
      });
      var C = this._zr.painter.getType() === "svg" ? this.getSvgDataURL() : this.renderToCanvas(r).toDataURL("image/" + (r && r.type || "png"));
      return E(o, function(g) {
        g.group.ignore = !1;
      }), C;
    }, u.prototype.getConnectedDataURL = function(r) {
      if (this._disposed) {
        this.id;
        return;
      }
      var s = r.type === "svg", p = this.group, o = Math.min, S = Math.max, C = 1 / 0;
      if (Ze[p]) {
        var g = C, y = C, T = -C, e = -C, i = [], t = r && r.pixelRatio || this.getDevicePixelRatio();
        E(N, function(d, v) {
          if (d.group === p) {
            var m = s ? d.getZr().painter.getSvgDom().innerHTML : d.renderToCanvas(Le(r)), _ = d.getDom().getBoundingClientRect();
            g = o(_.left, g), y = o(_.top, y), T = S(_.right, T), e = S(_.bottom, e), i.push({
              dom: m,
              left: _.left,
              top: _.top
            });
          }
        }), g *= t, y *= t, T *= t, e *= t;
        var n = T - g, a = e - y, l = dr.createCanvas(), f = Oe(l, {
          renderer: s ? "svg" : "canvas"
        });
        if (f.resize({
          width: n,
          height: a
        }), s) {
          var h = "";
          return E(i, function(d) {
            var v = d.left - g, m = d.top - y;
            h += '<g transform="translate(' + v + "," + m + ')">' + d.dom + "</g>";
          }), f.painter.getSvgRoot().innerHTML = h, r.connectedBackgroundColor && f.painter.setBackgroundColor(r.connectedBackgroundColor), f.refreshImmediately(), f.painter.toDataURL();
        } else
          return r.connectedBackgroundColor && f.add(new pr({
            shape: {
              x: 0,
              y: 0,
              width: n,
              height: a
            },
            style: {
              fill: r.connectedBackgroundColor
            }
          })), E(i, function(d) {
            var v = new hr({
              style: {
                x: d.left * t - g,
                y: d.top * t - y,
                image: d.dom
              }
            });
            f.add(v);
          }), f.refreshImmediately(), l.toDataURL("image/" + (r && r.type || "png"));
      } else
        return this.getDataURL(r);
    }, u.prototype.convertToPixel = function(r, s) {
      return pe(this, "convertToPixel", r, s);
    }, u.prototype.convertFromPixel = function(r, s) {
      return pe(this, "convertFromPixel", r, s);
    }, u.prototype.containPixel = function(r, s) {
      if (this._disposed) {
        this.id;
        return;
      }
      var p = this._model, o, S = oe(p, r);
      return E(S, function(C, g) {
        g.indexOf("Models") >= 0 && E(C, function(y) {
          var T = y.coordinateSystem;
          if (T && T.containPoint)
            o = o || !!T.containPoint(s);
          else if (g === "seriesModels") {
            var e = this._chartsMap[y.__viewId];
            e && e.containPoint && (o = o || e.containPoint(s, y));
          }
        }, this);
      }, this), !!o;
    }, u.prototype.getVisual = function(r, s) {
      var p = this._model, o = oe(p, r, {
        defaultMainType: "series"
      }), S = o.seriesModel, C = S.getData(), g = o.hasOwnProperty("dataIndexInside") ? o.dataIndexInside : o.hasOwnProperty("dataIndex") ? C.indexOfRawIndex(o.dataIndex) : null;
      return g != null ? ir(C, g, s) : nr(C, s);
    }, u.prototype.getViewOfComponentModel = function(r) {
      return this._componentsMap[r.__viewId];
    }, u.prototype.getViewOfSeriesModel = function(r) {
      return this._chartsMap[r.__viewId];
    }, u.prototype._initEvents = function() {
      var r = this;
      E(Or, function(s) {
        var p = function(o) {
          var S = r.getModel(), C = o.target, g, y = s === "globalout";
          if (y ? g = {} : C && q(C, function(n) {
            var a = Z(n);
            if (a && a.dataIndex != null) {
              var l = a.dataModel || S.getSeriesByIndex(a.seriesIndex);
              return g = l && l.getDataParams(a.dataIndex, a.dataType, C) || {}, !0;
            } else if (a.eventData)
              return g = U({}, a.eventData), !0;
          }, !0), g) {
            var T = g.componentType, e = g.componentIndex;
            (T === "markLine" || T === "markPoint" || T === "markArea") && (T = "series", e = g.seriesIndex);
            var i = T && e != null && S.getComponent(T, e), t = i && r[i.mainType === "series" ? "_chartsMap" : "_componentsMap"][i.__viewId];
            g.event = o, g.type = s, r._$eventProcessor.eventInfo = {
              targetEl: C,
              packedEvent: g,
              model: i,
              view: t
            }, r.trigger(s, g);
          }
        };
        p.zrEventfulCallAtLast = !0, r._zr.on(s, p, r);
      }), E(G, function(s, p) {
        r._messageCenter.on(p, function(o) {
          this.trigger(p, o);
        }, r);
      }), E(["selectchanged"], function(s) {
        r._messageCenter.on(s, function(p) {
          this.trigger(s, p);
        }, r);
      }), ar(this._messageCenter, this, this._api);
    }, u.prototype.isDisposed = function() {
      return this._disposed;
    }, u.prototype.clear = function() {
      if (this._disposed) {
        this.id;
        return;
      }
      this.setOption({
        series: []
      }, !0);
    }, u.prototype.dispose = function() {
      if (this._disposed) {
        this.id;
        return;
      }
      this._disposed = !0;
      var r = this.getDom();
      r && Qe(this.getDom(), Re, "");
      var s = this, p = s._api, o = s._model;
      E(s._componentsViews, function(S) {
        S.dispose(o, p);
      }), E(s._chartsViews, function(S) {
        S.dispose(o, p);
      }), s._zr.dispose(), s._dom = s._model = s._chartsMap = s._componentsMap = s._chartsViews = s._componentsViews = s._scheduler = s._api = s._zr = s._throttledZrFlush = s._theme = s._coordSysMgr = s._messageCenter = null, delete N[s.id];
    }, u.prototype.resize = function(r) {
      if (!this[A]) {
        if (this._disposed) {
          this.id;
          return;
        }
        this._zr.resize(r);
        var s = this._model;
        if (this._loadingFX && this._loadingFX.resize(), !!s) {
          var p = s.resetOption("media"), o = r && r.silent;
          this[P] && (o == null && (o = this[P].silent), p = !0, this[P] = null), this[A] = !0;
          try {
            p && k(this), V.update.call(this, {
              type: "resize",
              animation: U({
                // Disable animation
                duration: 0
              }, r && r.animation)
            });
          } catch (S) {
            throw this[A] = !1, S;
          }
          this[A] = !1, Y.call(this, o), B.call(this, o);
        }
      }
    }, u.prototype.showLoading = function(r, s) {
      if (this._disposed) {
        this.id;
        return;
      }
      if (H(r) && (s = r, r = ""), r = r || "default", this.hideLoading(), !!Se[r]) {
        var p = Se[r](this._api, s), o = this._zr;
        this._loadingFX = p, o.add(p);
      }
    }, u.prototype.hideLoading = function() {
      if (this._disposed) {
        this.id;
        return;
      }
      this._loadingFX && this._zr.remove(this._loadingFX), this._loadingFX = null;
    }, u.prototype.makeActionFromEvent = function(r) {
      var s = U({}, r);
      return s.type = G[r.type], s;
    }, u.prototype.dispatchAction = function(r, s) {
      if (this._disposed) {
        this.id;
        return;
      }
      if (H(s) || (s = {
        silent: !!s
      }), !!j[r.type] && this._model) {
        if (this[A]) {
          this._pendingActions.push(r);
          return;
        }
        var p = s.silent;
        ce.call(this, r, p);
        var o = s.flush;
        o ? this._zr.flush() : o !== !1 && b.browser.weChat && this._throttledZrFlush(), Y.call(this, p), B.call(this, p);
      }
    }, u.prototype.updateLabelLayout = function() {
      I.trigger("series:layoutlabels", this._model, this._api, {
        // Not adding series labels.
        // TODO
        updatedSeries: []
      });
    }, u.prototype.appendData = function(r) {
      if (this._disposed) {
        this.id;
        return;
      }
      var s = r.seriesIndex, p = this.getModel(), o = p.getSeriesByIndex(s);
      o.appendData(r), this._scheduler.unfinished = !0, this.getZr().wakeUp();
    }, u.internalField = function() {
      k = function(e) {
        var i = e._scheduler;
        i.restorePipelines(e._model), i.prepareStageTasks(), le(e, !0), le(e, !1), i.plan();
      }, le = function(e, i) {
        for (var t = e._model, n = e._scheduler, a = i ? e._componentsViews : e._chartsViews, l = i ? e._componentsMap : e._chartsMap, f = e._zr, h = e._api, d = 0; d < a.length; d++)
          a[d].__alive = !1;
        i ? t.eachComponent(function(_, w) {
          _ !== "series" && v(w);
        }) : t.eachSeries(v);
        function v(_) {
          var w = _.__requireNewView;
          _.__requireNewView = !1;
          var L = "_ec_" + _.id + "_" + _.type, R = !w && l[L];
          if (!R) {
            var x = be(_.type), D = i ? wt.getClass(x.main, x.sub) : (
              // FIXME:TS
              // (ChartView as ChartViewConstructor).getClass('series', classType.sub)
              // For backward compat, still support a chart type declared as only subType
              // like "liquidfill", but recommend "series.liquidfill"
              // But need a base class to make a type series.
              re.getClass(x.sub)
            );
            R = new D(), R.init(t, h), l[L] = R, a.push(R), f.add(R.group);
          }
          _.__viewId = R.__id = L, R.__alive = !0, R.__model = _, R.group.__ecComponentInfo = {
            mainType: _.mainType,
            index: _.componentIndex
          }, !i && n.prepareView(R, _, t, h);
        }
        for (var d = 0; d < a.length; ) {
          var m = a[d];
          m.__alive ? d++ : (!i && m.renderTask.dispose(), f.remove(m.group), m.dispose(t, h), a.splice(d, 1), l[m.__id] === m && delete l[m.__id], m.__id = m.group.__ecComponentInfo = null);
        }
      }, K = function(e, i, t, n, a) {
        var l = e._model;
        if (l.setUpdatePayload(t), !n) {
          E([].concat(e._componentsViews).concat(e._chartsViews), m);
          return;
        }
        var f = {};
        f[n + "Id"] = t[n + "Id"], f[n + "Index"] = t[n + "Index"], f[n + "Name"] = t[n + "Name"];
        var h = {
          mainType: n,
          query: f
        };
        a && (h.subType = a);
        var d = t.excludeSeriesId, v;
        d != null && (v = ee(), E(Wt(d), function(_) {
          var w = Nt(_, null);
          w != null && v.set(w, !0);
        })), l && l.eachComponent(h, function(_) {
          var w = v && v.get(_.id) != null;
          if (!w)
            if (Ve(t))
              if (_ instanceof xe)
                t.type === z && !t.notBlur && !_.get(["emphasis", "disabled"]) && zt(_, t, e._api);
              else {
                var L = Ft(_.mainType, _.componentIndex, t.name, e._api), R = L.focusSelf, x = L.dispatchers;
                t.type === z && R && !t.notBlur && bt(_.mainType, _.componentIndex, e._api), x && E(x, function(D) {
                  t.type === z ? ke(D) : ze(D);
                });
              }
            else
              De(t) && _ instanceof xe && (Yt(_, t, e._api), Ue(_), M(e));
        }, e), l && l.eachComponent(h, function(_) {
          var w = v && v.get(_.id) != null;
          w || m(e[n === "series" ? "_chartsMap" : "_componentsMap"][_.__viewId]);
        }, e);
        function m(_) {
          _ && _.__alive && _[i] && _[i](_.__model, l, e._api, t);
        }
      }, V = {
        prepareAndUpdate: function(e) {
          k(this), V.update.call(this, e, {
            // Needs to mark option changed if newOption is given.
            // It's from MagicType.
            // TODO If use a separate flag optionChanged in payload?
            optionChanged: e.newOption != null
          });
        },
        update: function(e, i) {
          var t = this._model, n = this._api, a = this._zr, l = this._coordSysMgr, f = this._scheduler;
          if (t) {
            t.setUpdatePayload(e), f.restoreData(t, e), f.performSeriesTasks(t), l.create(t, n), f.performDataProcessorTasks(t, e), he(this, t), l.update(t, n), r(t), f.performVisualTasks(t, e), ve(this, t, n, e, i);
            var h = t.get("backgroundColor") || "transparent", d = t.get("darkMode");
            a.setBackgroundColor(h), d != null && d !== "auto" && a.setDarkMode(d), I.trigger("afterupdate", t, n);
          }
        },
        updateTransform: function(e) {
          var i = this, t = this._model, n = this._api;
          if (t) {
            t.setUpdatePayload(e);
            var a = [];
            t.eachComponent(function(f, h) {
              if (f !== "series") {
                var d = i.getViewOfComponentModel(h);
                if (d && d.__alive)
                  if (d.updateTransform) {
                    var v = d.updateTransform(h, t, n, e);
                    v && v.update && a.push(d);
                  } else
                    a.push(d);
              }
            });
            var l = ee();
            t.eachSeries(function(f) {
              var h = i._chartsMap[f.__viewId];
              if (h.updateTransform) {
                var d = h.updateTransform(f, t, n, e);
                d && d.update && l.set(f.uid, 1);
              } else
                l.set(f.uid, 1);
            }), r(t), this._scheduler.performVisualTasks(t, e, {
              setDirty: !0,
              dirtyMap: l
            }), $(this, t, n, e, {}, l), I.trigger("afterupdate", t, n);
          }
        },
        updateView: function(e) {
          var i = this._model;
          i && (i.setUpdatePayload(e), re.markUpdateMethod(e, "updateView"), r(i), this._scheduler.performVisualTasks(i, e, {
            setDirty: !0
          }), ve(this, i, this._api, e, {}), I.trigger("afterupdate", i, this._api));
        },
        updateVisual: function(e) {
          var i = this, t = this._model;
          t && (t.setUpdatePayload(e), t.eachSeries(function(n) {
            n.getData().clearAllVisual();
          }), re.markUpdateMethod(e, "updateVisual"), r(t), this._scheduler.performVisualTasks(t, e, {
            visualType: "visual",
            setDirty: !0
          }), t.eachComponent(function(n, a) {
            if (n !== "series") {
              var l = i.getViewOfComponentModel(a);
              l && l.__alive && l.updateVisual(a, t, i._api, e);
            }
          }), t.eachSeries(function(n) {
            var a = i._chartsMap[n.__viewId];
            a.updateVisual(n, t, i._api, e);
          }), I.trigger("afterupdate", t, this._api));
        },
        updateLayout: function(e) {
          V.update.call(this, e);
        }
      }, pe = function(e, i, t, n) {
        if (e._disposed) {
          e.id;
          return;
        }
        for (var a = e._model, l = e._coordSysMgr.getCoordinateSystems(), f, h = oe(a, t), d = 0; d < l.length; d++) {
          var v = l[d];
          if (v[i] && (f = v[i](a, h, n)) != null)
            return f;
        }
      }, he = function(e, i) {
        var t = e._chartsMap, n = e._scheduler;
        i.eachSeries(function(a) {
          n.updateStreamModes(a, t[a.__viewId]);
        });
      }, ce = function(e, i) {
        var t = this, n = this.getModel(), a = e.type, l = e.escapeConnect, f = j[a], h = f.actionInfo, d = (h.update || "update").split(":"), v = d.pop(), m = d[0] != null && be(d[0]);
        this[A] = !0;
        var _ = [e], w = !1;
        e.batch && (w = !0, _ = Tt(e.batch, function(O) {
          return O = Ct(U({}, O), e), O.batch = null, O;
        }));
        var L = [], R, x = De(e), D = Ve(e);
        if (D && Ot(this._api), E(_, function(O) {
          if (R = f.action(O, t._model, t._api), R = R || U({}, O), R.type = h.event || R.type, L.push(R), D) {
            var we = Gt(e), ct = we.queryOptionMap, vt = we.mainTypeSpecified, _t = vt ? ct.keys()[0] : "series";
            K(t, v, O, _t), M(t);
          } else
            x ? (K(t, v, O, "series"), M(t)) : m && K(t, v, O, m.main, m.sub);
        }), v !== "none" && !D && !x && !m)
          try {
            this[P] ? (k(this), V.update.call(this, e), this[P] = null) : V[v].call(this, e);
          } catch (O) {
            throw this[A] = !1, O;
          }
        if (w ? R = {
          type: h.event || a,
          escapeConnect: l,
          batch: L
        } : R = L[0], this[A] = !1, !i) {
          var Ae = this._messageCenter;
          if (Ae.trigger(R.type, R), x) {
            var Pe = {
              type: "selectchanged",
              escapeConnect: l,
              selected: Mt(n),
              isFromClick: e.isFromClick || !1,
              fromAction: e.type,
              fromActionPayload: e
            };
            Ae.trigger(Pe.type, Pe);
          }
        }
      }, Y = function(e) {
        for (var i = this._pendingActions; i.length; ) {
          var t = i.shift();
          ce.call(this, t, e);
        }
      }, B = function(e) {
        !e && this.trigger("updated");
      }, He = function(e, i) {
        e.on("rendered", function(t) {
          i.trigger("rendered", t), // Although zr is dirty if initial animation is not finished
          // and this checking is called on frame, we also check
          // animation finished for robustness.
          e.animation.isFinished() && !i[P] && !i._scheduler.unfinished && !i._pendingActions.length && i.trigger("finished");
        });
      }, Ge = function(e, i) {
        e.on("mouseover", function(t) {
          var n = t.target, a = q(n, Fe);
          a && (Bt(a, t, i._api), M(i));
        }).on("mouseout", function(t) {
          var n = t.target, a = q(n, Fe);
          a && (Ht(a, t, i._api), M(i));
        }).on("click", function(t) {
          var n = t.target, a = q(n, function(h) {
            return Z(h).dataIndex != null;
          }, !0);
          if (a) {
            var l = a.selected ? "unselect" : "select", f = Z(a);
            i._api.dispatchAction({
              type: l,
              dataType: f.dataType,
              dataIndexInside: f.dataIndex,
              seriesIndex: f.seriesIndex,
              isFromClick: !0
            });
          }
        });
      };
      function r(e) {
        e.clearColorPalette(), e.eachSeries(function(i) {
          i.clearColorPalette();
        });
      }
      function s(e) {
        var i = [], t = [], n = !1;
        if (e.eachComponent(function(h, d) {
          var v = d.get("zlevel") || 0, m = d.get("z") || 0, _ = d.getZLevelKey();
          n = n || !!_, (h === "series" ? t : i).push({
            zlevel: v,
            z: m,
            idx: d.componentIndex,
            type: h,
            key: _
          });
        }), n) {
          var a = i.concat(t), l, f;
          te(a, function(h, d) {
            return h.zlevel === d.zlevel ? h.z - d.z : h.zlevel - d.zlevel;
          }), E(a, function(h) {
            var d = e.getComponent(h.type, h.idx), v = h.zlevel, m = h.key;
            l != null && (v = Math.max(l, v)), m ? (v === l && m !== f && v++, f = m) : f && (v === l && v++, f = ""), l = v, d.setZLevel(v);
          });
        }
      }
      ve = function(e, i, t, n, a) {
        s(i), Ne(e, i, t, n, a), E(e._chartsViews, function(l) {
          l.__alive = !1;
        }), $(e, i, t, n, a), E(e._chartsViews, function(l) {
          l.__alive || l.remove(i, t);
        });
      }, Ne = function(e, i, t, n, a, l) {
        E(l || e._componentsViews, function(f) {
          var h = f.__model;
          y(h, f), f.render(h, i, t, n), C(h, f), T(h, f);
        });
      }, $ = function(e, i, t, n, a, l) {
        var f = e._scheduler;
        a = U(a || {}, {
          updatedSeries: i.getSeries()
        }), I.trigger("series:beforeupdate", i, t, a);
        var h = !1;
        i.eachSeries(function(d) {
          var v = e._chartsMap[d.__viewId];
          v.__alive = !0;
          var m = v.renderTask;
          f.updatePayload(m, n), y(d, v), l && l.get(d.uid) && m.dirty(), m.perform(f.getPerformArgs(m)) && (h = !0), v.group.silent = !!d.get("silent"), S(d, v), Ue(d);
        }), f.unfinished = h || f.unfinished, I.trigger("series:layoutlabels", i, t, a), I.trigger("series:transition", i, t, a), i.eachSeries(function(d) {
          var v = e._chartsMap[d.__viewId];
          C(d, v), T(d, v);
        }), o(e, i), I.trigger("series:afterupdate", i, t, a);
      }, M = function(e) {
        e[fe] = !0, e.getZr().wakeUp();
      }, Xe = function(e) {
        e[fe] && (e.getZr().storage.traverse(function(i) {
          ue(i) || p(i);
        }), e[fe] = !1);
      };
      function p(e) {
        for (var i = [], t = e.currentStates, n = 0; n < t.length; n++) {
          var a = t[n];
          a === "emphasis" || a === "blur" || a === "select" || i.push(a);
        }
        e.selected && e.states.select && i.push("select"), e.hoverState === It && e.states.emphasis ? i.push("emphasis") : e.hoverState === Lt && e.states.blur && i.push("blur"), e.useStates(i);
      }
      function o(e, i) {
        var t = e._zr, n = t.storage, a = 0;
        n.traverse(function(l) {
          l.isGroup || a++;
        }), a > i.get("hoverLayerThreshold") && !b.node && !b.worker && i.eachSeries(function(l) {
          if (!l.preventUsingHoverLayer) {
            var f = e._chartsMap[l.__viewId];
            f.__alive && f.eachRendered(function(h) {
              h.states.emphasis && (h.states.emphasis.hoverLayer = !0);
            });
          }
        });
      }
      function S(e, i) {
        var t = e.get("blendMode") || null;
        i.eachRendered(function(n) {
          n.isGroup || (n.style.blend = t);
        });
      }
      function C(e, i) {
        if (!e.preventAutoZ) {
          var t = e.get("z") || 0, n = e.get("zlevel") || 0;
          i.eachRendered(function(a) {
            return g(a, t, n, -1 / 0), !0;
          });
        }
      }
      function g(e, i, t, n) {
        var a = e.getTextContent(), l = e.getTextGuideLine(), f = e.isGroup;
        if (f)
          for (var h = e.childrenRef(), d = 0; d < h.length; d++)
            n = Math.max(g(h[d], i, t, n), n);
        else
          e.z = i, e.zlevel = t, n = Math.max(e.z2, n);
        if (a && (a.z = i, a.zlevel = t, isFinite(n) && (a.z2 = n + 2)), l) {
          var v = e.textGuideLineConfig;
          l.z = i, l.zlevel = t, isFinite(n) && (l.z2 = n + (v && v.showAbove ? 1 : -1));
        }
        return n;
      }
      function y(e, i) {
        i.eachRendered(function(t) {
          if (!ue(t)) {
            var n = t.getTextContent(), a = t.getTextGuideLine();
            t.stateTransition && (t.stateTransition = null), n && n.stateTransition && (n.stateTransition = null), a && a.stateTransition && (a.stateTransition = null), t.hasState() ? (t.prevStates = t.currentStates, t.clearStates()) : t.prevStates && (t.prevStates = null);
          }
        });
      }
      function T(e, i) {
        var t = e.getModel("stateAnimation"), n = e.isAnimationEnabled(), a = t.get("duration"), l = a > 0 ? {
          duration: a,
          delay: t.get("delay"),
          easing: t.get("easing")
          // additive: stateAnimationModel.get('additive')
        } : null;
        i.eachRendered(function(f) {
          if (f.states && f.states.emphasis) {
            if (ue(f))
              return;
            if (f instanceof cr && xt(f), f.__dirty) {
              var h = f.prevStates;
              h && f.useStates(h);
            }
            if (n) {
              f.stateTransition = l;
              var d = f.getTextContent(), v = f.getTextGuideLine();
              d && (d.stateTransition = l), v && (v.stateTransition = l);
            }
            f.__dirty && p(f);
          }
        });
      }
      We = function(e) {
        return new /** @class */
        (function(i) {
          _e(t, i);
          function t() {
            return i !== null && i.apply(this, arguments) || this;
          }
          return t.prototype.getCoordinateSystems = function() {
            return e._coordSysMgr.getCoordinateSystems();
          }, t.prototype.getComponentByElement = function(n) {
            for (; n; ) {
              var a = n.__ecComponentInfo;
              if (a != null)
                return e._model.getComponent(a.mainType, a.index);
              n = n.parent;
            }
          }, t.prototype.enterEmphasis = function(n, a) {
            ke(n, a), M(e);
          }, t.prototype.leaveEmphasis = function(n, a) {
            ze(n, a), M(e);
          }, t.prototype.enterBlur = function(n) {
            Dt(n), M(e);
          }, t.prototype.leaveBlur = function(n) {
            Vt(n), M(e);
          }, t.prototype.enterSelect = function(n) {
            Ut(n), M(e);
          }, t.prototype.leaveSelect = function(n) {
            kt(n), M(e);
          }, t.prototype.getModel = function() {
            return e.getModel();
          }, t.prototype.getViewOfComponentModel = function(n) {
            return e.getViewOfComponentModel(n);
          }, t.prototype.getViewOfSeriesModel = function(n) {
            return e.getViewOfSeriesModel(n);
          }, t;
        }(Et))(e);
      }, ft = function(e) {
        function i(t, n) {
          for (var a = 0; a < t.length; a++) {
            var l = t[a];
            l[de] = n;
          }
        }
        E(G, function(t, n) {
          e._messageCenter.on(n, function(a) {
            if (Ze[e.group] && e[de] !== Be) {
              if (a && a.escapeConnect)
                return;
              var l = e.makeActionFromEvent(a), f = [];
              E(N, function(h) {
                h !== e && h.group === e.group && f.push(h);
              }), i(f, Be), E(f, function(h) {
                h[de] !== Pr && h.dispatchAction(l);
              }), i(f, wr);
            }
          });
        });
      };
    }(), u;
  }(Te)
), ye = dt.prototype;
ye.on = nt("on");
ye.off = nt("off");
ye.one = function(c, u, r) {
  var s = this;
  function p() {
    for (var o = [], S = 0; S < arguments.length; S++)
      o[S] = arguments[S];
    u && u.apply && u.apply(this, o), s.off(c, p);
  }
  this.on.call(this, c, p, r);
};
var Or = ["click", "dblclick", "mouseover", "mouseout", "mousemove", "mousedown", "mouseup", "globalout", "contextmenu"];
var j = {}, G = {}, ge = [], me = [], J = [], lt = {}, Se = {}, N = {}, Ze = {}, Mr = +/* @__PURE__ */ new Date() - 0, Re = "_echarts_instance_";
function Ci(c, u, r) {
  var s = !(r && r.ssr);
  if (s) {
    var p = Ir(c);
    if (p)
      return p;
  }
  var o = new dt(c, u, r);
  return o.id = "ec_" + Mr++, N[o.id] = o, s && Qe(c, Re, o.id), ft(o), I.trigger("afterinit", o), o;
}
function Ir(c) {
  return N[Xt(c, Re)];
}
function pt(c, u) {
  lt[c] = u;
}
function Lr(c) {
  Ke(me, c) < 0 && me.push(c);
}
function xr(c, u) {
  Ee(ge, c, u, Sr);
}
function yi(c) {
  ht("afterinit", c);
}
function Ri(c) {
  ht("afterupdate", c);
}
function ht(c, u) {
  I.on(c, u);
}
function X(c, u, r) {
  $e(u) && (r = u, u = "");
  var s = H(c) ? c.type : [c, c = {
    event: u
  }][0];
  c.event = (c.event || s).toLowerCase(), u = c.event, !G[u] && (mt(Ye.test(s) && Ye.test(u)), j[s] || (j[s] = {
    action: r,
    actionInfo: c
  }), G[u] = s);
}
function Ei(c, u) {
  je.register(c, u);
}
function Ai(c, u) {
  Ee(J, c, u, tt, "layout");
}
function F(c, u) {
  Ee(J, c, u, rt, "visual");
}
var qe = [];
function Ee(c, u, r, s, p) {
  if (($e(u) || H(u)) && (r = u, u = s), !(Ke(qe, r) >= 0)) {
    qe.push(r);
    var o = et.wrapStageHandler(r, p);
    o.__prio = u, o.__raw = r, c.push(o);
  }
}
function Dr(c, u) {
  Se[c] = u;
}
function Pi(c, u, r) {
  var s = lr("registerMap");
  s && s(c, u, r);
}
var wi = sr;
F(Ce, qt);
F(Q, Kt);
F(Q, $t);
F(Ce, tr);
F(Q, rr);
F(it, fr);
Lr(Je);
xr(gr, Pt);
Dr("default", jt);
X({
  type: z,
  event: z,
  update: z
}, W);
X({
  type: ie,
  event: ie,
  update: ie
}, W);
X({
  type: ne,
  event: ne,
  update: ne
}, W);
X({
  type: ae,
  event: ae,
  update: ae
}, W);
X({
  type: se,
  event: se,
  update: se
}, W);
pt("light", Jt);
pt("dark", Qt);
export {
  Ti as PRIORITY,
  Ir as getInstanceByDom,
  Ci as init,
  X as registerAction,
  Ei as registerCoordinateSystem,
  Ai as registerLayout,
  Dr as registerLoading,
  Ii as registerLocale,
  Pi as registerMap,
  yi as registerPostInit,
  Ri as registerPostUpdate,
  Lr as registerPreprocessor,
  xr as registerProcessor,
  pt as registerTheme,
  wi as registerTransform,
  ht as registerUpdateLifecycle,
  F as registerVisual
};
