import { isString as T, createHashMap as P, each as d, isNumber as G, isArrayLike as H, extend as c, isArray as O, bind as y, keys as z, isFunction as S, slice as B, clone as U, isObject as $, map as j } from "../../../zrender/lib/core/util.js";
import X from "../model/Model.js";
import Y from "./DataDiffer.js";
import { DefaultDataProvider as q } from "./helper/dataProvider.js";
import { summarizeDimensions as W } from "./helper/dimensionHelper.js";
import M from "./SeriesDimensionDefine.js";
import { SOURCE_FORMAT_TYPED_ARRAY as J, SOURCE_FORMAT_ORIGINAL as K } from "../util/types.js";
import { isDataItemOption as Q, convertOptionIdName as w } from "../util/model.js";
import { setCommonECData as Z } from "../util/innerStore.js";
import { isSourceInstance as b } from "./Source.js";
import A from "./DataStore.js";
import { isSeriesDataSchema as k } from "./helper/SeriesDataSchema.js";
var v = $, _ = j, tt = typeof Int32Array > "u" ? Array : Int32Array, et = "e\0\0", N = -1, it = ["hasItemOption", "_nameList", "_idList", "_invertedIndicesMap", "_dimSummary", "userOutput", "_rawData", "_dimValueGetter", "_nameDimIdx", "_idDimIdx", "_nameRepeatCount"], rt = ["_approximateExtent"], C, x, I, D, E, g, L, nt = (
  /** @class */
  function() {
    function n(t, e) {
      this.type = "list", this._dimOmitted = !1, this._nameList = [], this._idList = [], this._visual = {}, this._layout = {}, this._itemVisuals = [], this._itemLayouts = [], this._graphicEls = [], this._approximateExtent = {}, this._calculationInfo = {}, this.hasItemOption = !1, this.TRANSFERABLE_METHODS = ["cloneShallow", "downSample", "minmaxDownSample", "lttbDownSample", "map"], this.CHANGABLE_METHODS = ["filterSelf", "selectRange"], this.DOWNSAMPLE_METHODS = ["downSample", "minmaxDownSample", "lttbDownSample"];
      var i, r = !1;
      k(t) ? (i = t.dimensions, this._dimOmitted = t.isDimensionOmitted(), this._schema = t) : (r = !0, i = t), i = i || ["x", "y"];
      for (var o = {}, u = [], s = {}, a = !1, l = {}, h = 0; h < i.length; h++) {
        var m = i[h], p = T(m) ? new M({
          name: m
        }) : m instanceof M ? m : new M(m), f = p.name;
        p.type = p.type || "float", p.coordDim || (p.coordDim = f, p.coordDimIndex = 0);
        var R = p.otherDims = p.otherDims || {};
        u.push(f), o[f] = p, l[f] != null && (a = !0), p.createInvertedIndices && (s[f] = []), R.itemName === 0 && (this._nameDimIdx = h), R.itemId === 0 && (this._idDimIdx = h), r && (p.storeDimIndex = h);
      }
      if (this.dimensions = u, this._dimInfos = o, this._initGetDimensionInfo(a), this.hostModel = e, this._invertedIndicesMap = s, this._dimOmitted) {
        var F = this._dimIdxToName = P();
        d(u, function(V) {
          F.set(o[V].storeDimIndex, V);
        });
      }
    }
    return n.prototype.getDimension = function(t) {
      var e = this._recognizeDimIndex(t);
      if (e == null)
        return t;
      if (e = t, !this._dimOmitted)
        return this.dimensions[e];
      var i = this._dimIdxToName.get(e);
      if (i != null)
        return i;
      var r = this._schema.getSourceDimension(e);
      if (r)
        return r.name;
    }, n.prototype.getDimensionIndex = function(t) {
      var e = this._recognizeDimIndex(t);
      if (e != null)
        return e;
      if (t == null)
        return -1;
      var i = this._getDimInfo(t);
      return i ? i.storeDimIndex : this._dimOmitted ? this._schema.getSourceDimensionIndex(t) : -1;
    }, n.prototype._recognizeDimIndex = function(t) {
      if (G(t) || t != null && !isNaN(t) && !this._getDimInfo(t) && (!this._dimOmitted || this._schema.getSourceDimensionIndex(t) < 0))
        return +t;
    }, n.prototype._getStoreDimIndex = function(t) {
      var e = this.getDimensionIndex(t);
      return e;
    }, n.prototype.getDimensionInfo = function(t) {
      return this._getDimInfo(this.getDimension(t));
    }, n.prototype._initGetDimensionInfo = function(t) {
      var e = this._dimInfos;
      this._getDimInfo = t ? function(i) {
        return e.hasOwnProperty(i) ? e[i] : void 0;
      } : function(i) {
        return e[i];
      };
    }, n.prototype.getDimensionsOnCoord = function() {
      return this._dimSummary.dataDimsOnCoord.slice();
    }, n.prototype.mapDimension = function(t, e) {
      var i = this._dimSummary;
      if (e == null)
        return i.encodeFirstDimNotExtra[t];
      var r = i.encode[t];
      return r ? r[e] : null;
    }, n.prototype.mapDimensionsAll = function(t) {
      var e = this._dimSummary, i = e.encode[t];
      return (i || []).slice();
    }, n.prototype.getStore = function() {
      return this._store;
    }, n.prototype.initData = function(t, e, i) {
      var r = this, o;
      if (t instanceof A && (o = t), !o) {
        var u = this.dimensions, s = b(t) || H(t) ? new q(t, u.length) : t;
        o = new A();
        var a = _(u, function(l) {
          return {
            type: r._dimInfos[l].type,
            property: l
          };
        });
        o.initData(s, a, i);
      }
      this._store = o, this._nameList = (e || []).slice(), this._idList = [], this._nameRepeatCount = {}, this._doInit(0, o.count()), this._dimSummary = W(this, this._schema), this.userOutput = this._dimSummary.userOutput;
    }, n.prototype.appendData = function(t) {
      var e = this._store.appendData(t);
      this._doInit(e[0], e[1]);
    }, n.prototype.appendValues = function(t, e) {
      var i = this._store.appendValues(t, e && e.length), r = i.start, o = i.end, u = this._shouldMakeIdFromName();
      if (this._updateOrdinalMeta(), e)
        for (var s = r; s < o; s++) {
          var a = s - r;
          this._nameList[s] = e[a], u && L(this, s);
        }
    }, n.prototype._updateOrdinalMeta = function() {
      for (var t = this._store, e = this.dimensions, i = 0; i < e.length; i++) {
        var r = this._dimInfos[e[i]];
        r.ordinalMeta && t.collectOrdinalMeta(r.storeDimIndex, r.ordinalMeta);
      }
    }, n.prototype._shouldMakeIdFromName = function() {
      var t = this._store.getProvider();
      return this._idDimIdx == null && t.getSource().sourceFormat !== J && !t.fillStorage;
    }, n.prototype._doInit = function(t, e) {
      if (!(t >= e)) {
        var i = this._store, r = i.getProvider();
        this._updateOrdinalMeta();
        var o = this._nameList, u = this._idList, s = r.getSource().sourceFormat, a = s === K;
        if (a && !r.pure)
          for (var l = [], h = t; h < e; h++) {
            var m = r.getItem(h, l);
            if (!this.hasItemOption && Q(m) && (this.hasItemOption = !0), m) {
              var p = m.name;
              o[h] == null && p != null && (o[h] = w(p, null));
              var f = m.id;
              u[h] == null && f != null && (u[h] = w(f, null));
            }
          }
        if (this._shouldMakeIdFromName())
          for (var h = t; h < e; h++)
            L(this, h);
        C(this);
      }
    }, n.prototype.getApproximateExtent = function(t) {
      return this._approximateExtent[t] || this._store.getDataExtent(this._getStoreDimIndex(t));
    }, n.prototype.setApproximateExtent = function(t, e) {
      e = this.getDimension(e), this._approximateExtent[e] = t.slice();
    }, n.prototype.getCalculationInfo = function(t) {
      return this._calculationInfo[t];
    }, n.prototype.setCalculationInfo = function(t, e) {
      v(t) ? c(this._calculationInfo, t) : this._calculationInfo[t] = e;
    }, n.prototype.getName = function(t) {
      var e = this.getRawIndex(t), i = this._nameList[e];
      return i == null && this._nameDimIdx != null && (i = I(this, this._nameDimIdx, e)), i == null && (i = ""), i;
    }, n.prototype._getCategory = function(t, e) {
      var i = this._store.get(t, e), r = this._store.getOrdinalMeta(t);
      return r ? r.categories[i] : i;
    }, n.prototype.getId = function(t) {
      return x(this, this.getRawIndex(t));
    }, n.prototype.count = function() {
      return this._store.count();
    }, n.prototype.get = function(t, e) {
      var i = this._store, r = this._dimInfos[t];
      if (r)
        return i.get(r.storeDimIndex, e);
    }, n.prototype.getByRawIndex = function(t, e) {
      var i = this._store, r = this._dimInfos[t];
      if (r)
        return i.getByRawIndex(r.storeDimIndex, e);
    }, n.prototype.getIndices = function() {
      return this._store.getIndices();
    }, n.prototype.getDataExtent = function(t) {
      return this._store.getDataExtent(this._getStoreDimIndex(t));
    }, n.prototype.getSum = function(t) {
      return this._store.getSum(this._getStoreDimIndex(t));
    }, n.prototype.getMedian = function(t) {
      return this._store.getMedian(this._getStoreDimIndex(t));
    }, n.prototype.getValues = function(t, e) {
      var i = this, r = this._store;
      return O(t) ? r.getValues(_(t, function(o) {
        return i._getStoreDimIndex(o);
      }), e) : r.getValues(t);
    }, n.prototype.hasValue = function(t) {
      for (var e = this._dimSummary.dataDimIndicesOnCoord, i = 0, r = e.length; i < r; i++)
        if (isNaN(this._store.get(e[i], t)))
          return !1;
      return !0;
    }, n.prototype.indexOfName = function(t) {
      for (var e = 0, i = this._store.count(); e < i; e++)
        if (this.getName(e) === t)
          return e;
      return -1;
    }, n.prototype.getRawIndex = function(t) {
      return this._store.getRawIndex(t);
    }, n.prototype.indexOfRawIndex = function(t) {
      return this._store.indexOfRawIndex(t);
    }, n.prototype.rawIndexOf = function(t, e) {
      var i = t && this._invertedIndicesMap[t], r = i && i[e];
      return r == null || isNaN(r) ? N : r;
    }, n.prototype.indicesOfNearest = function(t, e, i) {
      return this._store.indicesOfNearest(this._getStoreDimIndex(t), e, i);
    }, n.prototype.each = function(t, e, i) {
      S(t) && (i = e, e = t, t = []);
      var r = i || this, o = _(D(t), this._getStoreDimIndex, this);
      this._store.each(o, r ? y(e, r) : e);
    }, n.prototype.filterSelf = function(t, e, i) {
      S(t) && (i = e, e = t, t = []);
      var r = i || this, o = _(D(t), this._getStoreDimIndex, this);
      return this._store = this._store.filter(o, r ? y(e, r) : e), this;
    }, n.prototype.selectRange = function(t) {
      var e = this, i = {}, r = z(t);
      return d(r, function(o) {
        var u = e._getStoreDimIndex(o);
        i[u] = t[o];
      }), this._store = this._store.selectRange(i), this;
    }, n.prototype.mapArray = function(t, e, i) {
      S(t) && (i = e, e = t, t = []), i = i || this;
      var r = [];
      return this.each(t, function() {
        r.push(e && e.apply(this, arguments));
      }, i), r;
    }, n.prototype.map = function(t, e, i, r) {
      var o = i || r || this, u = _(D(t), this._getStoreDimIndex, this), s = g(this);
      return s._store = this._store.map(u, o ? y(e, o) : e), s;
    }, n.prototype.modify = function(t, e, i, r) {
      var o = i || r || this, u = _(D(t), this._getStoreDimIndex, this);
      this._store.modify(u, o ? y(e, o) : e);
    }, n.prototype.downSample = function(t, e, i, r) {
      var o = g(this);
      return o._store = this._store.downSample(this._getStoreDimIndex(t), e, i, r), o;
    }, n.prototype.minmaxDownSample = function(t, e) {
      var i = g(this);
      return i._store = this._store.minmaxDownSample(this._getStoreDimIndex(t), e), i;
    }, n.prototype.lttbDownSample = function(t, e) {
      var i = g(this);
      return i._store = this._store.lttbDownSample(this._getStoreDimIndex(t), e), i;
    }, n.prototype.getRawDataItem = function(t) {
      return this._store.getRawDataItem(t);
    }, n.prototype.getItemModel = function(t) {
      var e = this.hostModel, i = this.getRawDataItem(t);
      return new X(i, e, e && e.ecModel);
    }, n.prototype.diff = function(t) {
      var e = this;
      return new Y(t ? t.getStore().getIndices() : [], this.getStore().getIndices(), function(i) {
        return x(t, i);
      }, function(i) {
        return x(e, i);
      });
    }, n.prototype.getVisual = function(t) {
      var e = this._visual;
      return e && e[t];
    }, n.prototype.setVisual = function(t, e) {
      this._visual = this._visual || {}, v(t) ? c(this._visual, t) : this._visual[t] = e;
    }, n.prototype.getItemVisual = function(t, e) {
      var i = this._itemVisuals[t], r = i && i[e];
      return r ?? this.getVisual(e);
    }, n.prototype.hasItemVisual = function() {
      return this._itemVisuals.length > 0;
    }, n.prototype.ensureUniqueItemVisual = function(t, e) {
      var i = this._itemVisuals, r = i[t];
      r || (r = i[t] = {});
      var o = r[e];
      return o == null && (o = this.getVisual(e), O(o) ? o = o.slice() : v(o) && (o = c({}, o)), r[e] = o), o;
    }, n.prototype.setItemVisual = function(t, e, i) {
      var r = this._itemVisuals[t] || {};
      this._itemVisuals[t] = r, v(e) ? c(r, e) : r[e] = i;
    }, n.prototype.clearAllVisual = function() {
      this._visual = {}, this._itemVisuals = [];
    }, n.prototype.setLayout = function(t, e) {
      v(t) ? c(this._layout, t) : this._layout[t] = e;
    }, n.prototype.getLayout = function(t) {
      return this._layout[t];
    }, n.prototype.getItemLayout = function(t) {
      return this._itemLayouts[t];
    }, n.prototype.setItemLayout = function(t, e, i) {
      this._itemLayouts[t] = i ? c(this._itemLayouts[t] || {}, e) : e;
    }, n.prototype.clearItemLayouts = function() {
      this._itemLayouts.length = 0;
    }, n.prototype.setItemGraphicEl = function(t, e) {
      var i = this.hostModel && this.hostModel.seriesIndex;
      Z(i, this.dataType, t, e), this._graphicEls[t] = e;
    }, n.prototype.getItemGraphicEl = function(t) {
      return this._graphicEls[t];
    }, n.prototype.eachItemGraphicEl = function(t, e) {
      d(this._graphicEls, function(i, r) {
        i && t && t.call(e, i, r);
      });
    }, n.prototype.cloneShallow = function(t) {
      return t || (t = new n(this._schema ? this._schema : _(this.dimensions, this._getDimInfo, this), this.hostModel)), E(t, this), t._store = this._store, t;
    }, n.prototype.wrapMethod = function(t, e) {
      var i = this[t];
      S(i) && (this.__wrappedMethods = this.__wrappedMethods || [], this.__wrappedMethods.push(t), this[t] = function() {
        var r = i.apply(this, arguments);
        return e.apply(this, [r].concat(B(arguments)));
      });
    }, n.internalField = function() {
      C = function(t) {
        var e = t._invertedIndicesMap;
        d(e, function(i, r) {
          var o = t._dimInfos[r], u = o.ordinalMeta, s = t._store;
          if (u) {
            i = e[r] = new tt(u.categories.length);
            for (var a = 0; a < i.length; a++)
              i[a] = N;
            for (var a = 0; a < s.count(); a++)
              i[s.get(o.storeDimIndex, a)] = a;
          }
        });
      }, I = function(t, e, i) {
        return w(t._getCategory(e, i), null);
      }, x = function(t, e) {
        var i = t._idList[e];
        return i == null && t._idDimIdx != null && (i = I(t, t._idDimIdx, e)), i == null && (i = et + e), i;
      }, D = function(t) {
        return O(t) || (t = t != null ? [t] : []), t;
      }, g = function(t) {
        var e = new n(t._schema ? t._schema : _(t.dimensions, t._getDimInfo, t), t.hostModel);
        return E(e, t), e;
      }, E = function(t, e) {
        d(it.concat(e.__wrappedMethods || []), function(i) {
          e.hasOwnProperty(i) && (t[i] = e[i]);
        }), t.__wrappedMethods = e.__wrappedMethods, d(rt, function(i) {
          t[i] = U(e[i]);
        }), t._calculationInfo = c({}, e._calculationInfo);
      }, L = function(t, e) {
        var i = t._nameList, r = t._idList, o = t._nameDimIdx, u = t._idDimIdx, s = i[e], a = r[e];
        if (s == null && o != null && (i[e] = s = I(t, o, e)), a == null && u != null && (r[e] = a = I(t, u, e)), a == null && s != null) {
          var l = t._nameRepeatCount, h = l[s] = (l[s] || 0) + 1;
          a = s, h > 1 && (a += "__ec__" + h), r[e] = a;
        }
      };
    }(), n;
  }()
);
const vt = nt;
export {
  vt as default
};
