import { isArray as g, isFunction as I, isString as y } from "../../../zrender/lib/core/util.js";
import m from "./helper/linkSeriesData.js";
import x from "./SeriesData.js";
import N from "./helper/createDimensions.js";
import { convertOptionIdName as T } from "../util/model.js";
var D = (
  /** @class */
  function() {
    function n(t, e) {
      this.depth = 0, this.height = 0, this.dataIndex = -1, this.children = [], this.viewChildren = [], this.isExpand = !1, this.name = t || "", this.hostTree = e;
    }
    return n.prototype.isRemoved = function() {
      return this.dataIndex < 0;
    }, n.prototype.eachNode = function(t, e, r) {
      I(t) && (r = e, e = t, t = null), t = t || {}, y(t) && (t = {
        order: t
      });
      var a = t.order || "preorder", o = this[t.attr || "children"], i;
      a === "preorder" && (i = e.call(r, this));
      for (var s = 0; !i && s < o.length; s++)
        o[s].eachNode(t, e, r);
      a === "postorder" && e.call(r, this);
    }, n.prototype.updateDepthAndHeight = function(t) {
      var e = 0;
      this.depth = t;
      for (var r = 0; r < this.children.length; r++) {
        var a = this.children[r];
        a.updateDepthAndHeight(t + 1), a.height > e && (e = a.height);
      }
      this.height = e + 1;
    }, n.prototype.getNodeById = function(t) {
      if (this.getId() === t)
        return this;
      for (var e = 0, r = this.children, a = r.length; e < a; e++) {
        var o = r[e].getNodeById(t);
        if (o)
          return o;
      }
    }, n.prototype.contains = function(t) {
      if (t === this)
        return !0;
      for (var e = 0, r = this.children, a = r.length; e < a; e++) {
        var o = r[e].contains(t);
        if (o)
          return o;
      }
    }, n.prototype.getAncestors = function(t) {
      for (var e = [], r = t ? this : this.parentNode; r; )
        e.push(r), r = r.parentNode;
      return e.reverse(), e;
    }, n.prototype.getAncestorsIndices = function() {
      for (var t = [], e = this; e; )
        t.push(e.dataIndex), e = e.parentNode;
      return t.reverse(), t;
    }, n.prototype.getDescendantIndices = function() {
      var t = [];
      return this.eachNode(function(e) {
        t.push(e.dataIndex);
      }), t;
    }, n.prototype.getValue = function(t) {
      var e = this.hostTree.data;
      return e.getStore().get(e.getDimensionIndex(t || "value"), this.dataIndex);
    }, n.prototype.setLayout = function(t, e) {
      this.dataIndex >= 0 && this.hostTree.data.setItemLayout(this.dataIndex, t, e);
    }, n.prototype.getLayout = function() {
      return this.hostTree.data.getItemLayout(this.dataIndex);
    }, n.prototype.getModel = function(t) {
      if (!(this.dataIndex < 0)) {
        var e = this.hostTree, r = e.data.getItemModel(this.dataIndex);
        return r.getModel(t);
      }
    }, n.prototype.getLevelModel = function() {
      return (this.hostTree.levelModels || [])[this.depth];
    }, n.prototype.setVisual = function(t, e) {
      this.dataIndex >= 0 && this.hostTree.data.setItemVisual(this.dataIndex, t, e);
    }, n.prototype.getVisual = function(t) {
      return this.hostTree.data.getItemVisual(this.dataIndex, t);
    }, n.prototype.getRawIndex = function() {
      return this.hostTree.data.getRawIndex(this.dataIndex);
    }, n.prototype.getId = function() {
      return this.hostTree.data.getId(this.dataIndex);
    }, n.prototype.getChildIndex = function() {
      if (this.parentNode) {
        for (var t = this.parentNode.children, e = 0; e < t.length; ++e)
          if (t[e] === this)
            return e;
        return -1;
      }
      return -1;
    }, n.prototype.isAncestorOf = function(t) {
      for (var e = t.parentNode; e; ) {
        if (e === this)
          return !0;
        e = e.parentNode;
      }
      return !1;
    }, n.prototype.isDescendantOf = function(t) {
      return t !== this && t.isAncestorOf(this);
    }, n;
  }()
), w = (
  /** @class */
  function() {
    function n(t) {
      this.type = "tree", this._nodes = [], this.hostModel = t;
    }
    return n.prototype.eachNode = function(t, e, r) {
      this.root.eachNode(t, e, r);
    }, n.prototype.getNodeByDataIndex = function(t) {
      var e = this.data.getRawIndex(t);
      return this._nodes[e];
    }, n.prototype.getNodeById = function(t) {
      return this.root.getNodeById(t);
    }, n.prototype.update = function() {
      for (var t = this.data, e = this._nodes, r = 0, a = e.length; r < a; r++)
        e[r].dataIndex = -1;
      for (var r = 0, a = t.count(); r < a; r++)
        e[t.getRawIndex(r)].dataIndex = r;
    }, n.prototype.clearLayouts = function() {
      this.data.clearItemLayouts();
    }, n.createTree = function(t, e, r) {
      var a = new n(e), o = [], i = 1;
      s(t);
      function s(d, f) {
        var l = d.value;
        i = Math.max(i, g(l) ? l.length : 1), o.push(d);
        var h = new D(T(d.name, ""), a);
        f ? A(h, f) : a.root = h, a._nodes.push(h);
        var p = d.children;
        if (p)
          for (var c = 0; c < p.length; c++)
            s(p[c], h);
      }
      a.root.updateDepthAndHeight(0);
      var v = N(o, {
        coordDimensions: ["value"],
        dimensionsCount: i
      }).dimensions, u = new x(v, e);
      return u.initData(o), r && r(u), m({
        mainData: u,
        struct: a,
        structAttr: "tree"
      }), a.update(), a;
    }, n;
  }()
);
function A(n, t) {
  var e = t.children;
  n.parentNode !== t && (e.push(n), n.parentNode = t);
}
const R = w;
export {
  D as TreeNode,
  R as default
};
