import { setAsPrimitive as B, isTypedArray as T, retrieve2 as _, each as U, map as A } from "../../../../zrender/lib/core/util.js";
import { createSource as l, cloneSourceShallow as M } from "../Source.js";
import { SOURCE_FORMAT_TYPED_ARRAY as O, SOURCE_FORMAT_ORIGINAL as E } from "../../util/types.js";
import { querySeriesUpstreamDatasetModel as G, queryDatasetUpstreamDatasetModels as R } from "./sourceHelper.js";
import { applyDataTransform as V } from "./transform.js";
import P from "../DataStore.js";
import { DefaultDataProvider as w } from "./dataProvider.js";
var F = (
  /** @class */
  function() {
    function s(r) {
      this._sourceList = [], this._storeList = [], this._upstreamSignList = [], this._versionSignBase = 0, this._dirty = !0, this._sourceHost = r;
    }
    return s.prototype.dirty = function() {
      this._setLocalSource([], []), this._storeList = [], this._dirty = !0;
    }, s.prototype._setLocalSource = function(r, e) {
      this._sourceList = r, this._upstreamSignList = e, this._versionSignBase++, this._versionSignBase > 9e10 && (this._versionSignBase = 0);
    }, s.prototype._getVersionSign = function() {
      return this._sourceHost.uid + "_" + this._versionSignBase;
    }, s.prototype.prepareSource = function() {
      this._isDirty() && (this._createSource(), this._dirty = !1);
    }, s.prototype._createSource = function() {
      this._setLocalSource([], []);
      var r = this._sourceHost, e = this._getUpstreamSourceManagers(), t = !!e.length, o, a;
      if (p(r)) {
        var n = r, i = void 0, u = void 0, c = void 0;
        if (t) {
          var f = e[0];
          f.prepareSource(), c = f.getSource(), i = c.data, u = c.sourceFormat, a = [f._getVersionSign()];
        } else
          i = n.get("data", !0), u = T(i) ? O : E, a = [];
        var v = this._getSourceMetaRawOption() || {}, h = c && c.metaRawOption || {}, g = _(v.seriesLayoutBy, h.seriesLayoutBy) || null, S = _(v.sourceHeader, h.sourceHeader), m = _(v.dimensions, h.dimensions), d = g !== h.seriesLayoutBy || !!S != !!h.sourceHeader || m;
        o = d ? [l(i, {
          seriesLayoutBy: g,
          sourceHeader: S,
          dimensions: m
        }, u)] : [];
      } else {
        var H = r;
        if (t) {
          var y = this._applyTransform(e);
          o = y.sourceList, a = y.upstreamSignList;
        } else {
          var D = H.get("source", !0);
          o = [l(D, this._getSourceMetaRawOption(), null)], a = [];
        }
      }
      this._setLocalSource(o, a);
    }, s.prototype._applyTransform = function(r) {
      var e = this._sourceHost, t = e.get("transform", !0), o = e.get("fromTransformResult", !0);
      if (o != null) {
        var a = "";
        r.length !== 1 && L(a);
      }
      var n, i = [], u = [];
      return U(r, function(c) {
        c.prepareSource();
        var f = c.getSource(o || 0), v = "";
        o != null && !f && L(v), i.push(f), u.push(c._getVersionSign());
      }), t ? n = V(t, i, {
        datasetIndex: e.componentIndex
      }) : o != null && (n = [M(i[0])]), {
        sourceList: n,
        upstreamSignList: u
      };
    }, s.prototype._isDirty = function() {
      if (this._dirty)
        return !0;
      for (var r = this._getUpstreamSourceManagers(), e = 0; e < r.length; e++) {
        var t = r[e];
        if (
          // Consider the case that there is ancestor diry, call it recursively.
          // The performance is probably not an issue because usually the chain is not long.
          t._isDirty() || this._upstreamSignList[e] !== t._getVersionSign()
        )
          return !0;
      }
    }, s.prototype.getSource = function(r) {
      r = r || 0;
      var e = this._sourceList[r];
      if (!e) {
        var t = this._getUpstreamSourceManagers();
        return t[0] && t[0].getSource(r);
      }
      return e;
    }, s.prototype.getSharedDataStore = function(r) {
      var e = r.makeStoreSchema();
      return this._innerGetDataStore(e.dimensions, r.source, e.hash);
    }, s.prototype._innerGetDataStore = function(r, e, t) {
      var o = 0, a = this._storeList, n = a[o];
      n || (n = a[o] = {});
      var i = n[t];
      if (!i) {
        var u = this._getUpstreamSourceManagers()[0];
        p(this._sourceHost) && u ? i = u._innerGetDataStore(r, e, t) : (i = new P(), i.initData(new w(e, r.length), r)), n[t] = i;
      }
      return i;
    }, s.prototype._getUpstreamSourceManagers = function() {
      var r = this._sourceHost;
      if (p(r)) {
        var e = G(r);
        return e ? [e.getSourceManager()] : [];
      } else
        return A(R(r), function(t) {
          return t.getSourceManager();
        });
    }, s.prototype._getSourceMetaRawOption = function() {
      var r = this._sourceHost, e, t, o;
      if (p(r))
        e = r.get("seriesLayoutBy", !0), t = r.get("sourceHeader", !0), o = r.get("dimensions", !0);
      else if (!this._getUpstreamSourceManagers().length) {
        var a = r;
        e = a.get("seriesLayoutBy", !0), t = a.get("sourceHeader", !0), o = a.get("dimensions", !0);
      }
      return {
        seriesLayoutBy: e,
        sourceHeader: t,
        dimensions: o
      };
    }, s;
  }()
);
function N(s) {
  var r = s.option.transform;
  r && B(s.option.transform);
}
function p(s) {
  return s.mainType === "series";
}
function L(s) {
  throw new Error(s);
}
export {
  F as SourceManager,
  N as disableTransformOptionMerge
};
