import "../util/graphic.js";
import { getECData as x } from "../util/innerStore.js";
import { parsePercent as S } from "../util/number.js";
import B from "../../../zrender/lib/core/Transformable.js";
import { setLabelLineStyle as z, getLabelLineStatesModels as H, updateLabelLinePoints as C } from "./labelGuideHelper.js";
import { makeInner as M } from "../util/model.js";
import { isFunction as R, keys as N, filter as _, each as U, retrieve2 as V, indexOf as Y } from "../../../zrender/lib/core/util.js";
import { prepareLayoutList as W, shiftLayoutOnX as j, shiftLayoutOnY as K, hideOverlap as w } from "./labelLayoutHelper.js";
import { labelInner as F, animateLabelValue as I } from "./labelStyle.js";
import { normalizeRadian as $ } from "../../../zrender/lib/contain/util.js";
import P from "../../../zrender/lib/core/BoundingRect.js";
import { isElementRemoved as q, initProps as A, updateProps as X } from "../animation/basicTransition.js";
function J(l) {
  if (l) {
    for (var r = [], n = 0; n < l.length; n++)
      r.push(l[n].slice());
    return r;
  }
}
function Q(l, r) {
  var n = l.label, t = r && r.getTextGuideLine();
  return {
    dataIndex: l.dataIndex,
    dataType: l.dataType,
    seriesIndex: l.seriesModel.seriesIndex,
    text: l.label.style.text,
    rect: l.hostRect,
    labelRect: l.rect,
    // x: labelAttr.x,
    // y: labelAttr.y,
    align: n.style.align,
    verticalAlign: n.style.verticalAlign,
    labelLinePoints: J(t && t.shape.points)
  };
}
var E = ["align", "verticalAlign", "width", "height", "fontSize"], d = new B(), T = M(), Z = M();
function y(l, r, n) {
  for (var t = 0; t < n.length; t++) {
    var a = n[t];
    r[a] != null && (l[a] = r[a]);
  }
}
var m = ["x", "y", "rotation"], k = (
  /** @class */
  function() {
    function l() {
      this._labelList = [], this._chartViewList = [];
    }
    return l.prototype.clearLabels = function() {
      this._labelList = [], this._chartViewList = [];
    }, l.prototype._addLabel = function(r, n, t, a, s) {
      var e = a.style, i = a.__hostTarget, v = i.textConfig || {}, f = a.getComputedTransform(), o = a.getBoundingRect().plain();
      P.applyTransform(o, o, f), f ? d.setLocalTransform(f) : (d.x = d.y = d.rotation = d.originX = d.originY = 0, d.scaleX = d.scaleY = 1), d.rotation = $(d.rotation);
      var c = a.__hostTarget, g;
      if (c) {
        g = c.getBoundingRect().plain();
        var u = c.getComputedTransform();
        P.applyTransform(g, g, u);
      }
      var p = g && c.getTextGuideLine();
      this._labelList.push({
        label: a,
        labelLine: p,
        seriesModel: t,
        dataIndex: r,
        dataType: n,
        layoutOption: s,
        computedLayoutOption: null,
        rect: o,
        hostRect: g,
        // Label with lower priority will be hidden when overlapped
        // Use rect size as default priority
        priority: g ? g.width * g.height : 0,
        // Save default label attributes.
        // For restore if developers want get back to default value in callback.
        defaultAttr: {
          ignore: a.ignore,
          labelGuideIgnore: p && p.ignore,
          x: d.x,
          y: d.y,
          scaleX: d.scaleX,
          scaleY: d.scaleY,
          rotation: d.rotation,
          style: {
            x: e.x,
            y: e.y,
            align: e.align,
            verticalAlign: e.verticalAlign,
            width: e.width,
            height: e.height,
            fontSize: e.fontSize
          },
          cursor: a.cursor,
          attachedPos: v.position,
          attachedRot: v.rotation
        }
      });
    }, l.prototype.addLabelsOfSeries = function(r) {
      var n = this;
      this._chartViewList.push(r);
      var t = r.__model, a = t.get("labelLayout");
      (R(a) || N(a).length) && r.group.traverse(function(s) {
        if (s.ignore)
          return !0;
        var e = s.getTextContent(), i = x(s);
        e && !e.disableLabelLayout && n._addLabel(i.dataIndex, i.dataType, t, e, a);
      });
    }, l.prototype.updateLayoutConfig = function(r) {
      var n = r.getWidth(), t = r.getHeight();
      function a(G, O) {
        return function() {
          C(G, O);
        };
      }
      for (var s = 0; s < this._labelList.length; s++) {
        var e = this._labelList[s], i = e.label, v = i.__hostTarget, f = e.defaultAttr, o = void 0;
        R(e.layoutOption) ? o = e.layoutOption(Q(e, v)) : o = e.layoutOption, o = o || {}, e.computedLayoutOption = o;
        var c = Math.PI / 180;
        v && v.setTextConfig({
          // Force to set local false.
          local: !1,
          // Ignore position and rotation config on the host el if x or y is changed.
          position: o.x != null || o.y != null ? null : f.attachedPos,
          // Ignore rotation config on the host el if rotation is changed.
          rotation: o.rotate != null ? o.rotate * c : f.attachedRot,
          offset: [o.dx || 0, o.dy || 0]
        });
        var g = !1;
        if (o.x != null ? (i.x = S(o.x, n), i.setStyle("x", 0), g = !0) : (i.x = f.x, i.setStyle("x", f.style.x)), o.y != null ? (i.y = S(o.y, t), i.setStyle("y", 0), g = !0) : (i.y = f.y, i.setStyle("y", f.style.y)), o.labelLinePoints) {
          var u = v.getTextGuideLine();
          u && (u.setShape({
            points: o.labelLinePoints
          }), g = !1);
        }
        var p = T(i);
        p.needsUpdateLabelLine = g, i.rotation = o.rotate != null ? o.rotate * c : f.rotation, i.scaleX = f.scaleX, i.scaleY = f.scaleY;
        for (var L = 0; L < E.length; L++) {
          var h = E[L];
          i.setStyle(h, o[h] != null ? o[h] : f.style[h]);
        }
        if (o.draggable) {
          if (i.draggable = !0, i.cursor = "move", v) {
            var b = e.seriesModel;
            if (e.dataIndex != null) {
              var D = e.seriesModel.getData(e.dataType);
              b = D.getItemModel(e.dataIndex);
            }
            i.on("drag", a(v, b.getModel("labelLine")));
          }
        } else
          i.off("drag"), i.cursor = f.cursor;
      }
    }, l.prototype.layout = function(r) {
      var n = r.getWidth(), t = r.getHeight(), a = W(this._labelList), s = _(a, function(v) {
        return v.layoutOption.moveOverlap === "shiftX";
      }), e = _(a, function(v) {
        return v.layoutOption.moveOverlap === "shiftY";
      });
      j(s, 0, n), K(e, 0, t);
      var i = _(a, function(v) {
        return v.layoutOption.hideOverlap;
      });
      w(i);
    }, l.prototype.processLabelsOverall = function() {
      var r = this;
      U(this._chartViewList, function(n) {
        var t = n.__model, a = n.ignoreLabelLineUpdate, s = t.isAnimationEnabled();
        n.group.traverse(function(e) {
          if (e.ignore && !e.forceLabelAnimation)
            return !0;
          var i = !a, v = e.getTextContent();
          !i && v && (i = T(v).needsUpdateLabelLine), i && r._updateLabelLine(e, t), s && r._animateLabels(e, t);
        });
      });
    }, l.prototype._updateLabelLine = function(r, n) {
      var t = r.getTextContent(), a = x(r), s = a.dataIndex;
      if (t && s != null) {
        var e = n.getData(a.dataType), i = e.getItemModel(s), v = {}, f = e.getItemVisual(s, "style");
        if (f) {
          var o = e.getVisual("drawType");
          v.stroke = f[o];
        }
        var c = i.getModel("labelLine");
        z(r, H(i), v), C(r, c);
      }
    }, l.prototype._animateLabels = function(r, n) {
      var t = r.getTextContent(), a = r.getTextGuideLine();
      if (t && (r.forceLabelAnimation || !t.ignore && !t.invisible && !r.disableLabelAnimation && !q(r))) {
        var s = T(t), e = s.oldLayout, i = x(r), v = i.dataIndex, f = {
          x: t.x,
          y: t.y,
          rotation: t.rotation
        }, o = n.getData(i.dataType);
        if (e) {
          t.attr(e);
          var g = r.prevStates;
          g && (Y(g, "select") >= 0 && t.attr(s.oldLayoutSelect), Y(g, "emphasis") >= 0 && t.attr(s.oldLayoutEmphasis)), X(t, f, n, v);
        } else if (t.attr(f), !F(t).valueAnimation) {
          var c = V(t.style.opacity, 1);
          t.style.opacity = 0, A(t, {
            style: {
              opacity: c
            }
          }, n, v);
        }
        if (s.oldLayout = f, t.states.select) {
          var u = s.oldLayoutSelect = {};
          y(u, f, m), y(u, t.states.select, m);
        }
        if (t.states.emphasis) {
          var p = s.oldLayoutEmphasis = {};
          y(p, f, m), y(p, t.states.emphasis, m);
        }
        I(t, v, o, n, n);
      }
      if (a && !a.ignore && !a.invisible) {
        var s = Z(a), e = s.oldLayout, L = {
          points: a.shape.points
        };
        e ? (a.attr({
          shape: e
        }), X(a, {
          shape: L
        }, n)) : (a.setShape(L), a.style.strokePercent = 0, A(a, {
          style: {
            strokePercent: 1
          }
        }, n)), s.oldLayout = L;
      }
    }, l;
  }()
);
const dt = k;
export {
  dt as default
};
