import { defaults as Y, each as l, keys as Z } from "../../../zrender/lib/core/util.js";
import { parsePercent as S } from "../util/number.js";
import { isDimensionStacked as $ } from "../data/helper/dataStackHelper.js";
import N from "../chart/helper/createRenderPlanner.js";
import { createFloat32Array as R } from "../util/vendor.js";
var E = "__ec_stack_";
function F(n) {
  return n.get("stack") || E + n.seriesIndex;
}
function V(n) {
  return n.dim + n.index;
}
function da(n) {
  var i = [], t = n.axis, a = "axis0";
  if (t.type === "category") {
    for (var u = t.getBandWidth(), r = 0; r < n.count; r++)
      i.push(Y({
        bandWidth: u,
        axisKey: a,
        stackId: E + r
      }, n));
    for (var f = q(i), e = [], r = 0; r < n.count; r++) {
      var o = f[a][E + r];
      o.offsetCenter = o.offset + o.width / 2, e.push(o);
    }
    return e;
  }
}
function j(n, i) {
  var t = [];
  return i.eachSeriesByType(n, function(a) {
    J(a) && t.push(a);
  }), t;
}
function aa(n) {
  var i = {};
  l(n, function(o) {
    var d = o.coordinateSystem, v = d.getBaseAxis();
    if (!(v.type !== "time" && v.type !== "value"))
      for (var s = o.getData(), h = v.dim + "_" + v.index, m = s.getDimensionIndex(s.mapDimension(v.dim)), p = s.getStore(), x = 0, b = p.count(); x < b; ++x) {
        var c = p.get(m, x);
        i[h] ? i[h].push(c) : i[h] = [c];
      }
  });
  var t = {};
  for (var a in i)
    if (i.hasOwnProperty(a)) {
      var u = i[a];
      if (u) {
        u.sort(function(o, d) {
          return o - d;
        });
        for (var r = null, f = 1; f < u.length; ++f) {
          var e = u[f] - u[f - 1];
          e > 0 && (r = r === null ? e : Math.min(r, e));
        }
        t[a] = r;
      }
    }
  return t;
}
function ta(n) {
  var i = aa(n), t = [];
  return l(n, function(a) {
    var u = a.coordinateSystem, r = u.getBaseAxis(), f = r.getExtent(), e;
    if (r.type === "category")
      e = r.getBandWidth();
    else if (r.type === "value" || r.type === "time") {
      var o = r.dim + "_" + r.index, d = i[o], v = Math.abs(f[1] - f[0]), s = r.scale.getExtent(), h = Math.abs(s[1] - s[0]);
      e = d ? v / h * d : v;
    } else {
      var m = a.getData();
      e = Math.abs(f[1] - f[0]) / m.count();
    }
    var p = S(a.get("barWidth"), e), x = S(a.get("barMaxWidth"), e), b = S(
      // barMinWidth by default is 0.5 / 1 in cartesian. Because in value axis,
      // the auto-calculated bar width might be less than 0.5 / 1.
      a.get("barMinWidth") || (Q(a) ? 0.5 : 1),
      e
    ), c = a.get("barGap"), y = a.get("barCategoryGap");
    t.push({
      bandWidth: e,
      barWidth: p,
      barMaxWidth: x,
      barMinWidth: b,
      barGap: c,
      barCategoryGap: y,
      axisKey: V(r),
      stackId: F(a)
    });
  }), q(t);
}
function q(n) {
  var i = {};
  l(n, function(a, u) {
    var r = a.axisKey, f = a.bandWidth, e = i[r] || {
      bandWidth: f,
      remainedWidth: f,
      autoWidthCount: 0,
      categoryGap: null,
      gap: "20%",
      stacks: {}
    }, o = e.stacks;
    i[r] = e;
    var d = a.stackId;
    o[d] || e.autoWidthCount++, o[d] = o[d] || {
      width: 0,
      maxWidth: 0
    };
    var v = a.barWidth;
    v && !o[d].width && (o[d].width = v, v = Math.min(e.remainedWidth, v), e.remainedWidth -= v);
    var s = a.barMaxWidth;
    s && (o[d].maxWidth = s);
    var h = a.barMinWidth;
    h && (o[d].minWidth = h);
    var m = a.barGap;
    m != null && (e.gap = m);
    var p = a.barCategoryGap;
    p != null && (e.categoryGap = p);
  });
  var t = {};
  return l(i, function(a, u) {
    t[u] = {};
    var r = a.stacks, f = a.bandWidth, e = a.categoryGap;
    if (e == null) {
      var o = Z(r).length;
      e = Math.max(35 - o * 4, 15) + "%";
    }
    var d = S(e, f), v = S(a.gap, 1), s = a.remainedWidth, h = a.autoWidthCount, m = (s - d) / (h + (h - 1) * v);
    m = Math.max(m, 0), l(r, function(c) {
      var y = c.maxWidth, W = c.minWidth;
      if (c.width) {
        var g = c.width;
        y && (g = Math.min(g, y)), W && (g = Math.max(g, W)), c.width = g, s -= g + v * g, h--;
      } else {
        var g = m;
        y && y < g && (g = Math.min(y, s)), W && W > g && (g = W), g !== m && (c.width = g, s -= g + v * g, h--);
      }
    }), m = (s - d) / (h + (h - 1) * v), m = Math.max(m, 0);
    var p = 0, x;
    l(r, function(c, y) {
      c.width || (c.width = m), x = c, p += c.width * (1 + v);
    }), x && (p -= x.width * v);
    var b = -p / 2;
    l(r, function(c, y) {
      t[u][y] = t[u][y] || {
        bandWidth: f,
        offset: b,
        width: c.width
      }, b += c.width * (1 + v);
    });
  }), t;
}
function ua(n, i, t) {
  if (n && i) {
    var a = n[V(i)];
    return a != null && t != null ? a[F(t)] : a;
  }
}
function fa(n, i) {
  var t = j(n, i), a = ta(t);
  l(t, function(u) {
    var r = u.getData(), f = u.coordinateSystem, e = f.getBaseAxis(), o = F(u), d = a[V(e)][o], v = d.offset, s = d.width;
    r.setLayout({
      bandWidth: d.bandWidth,
      offset: v,
      size: s
    });
  });
}
function sa(n) {
  return {
    seriesType: n,
    plan: N(),
    reset: function(i) {
      if (J(i)) {
        var t = i.getData(), a = i.coordinateSystem, u = a.getBaseAxis(), r = a.getOtherAxis(u), f = t.getDimensionIndex(t.mapDimension(r.dim)), e = t.getDimensionIndex(t.mapDimension(u.dim)), o = i.get("showBackground", !0), d = t.mapDimension(r.dim), v = t.getCalculationInfo("stackResultDimension"), s = $(t, d) && !!t.getCalculationInfo("stackedOnSeries"), h = r.isHorizontal(), m = ra(u, r), p = Q(i), x = i.get("barMinHeight") || 0, b = v && t.getDimensionIndex(v), c = t.getLayout("size"), y = t.getLayout("offset");
        return {
          progress: function(W, g) {
            for (var K = W.count, A = p && R(K * 3), L = p && o && R(K * 3), X = p && R(K), M = a.master.getRect(), U = h ? M.width : M.height, k, _ = g.getStore(), D = 0; (k = W.next()) != null; ) {
              var O = _.get(s ? b : f, k), T = _.get(e, k), C = m, z = void 0;
              s && (z = +O - _.get(f, k));
              var P = void 0, B = void 0, G = void 0, w = void 0;
              if (h) {
                var I = a.dataToPoint([O, T]);
                if (s) {
                  var H = a.dataToPoint([z, T]);
                  C = H[0];
                }
                P = C, B = I[1] + y, G = I[0] - C, w = c, Math.abs(G) < x && (G = (G < 0 ? -1 : 1) * x);
              } else {
                var I = a.dataToPoint([T, O]);
                if (s) {
                  var H = a.dataToPoint([T, z]);
                  C = H[1];
                }
                P = I[0] + y, B = C, G = c, w = I[1] - C, Math.abs(w) < x && (w = (w <= 0 ? -1 : 1) * x);
              }
              p ? (A[D] = P, A[D + 1] = B, A[D + 2] = h ? G : w, L && (L[D] = h ? M.x : P, L[D + 1] = h ? B : M.y, L[D + 2] = U), X[k] = k) : g.setItemLayout(k, {
                x: P,
                y: B,
                width: G,
                height: w
              }), D += 3;
            }
            p && g.setLayout({
              largePoints: A,
              largeDataIndices: X,
              largeBackgroundPoints: L,
              valueAxisHorizontal: h
            });
          }
        };
      }
    }
  };
}
function J(n) {
  return n.coordinateSystem && n.coordinateSystem.type === "cartesian2d";
}
function Q(n) {
  return n.pipelineContext && n.pipelineContext.large;
}
function ra(n, i) {
  var t = i.model.get("startValue");
  return t || (t = 0), i.toGlobalCoord(i.dataToCoord(i.type === "log" ? t > 0 ? t : 1 : t));
}
export {
  sa as createProgressiveLayout,
  da as getLayoutOnAxis,
  fa as layout,
  ta as makeColumnLayout,
  j as prepareLayoutBarSeries,
  ua as retrieveColumnLayout
};
