import { __extends as Q } from "../../../tslib/tslib.es6.js";
import { each as h, createHashMap as d, clone as A, merge as T, extend as L, filter as g, isFunction as Y, isString as $, isObject as F, isArray as J, mixin as R } from "../../../zrender/lib/core/util.js";
import { normalizeToArray as S, mappingToExists as W, setComponentTypeToKeyInfo as X, isComponentIdInternal as Z, convertOptionIdName as N } from "../util/model.js";
import w from "./Model.js";
import v from "./Component.js";
import ee from "./globalDefault.js";
import { resetSourceDefaulter as te } from "../data/helper/sourceHelper.js";
import { concatInternalOptions as ne } from "./internalComponentCreator.js";
import { PaletteMixin as re } from "./mixin/palette.js";
var O, I, z, G = "\0_ec_inner", ie = 1, V = (
  /** @class */
  function(l) {
    Q(i, l);
    function i() {
      return l !== null && l.apply(this, arguments) || this;
    }
    return i.prototype.init = function(e, n, t, r, o, p) {
      r = r || {}, this.option = null, this._theme = new w(r), this._locale = new w(o), this._optionManager = p;
    }, i.prototype.setOption = function(e, n, t) {
      var r = K(n);
      this._optionManager.setOption(e, t, r), this._resetOption(null, r);
    }, i.prototype.resetOption = function(e, n) {
      return this._resetOption(e, K(n));
    }, i.prototype._resetOption = function(e, n) {
      var t = !1, r = this._optionManager;
      if (!e || e === "recreate") {
        var o = r.mountOption(e === "recreate");
        !this.option || e === "recreate" ? z(this, o) : (this.restoreData(), this._mergeOption(o, n)), t = !0;
      }
      if ((e === "timeline" || e === "media") && this.restoreData(), !e || e === "recreate" || e === "timeline") {
        var p = r.getTimelineOption(this);
        p && (t = !0, this._mergeOption(p, n));
      }
      if (!e || e === "recreate" || e === "media") {
        var u = r.getMediaOption(this);
        u.length && h(u, function(s) {
          t = !0, this._mergeOption(s, n);
        }, this);
      }
      return t;
    }, i.prototype.mergeOption = function(e) {
      this._mergeOption(e, null);
    }, i.prototype._mergeOption = function(e, n) {
      var t = this.option, r = this._componentsMap, o = this._componentsCount, p = [], u = d(), s = n && n.replaceMergeMainTypeMap;
      te(this), h(e, function(a, f) {
        a != null && (v.hasClass(f) ? f && (p.push(f), u.set(f, !0)) : t[f] = t[f] == null ? A(a) : T(t[f], a, !0));
      }), s && s.each(function(a, f) {
        v.hasClass(f) && !u.get(f) && (p.push(f), u.set(f, !0));
      }), v.topologicalTravel(p, v.getAllClassMainTypes(), _, this);
      function _(a) {
        var f = ne(this, a, S(e[a])), M = r.get(a), m = (
          // `!oldCmptList` means init. See the comment in `mappingToExists`
          M ? s && s.get(a) ? "replaceMerge" : "normalMerge" : "replaceAll"
        ), D = W(M, f, m);
        X(D, a, v), t[a] = null, r.set(a, null), o.set(a, 0);
        var x = [], B = [], E = 0, P;
        h(D, function(y, q) {
          var c = y.existing, C = y.newOption;
          if (!C)
            c && (c.mergeOption({}, this), c.optionUpdated({}, !1));
          else {
            var H = a === "series", b = v.getClass(
              a,
              y.keyInfo.subType,
              !H
              // Give a more detailed warn later if series don't exists
            );
            if (!b)
              return;
            if (a === "tooltip") {
              if (P)
                return;
              P = !0;
            }
            if (c && c.constructor === b)
              c.name = y.keyInfo.name, c.mergeOption(C, this), c.optionUpdated(C, !1);
            else {
              var U = L({
                componentIndex: q
              }, y.keyInfo);
              c = new b(C, this, this, U), L(c, U), y.brandNew && (c.__requireNewView = !0), c.init(C, this, this), c.optionUpdated(null, !0);
            }
          }
          c ? (x.push(c.option), B.push(c), E++) : (x.push(void 0), B.push(void 0));
        }, this), t[a] = x, r.set(a, B), o.set(a, E), a === "series" && O(this);
      }
      this._seriesIndices || O(this);
    }, i.prototype.getOption = function() {
      var e = A(this.option);
      return h(e, function(n, t) {
        if (v.hasClass(t)) {
          for (var r = S(n), o = r.length, p = !1, u = o - 1; u >= 0; u--)
            r[u] && !Z(r[u]) ? p = !0 : (r[u] = null, !p && o--);
          r.length = o, e[t] = r;
        }
      }), delete e[G], e;
    }, i.prototype.getTheme = function() {
      return this._theme;
    }, i.prototype.getLocaleModel = function() {
      return this._locale;
    }, i.prototype.setUpdatePayload = function(e) {
      this._payload = e;
    }, i.prototype.getUpdatePayload = function() {
      return this._payload;
    }, i.prototype.getComponent = function(e, n) {
      var t = this._componentsMap.get(e);
      if (t) {
        var r = t[n || 0];
        if (r)
          return r;
        if (n == null) {
          for (var o = 0; o < t.length; o++)
            if (t[o])
              return t[o];
        }
      }
    }, i.prototype.queryComponents = function(e) {
      var n = e.mainType;
      if (!n)
        return [];
      var t = e.index, r = e.id, o = e.name, p = this._componentsMap.get(n);
      if (!p || !p.length)
        return [];
      var u;
      return t != null ? (u = [], h(S(t), function(s) {
        p[s] && u.push(p[s]);
      })) : r != null ? u = j("id", r, p) : o != null ? u = j("name", o, p) : u = g(p, function(s) {
        return !!s;
      }), k(u, e);
    }, i.prototype.findComponents = function(e) {
      var n = e.query, t = e.mainType, r = p(n), o = r ? this.queryComponents(r) : g(this._componentsMap.get(t), function(s) {
        return !!s;
      });
      return u(k(o, e));
      function p(s) {
        var _ = t + "Index", a = t + "Id", f = t + "Name";
        return s && (s[_] != null || s[a] != null || s[f] != null) ? {
          mainType: t,
          // subType will be filtered finally.
          index: s[_],
          id: s[a],
          name: s[f]
        } : null;
      }
      function u(s) {
        return e.filter ? g(s, e.filter) : s;
      }
    }, i.prototype.eachComponent = function(e, n, t) {
      var r = this._componentsMap;
      if (Y(e)) {
        var o = n, p = e;
        r.each(function(a, f) {
          for (var M = 0; a && M < a.length; M++) {
            var m = a[M];
            m && p.call(o, f, m, m.componentIndex);
          }
        });
      } else
        for (var u = $(e) ? r.get(e) : F(e) ? this.findComponents(e) : null, s = 0; u && s < u.length; s++) {
          var _ = u[s];
          _ && n.call(t, _, _.componentIndex);
        }
    }, i.prototype.getSeriesByName = function(e) {
      var n = N(e, null);
      return g(this._componentsMap.get("series"), function(t) {
        return !!t && n != null && t.name === n;
      });
    }, i.prototype.getSeriesByIndex = function(e) {
      return this._componentsMap.get("series")[e];
    }, i.prototype.getSeriesByType = function(e) {
      return g(this._componentsMap.get("series"), function(n) {
        return !!n && n.subType === e;
      });
    }, i.prototype.getSeries = function() {
      return g(this._componentsMap.get("series"), function(e) {
        return !!e;
      });
    }, i.prototype.getSeriesCount = function() {
      return this._componentsCount.get("series");
    }, i.prototype.eachSeries = function(e, n) {
      I(this), h(this._seriesIndices, function(t) {
        var r = this._componentsMap.get("series")[t];
        e.call(n, r, t);
      }, this);
    }, i.prototype.eachRawSeries = function(e, n) {
      h(this._componentsMap.get("series"), function(t) {
        t && e.call(n, t, t.componentIndex);
      });
    }, i.prototype.eachSeriesByType = function(e, n, t) {
      I(this), h(this._seriesIndices, function(r) {
        var o = this._componentsMap.get("series")[r];
        o.subType === e && n.call(t, o, r);
      }, this);
    }, i.prototype.eachRawSeriesByType = function(e, n, t) {
      return h(this.getSeriesByType(e), n, t);
    }, i.prototype.isSeriesFiltered = function(e) {
      return I(this), this._seriesIndicesMap.get(e.componentIndex) == null;
    }, i.prototype.getCurrentSeriesIndices = function() {
      return (this._seriesIndices || []).slice();
    }, i.prototype.filterSeries = function(e, n) {
      I(this);
      var t = [];
      h(this._seriesIndices, function(r) {
        var o = this._componentsMap.get("series")[r];
        e.call(n, o, r) && t.push(r);
      }, this), this._seriesIndices = t, this._seriesIndicesMap = d(t);
    }, i.prototype.restoreData = function(e) {
      O(this);
      var n = this._componentsMap, t = [];
      n.each(function(r, o) {
        v.hasClass(o) && t.push(o);
      }), v.topologicalTravel(t, v.getAllClassMainTypes(), function(r) {
        h(n.get(r), function(o) {
          o && (r !== "series" || !oe(o, e)) && o.restoreData();
        });
      });
    }, i.internalField = function() {
      O = function(e) {
        var n = e._seriesIndices = [];
        h(e._componentsMap.get("series"), function(t) {
          t && n.push(t.componentIndex);
        }), e._seriesIndicesMap = d(n);
      }, I = function(e) {
      }, z = function(e, n) {
        e.option = {}, e.option[G] = ie, e._componentsMap = d({
          series: []
        }), e._componentsCount = d();
        var t = n.aria;
        F(t) && t.enabled == null && (t.enabled = !0), se(n, e._theme.option), T(n, ee, !1), e._mergeOption(n, null);
      };
    }(), i;
  }(w)
);
function oe(l, i) {
  if (i) {
    var e = i.seriesIndex, n = i.seriesId, t = i.seriesName;
    return e != null && l.componentIndex !== e || n != null && l.id !== n || t != null && l.name !== t;
  }
}
function se(l, i) {
  var e = l.color && !l.colorLayer;
  h(i, function(n, t) {
    t === "colorLayer" && e || v.hasClass(t) || (typeof n == "object" ? l[t] = l[t] ? T(l[t], n, !1) : A(n) : l[t] == null && (l[t] = n));
  });
}
function j(l, i, e) {
  if (J(i)) {
    var n = d();
    return h(i, function(r) {
      if (r != null) {
        var o = N(r, null);
        o != null && n.set(r, !0);
      }
    }), g(e, function(r) {
      return r && n.get(r[l]);
    });
  } else {
    var t = N(i, null);
    return g(e, function(r) {
      return r && t != null && r[l] === t;
    });
  }
}
function k(l, i) {
  return i.hasOwnProperty("subType") ? g(l, function(e) {
    return e && e.subType === i.subType;
  }) : l;
}
function K(l) {
  var i = d();
  return l && h(S(l.replaceMerge), function(e) {
    i.set(e, !0);
  }), {
    replaceMergeMainTypeMap: i
  };
}
R(V, re);
const _e = V;
export {
  _e as default
};
