import { __extends as ne } from "../../../tslib/tslib.es6.js";
import { parseDate as p, nice as ae } from "../util/number.js";
import { format as ue, fullLeveledFormatter as $, getDefaultFormatPrecisionOfInterval as ie, getPrimaryTimeUnit as A, leveledFormat as se, ONE_DAY as v, ONE_SECOND as V, ONE_MINUTE as W, ONE_HOUR as F, ONE_YEAR as j, isPrimaryTimeUnit as oe, timeUnits as ce, secondsSetterName as Z, millisecondsSetterName as I, minutesSetterName as U, hoursSetterName as T, dateSetterName as C, monthSetterName as x, millisecondsGetterName as le, secondsGetterName as fe, minutesGetterName as he, hoursGetterName as ve, dateGetterName as me, monthGetterName as de, fullYearGetterName as ge, fullYearSetterName as ye, getUnitValue as J } from "../util/time.js";
import { contain as Se, normalize as _e, scale as we } from "./helper.js";
import be from "./Interval.js";
import Me from "./Scale.js";
import { isNumber as De, filter as K, map as Oe } from "../../../zrender/lib/core/util.js";
var Ee = function(r, n, e, t) {
  for (; e < t; ) {
    var a = e + t >>> 1;
    r[a][1] < n ? e = a + 1 : t = a;
  }
  return e;
}, ee = (
  /** @class */
  function(r) {
    ne(n, r);
    function n(e) {
      var t = r.call(this, e) || this;
      return t.type = "time", t;
    }
    return n.prototype.getLabel = function(e) {
      var t = this.getSetting("useUTC");
      return ue(e.value, $[ie(A(this._minLevelUnit))] || $.second, t, this.getSetting("locale"));
    }, n.prototype.getFormattedLabel = function(e, t, a) {
      var i = this.getSetting("useUTC"), o = this.getSetting("locale");
      return se(e, t, a, o, i);
    }, n.prototype.getTicks = function() {
      var e = this._interval, t = this._extent, a = [];
      if (!e)
        return a;
      a.push({
        value: t[0],
        level: 0
      });
      var i = this.getSetting("useUTC"), o = Ye(this._minLevelUnit, this._approxInterval, i, t);
      return a = a.concat(o), a.push({
        value: t[1],
        level: 0
      }), a;
    }, n.prototype.calcNiceExtent = function(e) {
      var t = this._extent;
      if (t[0] === t[1] && (t[0] -= v, t[1] += v), t[1] === -1 / 0 && t[0] === 1 / 0) {
        var a = /* @__PURE__ */ new Date();
        t[1] = +new Date(a.getFullYear(), a.getMonth(), a.getDate()), t[0] = t[1] - v;
      }
      this.calcNiceTicks(e.splitNumber, e.minInterval, e.maxInterval);
    }, n.prototype.calcNiceTicks = function(e, t, a) {
      e = e || 10;
      var i = this._extent, o = i[1] - i[0];
      this._approxInterval = o / e, t != null && this._approxInterval < t && (this._approxInterval = t), a != null && this._approxInterval > a && (this._approxInterval = a);
      var g = k.length, y = Math.min(Ee(k, this._approxInterval, 0, g), g - 1);
      this._interval = k[y][1], this._minLevelUnit = k[Math.max(y - 1, 0)][0];
    }, n.prototype.parse = function(e) {
      return De(e) ? e : +p(e);
    }, n.prototype.contain = function(e) {
      return Se(this.parse(e), this._extent);
    }, n.prototype.normalize = function(e) {
      return _e(this.parse(e), this._extent);
    }, n.prototype.scale = function(e) {
      return we(e, this._extent);
    }, n.type = "time", n;
  }(be)
), k = [
  // Format                           interval
  ["second", V],
  ["minute", W],
  ["hour", F],
  ["quarter-day", F * 6],
  ["half-day", F * 12],
  ["day", v * 1.2],
  ["half-week", v * 3.5],
  ["week", v * 7],
  ["month", v * 31],
  ["quarter", v * 95],
  ["half-year", j / 2],
  ["year", j]
  // 1Y
];
function Le(r, n, e, t) {
  var a = p(n), i = p(e), o = function(N) {
    return J(a, N, t) === J(i, N, t);
  }, g = function() {
    return o("year");
  }, y = function() {
    return g() && o("month");
  }, S = function() {
    return y() && o("day");
  }, f = function() {
    return S() && o("hour");
  }, _ = function() {
    return f() && o("minute");
  }, E = function() {
    return _() && o("second");
  }, u = function() {
    return E() && o("millisecond");
  };
  switch (r) {
    case "year":
      return g();
    case "month":
      return y();
    case "day":
      return S();
    case "hour":
      return f();
    case "minute":
      return _();
    case "second":
      return E();
    case "millisecond":
      return u();
  }
}
function Ae(r, n) {
  return r /= v, r > 16 ? 16 : r > 7.5 ? 7 : r > 3.5 ? 4 : r > 1.5 ? 2 : 1;
}
function Ne(r) {
  var n = 30 * v;
  return r /= n, r > 6 ? 6 : r > 3 ? 3 : r > 2 ? 2 : 1;
}
function ke(r) {
  return r /= F, r > 12 ? 12 : r > 6 ? 6 : r > 3.5 ? 4 : r > 2 ? 2 : 1;
}
function Q(r, n) {
  return r /= n ? W : V, r > 30 ? 30 : r > 20 ? 20 : r > 15 ? 15 : r > 10 ? 10 : r > 5 ? 5 : r > 2 ? 2 : 1;
}
function Fe(r) {
  return ae(r, !0);
}
function Ge(r, n, e) {
  var t = new Date(r);
  switch (A(n)) {
    case "year":
    case "month":
      t[x(e)](0);
    case "day":
      t[C(e)](1);
    case "hour":
      t[T(e)](0);
    case "minute":
      t[U(e)](0);
    case "second":
      t[Z(e)](0), t[I(e)](0);
  }
  return t.getTime();
}
function Ye(r, n, e, t) {
  var a = 1e4, i = ce, o = 0;
  function g(l, s, M, D, H, m, L) {
    for (var O = new Date(s), c = s, h = O[D](); c < M && c <= t[1]; )
      L.push({
        value: c
      }), h += l, O[H](h), c = O.getTime();
    L.push({
      value: c,
      notAdd: !0
    });
  }
  function y(l, s, M) {
    var D = [], H = !s.length;
    if (!Le(A(l), t[0], t[1], e)) {
      H && (s = [{
        // TODO Optimize. Not include so may ticks.
        value: Ge(new Date(t[0]), l, e)
      }, {
        value: t[1]
      }]);
      for (var m = 0; m < s.length - 1; m++) {
        var L = s[m].value, O = s[m + 1].value;
        if (L !== O) {
          var c = void 0, h = void 0, d = void 0, X = !1;
          switch (l) {
            case "year":
              c = Math.max(1, Math.round(n / v / 365)), h = ge(e), d = ye(e);
              break;
            case "half-year":
            case "quarter":
            case "month":
              c = Ne(n), h = de(e), d = x(e);
              break;
            case "week":
            case "half-week":
            case "day":
              c = Ae(n), h = me(e), d = C(e), X = !0;
              break;
            case "half-day":
            case "quarter-day":
            case "hour":
              c = ke(n), h = ve(e), d = T(e);
              break;
            case "minute":
              c = Q(n, !0), h = he(e), d = U(e);
              break;
            case "second":
              c = Q(n, !1), h = fe(e), d = Z(e);
              break;
            case "millisecond":
              c = Fe(n), h = le(e), d = I(e);
              break;
          }
          g(c, L, O, h, d, X, D), l === "year" && M.length > 1 && m === 0 && M.unshift({
            value: M[0].value - c
          });
        }
      }
      for (var m = 0; m < D.length; m++)
        M.push(D[m]);
      return D;
    }
  }
  for (var S = [], f = [], _ = 0, E = 0, u = 0; u < i.length && o++ < a; ++u) {
    var N = A(i[u]);
    if (oe(i[u])) {
      y(i[u], S[S.length - 1] || [], f);
      var te = i[u + 1] ? A(i[u + 1]) : null;
      if (N !== te) {
        if (f.length) {
          E = _, f.sort(function(l, s) {
            return l.value - s.value;
          });
          for (var z = [], w = 0; w < f.length; ++w) {
            var G = f[w].value;
            (w === 0 || f[w - 1].value !== G) && (z.push(f[w]), G >= t[0] && G <= t[1] && _++);
          }
          var Y = (t[1] - t[0]) / n;
          if (_ > Y * 1.5 && E > Y / 1.5 || (S.push(z), _ > Y || r === i[u]))
            break;
        }
        f = [];
      }
    }
  }
  for (var P = K(Oe(S, function(l) {
    return K(l, function(s) {
      return s.value >= t[0] && s.value <= t[1] && !s.notAdd;
    });
  }), function(l) {
    return l.length > 0;
  }), b = [], re = P.length - 1, u = 0; u < P.length; ++u)
    for (var R = P[u], q = 0; q < R.length; ++q)
      b.push({
        value: R[q].value,
        level: re - u
      });
  b.sort(function(l, s) {
    return l.value - s.value;
  });
  for (var B = [], u = 0; u < b.length; ++u)
    (u === 0 || b[u].value !== b[u - 1].value) && B.push(b[u]);
  return B;
}
Me.registerClass(ee);
const Xe = ee;
export {
  Xe as default
};
