import { curry as L, isObject as C, isArray as k, each as S, defaults as B } from "../../../zrender/lib/core/util.js";
import P from "../../../zrender/lib/core/BoundingRect.js";
import { parsePercent as d } from "./number.js";
import { normalizeCssArray as A } from "./format.js";
var M = S, F = ["left", "right", "top", "bottom", "width", "height"], g = [["width", "left", "right"], ["height", "top", "bottom"]];
function z(r, i, t, l, h) {
  var a = 0, v = 0;
  l == null && (l = 1 / 0), h == null && (h = 1 / 0);
  var c = 0;
  i.eachChild(function(f, u) {
    var e = f.getBoundingRect(), N = i.childAt(u + 1), n = N && N.getBoundingRect(), y, s;
    if (r === "horizontal") {
      var o = e.width + (n ? -n.x + e.x : 0);
      y = a + o, y > l || f.newline ? (a = 0, y = o, v += c + t, c = e.height) : c = Math.max(c, e.height);
    } else {
      var b = e.height + (n ? -n.y + e.y : 0);
      s = v + b, s > h || f.newline ? (a += c + t, v = 0, s = b, c = e.width) : c = Math.max(c, e.width);
    }
    f.newline || (f.x = a, f.y = v, f.markRedraw(), r === "horizontal" ? a = y + t : v = s + t);
  });
}
var q = z;
L(z, "vertical");
L(z, "horizontal");
function D(r, i, t) {
  var l = i.width, h = i.height, a = d(r.left, l), v = d(r.top, h), c = d(r.right, l), f = d(r.bottom, h);
  return (isNaN(a) || isNaN(parseFloat(r.left))) && (a = 0), (isNaN(c) || isNaN(parseFloat(r.right))) && (c = l), (isNaN(v) || isNaN(parseFloat(r.top))) && (v = 0), (isNaN(f) || isNaN(parseFloat(r.bottom))) && (f = h), t = A(t || 0), {
    width: Math.max(c - a - t[1] - t[3], 0),
    height: Math.max(f - v - t[0] - t[2], 0)
  };
}
function T(r, i, t) {
  t = A(t || 0);
  var l = i.width, h = i.height, a = d(r.left, l), v = d(r.top, h), c = d(r.right, l), f = d(r.bottom, h), u = d(r.width, l), e = d(r.height, h), N = t[2] + t[0], n = t[1] + t[3], y = r.aspect;
  switch (isNaN(u) && (u = l - c - n - a), isNaN(e) && (e = h - f - N - v), y != null && (isNaN(u) && isNaN(e) && (y > l / h ? u = l * 0.8 : e = h * 0.8), isNaN(u) && (u = y * e), isNaN(e) && (e = u / y)), isNaN(a) && (a = l - c - u - n), isNaN(v) && (v = h - f - e - N), r.left || r.right) {
    case "center":
      a = l / 2 - u / 2 - t[3];
      break;
    case "right":
      a = l - u - n;
      break;
  }
  switch (r.top || r.bottom) {
    case "middle":
    case "center":
      v = h / 2 - e / 2 - t[0];
      break;
    case "bottom":
      v = h - e - N;
      break;
  }
  a = a || 0, v = v || 0, isNaN(u) && (u = l - n - a - (c || 0)), isNaN(e) && (e = h - N - v - (f || 0));
  var s = new P(a + t[3], v + t[0], u, e);
  return s.margin = t, s;
}
function G(r, i, t, l, h, a) {
  var v = !h || !h.hv || h.hv[0], c = !h || !h.hv || h.hv[1], f = h && h.boundingMode || "all";
  if (a = a || r, a.x = r.x, a.y = r.y, !v && !c)
    return !1;
  var u;
  if (f === "raw")
    u = r.type === "group" ? new P(0, 0, +i.width || 0, +i.height || 0) : r.getBoundingRect();
  else if (u = r.getBoundingRect(), r.needLocalTransform()) {
    var e = r.getLocalTransform();
    u = u.clone(), u.applyTransform(e);
  }
  var N = T(B({
    width: u.width,
    height: u.height
  }, i), t, l), n = v ? N.x - u.x : 0, y = c ? N.y - u.y : 0;
  return f === "raw" ? (a.x = n, a.y = y) : (a.x += n, a.y += y), a === r && r.markRedraw(), !0;
}
function J(r, i) {
  return r[g[i][0]] != null || r[g[i][1]] != null && r[g[i][2]] != null;
}
function K(r) {
  var i = r.layoutMode || r.constructor.layoutMode;
  return C(i) ? i : i ? {
    type: i
  } : null;
}
function Q(r, i, t) {
  var l = t && t.ignoreSize;
  !k(l) && (l = [l, l]);
  var h = v(g[0], 0), a = v(g[1], 1);
  u(g[0], r, h), u(g[1], r, a);
  function v(e, N) {
    var n = {}, y = 0, s = {}, o = 0, b = 2;
    if (M(e, function(w) {
      s[w] = r[w];
    }), M(e, function(w) {
      c(i, w) && (n[w] = s[w] = i[w]), f(n, w) && y++, f(s, w) && o++;
    }), l[N])
      return f(i, e[1]) ? s[e[2]] = null : f(i, e[2]) && (s[e[1]] = null), s;
    if (o === b || !y)
      return s;
    if (y >= b)
      return n;
    for (var R = 0; R < e.length; R++) {
      var x = e[R];
      if (!c(n, x) && c(r, x)) {
        n[x] = r[x];
        break;
      }
    }
    return n;
  }
  function c(e, N) {
    return e.hasOwnProperty(N);
  }
  function f(e, N) {
    return e[N] != null && e[N] !== "auto";
  }
  function u(e, N, n) {
    M(e, function(y) {
      N[y] = n[y];
    });
  }
}
function U(r) {
  return V({}, r);
}
function V(r, i) {
  return i && r && M(F, function(t) {
    i.hasOwnProperty(t) && (r[t] = i[t]);
  }), r;
}
export {
  g as HV_NAMES,
  F as LOCATION_PARAMS,
  q as box,
  V as copyLayoutParams,
  K as fetchLayoutMode,
  D as getAvailableSize,
  U as getLayoutParams,
  T as getLayoutRect,
  Q as mergeLayoutParam,
  G as positionElement,
  J as sizeCalculable
};
