import { isString as x, isFunction as P, extend as R, defaults as V, isArray as k, isNumber as Q } from "../../../zrender/lib/core/util.js";
import { parseDate as H } from "./number.js";
import { getLocaleModel as j, getDefaultLocaleModel as z, SYSTEM_LANG as B } from "../core/locale.js";
import I from "../model/Model.js";
var J = 1e3, K = J * 60, X = K * 60, Z = X * 24, te = Z * 365, f = {
  year: "{yyyy}",
  month: "{MMM}",
  day: "{d}",
  hour: "{HH}:{mm}",
  minute: "{HH}:{mm}",
  second: "{HH}:{mm}:{ss}",
  millisecond: "{HH}:{mm}:{ss} {SSS}",
  none: "{yyyy}-{MM}-{dd} {HH}:{mm}:{ss} {SSS}"
}, p = "{yyyy}-{MM}-{dd}", ne = {
  year: "{yyyy}",
  month: "{yyyy}-{MM}",
  day: p,
  hour: p + " " + f.hour,
  minute: p + " " + f.minute,
  second: p + " " + f.second,
  millisecond: f.none
}, N = ["year", "month", "day", "hour", "minute", "second", "millisecond"], U = ["year", "half-year", "quarter", "month", "week", "half-week", "day", "half-day", "quarter-day", "hour", "minute", "second", "millisecond"];
function d(e, n) {
  return e += "", "0000".substr(0, n - e.length) + e;
}
function T(e) {
  switch (e) {
    case "half-year":
    case "quarter":
      return "month";
    case "week":
    case "half-week":
      return "day";
    case "half-day":
    case "quarter-day":
      return "hour";
    default:
      return e;
  }
}
function le(e) {
  return e === T(e);
}
function oe(e) {
  switch (e) {
    case "year":
    case "month":
      return "day";
    case "millisecond":
      return "millisecond";
    default:
      return "second";
  }
}
function $(e, n, r, a) {
  var l = H(e), t = l[w(r)](), o = l[h(r)]() + 1, s = Math.floor((o - 1) / 3) + 1, c = l[D(r)](), u = l["get" + (r ? "UTC" : "") + "Day"](), i = l[S(r)](), m = (i - 1) % 12 + 1, y = l[O(r)](), v = l[b(r)](), g = l[A(r)](), Y = i >= 12 ? "pm" : "am", G = Y.toUpperCase(), F = a instanceof I ? a : j(a || B) || z(), M = F.getModel("time"), q = M.get("month"), _ = M.get("monthAbbr"), L = M.get("dayOfWeek"), W = M.get("dayOfWeekAbbr");
  return (n || "").replace(/{a}/g, Y + "").replace(/{A}/g, G + "").replace(/{yyyy}/g, t + "").replace(/{yy}/g, d(t % 100 + "", 2)).replace(/{Q}/g, s + "").replace(/{MMMM}/g, q[o - 1]).replace(/{MMM}/g, _[o - 1]).replace(/{MM}/g, d(o, 2)).replace(/{M}/g, o + "").replace(/{dd}/g, d(c, 2)).replace(/{d}/g, c + "").replace(/{eeee}/g, L[u]).replace(/{ee}/g, W[u]).replace(/{e}/g, u + "").replace(/{HH}/g, d(i, 2)).replace(/{H}/g, i + "").replace(/{hh}/g, d(m + "", 2)).replace(/{h}/g, m + "").replace(/{mm}/g, d(y, 2)).replace(/{m}/g, y + "").replace(/{ss}/g, d(v, 2)).replace(/{s}/g, v + "").replace(/{SSS}/g, d(g, 3)).replace(/{S}/g, g + "");
}
function ue(e, n, r, a, l) {
  var t = null;
  if (x(r))
    t = r;
  else if (P(r))
    t = r(e.value, n, {
      level: e.level
    });
  else {
    var o = R({}, f);
    if (e.level > 0)
      for (var s = 0; s < N.length; ++s)
        o[N[s]] = "{primary|" + o[N[s]] + "}";
    var c = r ? r.inherit === !1 ? r : V(r, o) : o, u = E(e.value, l);
    if (c[u])
      t = c[u];
    else if (c.inherit) {
      for (var i = U.indexOf(u), s = i - 1; s >= 0; --s)
        if (c[u]) {
          t = c[u];
          break;
        }
      t = t || o.none;
    }
    if (k(t)) {
      var m = e.level == null ? 0 : e.level >= 0 ? e.level : t.length + e.level;
      m = Math.min(m, t.length - 1), t = t[m];
    }
  }
  return $(new Date(e.value), t, l, a);
}
function E(e, n) {
  var r = H(e), a = r[h(n)]() + 1, l = r[D(n)](), t = r[S(n)](), o = r[O(n)](), s = r[b(n)](), c = r[A(n)](), u = c === 0, i = u && s === 0, m = i && o === 0, y = m && t === 0, v = y && l === 1, g = v && a === 1;
  return g ? "year" : v ? "month" : y ? "day" : m ? "hour" : i ? "minute" : u ? "second" : "millisecond";
}
function se(e, n, r) {
  var a = Q(e) ? H(e) : e;
  switch (n = n || E(e, r), n) {
    case "year":
      return a[w(r)]();
    case "half-year":
      return a[h(r)]() >= 6 ? 1 : 0;
    case "quarter":
      return Math.floor((a[h(r)]() + 1) / 4);
    case "month":
      return a[h(r)]();
    case "day":
      return a[D(r)]();
    case "half-day":
      return a[S(r)]() / 24;
    case "hour":
      return a[S(r)]();
    case "minute":
      return a[O(r)]();
    case "second":
      return a[b(r)]();
    case "millisecond":
      return a[A(r)]();
  }
}
function w(e) {
  return e ? "getUTCFullYear" : "getFullYear";
}
function h(e) {
  return e ? "getUTCMonth" : "getMonth";
}
function D(e) {
  return e ? "getUTCDate" : "getDate";
}
function S(e) {
  return e ? "getUTCHours" : "getHours";
}
function O(e) {
  return e ? "getUTCMinutes" : "getMinutes";
}
function b(e) {
  return e ? "getUTCSeconds" : "getSeconds";
}
function A(e) {
  return e ? "getUTCMilliseconds" : "getMilliseconds";
}
function ce(e) {
  return e ? "setUTCFullYear" : "setFullYear";
}
function ie(e) {
  return e ? "setUTCMonth" : "setMonth";
}
function me(e) {
  return e ? "setUTCDate" : "setDate";
}
function de(e) {
  return e ? "setUTCHours" : "setHours";
}
function ye(e) {
  return e ? "setUTCMinutes" : "setMinutes";
}
function ve(e) {
  return e ? "setUTCSeconds" : "setSeconds";
}
function fe(e) {
  return e ? "setUTCMilliseconds" : "setMilliseconds";
}
export {
  Z as ONE_DAY,
  X as ONE_HOUR,
  K as ONE_MINUTE,
  J as ONE_SECOND,
  te as ONE_YEAR,
  D as dateGetterName,
  me as dateSetterName,
  f as defaultLeveledFormatter,
  $ as format,
  ne as fullLeveledFormatter,
  w as fullYearGetterName,
  ce as fullYearSetterName,
  oe as getDefaultFormatPrecisionOfInterval,
  T as getPrimaryTimeUnit,
  E as getUnitFromValue,
  se as getUnitValue,
  S as hoursGetterName,
  de as hoursSetterName,
  le as isPrimaryTimeUnit,
  ue as leveledFormat,
  A as millisecondsGetterName,
  fe as millisecondsSetterName,
  O as minutesGetterName,
  ye as minutesSetterName,
  h as monthGetterName,
  ie as monthSetterName,
  d as pad,
  N as primaryTimeUnits,
  b as secondsGetterName,
  ve as secondsSetterName,
  U as timeUnits
};
