import { clone as F, assert as R, bind as D, keys as $, isObject as h, each as S, isArray as I, isString as k, map as G, noop as O } from "../../../zrender/lib/core/util.js";
import { fastLerp as M, stringify as x, parse as U, modifyHSL as w, modifyAlpha as Z } from "../../../zrender/lib/tool/color.js";
import { linearMap as d } from "../util/number.js";
import "../util/log.js";
var m = S, j = h, v = -1, T = (
  /** @class */
  function() {
    function a(i) {
      var r = i.mappingMethod, n = i.type, t = this.option = F(i);
      this.type = n, this.mappingMethod = r, this._normalizeData = Y[r];
      var e = a.visualHandlers[n];
      this.applyVisual = e.applyVisual, this.getColorMapper = e.getColorMapper, this._normalizedToVisual = e._normalizedToVisual[r], r === "piecewise" ? (b(t), B(t)) : r === "category" ? t.categories ? X(t) : b(t, !0) : (R(r !== "linear" || t.dataExtent), b(t));
    }
    return a.prototype.mapValueToVisual = function(i) {
      var r = this._normalizeData(i);
      return this._normalizedToVisual(r, i);
    }, a.prototype.getNormalizer = function() {
      return D(this._normalizeData, this);
    }, a.listVisualTypes = function() {
      return $(a.visualHandlers);
    }, a.isValidType = function(i) {
      return a.visualHandlers.hasOwnProperty(i);
    }, a.eachVisual = function(i, r, n) {
      h(i) ? S(i, r, n) : r.call(n, i);
    }, a.mapVisual = function(i, r, n) {
      var t, e = I(i) ? [] : h(i) ? {} : (t = !0, null);
      return a.eachVisual(i, function(o, u) {
        var l = r.call(n, o, u);
        t ? e = l : e[u] = l;
      }), e;
    }, a.retrieveVisuals = function(i) {
      var r = {}, n;
      return i && m(a.visualHandlers, function(t, e) {
        i.hasOwnProperty(e) && (r[e] = i[e], n = !0);
      }), n ? r : null;
    }, a.prepareVisualTypes = function(i) {
      if (I(i))
        i = i.slice();
      else if (j(i)) {
        var r = [];
        m(i, function(n, t) {
          r.push(t);
        }), i = r;
      } else
        return [];
      return i.sort(function(n, t) {
        return t === "color" && n !== "color" && n.indexOf("color") === 0 ? 1 : -1;
      }), i;
    }, a.dependsOn = function(i, r) {
      return r === "color" ? !!(i && i.indexOf(r) === 0) : i === r;
    }, a.findPieceIndex = function(i, r, n) {
      for (var t, e = 1 / 0, o = 0, u = r.length; o < u; o++) {
        var l = r[o].value;
        if (l != null) {
          if (l === i || k(l) && l === i + "")
            return o;
          n && z(l, o);
        }
      }
      for (var o = 0, u = r.length; o < u; o++) {
        var H = r[o], s = H.interval, V = H.close;
        if (s) {
          if (s[0] === -1 / 0) {
            if (y(V[1], i, s[1]))
              return o;
          } else if (s[1] === 1 / 0) {
            if (y(V[0], s[0], i))
              return o;
          } else if (y(V[0], s[0], i) && y(V[1], i, s[1]))
            return o;
          n && z(s[0], o), n && z(s[1], o);
        }
      }
      if (n)
        return i === 1 / 0 ? r.length - 1 : i === -1 / 0 ? 0 : t;
      function z(N, E) {
        var A = Math.abs(N - i);
        A < e && (e = A, t = E);
      }
    }, a.visualHandlers = {
      color: {
        applyVisual: f("color"),
        getColorMapper: function() {
          var i = this.option;
          return D(i.mappingMethod === "category" ? function(r, n) {
            return !n && (r = this._normalizeData(r)), p.call(this, r);
          } : function(r, n, t) {
            var e = !!t;
            return !n && (r = this._normalizeData(r)), t = M(r, i.parsedVisual, t), e ? t : x(t, "rgba");
          }, this);
        },
        _normalizedToVisual: {
          linear: function(i) {
            return x(M(i, this.option.parsedVisual), "rgba");
          },
          category: p,
          piecewise: function(i, r) {
            var n = P.call(this, r);
            return n == null && (n = x(M(i, this.option.parsedVisual), "rgba")), n;
          },
          fixed: c
        }
      },
      colorHue: g(function(i, r) {
        return w(i, r);
      }),
      colorSaturation: g(function(i, r) {
        return w(i, null, r);
      }),
      colorLightness: g(function(i, r) {
        return w(i, null, null, r);
      }),
      colorAlpha: g(function(i, r) {
        return Z(i, r);
      }),
      decal: {
        applyVisual: f("decal"),
        _normalizedToVisual: {
          linear: null,
          category: p,
          piecewise: null,
          fixed: null
        }
      },
      opacity: {
        applyVisual: f("opacity"),
        _normalizedToVisual: _([0, 1])
      },
      liftZ: {
        applyVisual: f("liftZ"),
        _normalizedToVisual: {
          linear: c,
          category: c,
          piecewise: c,
          fixed: c
        }
      },
      symbol: {
        applyVisual: function(i, r, n) {
          var t = this.mapValueToVisual(i);
          n("symbol", t);
        },
        _normalizedToVisual: {
          linear: L,
          category: p,
          piecewise: function(i, r) {
            var n = P.call(this, r);
            return n == null && (n = L.call(this, i)), n;
          },
          fixed: c
        }
      },
      symbolSize: {
        applyVisual: f("symbolSize"),
        _normalizedToVisual: _([0, 1])
      }
    }, a;
  }()
);
function B(a) {
  var i = a.pieceList;
  a.hasSpecialVisual = !1, S(i, function(r, n) {
    r.originIndex = n, r.visual != null && (a.hasSpecialVisual = !0);
  });
}
function X(a) {
  var i = a.categories, r = a.categoryMap = {}, n = a.visual;
  if (m(i, function(o, u) {
    r[o] = u;
  }), !I(n)) {
    var t = [];
    h(n) ? m(n, function(o, u) {
      var l = r[u];
      t[l ?? v] = o;
    }) : t[v] = n, n = C(a, t);
  }
  for (var e = i.length - 1; e >= 0; e--)
    n[e] == null && (delete r[i[e]], i.pop());
}
function b(a, i) {
  var r = a.visual, n = [];
  h(r) ? m(r, function(e) {
    n.push(e);
  }) : r != null && n.push(r);
  var t = {
    color: 1,
    symbol: 1
  };
  !i && n.length === 1 && !t.hasOwnProperty(a.type) && (n[1] = n[0]), C(a, n);
}
function g(a) {
  return {
    applyVisual: function(i, r, n) {
      var t = this.mapValueToVisual(i);
      n("color", a(r("color"), t));
    },
    _normalizedToVisual: _([0, 1])
  };
}
function L(a) {
  var i = this.option.visual;
  return i[Math.round(d(a, [0, 1], [0, i.length - 1], !0))] || {};
}
function f(a) {
  return function(i, r, n) {
    n(a, this.mapValueToVisual(i));
  };
}
function p(a) {
  var i = this.option.visual;
  return i[this.option.loop && a !== v ? a % i.length : a];
}
function c() {
  return this.option.visual[0];
}
function _(a) {
  return {
    linear: function(i) {
      return d(i, a, this.option.visual, !0);
    },
    category: p,
    piecewise: function(i, r) {
      var n = P.call(this, r);
      return n == null && (n = d(i, a, this.option.visual, !0)), n;
    },
    fixed: c
  };
}
function P(a) {
  var i = this.option, r = i.pieceList;
  if (i.hasSpecialVisual) {
    var n = T.findPieceIndex(a, r), t = r[n];
    if (t && t.visual)
      return t.visual[this.type];
  }
}
function C(a, i) {
  return a.visual = i, a.type === "color" && (a.parsedVisual = G(i, function(r) {
    var n = U(r);
    return n || [0, 0, 0, 1];
  })), i;
}
var Y = {
  linear: function(a) {
    return d(a, this.option.dataExtent, [0, 1], !0);
  },
  piecewise: function(a) {
    var i = this.option.pieceList, r = T.findPieceIndex(a, i, !0);
    if (r != null)
      return d(r, [0, i.length - 1], [0, 1], !0);
  },
  category: function(a) {
    var i = this.option.categories ? this.option.categoryMap[a] : a;
    return i ?? v;
  },
  fixed: O
};
function y(a, i, r) {
  return a ? i <= r : i < r;
}
const ii = T;
export {
  ii as default
};
