import { defineComponent as R, ref as _, reactive as A, withKeys as F, createVNode as o, mergeProps as H } from "vue";
import { popupSharedProps as K, popupSharedPropKeys as N } from "../popup/shared.js";
import { Popup as z } from "../popup/index.js";
import { Button as y } from "../button/index.js";
import { ActionBar as I } from "../action-bar/index.js";
import { ActionBarButton as v } from "../action-bar-button/index.js";
import { extend as L, noop as k, pick as M, isFunction as U } from "../utils/basic.js";
import { BORDER_TOP as V, BORDER_LEFT as j } from "../utils/constant.js";
import { createNamespace as q } from "../utils/create.js";
import { numericProp as G, unknownProp as J, makeStringProp as Q, truthProp as g } from "../utils/props.js";
import { addUnit as W } from "../utils/format.js";
import { callInterceptor as X } from "../utils/interceptor.js";
const [Y, l, d] = q("dialog"), Z = L({}, K, {
  title: String,
  theme: String,
  width: G,
  message: [String, Function],
  callback: Function,
  allowHtml: Boolean,
  className: J,
  transition: Q("van-dialog-bounce"),
  messageAlign: String,
  closeOnPopstate: g,
  showCancelButton: Boolean,
  cancelButtonText: String,
  cancelButtonColor: String,
  cancelButtonDisabled: Boolean,
  confirmButtonText: String,
  confirmButtonColor: String,
  confirmButtonDisabled: Boolean,
  showConfirmButton: g,
  closeOnClickOverlay: Boolean,
  keyboardEnabled: g,
  destroyOnClose: Boolean
}), $ = [...N, "transition", "closeOnPopstate", "destroyOnClose"];
var ue = R({
  name: Y,
  props: Z,
  emits: ["confirm", "cancel", "keydown", "update:show"],
  setup(e, {
    emit: u,
    slots: a
  }) {
    const h = _(), i = A({
      confirm: !1,
      cancel: !1
    }), C = (t) => u("update:show", t), w = (t) => {
      var n;
      C(!1), (n = e.callback) == null || n.call(e, t);
    }, b = (t) => () => {
      e.show && (u(t), e.beforeClose ? (i[t] = !0, X(e.beforeClose, {
        args: [t],
        done() {
          w(t), i[t] = !1;
        },
        canceled() {
          i[t] = !1;
        }
      })) : w(t));
    }, m = b("cancel"), f = b("confirm"), x = F((t) => {
      var n, c;
      if (!e.keyboardEnabled || t.target !== ((c = (n = h.value) == null ? void 0 : n.popupRef) == null ? void 0 : c.value))
        return;
      ({
        Enter: e.showConfirmButton ? f : k,
        Escape: e.showCancelButton ? m : k
      })[t.key](), u("keydown", t);
    }, ["enter", "esc"]), T = () => {
      const t = a.title ? a.title() : e.title;
      if (t)
        return o("div", {
          class: l("header", {
            isolated: !e.message && !a.default
          })
        }, [t]);
    }, P = (t) => {
      const {
        message: n,
        allowHtml: c,
        messageAlign: r
      } = e, s = l("message", {
        "has-title": t,
        [r]: r
      }), B = U(n) ? n() : n;
      return c && typeof B == "string" ? o("div", {
        class: s,
        innerHTML: B
      }, null) : o("div", {
        class: s
      }, [B]);
    }, S = () => {
      if (a.default)
        return o("div", {
          class: l("content")
        }, [a.default()]);
      const {
        title: t,
        message: n,
        allowHtml: c
      } = e;
      if (n) {
        const r = !!(t || a.title);
        return o("div", {
          key: c ? 1 : 0,
          class: l("content", {
            isolated: !r
          })
        }, [P(r)]);
      }
    }, E = () => o("div", {
      class: [V, l("footer")]
    }, [e.showCancelButton && o(y, {
      size: "large",
      text: e.cancelButtonText || d("cancel"),
      class: l("cancel"),
      style: {
        color: e.cancelButtonColor
      },
      loading: i.cancel,
      disabled: e.cancelButtonDisabled,
      onClick: m
    }, null), e.showConfirmButton && o(y, {
      size: "large",
      text: e.confirmButtonText || d("confirm"),
      class: [l("confirm"), {
        [j]: e.showCancelButton
      }],
      style: {
        color: e.confirmButtonColor
      },
      loading: i.confirm,
      disabled: e.confirmButtonDisabled,
      onClick: f
    }, null)]), O = () => o(I, {
      class: l("footer")
    }, {
      default: () => [e.showCancelButton && o(v, {
        type: "warning",
        text: e.cancelButtonText || d("cancel"),
        class: l("cancel"),
        color: e.cancelButtonColor,
        loading: i.cancel,
        disabled: e.cancelButtonDisabled,
        onClick: m
      }, null), e.showConfirmButton && o(v, {
        type: "danger",
        text: e.confirmButtonText || d("confirm"),
        class: l("confirm"),
        color: e.confirmButtonColor,
        loading: i.confirm,
        disabled: e.confirmButtonDisabled,
        onClick: f
      }, null)]
    }), D = () => a.footer ? a.footer() : e.theme === "round-button" ? O() : E();
    return () => {
      const {
        width: t,
        title: n,
        theme: c,
        message: r,
        className: s
      } = e;
      return o(z, H({
        ref: h,
        role: "dialog",
        class: [l([c]), s],
        style: {
          width: W(t)
        },
        tabindex: 0,
        "aria-labelledby": n || r,
        onKeydown: x,
        "onUpdate:show": C
      }, M(e, $)), {
        default: () => [T(), S(), D()]
      });
    };
  }
});
export {
  ue as default,
  Z as dialogProps
};
