import { defineComponent as Y, ref as V, computed as u, watch as O, createVNode as c, mergeProps as j, nextTick as N } from "vue";
import { name as z, assignDefaultFields as A, getColumnsType as G, formatCascadeColumns as q, findOptionByValue as J, isOptionExist as w, getFirstEnabledOption as Q, bem as m } from "./utils.js";
import { useParent as W, useChildren as X, useEventListener as Z } from "../../../@vant/use/dist/index.esm.js";
import { useExpose as ee } from "../composables/use-expose.js";
import { Loading as oe } from "../loading/index.js";
import le, { PICKER_KEY as te } from "./PickerColumn.js";
import ne, { pickerToolbarProps as ae, pickerToolbarPropKeys as ie, pickerToolbarSlots as re } from "./PickerToolbar.js";
import { PICKER_GROUP_KEY as ue } from "../picker-group/PickerGroup.js";
import { extend as f, isSameValue as b, pick as H } from "../utils/basic.js";
import { BORDER_UNSET_TOP_BOTTOM as ce } from "../utils/constant.js";
import { makeNumericProp as k, truthProp as se, makeArrayProp as B, makeStringProp as me } from "../utils/props.js";
import { unitToPx as de } from "../utils/format.js";
import { preventDefault as ve } from "../utils/dom.js";
const pe = f({
  loading: Boolean,
  readonly: Boolean,
  allowHtml: Boolean,
  optionHeight: k(44),
  showToolbar: se,
  swipeDuration: k(1e3),
  visibleOptionNum: k(6)
}, ae), fe = f({}, pe, {
  columns: B(),
  modelValue: B(),
  toolbarPosition: me("top"),
  columnsFieldNames: Object
});
var we = Y({
  name: z,
  props: fe,
  emits: ["confirm", "cancel", "change", "scrollInto", "clickOption", "update:modelValue"],
  setup(t, {
    emit: r,
    slots: i
  }) {
    const P = V(), n = V(t.modelValue.slice(0)), {
      parent: D
    } = W(ue), {
      children: I,
      linkChildren: R
    } = X(te);
    R();
    const a = u(() => A(t.columnsFieldNames)), d = u(() => de(t.optionHeight)), C = u(() => G(t.columns, a.value)), s = u(() => {
      const {
        columns: e
      } = t;
      switch (C.value) {
        case "multiple":
          return e;
        case "cascade":
          return q(e, a.value, n);
        default:
          return [e];
      }
    }), y = u(() => s.value.some((e) => e.length)), E = u(() => s.value.map((e, o) => J(e, n.value[o], a.value))), x = u(() => s.value.map((e, o) => e.findIndex((l) => l[a.value.value] === n.value[o]))), h = (e, o) => {
      if (n.value[e] !== o) {
        const l = n.value.slice(0);
        l[e] = o, n.value = l;
      }
    }, v = () => ({
      selectedValues: n.value.slice(0),
      selectedOptions: E.value,
      selectedIndexes: x.value
    }), K = (e, o) => {
      h(o, e), C.value === "cascade" && n.value.forEach((l, _) => {
        const g = s.value[_];
        w(g, l, a.value) || h(_, g.length ? g[0][a.value.value] : void 0);
      }), N(() => {
        r("change", f({
          columnIndex: o
        }, v()));
      });
    }, $ = (e, o) => {
      const l = {
        columnIndex: o,
        currentOption: e
      };
      r("clickOption", f(v(), l)), r("scrollInto", l);
    }, T = () => {
      I.forEach((o) => o.stopMomentum());
      const e = v();
      return N(() => {
        r("confirm", e);
      }), e;
    }, F = () => r("cancel", v()), M = () => s.value.map((e, o) => c(le, {
      value: n.value[o],
      fields: a.value,
      options: e,
      readonly: t.readonly,
      allowHtml: t.allowHtml,
      optionHeight: d.value,
      swipeDuration: t.swipeDuration,
      visibleOptionNum: t.visibleOptionNum,
      onChange: (l) => K(l, o),
      onClickOption: (l) => $(l, o),
      onScrollInto: (l) => {
        r("scrollInto", {
          currentOption: l,
          columnIndex: o
        });
      }
    }, {
      option: i.option
    })), L = (e) => {
      if (y.value) {
        const o = {
          height: `${d.value}px`
        }, l = {
          backgroundSize: `100% ${(e - d.value) / 2}px`
        };
        return [c("div", {
          class: m("mask"),
          style: l
        }, null), c("div", {
          class: [ce, m("frame")],
          style: o
        }, null)];
      }
    }, U = () => {
      const e = d.value * +t.visibleOptionNum, o = {
        height: `${e}px`
      };
      return !t.loading && !y.value && i.empty ? i.empty() : c("div", {
        ref: P,
        class: m("columns"),
        style: o
      }, [M(), L(e)]);
    }, S = () => {
      if (t.showToolbar && !D)
        return c(ne, j(H(t, ie), {
          onConfirm: T,
          onCancel: F
        }), H(i, re));
    };
    O(s, (e) => {
      e.forEach((o, l) => {
        o.length && !w(o, n.value[l], a.value) && h(l, Q(o)[a.value.value]);
      });
    }, {
      immediate: !0
    });
    let p;
    return O(() => t.modelValue, (e) => {
      !b(e, n.value) && !b(e, p) && (n.value = e.slice(0), p = e.slice(0));
    }, {
      deep: !0
    }), O(n, (e) => {
      b(e, t.modelValue) || (p = e.slice(0), r("update:modelValue", p));
    }, {
      immediate: !0
    }), Z("touchmove", ve, {
      target: P
    }), ee({
      confirm: T,
      getSelectedOptions: () => E.value
    }), () => {
      var e, o;
      return c("div", {
        class: m()
      }, [t.toolbarPosition === "top" ? S() : null, t.loading ? c(oe, {
        class: m("loading")
      }, null) : null, (e = i["columns-top"]) == null ? void 0 : e.call(i), U(), (o = i["columns-bottom"]) == null ? void 0 : o.call(i), t.toolbarPosition === "bottom" ? S() : null]);
    };
  }
});
export {
  we as default,
  fe as pickerProps,
  pe as pickerSharedProps
};
