import { defineComponent as L, ref as w, computed as R, watch as K, nextTick as G, onMounted as F, onActivated as N, onDeactivated as $, provide as H, createVNode as l, Teleport as M, Fragment as U, mergeProps as O, Transition as V, withDirectives as Y, vShow as Z } from "vue";
import { popupSharedProps as j } from "./shared.js";
import { useEventListener as q } from "../../../@vant/use/dist/index.esm.js";
import { useExpose as J } from "../composables/use-expose.js";
import { useLockScroll as Q } from "../composables/use-lock-scroll.js";
import { useLazyRender as W } from "../composables/use-lazy-render.js";
import { POPUP_TOGGLE_KEY as X } from "../composables/on-popup-reopen.js";
import { useGlobalZIndex as ee } from "../composables/use-global-z-index.js";
import { useScopeId as p } from "../composables/use-scope-id.js";
import { Icon as oe } from "../icon/index.js";
import { Overlay as ne } from "../overlay/index.js";
import { callInterceptor as te } from "../utils/interceptor.js";
import { HAPTICS_FEEDBACK as ae } from "../utils/constant.js";
import { extend as le, isDef as re } from "../utils/basic.js";
import { makeStringProp as v } from "../utils/props.js";
import { createNamespace as ie } from "../utils/create.js";
const se = le({}, j, {
  round: Boolean,
  position: v("center"),
  closeIcon: v("cross"),
  closeable: Boolean,
  transition: String,
  iconPrefix: String,
  closeOnPopstate: Boolean,
  closeIconPosition: v("top-right"),
  destroyOnClose: Boolean,
  safeAreaInsetTop: Boolean,
  safeAreaInsetBottom: Boolean
}), [ce, x] = ie("popup");
var Ae = L({
  name: ce,
  inheritAttrs: !1,
  props: se,
  emits: ["open", "close", "opened", "closed", "keydown", "update:show", "clickOverlay", "clickCloseIcon"],
  setup(e, {
    emit: n,
    attrs: y,
    slots: d
  }) {
    let a, r;
    const f = w(), i = w(), P = W(() => e.show || !e.lazyRender), b = R(() => {
      const o = {
        zIndex: f.value
      };
      if (re(e.duration)) {
        const t = e.position === "center" ? "animationDuration" : "transitionDuration";
        o[t] = `${e.duration}s`;
      }
      return o;
    }), I = () => {
      a || (a = !0, f.value = e.zIndex !== void 0 ? +e.zIndex : ee(), n("open"));
    }, s = () => {
      a && te(e.beforeClose, {
        done() {
          a = !1, n("close"), n("update:show", !1);
        }
      });
    }, A = (o) => {
      n("clickOverlay", o), e.closeOnClickOverlay && s();
    }, C = () => {
      if (e.overlay)
        return l(ne, O({
          show: e.show,
          class: e.overlayClass,
          zIndex: f.value,
          duration: e.duration,
          customStyle: e.overlayStyle,
          role: e.closeOnClickOverlay ? "button" : void 0,
          tabindex: e.closeOnClickOverlay ? 0 : void 0
        }, p(), {
          onClick: A
        }), {
          default: d["overlay-content"]
        });
    }, S = (o) => {
      n("clickCloseIcon", o), s();
    }, T = () => {
      if (e.closeable)
        return l(oe, {
          role: "button",
          tabindex: 0,
          name: e.closeIcon,
          class: [x("close-icon", e.closeIconPosition), ae],
          classPrefix: e.iconPrefix,
          onClick: S
        }, null);
    };
    let u;
    const B = () => {
      u && clearTimeout(u), u = setTimeout(() => {
        n("opened");
      });
    }, z = () => n("closed"), g = (o) => n("keydown", o), E = P(() => {
      var o;
      const {
        destroyOnClose: t,
        round: m,
        position: c,
        safeAreaInsetTop: D,
        safeAreaInsetBottom: _,
        show: k
      } = e;
      if (!(!k && t))
        return Y(l("div", O({
          ref: i,
          style: b.value,
          role: "dialog",
          tabindex: 0,
          class: [x({
            round: m,
            [c]: c
          }), {
            "van-safe-area-top": D,
            "van-safe-area-bottom": _
          }],
          onKeydown: g
        }, y, p()), [(o = d.default) == null ? void 0 : o.call(d), T()]), [[Z, k]]);
    }), h = () => {
      const {
        position: o,
        transition: t,
        transitionAppear: m
      } = e, c = o === "center" ? "van-fade" : `van-popup-slide-${o}`;
      return l(V, {
        name: t || c,
        appear: m,
        onAfterEnter: B,
        onAfterLeave: z
      }, {
        default: E
      });
    };
    return K(() => e.show, (o) => {
      o && !a && (I(), y.tabindex === 0 && G(() => {
        var t;
        (t = i.value) == null || t.focus();
      })), !o && a && (a = !1, n("close"));
    }), J({
      popupRef: i
    }), Q(i, () => e.show && e.lockScroll), q("popstate", () => {
      e.closeOnPopstate && (s(), r = !1);
    }), F(() => {
      e.show && I();
    }), N(() => {
      r && (n("update:show", !0), r = !1);
    }), $(() => {
      e.show && e.teleport && (s(), r = !0);
    }), H(X, () => e.show), () => e.teleport ? l(M, {
      to: e.teleport
    }, {
      default: () => [C(), h()]
    }) : l(U, null, [C(), h()]);
  }
});
export {
  Ae as default,
  se as popupProps
};
