import N, { TRANSFORMABLE_PROPS as U } from "./core/Transformable.js";
import W, { cloneValue as V } from "./animation/Animator.js";
import b from "./core/BoundingRect.js";
import j from "./core/Eventful.js";
import { calculateTextPosition as K, parsePercent as E } from "./contain/text.js";
import { reduce as O, extend as x, isObject as F, keys as Y, indexOf as P, logError as k, mixin as X, isArrayLike as w, isGradientObject as tt, filter as M, guid as it, isTypedArray as rt } from "./core/util.js";
import { LIGHT_LABEL_COLOR as et, DARK_LABEL_COLOR as ot } from "./config.js";
import { parse as nt, stringify as st } from "./tool/color.js";
import { REDRAW_BIT as R } from "./graphic/constants.js";
var z = "__zr_normal__", H = U.concat(["ignore"]), at = O(U, function(e, t) {
  return e[t] = !0, e;
}, { ignore: !1 }), C = {}, ht = new b(0, 0, 0, 0), Z = function() {
  function e(t) {
    this.id = it(), this.animators = [], this.currentStates = [], this.states = {}, this._init(t);
  }
  return e.prototype._init = function(t) {
    this.attr(t);
  }, e.prototype.drift = function(t, i, r) {
    switch (this.draggable) {
      case "horizontal":
        i = 0;
        break;
      case "vertical":
        t = 0;
        break;
    }
    var n = this.transform;
    n || (n = this.transform = [1, 0, 0, 1, 0, 0]), n[4] += t, n[5] += i, this.decomposeTransform(), this.markRedraw();
  }, e.prototype.beforeUpdate = function() {
  }, e.prototype.afterUpdate = function() {
  }, e.prototype.update = function() {
    this.updateTransform(), this.__dirty && this.updateInnerText();
  }, e.prototype.updateInnerText = function(t) {
    var i = this._textContent;
    if (i && (!i.ignore || t)) {
      this.textConfig || (this.textConfig = {});
      var r = this.textConfig, n = r.local, o = i.innerTransformable, s = void 0, u = void 0, a = !1;
      o.parent = n ? this : null;
      var p = !1;
      if (o.copyTransform(i), r.position != null) {
        var h = ht;
        r.layoutRect ? h.copy(r.layoutRect) : h.copy(this.getBoundingRect()), n || h.applyTransform(this.transform), this.calculateTextPosition ? this.calculateTextPosition(C, r, h) : K(C, r, h), o.x = C.x, o.y = C.y, s = C.align, u = C.verticalAlign;
        var v = r.origin;
        if (v && r.rotation != null) {
          var l = void 0, m = void 0;
          v === "center" ? (l = h.width * 0.5, m = h.height * 0.5) : (l = E(v[0], h.width), m = E(v[1], h.height)), p = !0, o.originX = -o.x + l + (n ? 0 : h.x), o.originY = -o.y + m + (n ? 0 : h.y);
        }
      }
      r.rotation != null && (o.rotation = r.rotation);
      var _ = r.offset;
      _ && (o.x += _[0], o.y += _[1], p || (o.originX = -_[0], o.originY = -_[1]));
      var d = r.inside == null ? typeof r.position == "string" && r.position.indexOf("inside") >= 0 : r.inside, c = this._innerTextDefaultStyle || (this._innerTextDefaultStyle = {}), f = void 0, g = void 0, y = void 0;
      d && this.canBeInsideText() ? (f = r.insideFill, g = r.insideStroke, (f == null || f === "auto") && (f = this.getInsideTextFill()), (g == null || g === "auto") && (g = this.getInsideTextStroke(f), y = !0)) : (f = r.outsideFill, g = r.outsideStroke, (f == null || f === "auto") && (f = this.getOutsideFill()), (g == null || g === "auto") && (g = this.getOutsideStroke(f), y = !0)), f = f || "#000", (f !== c.fill || g !== c.stroke || y !== c.autoStroke || s !== c.align || u !== c.verticalAlign) && (a = !0, c.fill = f, c.stroke = g, c.autoStroke = y, c.align = s, c.verticalAlign = u, i.setDefaultTextStyle(c)), i.__dirty |= R, a && i.dirtyStyle(!0);
    }
  }, e.prototype.canBeInsideText = function() {
    return !0;
  }, e.prototype.getInsideTextFill = function() {
    return "#fff";
  }, e.prototype.getInsideTextStroke = function(t) {
    return "#000";
  }, e.prototype.getOutsideFill = function() {
    return this.__zr && this.__zr.isDarkMode() ? et : ot;
  }, e.prototype.getOutsideStroke = function(t) {
    var i = this.__zr && this.__zr.getBackgroundColor(), r = typeof i == "string" && nt(i);
    r || (r = [255, 255, 255, 1]);
    for (var n = r[3], o = this.__zr.isDarkMode(), s = 0; s < 3; s++)
      r[s] = r[s] * n + (o ? 0 : 255) * (1 - n);
    return r[3] = 1, st(r, "rgba");
  }, e.prototype.traverse = function(t, i) {
  }, e.prototype.attrKV = function(t, i) {
    t === "textConfig" ? this.setTextConfig(i) : t === "textContent" ? this.setTextContent(i) : t === "clipPath" ? this.setClipPath(i) : t === "extra" ? (this.extra = this.extra || {}, x(this.extra, i)) : this[t] = i;
  }, e.prototype.hide = function() {
    this.ignore = !0, this.markRedraw();
  }, e.prototype.show = function() {
    this.ignore = !1, this.markRedraw();
  }, e.prototype.attr = function(t, i) {
    if (typeof t == "string")
      this.attrKV(t, i);
    else if (F(t))
      for (var r = t, n = Y(r), o = 0; o < n.length; o++) {
        var s = n[o];
        this.attrKV(s, t[s]);
      }
    return this.markRedraw(), this;
  }, e.prototype.saveCurrentToNormalState = function(t) {
    this._innerSaveToNormal(t);
    for (var i = this._normalState, r = 0; r < this.animators.length; r++) {
      var n = this.animators[r], o = n.__fromStateTransition;
      if (!(n.getLoop() || o && o !== z)) {
        var s = n.targetName, u = s ? i[s] : i;
        n.saveTo(u);
      }
    }
  }, e.prototype._innerSaveToNormal = function(t) {
    var i = this._normalState;
    i || (i = this._normalState = {}), t.textConfig && !i.textConfig && (i.textConfig = this.textConfig), this._savePrimaryToNormal(t, i, H);
  }, e.prototype._savePrimaryToNormal = function(t, i, r) {
    for (var n = 0; n < r.length; n++) {
      var o = r[n];
      t[o] != null && !(o in i) && (i[o] = this[o]);
    }
  }, e.prototype.hasState = function() {
    return this.currentStates.length > 0;
  }, e.prototype.getState = function(t) {
    return this.states[t];
  }, e.prototype.ensureState = function(t) {
    var i = this.states;
    return i[t] || (i[t] = {}), i[t];
  }, e.prototype.clearStates = function(t) {
    this.useState(z, !1, t);
  }, e.prototype.useState = function(t, i, r, n) {
    var o = t === z, s = this.hasState();
    if (!(!s && o)) {
      var u = this.currentStates, a = this.stateTransition;
      if (!(P(u, t) >= 0 && (i || u.length === 1))) {
        var p;
        if (this.stateProxy && !o && (p = this.stateProxy(t)), p || (p = this.states && this.states[t]), !p && !o) {
          k("State " + t + " not exists.");
          return;
        }
        o || this.saveCurrentToNormalState(p);
        var h = !!(p && p.hoverLayer || n);
        h && this._toggleHoverLayerFlag(!0), this._applyStateObj(t, p, this._normalState, i, !r && !this.__inHover && a && a.duration > 0, a);
        var v = this._textContent, l = this._textGuide;
        return v && v.useState(t, i, r, h), l && l.useState(t, i, r, h), o ? (this.currentStates = [], this._normalState = {}) : i ? this.currentStates.push(t) : this.currentStates = [t], this._updateAnimationTargets(), this.markRedraw(), !h && this.__inHover && (this._toggleHoverLayerFlag(!1), this.__dirty &= ~R), p;
      }
    }
  }, e.prototype.useStates = function(t, i, r) {
    if (!t.length)
      this.clearStates();
    else {
      var n = [], o = this.currentStates, s = t.length, u = s === o.length;
      if (u) {
        for (var a = 0; a < s; a++)
          if (t[a] !== o[a]) {
            u = !1;
            break;
          }
      }
      if (u)
        return;
      for (var a = 0; a < s; a++) {
        var p = t[a], h = void 0;
        this.stateProxy && (h = this.stateProxy(p, t)), h || (h = this.states[p]), h && n.push(h);
      }
      var v = n[s - 1], l = !!(v && v.hoverLayer || r);
      l && this._toggleHoverLayerFlag(!0);
      var m = this._mergeStates(n), _ = this.stateTransition;
      this.saveCurrentToNormalState(m), this._applyStateObj(t.join(","), m, this._normalState, !1, !i && !this.__inHover && _ && _.duration > 0, _);
      var d = this._textContent, c = this._textGuide;
      d && d.useStates(t, i, l), c && c.useStates(t, i, l), this._updateAnimationTargets(), this.currentStates = t.slice(), this.markRedraw(), !l && this.__inHover && (this._toggleHoverLayerFlag(!1), this.__dirty &= ~R);
    }
  }, e.prototype.isSilent = function() {
    for (var t = this.silent, i = this.parent; !t && i; ) {
      if (i.silent) {
        t = !0;
        break;
      }
      i = i.parent;
    }
    return t;
  }, e.prototype._updateAnimationTargets = function() {
    for (var t = 0; t < this.animators.length; t++) {
      var i = this.animators[t];
      i.targetName && i.changeTarget(this[i.targetName]);
    }
  }, e.prototype.removeState = function(t) {
    var i = P(this.currentStates, t);
    if (i >= 0) {
      var r = this.currentStates.slice();
      r.splice(i, 1), this.useStates(r);
    }
  }, e.prototype.replaceState = function(t, i, r) {
    var n = this.currentStates.slice(), o = P(n, t), s = P(n, i) >= 0;
    o >= 0 ? s ? n.splice(o, 1) : n[o] = i : r && !s && n.push(i), this.useStates(n);
  }, e.prototype.toggleState = function(t, i) {
    i ? this.useState(t, !0) : this.removeState(t);
  }, e.prototype._mergeStates = function(t) {
    for (var i = {}, r, n = 0; n < t.length; n++) {
      var o = t[n];
      x(i, o), o.textConfig && (r = r || {}, x(r, o.textConfig));
    }
    return r && (i.textConfig = r), i;
  }, e.prototype._applyStateObj = function(t, i, r, n, o, s) {
    var u = !(i && n);
    i && i.textConfig ? (this.textConfig = x({}, n ? this.textConfig : r.textConfig), x(this.textConfig, i.textConfig)) : u && r.textConfig && (this.textConfig = r.textConfig);
    for (var a = {}, p = !1, h = 0; h < H.length; h++) {
      var v = H[h], l = o && at[v];
      i && i[v] != null ? l ? (p = !0, a[v] = i[v]) : this[v] = i[v] : u && r[v] != null && (l ? (p = !0, a[v] = r[v]) : this[v] = r[v]);
    }
    if (!o)
      for (var h = 0; h < this.animators.length; h++) {
        var m = this.animators[h], _ = m.targetName;
        m.getLoop() || m.__changeFinalValue(_ ? (i || r)[_] : i || r);
      }
    p && this._transitionState(t, a, s);
  }, e.prototype._attachComponent = function(t) {
    if (!(t.__zr && !t.__hostTarget) && t !== this) {
      var i = this.__zr;
      i && t.addSelfToZr(i), t.__zr = i, t.__hostTarget = this;
    }
  }, e.prototype._detachComponent = function(t) {
    t.__zr && t.removeSelfFromZr(t.__zr), t.__zr = null, t.__hostTarget = null;
  }, e.prototype.getClipPath = function() {
    return this._clipPath;
  }, e.prototype.setClipPath = function(t) {
    this._clipPath && this._clipPath !== t && this.removeClipPath(), this._attachComponent(t), this._clipPath = t, this.markRedraw();
  }, e.prototype.removeClipPath = function() {
    var t = this._clipPath;
    t && (this._detachComponent(t), this._clipPath = null, this.markRedraw());
  }, e.prototype.getTextContent = function() {
    return this._textContent;
  }, e.prototype.setTextContent = function(t) {
    var i = this._textContent;
    i !== t && (i && i !== t && this.removeTextContent(), t.innerTransformable = new N(), this._attachComponent(t), this._textContent = t, this.markRedraw());
  }, e.prototype.setTextConfig = function(t) {
    this.textConfig || (this.textConfig = {}), x(this.textConfig, t), this.markRedraw();
  }, e.prototype.removeTextConfig = function() {
    this.textConfig = null, this.markRedraw();
  }, e.prototype.removeTextContent = function() {
    var t = this._textContent;
    t && (t.innerTransformable = null, this._detachComponent(t), this._textContent = null, this._innerTextDefaultStyle = null, this.markRedraw());
  }, e.prototype.getTextGuideLine = function() {
    return this._textGuide;
  }, e.prototype.setTextGuideLine = function(t) {
    this._textGuide && this._textGuide !== t && this.removeTextGuideLine(), this._attachComponent(t), this._textGuide = t, this.markRedraw();
  }, e.prototype.removeTextGuideLine = function() {
    var t = this._textGuide;
    t && (this._detachComponent(t), this._textGuide = null, this.markRedraw());
  }, e.prototype.markRedraw = function() {
    this.__dirty |= R;
    var t = this.__zr;
    t && (this.__inHover ? t.refreshHover() : t.refresh()), this.__hostTarget && this.__hostTarget.markRedraw();
  }, e.prototype.dirty = function() {
    this.markRedraw();
  }, e.prototype._toggleHoverLayerFlag = function(t) {
    this.__inHover = t;
    var i = this._textContent, r = this._textGuide;
    i && (i.__inHover = t), r && (r.__inHover = t);
  }, e.prototype.addSelfToZr = function(t) {
    if (this.__zr !== t) {
      this.__zr = t;
      var i = this.animators;
      if (i)
        for (var r = 0; r < i.length; r++)
          t.animation.addAnimator(i[r]);
      this._clipPath && this._clipPath.addSelfToZr(t), this._textContent && this._textContent.addSelfToZr(t), this._textGuide && this._textGuide.addSelfToZr(t);
    }
  }, e.prototype.removeSelfFromZr = function(t) {
    if (this.__zr) {
      this.__zr = null;
      var i = this.animators;
      if (i)
        for (var r = 0; r < i.length; r++)
          t.animation.removeAnimator(i[r]);
      this._clipPath && this._clipPath.removeSelfFromZr(t), this._textContent && this._textContent.removeSelfFromZr(t), this._textGuide && this._textGuide.removeSelfFromZr(t);
    }
  }, e.prototype.animate = function(t, i, r) {
    var n = t ? this[t] : this, o = new W(n, i, r);
    return t && (o.targetName = t), this.addAnimator(o, t), o;
  }, e.prototype.addAnimator = function(t, i) {
    var r = this.__zr, n = this;
    t.during(function() {
      n.updateDuringAnimation(i);
    }).done(function() {
      var o = n.animators, s = P(o, t);
      s >= 0 && o.splice(s, 1);
    }), this.animators.push(t), r && r.animation.addAnimator(t), r && r.wakeUp();
  }, e.prototype.updateDuringAnimation = function(t) {
    this.markRedraw();
  }, e.prototype.stopAnimation = function(t, i) {
    for (var r = this.animators, n = r.length, o = [], s = 0; s < n; s++) {
      var u = r[s];
      !t || t === u.scope ? u.stop(i) : o.push(u);
    }
    return this.animators = o, this;
  }, e.prototype.animateTo = function(t, i, r) {
    B(this, t, i, r);
  }, e.prototype.animateFrom = function(t, i, r) {
    B(this, t, i, r, !0);
  }, e.prototype._transitionState = function(t, i, r, n) {
    for (var o = B(this, i, r, n), s = 0; s < o.length; s++)
      o[s].__fromStateTransition = t;
  }, e.prototype.getBoundingRect = function() {
    return null;
  }, e.prototype.getPaintRect = function() {
    return null;
  }, e.initDefaultProps = function() {
    var t = e.prototype;
    t.type = "element", t.name = "", t.ignore = t.silent = t.isGroup = t.draggable = t.dragging = t.ignoreClip = t.__inHover = !1, t.__dirty = R;
    function i(r, n, o, s) {
      Object.defineProperty(t, r, {
        get: function() {
          if (!this[n]) {
            var a = this[n] = [];
            u(this, a);
          }
          return this[n];
        },
        set: function(a) {
          this[o] = a[0], this[s] = a[1], this[n] = a, u(this, a);
        }
      });
      function u(a, p) {
        Object.defineProperty(p, 0, {
          get: function() {
            return a[o];
          },
          set: function(h) {
            a[o] = h;
          }
        }), Object.defineProperty(p, 1, {
          get: function() {
            return a[s];
          },
          set: function(h) {
            a[s] = h;
          }
        });
      }
    }
    Object.defineProperty && (i("position", "_legacyPos", "x", "y"), i("scale", "_legacyScale", "scaleX", "scaleY"), i("origin", "_legacyOrigin", "originX", "originY"));
  }(), e;
}();
X(Z, j);
X(Z, N);
function B(e, t, i, r, n) {
  i = i || {};
  var o = [];
  $(e, "", e, t, i, r, o, n);
  var s = o.length, u = !1, a = i.done, p = i.aborted, h = function() {
    u = !0, s--, s <= 0 && (u ? a && a() : p && p());
  }, v = function() {
    s--, s <= 0 && (u ? a && a() : p && p());
  };
  s || a && a(), o.length > 0 && i.during && o[0].during(function(_, d) {
    i.during(d);
  });
  for (var l = 0; l < o.length; l++) {
    var m = o[l];
    h && m.done(h), v && m.aborted(v), i.force && m.duration(i.duration), m.start(i.easing);
  }
  return o;
}
function I(e, t, i) {
  for (var r = 0; r < i; r++)
    e[r] = t[r];
}
function ft(e) {
  return w(e[0]);
}
function ut(e, t, i) {
  if (w(t[i]))
    if (w(e[i]) || (e[i] = []), rt(t[i])) {
      var r = t[i].length;
      e[i].length !== r && (e[i] = new t[i].constructor(r), I(e[i], t[i], r));
    } else {
      var n = t[i], o = e[i], s = n.length;
      if (ft(n))
        for (var u = n[0].length, a = 0; a < s; a++)
          o[a] ? I(o[a], n[a], u) : o[a] = Array.prototype.slice.call(n[a]);
      else
        I(o, n, s);
      o.length = n.length;
    }
  else
    e[i] = t[i];
}
function pt(e, t) {
  return e === t || w(e) && w(t) && vt(e, t);
}
function vt(e, t) {
  var i = e.length;
  if (i !== t.length)
    return !1;
  for (var r = 0; r < i; r++)
    if (e[r] !== t[r])
      return !1;
  return !0;
}
function $(e, t, i, r, n, o, s, u) {
  for (var a = Y(r), p = n.duration, h = n.delay, v = n.additive, l = n.setToFinal, m = !F(o), _ = e.animators, d = [], c = 0; c < a.length; c++) {
    var f = a[c], g = r[f];
    if (g != null && i[f] != null && (m || o[f]))
      if (F(g) && !w(g) && !tt(g)) {
        if (t) {
          u || (i[f] = g, e.updateDuringAnimation(t));
          continue;
        }
        $(e, f, i[f], g, n, o && o[f], s, u);
      } else
        d.push(f);
    else
      u || (i[f] = g, e.updateDuringAnimation(t), d.push(f));
  }
  var y = d.length;
  if (!v && y)
    for (var T = 0; T < _.length; T++) {
      var S = _[T];
      if (S.targetName === t) {
        var q = S.stopTracks(d);
        if (q) {
          var J = P(_, S);
          _.splice(J, 1);
        }
      }
    }
  if (n.force || (d = M(d, function(D) {
    return !pt(r[D], i[D]);
  }), y = d.length), y > 0 || n.force && !s.length) {
    var A = void 0, L = void 0, G = void 0;
    if (u) {
      L = {}, l && (A = {});
      for (var T = 0; T < y; T++) {
        var f = d[T];
        L[f] = i[f], l ? A[f] = r[f] : i[f] = r[f];
      }
    } else if (l) {
      G = {};
      for (var T = 0; T < y; T++) {
        var f = d[T];
        G[f] = V(i[f]), ut(i, r, f);
      }
    }
    var S = new W(i, !1, !1, v ? M(_, function(Q) {
      return Q.targetName === t;
    }) : null);
    S.targetName = t, n.scope && (S.scope = n.scope), l && A && S.whenWithKeys(0, A, d), G && S.whenWithKeys(0, G, d), S.whenWithKeys(p ?? 500, u ? L : r, d).delay(h || 0), e.addAnimator(S, t), s.push(S);
  }
}
const xt = Z;
export {
  z as PRESERVED_NORMAL_STATE,
  xt as default
};
