import { brush as T, setClipPath as B, setGradient as D, setPattern as R } from "./graphic.js";
import { createBrushScope as x, createVNode as l, getCssString as U, createSVGVNode as S, vNodeToString as A, createElement as P } from "./core.js";
import { isPattern as L, encodeBase64 as z, isGradient as C, normalizeColor as H } from "./helper.js";
import { map as M, keys as k, retrieve2 as g, noop as I, extend as O } from "../core/util.js";
import E, { updateAttrs as F } from "./patch.js";
import { getSize as G } from "../canvas/helper.js";
var W = 0, $ = function() {
  function o(t, e, r) {
    if (this.type = "svg", this.refreshHover = b(), this.configLayer = b(), this.storage = e, this._opts = r = O({}, r), this.root = t, this._id = "zr" + W++, this._oldVNode = S(r.width, r.height), t && !r.ssr) {
      var s = this._viewport = document.createElement("div");
      s.style.cssText = "position:relative;overflow:hidden";
      var i = this._svgDom = this._oldVNode.elm = P("svg");
      F(null, this._oldVNode), s.appendChild(i), t.appendChild(s);
    }
    this.resize(r.width, r.height);
  }
  return o.prototype.getType = function() {
    return this.type;
  }, o.prototype.getViewportRoot = function() {
    return this._viewport;
  }, o.prototype.getViewportRootOffset = function() {
    var t = this.getViewportRoot();
    if (t)
      return {
        offsetLeft: t.offsetLeft || 0,
        offsetTop: t.offsetTop || 0
      };
  }, o.prototype.getSvgDom = function() {
    return this._svgDom;
  }, o.prototype.refresh = function() {
    if (this.root) {
      var t = this.renderToVNode({
        willUpdate: !0
      });
      t.attrs.style = "position:absolute;left:0;top:0;user-select:none", E(this._oldVNode, t), this._oldVNode = t;
    }
  }, o.prototype.renderOneToVNode = function(t) {
    return T(t, x(this._id));
  }, o.prototype.renderToVNode = function(t) {
    t = t || {};
    var e = this.storage.getDisplayList(!0), r = this._width, s = this._height, i = x(this._id);
    i.animation = t.animation, i.willUpdate = t.willUpdate, i.compress = t.compress, i.emphasis = t.emphasis, i.ssr = this._opts.ssr;
    var h = [], n = this._bgVNode = j(r, s, this._backgroundColor, i);
    n && h.push(n);
    var a = t.compress ? null : this._mainVNode = l("g", "main", {}, []);
    this._paintList(e, i, a ? a.children : h), a && h.push(a);
    var v = M(k(i.defs), function(f) {
      return i.defs[f];
    });
    if (v.length && h.push(l("defs", "defs", {}, v)), t.animation) {
      var d = U(i.cssNodes, i.cssAnims, { newline: !0 });
      if (d) {
        var u = l("style", "stl", {}, [], d);
        h.push(u);
      }
    }
    return S(r, s, h, t.useViewBox);
  }, o.prototype.renderToString = function(t) {
    return t = t || {}, A(this.renderToVNode({
      animation: g(t.cssAnimation, !0),
      emphasis: g(t.cssEmphasis, !0),
      willUpdate: !1,
      compress: !0,
      useViewBox: g(t.useViewBox, !0)
    }), { newline: !0 });
  }, o.prototype.setBackgroundColor = function(t) {
    this._backgroundColor = t;
  }, o.prototype.getSvgRoot = function() {
    return this._mainVNode && this._mainVNode.elm;
  }, o.prototype._paintList = function(t, e, r) {
    for (var s = t.length, i = [], h = 0, n, a, v = 0, d = 0; d < s; d++) {
      var u = t[d];
      if (!u.invisible) {
        var f = u.__clipPaths, _ = f && f.length || 0, V = a && a.length || 0, p = void 0;
        for (p = Math.max(_ - 1, V - 1); p >= 0 && !(f && a && f[p] === a[p]); p--)
          ;
        for (var y = V - 1; y > p; y--)
          h--, n = i[h - 1];
        for (var c = p + 1; c < _; c++) {
          var N = {};
          B(f[c], N, e);
          var m = l("g", "clip-g-" + v++, N, []);
          (n ? n.children : r).push(m), i[h++] = m, n = m;
        }
        a = f;
        var w = T(u, e);
        w && (n ? n.children : r).push(w);
      }
    }
  }, o.prototype.resize = function(t, e) {
    var r = this._opts, s = this.root, i = this._viewport;
    if (t != null && (r.width = t), e != null && (r.height = e), s && i && (i.style.display = "none", t = G(s, 0, r), e = G(s, 1, r), i.style.display = ""), this._width !== t || this._height !== e) {
      if (this._width = t, this._height = e, i) {
        var h = i.style;
        h.width = t + "px", h.height = e + "px";
      }
      if (L(this._backgroundColor))
        this.refresh();
      else {
        var n = this._svgDom;
        n && (n.setAttribute("width", t), n.setAttribute("height", e));
        var a = this._bgVNode && this._bgVNode.elm;
        a && (a.setAttribute("width", t), a.setAttribute("height", e));
      }
    }
  }, o.prototype.getWidth = function() {
    return this._width;
  }, o.prototype.getHeight = function() {
    return this._height;
  }, o.prototype.dispose = function() {
    this.root && (this.root.innerHTML = ""), this._svgDom = this._viewport = this.storage = this._oldVNode = this._bgVNode = this._mainVNode = null;
  }, o.prototype.clear = function() {
    this._svgDom && (this._svgDom.innerHTML = null), this._oldVNode = null;
  }, o.prototype.toDataURL = function(t) {
    var e = this.renderToString(), r = "data:image/svg+xml;";
    return t ? (e = z(e), e && r + "base64," + e) : r + "charset=UTF-8," + encodeURIComponent(e);
  }, o;
}();
function b(o) {
  return function() {
  };
}
function j(o, t, e, r) {
  var s;
  if (e && e !== "none")
    if (s = l("rect", "bg", {
      width: o,
      height: t,
      x: "0",
      y: "0"
    }), C(e))
      D({ fill: e }, s.attrs, "fill", r);
    else if (L(e))
      R({
        style: {
          fill: e
        },
        dirty: I,
        getBoundingRect: function() {
          return { width: o, height: t };
        }
      }, s.attrs, "fill", r);
    else {
      var i = H(e), h = i.color, n = i.opacity;
      s.attrs.fill = h, n < 1 && (s.attrs["fill-opacity"] = n);
    }
  return s;
}
const Z = $;
export {
  Z as default
};
