import { copyTransform as mr } from "../core/Transformable.js";
import { createBrushScope as lr } from "./core.js";
import cr from "./SVGPathRebuilder.js";
import hr from "../core/PathProxy.js";
import { getSRTTransformString as dr, getPathPrecision as gr } from "./helper.js";
import { each as pr, keys as V, isString as tr, extend as X, filter as Ir, isNumber as Or } from "../core/util.js";
import Sr from "../graphic/CompoundPath.js";
import { createCubicEasingFunc as Ar } from "../animation/cubicEasing.js";
import { getClassId as br } from "./cssClassId.js";
var ar = {
  cubicIn: "0.32,0,0.67,0",
  cubicOut: "0.33,1,0.68,1",
  cubicInOut: "0.65,0,0.35,1",
  quadraticIn: "0.11,0,0.5,0",
  quadraticOut: "0.5,1,0.89,1",
  quadraticInOut: "0.45,0,0.55,1",
  quarticIn: "0.5,0,0.75,0",
  quarticOut: "0.25,1,0.5,1",
  quarticInOut: "0.76,0,0.24,1",
  quinticIn: "0.64,0,0.78,0",
  quinticOut: "0.22,1,0.36,1",
  quinticInOut: "0.83,0,0.17,1",
  sinusoidalIn: "0.12,0,0.39,0",
  sinusoidalOut: "0.61,1,0.88,1",
  sinusoidalInOut: "0.37,0,0.63,1",
  exponentialIn: "0.7,0,0.84,0",
  exponentialOut: "0.16,1,0.3,1",
  exponentialInOut: "0.87,0,0.13,1",
  circularIn: "0.55,0,1,0.45",
  circularOut: "0,0.55,0.45,1",
  circularInOut: "0.85,0,0.15,1"
}, g = "transform-origin";
function Tr(r, t, n) {
  var u = X({}, r.shape);
  X(u, t), r.buildPath(n, u);
  var e = new cr();
  return e.reset(gr(r)), n.rebuildPath(e, 1), e.generateStr(), e.getStr();
}
function xr(r, t) {
  var n = t.originX, u = t.originY;
  (n || u) && (r[g] = n + "px " + u + "px");
}
var Pr = {
  fill: "fill",
  opacity: "opacity",
  lineWidth: "stroke-width",
  lineDashOffset: "stroke-dashoffset"
};
function er(r, t) {
  var n = t.zrId + "-ani-" + t.cssAnimIdx++;
  return t.cssAnims[n] = r, n;
}
function qr(r, t, n) {
  var u = r.shape.paths, e = {}, l, v;
  if (pr(u, function(h) {
    var s = lr(n.zrId);
    s.animation = !0, Cr(h, {}, s, !0);
    var f = s.cssAnims, m = s.cssNodes, S = V(f), A = S.length;
    if (A) {
      v = S[A - 1];
      var d = f[v];
      for (var p in d) {
        var B = d[p];
        e[p] = e[p] || { d: "" }, e[p].d += B.d || "";
      }
      for (var P in m) {
        var b = m[P].animation;
        b.indexOf(v) >= 0 && (l = b);
      }
    }
  }), !!l) {
    t.d = !1;
    var c = er(e, n);
    return l.replace(v, c);
  }
}
function nr(r) {
  return tr(r) ? ar[r] ? "cubic-bezier(" + ar[r] + ")" : Ar(r) ? r : "" : "";
}
function Cr(r, t, n, u) {
  var e = r.animators, l = e.length, v = [];
  if (r instanceof Sr) {
    var c = qr(r, t, n);
    if (c)
      v.push(c);
    else if (!l)
      return;
  } else if (!l)
    return;
  for (var h = {}, s = 0; s < l; s++) {
    var f = e[s], m = [f.getMaxTime() / 1e3 + "s"], S = nr(f.getClip().easing), A = f.getDelay();
    S ? m.push(S) : m.push("linear"), A && m.push(A / 1e3 + "s"), f.getLoop() && m.push("infinite");
    var d = m.join(" ");
    h[d] = h[d] || [d, []], h[d][1].push(f);
  }
  function p(b) {
    var D = b[1], W = D.length, q = {}, C = {}, i = {}, T = "animation-timing-function";
    function F(w, z, Z) {
      for (var E = w.getTracks(), fr = w.getMaxTime(), K = 0; K < E.length; K++) {
        var L = E[K];
        if (L.needsAnimate()) {
          var $ = L.keyframes, Y = L.propName;
          if (Z && (Y = Z(Y)), Y)
            for (var R = 0; R < $.length; R++) {
              var _ = $[R], j = Math.round(_.time / fr * 100) + "%", rr = nr(_.easing), ir = _.rawValue;
              (tr(ir) || Or(ir)) && (z[j] = z[j] || {}, z[j][Y] = _.rawValue, rr && (z[j][T] = rr));
            }
        }
      }
    }
    for (var o = 0; o < W; o++) {
      var I = D[o], N = I.targetName;
      N ? N === "shape" && F(I, C) : !u && F(I, q);
    }
    for (var a in q) {
      var y = {};
      mr(y, r), X(y, q[a]);
      var k = dr(y), x = q[a][T];
      i[a] = k ? {
        transform: k
      } : {}, xr(i[a], y), x && (i[a][T] = x);
    }
    var O, H = !0;
    for (var a in C) {
      i[a] = i[a] || {};
      var J = !O, x = C[a][T];
      J && (O = new hr());
      var or = O.len();
      O.reset(), i[a].d = Tr(r, C[a], O);
      var ur = O.len();
      if (!J && or !== ur) {
        H = !1;
        break;
      }
      x && (i[a][T] = x);
    }
    if (!H)
      for (var a in i)
        delete i[a].d;
    if (!u)
      for (var o = 0; o < W; o++) {
        var I = D[o], N = I.targetName;
        N === "style" && F(I, i, function(E) {
          return Pr[E];
        });
      }
    for (var M = V(i), Q = !0, G, o = 1; o < M.length; o++) {
      var U = M[o - 1], vr = M[o];
      if (i[U][g] !== i[vr][g]) {
        Q = !1;
        break;
      }
      G = i[U][g];
    }
    if (Q && G) {
      for (var a in i)
        i[a][g] && delete i[a][g];
      t[g] = G;
    }
    if (Ir(M, function(w) {
      return V(i[w]).length > 0;
    }).length) {
      var sr = er(i, n);
      return sr + " " + b[0] + " both";
    }
  }
  for (var B in h) {
    var c = p(h[B]);
    c && v.push(c);
  }
  if (v.length) {
    var P = n.zrId + "-cls-" + br();
    n.cssNodes["." + P] = {
      animation: v.join(",")
    }, t.class = P;
  }
}
export {
  Pr as ANIMATE_STYLE_MAP,
  ar as EASING_MAP,
  Cr as createCSSAnimation
};
