import { isLinearGradient as $, isRadialGradient as H, round4 as W, normalizeColor as Z, getIdURL as D, isImagePattern as rr, getSRTTransformString as tr, getPathPrecision as ar, adjustTextY as nr, TEXT_ALIGN_TO_ANCHOR as ir, isGradient as er, isPattern as or, getMatrixStr as fr, hasShadow as sr, getShadowKey as vr, isAroundZero as T } from "./helper.js";
import hr from "../graphic/Path.js";
import ur from "../graphic/Image.js";
import { getLineHeight as dr } from "../contain/text.js";
import pr from "../graphic/TSpan.js";
import lr from "./SVGPathRebuilder.js";
import cr from "./mapStyleToAttrs.js";
import { vNodeToString as B, createVNode as g, META_DATA_PREFIX as j } from "./core.js";
import { retrieve2 as G, isString as N, assert as E, clone as yr, isFunction as gr, map as mr } from "../core/util.js";
import { createOrUpdateImage as Sr } from "../graphic/helper/image.js";
import { createCSSAnimation as F } from "./cssAnimation.js";
import { hasSeparateFont as xr, parseFontSize as Pr } from "../graphic/Text.js";
import { DEFAULT_FONT as wr, DEFAULT_FONT_FAMILY as Ar } from "../core/platform.js";
import { createCSSEmphasis as Tr } from "./cssEmphasis.js";
import { getElementSSRData as br } from "../zrender.js";
var b = Math.round;
function q(r) {
  return r && N(r.src);
}
function J(r) {
  return r && gr(r.toDataURL);
}
function O(r, i, t, a) {
  cr(function(n, e) {
    var o = n === "fill" || n === "stroke";
    o && er(e) ? Fr(i, r, n, a) : o && or(e) ? Or(t, r, n, a) : r[n] = e, o && a.ssr && e === "none" && (r["pointer-events"] = "visible");
  }, i, t, !1), Nr(t, r, a);
}
function V(r, i) {
  var t = br(i);
  t && (t.each(function(a, n) {
    a != null && (r[(j + n).toLowerCase()] = a + "");
  }), i.isSilent() && (r[j + "silent"] = "true"));
}
function K(r) {
  return T(r[0] - 1) && T(r[1]) && T(r[2]) && T(r[3] - 1);
}
function Cr(r) {
  return T(r[4]) && T(r[5]);
}
function z(r, i, t) {
  if (i && !(Cr(i) && K(i))) {
    var a = t ? 10 : 1e4;
    r.transform = K(i) ? "translate(" + b(i[4] * a) / a + " " + b(i[5] * a) / a + ")" : fr(i);
  }
}
function X(r, i, t) {
  for (var a = r.points, n = [], e = 0; e < a.length; e++)
    n.push(b(a[e][0] * t) / t), n.push(b(a[e][1] * t) / t);
  i.points = n.join(" ");
}
function Y(r) {
  return !r.smooth;
}
function Rr(r) {
  var i = mr(r, function(t) {
    return typeof t == "string" ? [t, t] : t;
  });
  return function(t, a, n) {
    for (var e = 0; e < i.length; e++) {
      var o = i[e], s = t[o[0]];
      s != null && (a[o[1]] = b(s * n) / n);
    }
  };
}
var Dr = {
  circle: [Rr(["cx", "cy", "r"])],
  polyline: [X, Y],
  polygon: [X, Y]
};
function Lr(r) {
  for (var i = r.animators, t = 0; t < i.length; t++)
    if (i[t].targetName === "shape")
      return !0;
  return !1;
}
function Q(r, i) {
  var t = r.style, a = r.shape, n = Dr[r.type], e = {}, o = i.animation, s = "path", f = r.style.strokePercent, v = i.compress && ar(r) || 4;
  if (n && !i.willUpdate && !(n[1] && !n[1](a)) && !(o && Lr(r)) && !(f < 1)) {
    s = r.type;
    var y = Math.pow(10, v);
    n[0](a, e, y);
  } else {
    var l = !r.path || r.shapeChanged();
    r.path || r.createPathProxy();
    var u = r.path;
    l && (u.beginPath(), r.buildPath(u, r.shape), r.pathUpdated());
    var h = u.getVersion(), p = r, d = p.__svgPathBuilder;
    (p.__svgPathVersion !== h || !d || f !== p.__svgPathStrokePercent) && (d || (d = p.__svgPathBuilder = new lr()), d.reset(v), u.rebuildPath(d, f), d.generateStr(), p.__svgPathVersion = h, p.__svgPathStrokePercent = f), e.d = d.getStr();
  }
  return z(e, r.transform), O(e, t, r, i), V(e, r), i.animation && F(r, e, i), i.emphasis && Tr(r, e, i), g(s, r.id + "", e);
}
function Ur(r, i) {
  var t = r.style, a = t.image;
  if (a && !N(a) && (q(a) ? a = a.src : J(a) && (a = a.toDataURL())), !!a) {
    var n = t.x || 0, e = t.y || 0, o = t.width, s = t.height, f = {
      href: a,
      width: o,
      height: s
    };
    return n && (f.x = n), e && (f.y = e), z(f, r.transform), O(f, t, r, i), V(f, r), i.animation && F(r, f, i), g("image", r.id + "", f);
  }
}
function Gr(r, i) {
  var t = r.style, a = t.text;
  if (a != null && (a += ""), !(!a || isNaN(t.x) || isNaN(t.y))) {
    var n = t.font || wr, e = t.x || 0, o = nr(t.y || 0, dr(n), t.textBaseline), s = ir[t.textAlign] || t.textAlign, f = {
      "dominant-baseline": "central",
      "text-anchor": s
    };
    if (xr(t)) {
      var v = "", y = t.fontStyle, l = Pr(t.fontSize);
      if (!parseFloat(l))
        return;
      var u = t.fontFamily || Ar, h = t.fontWeight;
      v += "font-size:" + l + ";font-family:" + u + ";", y && y !== "normal" && (v += "font-style:" + y + ";"), h && h !== "normal" && (v += "font-weight:" + h + ";"), f.style = v;
    } else
      f.style = "font: " + n;
    return a.match(/\s/) && (f["xml:space"] = "preserve"), e && (f.x = e), o && (f.y = o), z(f, r.transform), O(f, t, r, i), V(f, r), i.animation && F(r, f, i), g("text", r.id + "", f, void 0, a);
  }
}
function Qr(r, i) {
  if (r instanceof hr)
    return Q(r, i);
  if (r instanceof ur)
    return Ur(r, i);
  if (r instanceof pr)
    return Gr(r, i);
}
function Nr(r, i, t) {
  var a = r.style;
  if (sr(a)) {
    var n = vr(r), e = t.shadowCache, o = e[n];
    if (!o) {
      var s = r.getGlobalScale(), f = s[0], v = s[1];
      if (!f || !v)
        return;
      var y = a.shadowOffsetX || 0, l = a.shadowOffsetY || 0, u = a.shadowBlur, h = Z(a.shadowColor), p = h.opacity, d = h.color, x = u / 2 / f, A = u / 2 / v, m = x + " " + A;
      o = t.zrId + "-s" + t.shadowIdx++, t.defs[o] = g("filter", o, {
        id: o,
        x: "-100%",
        y: "-100%",
        width: "300%",
        height: "300%"
      }, [
        g("feDropShadow", "", {
          dx: y / f,
          dy: l / v,
          stdDeviation: m,
          "flood-color": d,
          "flood-opacity": p
        })
      ]), e[n] = o;
    }
    i.filter = D(o);
  }
}
function Fr(r, i, t, a) {
  var n = r[t], e, o = {
    gradientUnits: n.global ? "userSpaceOnUse" : "objectBoundingBox"
  };
  if ($(n))
    e = "linearGradient", o.x1 = n.x, o.y1 = n.y, o.x2 = n.x2, o.y2 = n.y2;
  else if (H(n))
    e = "radialGradient", o.cx = G(n.x, 0.5), o.cy = G(n.y, 0.5), o.r = G(n.r, 0.5);
  else
    return;
  for (var s = n.colorStops, f = [], v = 0, y = s.length; v < y; ++v) {
    var l = W(s[v].offset) * 100 + "%", u = s[v].color, h = Z(u), p = h.color, d = h.opacity, x = {
      offset: l
    };
    x["stop-color"] = p, d < 1 && (x["stop-opacity"] = d), f.push(g("stop", v + "", x));
  }
  var A = g(e, "", o, f), m = B(A), S = a.gradientCache, c = S[m];
  c || (c = a.zrId + "-g" + a.gradientIdx++, S[m] = c, o.id = c, a.defs[c] = g(e, c, o, f)), i[t] = D(c);
}
function Or(r, i, t, a) {
  var n = r.style[t], e = r.getBoundingRect(), o = {}, s = n.repeat, f = s === "no-repeat", v = s === "repeat-x", y = s === "repeat-y", l;
  if (rr(n)) {
    var u = n.imageWidth, h = n.imageHeight, p = void 0, d = n.image;
    if (N(d) ? p = d : q(d) ? p = d.src : J(d) && (p = d.toDataURL()), typeof Image > "u") {
      var x = "Image width/height must been given explictly in svg-ssr renderer.";
      E(u, x), E(h, x);
    } else if (u == null || h == null) {
      var A = function(P, _) {
        if (P) {
          var U = P.elm, C = u || _.width, R = h || _.height;
          P.tag === "pattern" && (v ? (R = 1, C /= e.width) : y && (C = 1, R /= e.height)), P.attrs.width = C, P.attrs.height = R, U && (U.setAttribute("width", C), U.setAttribute("height", R));
        }
      }, m = Sr(p, null, r, function(P) {
        f || A(L, P), A(l, P);
      });
      m && m.width && m.height && (u = u || m.width, h = h || m.height);
    }
    l = g("image", "img", {
      href: p,
      width: u,
      height: h
    }), o.width = u, o.height = h;
  } else
    n.svgElement && (l = yr(n.svgElement), o.width = n.svgWidth, o.height = n.svgHeight);
  if (l) {
    var S, c;
    f ? S = c = 1 : v ? (c = 1, S = o.width / e.width) : y ? (S = 1, c = o.height / e.height) : o.patternUnits = "userSpaceOnUse", S != null && !isNaN(S) && (o.width = S), c != null && !isNaN(c) && (o.height = c);
    var I = tr(n);
    I && (o.patternTransform = I);
    var L = g("pattern", "", o, [l]), M = B(L), k = a.patternCache, w = k[M];
    w || (w = a.zrId + "-p" + a.patternIdx++, k[M] = w, o.id = w, L = a.defs[w] = g("pattern", w, o, [l])), i[t] = D(w);
  }
}
function $r(r, i, t) {
  var a = t.clipPathCache, n = t.defs, e = a[r.id];
  if (!e) {
    e = t.zrId + "-c" + t.clipPathIdx++;
    var o = {
      id: e
    };
    a[r.id] = e, n[e] = g("clipPath", e, o, [Q(r, t)]);
  }
  i["clip-path"] = D(e);
}
export {
  Qr as brush,
  Ur as brushSVGImage,
  Q as brushSVGPath,
  Gr as brushSVGTSpan,
  $r as setClipPath,
  Fr as setGradient,
  Or as setPattern
};
