import { cubicSubdivide as P } from "../core/curve.js";
import z from "../graphic/Path.js";
import { defaults as $, map as O } from "../core/util.js";
import { lerp as vr } from "../core/vector.js";
import { clonePath as nr } from "./path.js";
import ar from "../core/Transformable.js";
import { split as er } from "./dividePath.js";
import { pathToBezierCurves as j } from "./convertPath.js";
function fr(v, r) {
  var a = v.length, n = r.length;
  if (a === n)
    return [v, r];
  for (var l = [], i = [], o = a < n ? v : r, e = Math.min(a, n), t = Math.abs(n - a) / 6, f = (e - 2) / 6, u = Math.ceil(t / f) + 1, d = [o[0], o[1]], c = t, h = 2; h < e; ) {
    var p = o[h - 2], T = o[h - 1], Z = o[h++], _ = o[h++], D = o[h++], M = o[h++], C = o[h++], s = o[h++];
    if (c <= 0) {
      d.push(Z, _, D, M, C, s);
      continue;
    }
    for (var g = Math.min(c, u - 1) + 1, R = 1; R <= g; R++) {
      var y = R / g;
      P(p, Z, D, C, y, l), P(T, _, M, s, y, i), p = l[3], T = i[3], d.push(l[1], i[1], l[2], i[2], p, T), Z = l[5], _ = i[5], D = l[6], M = i[6];
    }
    c -= g - 1;
  }
  return o === v ? [d, r] : [v, d];
}
function w(v, r) {
  for (var a = v.length, n = v[a - 2], l = v[a - 1], i = [], o = 0; o < r.length; )
    i[o++] = n, i[o++] = l;
  return i;
}
function lr(v, r) {
  for (var a, n, l, i = [], o = [], e = 0; e < Math.max(v.length, r.length); e++) {
    var t = v[e], f = r[e], u = void 0, d = void 0;
    t ? f ? (a = fr(t, f), u = a[0], d = a[1], n = u, l = d) : (d = w(l || t, t), u = t) : (u = w(n || f, f), d = f), i.push(u), o.push(d);
  }
  return [i, o];
}
function k(v) {
  for (var r = 0, a = 0, n = 0, l = v.length, i = 0, o = l - 2; i < l; o = i, i += 2) {
    var e = v[o], t = v[o + 1], f = v[i], u = v[i + 1], d = e * u - f * t;
    r += d, a += (e + f) * d, n += (t + u) * d;
  }
  return r === 0 ? [v[0] || 0, v[1] || 0] : [a / r / 3, n / r / 3, r];
}
function or(v, r, a, n) {
  for (var l = (v.length - 2) / 6, i = 1 / 0, o = 0, e = v.length, t = e - 2, f = 0; f < l; f++) {
    for (var u = f * 6, d = 0, c = 0; c < e; c += 2) {
      var h = c === 0 ? u : (u + c - 2) % t + 2, p = v[h] - a[0], T = v[h + 1] - a[1], Z = r[c] - n[0], _ = r[c + 1] - n[1], D = Z - p, M = _ - T;
      d += D * D + M * M;
    }
    d < i && (i = d, o = f);
  }
  return o;
}
function dr(v) {
  for (var r = [], a = v.length, n = 0; n < a; n += 2)
    r[n] = v[a - n - 2], r[n + 1] = v[a - n - 1];
  return r;
}
function ir(v, r, a, n) {
  for (var l = [], i, o = 0; o < v.length; o++) {
    var e = v[o], t = r[o], f = k(e), u = k(t);
    i == null && (i = f[2] < 0 != u[2] < 0);
    var d = [], c = [], h = 0, p = 1 / 0, T = [], Z = e.length;
    i && (e = dr(e));
    for (var _ = or(e, t, f, u) * 6, D = Z - 2, M = 0; M < D; M += 2) {
      var C = (_ + M) % D + 2;
      d[M + 2] = e[C] - f[0], d[M + 3] = e[C + 1] - f[1];
    }
    if (d[0] = e[_] - f[0], d[1] = e[_ + 1] - f[1], a > 0)
      for (var s = n / a, g = -n / 2; g <= n / 2; g += s) {
        for (var R = Math.sin(g), y = Math.cos(g), I = 0, M = 0; M < e.length; M += 2) {
          var N = d[M], X = d[M + 1], U = t[M] - u[0], H = t[M + 1] - u[1], G = U * y - H * R, J = U * R + H * y;
          T[M] = G, T[M + 1] = J;
          var q = G - N, F = J - X;
          I += q * q + F * F;
        }
        if (I < p) {
          p = I, h = g;
          for (var V = 0; V < T.length; V++)
            c[V] = T[V];
        }
      }
    else
      for (var E = 0; E < Z; E += 2)
        c[E] = t[E] - u[0], c[E + 1] = t[E + 1] - u[1];
    l.push({
      from: d,
      to: c,
      fromCp: f,
      toCp: u,
      rotation: -h
    });
  }
  return l;
}
function Y(v) {
  return v.__isCombineMorphing;
}
var S = "__mOriginal_";
function m(v, r, a) {
  var n = S + r, l = v[n] || v[r];
  v[n] || (v[n] = v[r]);
  var i = a.replace, o = a.after, e = a.before;
  v[r] = function() {
    var t = arguments, f;
    return e && e.apply(this, t), i ? f = i.apply(this, t) : f = l.apply(this, t), o && o.apply(this, t), f;
  };
}
function K(v, r) {
  var a = S + r;
  v[a] && (v[r] = v[a], v[a] = null);
}
function x(v, r) {
  for (var a = 0; a < v.length; a++)
    for (var n = v[a], l = 0; l < n.length; ) {
      var i = n[l], o = n[l + 1];
      n[l++] = r[0] * i + r[2] * o + r[4], n[l++] = r[1] * i + r[3] * o + r[5];
    }
}
function B(v, r) {
  var a = v.getUpdatedPathProxy(), n = r.getUpdatedPathProxy(), l = lr(j(a), j(n)), i = l[0], o = l[1], e = v.getComputedTransform(), t = r.getComputedTransform();
  function f() {
    this.transform = null;
  }
  e && x(i, e), t && x(o, t), m(r, "updateTransform", { replace: f }), r.transform = null;
  var u = ir(i, o, 10, Math.PI), d = [];
  m(r, "buildPath", { replace: function(c) {
    for (var h = r.__morphT, p = 1 - h, T = [], Z = 0; Z < u.length; Z++) {
      var _ = u[Z], D = _.from, M = _.to, C = _.rotation * h, s = _.fromCp, g = _.toCp, R = Math.sin(C), y = Math.cos(C);
      vr(T, s, g, h);
      for (var I = 0; I < D.length; I += 2) {
        var N = D[I], X = D[I + 1], U = M[I], H = M[I + 1], G = N * p + U * h, J = X * p + H * h;
        d[I] = G * y - J * R + T[0], d[I + 1] = G * R + J * y + T[1];
      }
      var q = d[0], F = d[1];
      c.moveTo(q, F);
      for (var I = 2; I < D.length; ) {
        var U = d[I++], H = d[I++], V = d[I++], E = d[I++], Q = d[I++], W = d[I++];
        q === U && F === H && V === Q && E === W ? c.lineTo(Q, W) : c.bezierCurveTo(U, H, V, E, Q, W), q = Q, F = W;
      }
    }
  } });
}
function b(v, r, a) {
  if (!v || !r)
    return r;
  var n = a.done, l = a.during;
  B(v, r), r.__morphT = 0;
  function i() {
    K(r, "buildPath"), K(r, "updateTransform"), r.__morphT = -1, r.createPathProxy(), r.dirtyShape();
  }
  return r.animateTo({
    __morphT: 1
  }, $({
    during: function(o) {
      r.dirtyShape(), l && l(o);
    },
    done: function() {
      i(), n && n();
    }
  }, a)), r;
}
function tr(v, r, a, n, l, i) {
  var o = 16;
  v = l === a ? 0 : Math.round(32767 * (v - a) / (l - a)), r = i === n ? 0 : Math.round(32767 * (r - n) / (i - n));
  for (var e = 0, t, f = (1 << o) / 2; f > 0; f /= 2) {
    var u = 0, d = 0;
    (v & f) > 0 && (u = 1), (r & f) > 0 && (d = 1), e += f * f * (3 * u ^ d), d === 0 && (u === 1 && (v = f - 1 - v, r = f - 1 - r), t = v, v = r, r = t);
  }
  return e;
}
function A(v) {
  var r = 1 / 0, a = 1 / 0, n = -1 / 0, l = -1 / 0, i = O(v, function(e) {
    var t = e.getBoundingRect(), f = e.getComputedTransform(), u = t.x + t.width / 2 + (f ? f[4] : 0), d = t.y + t.height / 2 + (f ? f[5] : 0);
    return r = Math.min(u, r), a = Math.min(d, a), n = Math.max(u, n), l = Math.max(d, l), [u, d];
  }), o = O(i, function(e, t) {
    return {
      cp: e,
      z: tr(e[0], e[1], r, a, n, l),
      path: v[t]
    };
  });
  return o.sort(function(e, t) {
    return e.z - t.z;
  }).map(function(e) {
    return e.path;
  });
}
function rr(v) {
  return er(v.path, v.count);
}
function L() {
  return {
    fromIndividuals: [],
    toIndividuals: [],
    count: 0
  };
}
function Ir(v, r, a) {
  var n = [];
  function l(s) {
    for (var g = 0; g < s.length; g++) {
      var R = s[g];
      Y(R) ? l(R.childrenRef()) : R instanceof z && n.push(R);
    }
  }
  l(v);
  var i = n.length;
  if (!i)
    return L();
  var o = a.dividePath || rr, e = o({
    path: r,
    count: i
  });
  if (e.length !== i)
    return console.error("Invalid morphing: unmatched splitted path"), L();
  n = A(n), e = A(e);
  for (var t = a.done, f = a.during, u = a.individualDelay, d = new ar(), c = 0; c < i; c++) {
    var h = n[c], p = e[c];
    p.parent = r, p.copyTransform(d), u || B(h, p);
  }
  r.__isCombineMorphing = !0, r.childrenRef = function() {
    return e;
  };
  function T(s) {
    for (var g = 0; g < e.length; g++)
      e[g].addSelfToZr(s);
  }
  m(r, "addSelfToZr", {
    after: function(s) {
      T(s);
    }
  }), m(r, "removeSelfFromZr", {
    after: function(s) {
      for (var g = 0; g < e.length; g++)
        e[g].removeSelfFromZr(s);
    }
  });
  function Z() {
    r.__isCombineMorphing = !1, r.__morphT = -1, r.childrenRef = null, K(r, "addSelfToZr"), K(r, "removeSelfFromZr");
  }
  var _ = e.length;
  if (u)
    for (var D = _, M = function() {
      D--, D === 0 && (Z(), t && t());
    }, c = 0; c < _; c++) {
      var C = u ? $({
        delay: (a.delay || 0) + u(c, _, n[c], e[c]),
        done: M
      }, a) : a;
      b(n[c], e[c], C);
    }
  else
    r.__morphT = 0, r.animateTo({
      __morphT: 1
    }, $({
      during: function(s) {
        for (var g = 0; g < _; g++) {
          var R = e[g];
          R.__morphT = r.__morphT, R.dirtyShape();
        }
        f && f(s);
      },
      done: function() {
        Z();
        for (var s = 0; s < v.length; s++)
          K(v[s], "updateTransform");
        t && t();
      }
    }, a));
  return r.__zr && T(r.__zr), {
    fromIndividuals: n,
    toIndividuals: e,
    count: _
  };
}
function pr(v, r, a) {
  var n = r.length, l = [], i = a.dividePath || rr;
  function o(h) {
    for (var p = 0; p < h.length; p++) {
      var T = h[p];
      Y(T) ? o(T.childrenRef()) : T instanceof z && l.push(T);
    }
  }
  if (Y(v)) {
    o(v.childrenRef());
    var e = l.length;
    if (e < n)
      for (var t = 0, f = e; f < n; f++)
        l.push(nr(l[t++ % e]));
    l.length = n;
  } else {
    l = i({ path: v, count: n });
    for (var u = v.getComputedTransform(), f = 0; f < l.length; f++)
      l[f].setLocalTransform(u);
    if (l.length !== n)
      return console.error("Invalid morphing: unmatched splitted path"), L();
  }
  l = A(l), r = A(r);
  for (var d = a.individualDelay, f = 0; f < n; f++) {
    var c = d ? $({
      delay: (a.delay || 0) + d(f, n, l[f], r[f])
    }, a) : a;
    b(l[f], r[f], c);
  }
  return {
    fromIndividuals: l,
    toIndividuals: r,
    count: r.length
  };
}
export {
  lr as alignBezierCurves,
  k as centroid,
  Ir as combineMorph,
  er as defaultDividePath,
  Y as isCombineMorphing,
  b as morphPath,
  pr as separateMorph
};
