import b from "../graphic/Group.js";
import G from "../graphic/Image.js";
import W from "../graphic/shape/Circle.js";
import P from "../graphic/shape/Rect.js";
import V from "../graphic/shape/Ellipse.js";
import j from "../graphic/shape/Line.js";
import H from "../graphic/shape/Polygon.js";
import J from "../graphic/shape/Polyline.js";
import { mul as T, rotate as K, scale as q, translate as Z, create as z } from "../core/matrix.js";
import { createFromString as Q } from "./path.js";
import { keys as O, hasOwn as _, defaults as $, each as E, map as m, trim as B } from "../core/util.js";
import N from "../graphic/LinearGradient.js";
import tt from "../graphic/RadialGradient.js";
import et from "../graphic/TSpan.js";
import { parseXML as rt } from "./parseXML.js";
var w, d = {
  fill: "fill",
  stroke: "stroke",
  "stroke-width": "lineWidth",
  opacity: "opacity",
  "fill-opacity": "fillOpacity",
  "stroke-opacity": "strokeOpacity",
  "stroke-dasharray": "lineDash",
  "stroke-dashoffset": "lineDashOffset",
  "stroke-linecap": "lineCap",
  "stroke-linejoin": "lineJoin",
  "stroke-miterlimit": "miterLimit",
  "font-family": "fontFamily",
  "font-size": "fontSize",
  "font-style": "fontStyle",
  "font-weight": "fontWeight",
  "text-anchor": "textAlign",
  visibility: "visibility",
  display: "display"
}, U = O(d), F = {
  "alignment-baseline": "textBaseline",
  "stop-color": "stopColor"
}, L = O(F), it = function() {
  function s() {
    this._defs = {}, this._root = null;
  }
  return s.prototype.parse = function(e, i) {
    i = i || {};
    var t = rt(e);
    this._defsUsePending = [];
    var r = new b();
    this._root = r;
    var a = [], f = t.getAttribute("viewBox") || "", l = parseFloat(t.getAttribute("width") || i.width), n = parseFloat(t.getAttribute("height") || i.height);
    isNaN(l) && (l = null), isNaN(n) && (n = null), o(t, r, null, !0, !1);
    for (var g = t.firstChild; g; )
      this._parseNode(g, r, a, null, !1, !1), g = g.nextSibling;
    nt(this._defs, this._defsUsePending), this._defsUsePending = [];
    var y, v;
    if (f) {
      var p = S(f);
      p.length >= 4 && (y = {
        x: parseFloat(p[0] || 0),
        y: parseFloat(p[1] || 0),
        width: parseFloat(p[2]),
        height: parseFloat(p[3])
      });
    }
    if (y && l != null && n != null && (v = pt(y, { x: 0, y: 0, width: l, height: n }), !i.ignoreViewBox)) {
      var h = r;
      r = new b(), r.add(h), h.scaleX = h.scaleY = v.scale, h.x = v.x, h.y = v.y;
    }
    return !i.ignoreRootClip && l != null && n != null && r.setClipPath(new P({
      shape: { x: 0, y: 0, width: l, height: n }
    })), {
      root: r,
      width: l,
      height: n,
      viewBoxRect: y,
      viewBoxTransform: v,
      named: a
    };
  }, s.prototype._parseNode = function(e, i, t, r, a, f) {
    var l = e.nodeName.toLowerCase(), n, g = r;
    if (l === "defs" && (a = !0), l === "text" && (f = !0), l === "defs" || l === "switch")
      n = i;
    else {
      if (!a) {
        var y = w[l];
        if (y && _(w, l)) {
          n = y.call(this, e, i);
          var v = e.getAttribute("name");
          if (v) {
            var p = {
              name: v,
              namedFrom: null,
              svgNodeTagLower: l,
              el: n
            };
            t.push(p), l === "g" && (g = p);
          } else
            r && t.push({
              name: r.name,
              namedFrom: r,
              svgNodeTagLower: l,
              el: n
            });
          i.add(n);
        }
      }
      var h = I[l];
      if (h && _(I, l)) {
        var R = h.call(this, e), k = e.getAttribute("id");
        k && (this._defs[k] = R);
      }
    }
    if (n && n.isGroup)
      for (var c = e.firstChild; c; )
        c.nodeType === 1 ? this._parseNode(c, n, t, g, a, f) : c.nodeType === 3 && f && this._parseText(c, n), c = c.nextSibling;
  }, s.prototype._parseText = function(e, i) {
    var t = new et({
      style: {
        text: e.textContent
      },
      silent: !0,
      x: this._textX || 0,
      y: this._textY || 0
    });
    u(i, t), o(e, t, this._defsUsePending, !1, !1), at(t, i);
    var r = t.style, a = r.fontSize;
    a && a < 9 && (r.fontSize = 9, t.scaleX *= a / 9, t.scaleY *= a / 9);
    var f = (r.fontSize || r.fontFamily) && [
      r.fontStyle,
      r.fontWeight,
      (r.fontSize || 12) + "px",
      r.fontFamily || "sans-serif"
    ].join(" ");
    r.font = f;
    var l = t.getBoundingRect();
    return this._textX += l.width, i.add(t), t;
  }, s.internalField = function() {
    w = {
      g: function(e, i) {
        var t = new b();
        return u(i, t), o(e, t, this._defsUsePending, !1, !1), t;
      },
      rect: function(e, i) {
        var t = new P();
        return u(i, t), o(e, t, this._defsUsePending, !1, !1), t.setShape({
          x: parseFloat(e.getAttribute("x") || "0"),
          y: parseFloat(e.getAttribute("y") || "0"),
          width: parseFloat(e.getAttribute("width") || "0"),
          height: parseFloat(e.getAttribute("height") || "0")
        }), t.silent = !0, t;
      },
      circle: function(e, i) {
        var t = new W();
        return u(i, t), o(e, t, this._defsUsePending, !1, !1), t.setShape({
          cx: parseFloat(e.getAttribute("cx") || "0"),
          cy: parseFloat(e.getAttribute("cy") || "0"),
          r: parseFloat(e.getAttribute("r") || "0")
        }), t.silent = !0, t;
      },
      line: function(e, i) {
        var t = new j();
        return u(i, t), o(e, t, this._defsUsePending, !1, !1), t.setShape({
          x1: parseFloat(e.getAttribute("x1") || "0"),
          y1: parseFloat(e.getAttribute("y1") || "0"),
          x2: parseFloat(e.getAttribute("x2") || "0"),
          y2: parseFloat(e.getAttribute("y2") || "0")
        }), t.silent = !0, t;
      },
      ellipse: function(e, i) {
        var t = new V();
        return u(i, t), o(e, t, this._defsUsePending, !1, !1), t.setShape({
          cx: parseFloat(e.getAttribute("cx") || "0"),
          cy: parseFloat(e.getAttribute("cy") || "0"),
          rx: parseFloat(e.getAttribute("rx") || "0"),
          ry: parseFloat(e.getAttribute("ry") || "0")
        }), t.silent = !0, t;
      },
      polygon: function(e, i) {
        var t = e.getAttribute("points"), r;
        t && (r = X(t));
        var a = new H({
          shape: {
            points: r || []
          },
          silent: !0
        });
        return u(i, a), o(e, a, this._defsUsePending, !1, !1), a;
      },
      polyline: function(e, i) {
        var t = e.getAttribute("points"), r;
        t && (r = X(t));
        var a = new J({
          shape: {
            points: r || []
          },
          silent: !0
        });
        return u(i, a), o(e, a, this._defsUsePending, !1, !1), a;
      },
      image: function(e, i) {
        var t = new G();
        return u(i, t), o(e, t, this._defsUsePending, !1, !1), t.setStyle({
          image: e.getAttribute("xlink:href") || e.getAttribute("href"),
          x: +e.getAttribute("x"),
          y: +e.getAttribute("y"),
          width: +e.getAttribute("width"),
          height: +e.getAttribute("height")
        }), t.silent = !0, t;
      },
      text: function(e, i) {
        var t = e.getAttribute("x") || "0", r = e.getAttribute("y") || "0", a = e.getAttribute("dx") || "0", f = e.getAttribute("dy") || "0";
        this._textX = parseFloat(t) + parseFloat(a), this._textY = parseFloat(r) + parseFloat(f);
        var l = new b();
        return u(i, l), o(e, l, this._defsUsePending, !1, !0), l;
      },
      tspan: function(e, i) {
        var t = e.getAttribute("x"), r = e.getAttribute("y");
        t != null && (this._textX = parseFloat(t)), r != null && (this._textY = parseFloat(r));
        var a = e.getAttribute("dx") || "0", f = e.getAttribute("dy") || "0", l = new b();
        return u(i, l), o(e, l, this._defsUsePending, !1, !0), this._textX += parseFloat(a), this._textY += parseFloat(f), l;
      },
      path: function(e, i) {
        var t = e.getAttribute("d") || "", r = Q(t);
        return u(i, r), o(e, r, this._defsUsePending, !1, !1), r.silent = !0, r;
      }
    };
  }(), s;
}(), I = {
  lineargradient: function(s) {
    var e = parseInt(s.getAttribute("x1") || "0", 10), i = parseInt(s.getAttribute("y1") || "0", 10), t = parseInt(s.getAttribute("x2") || "10", 10), r = parseInt(s.getAttribute("y2") || "0", 10), a = new N(e, i, t, r);
    return Y(s, a), C(s, a), a;
  },
  radialgradient: function(s) {
    var e = parseInt(s.getAttribute("cx") || "0", 10), i = parseInt(s.getAttribute("cy") || "0", 10), t = parseInt(s.getAttribute("r") || "0", 10), r = new tt(e, i, t);
    return Y(s, r), C(s, r), r;
  }
};
function Y(s, e) {
  var i = s.getAttribute("gradientUnits");
  i === "userSpaceOnUse" && (e.global = !0);
}
function C(s, e) {
  for (var i = s.firstChild; i; ) {
    if (i.nodeType === 1 && i.nodeName.toLocaleLowerCase() === "stop") {
      var t = i.getAttribute("offset"), r = void 0;
      t && t.indexOf("%") > 0 ? r = parseInt(t, 10) / 100 : t ? r = parseFloat(t) : r = 0;
      var a = {};
      D(i, a, a);
      var f = a.stopColor || i.getAttribute("stop-color") || "#000000";
      e.colorStops.push({
        offset: r,
        color: f
      });
    }
    i = i.nextSibling;
  }
}
function u(s, e) {
  s && s.__inheritedStyle && (e.__inheritedStyle || (e.__inheritedStyle = {}), $(e.__inheritedStyle, s.__inheritedStyle));
}
function X(s) {
  for (var e = S(s), i = [], t = 0; t < e.length; t += 2) {
    var r = parseFloat(e[t]), a = parseFloat(e[t + 1]);
    i.push([r, a]);
  }
  return i;
}
function o(s, e, i, t, r) {
  var a = e, f = a.__inheritedStyle = a.__inheritedStyle || {}, l = {};
  s.nodeType === 1 && (ot(s, e), D(s, f, l), t || ut(s, f, l)), a.style = a.style || {}, f.fill != null && (a.style.fill = M(a, "fill", f.fill, i)), f.stroke != null && (a.style.stroke = M(a, "stroke", f.stroke, i)), E([
    "lineWidth",
    "opacity",
    "fillOpacity",
    "strokeOpacity",
    "miterLimit",
    "fontSize"
  ], function(n) {
    f[n] != null && (a.style[n] = parseFloat(f[n]));
  }), E([
    "lineDashOffset",
    "lineCap",
    "lineJoin",
    "fontWeight",
    "fontFamily",
    "fontStyle",
    "textAlign"
  ], function(n) {
    f[n] != null && (a.style[n] = f[n]);
  }), r && (a.__selfStyle = l), f.lineDash && (a.style.lineDash = m(S(f.lineDash), function(n) {
    return parseFloat(n);
  })), (f.visibility === "hidden" || f.visibility === "collapse") && (a.invisible = !0), f.display === "none" && (a.ignore = !0);
}
function at(s, e) {
  var i = e.__selfStyle;
  if (i) {
    var t = i.textBaseline, r = t;
    !t || t === "auto" || t === "baseline" ? r = "alphabetic" : t === "before-edge" || t === "text-before-edge" ? r = "top" : t === "after-edge" || t === "text-after-edge" ? r = "bottom" : (t === "central" || t === "mathematical") && (r = "middle"), s.style.textBaseline = r;
  }
  var a = e.__inheritedStyle;
  if (a) {
    var f = a.textAlign, l = f;
    f && (f === "middle" && (l = "center"), s.style.textAlign = l);
  }
}
var st = /^url\(\s*#(.*?)\)/;
function M(s, e, i, t) {
  var r = i && i.match(st);
  if (r) {
    var a = B(r[1]);
    t.push([s, e, a]);
    return;
  }
  return i === "none" && (i = null), i;
}
function nt(s, e) {
  for (var i = 0; i < e.length; i++) {
    var t = e[i];
    t[0].style[t[1]] = s[t[2]];
  }
}
var lt = /-?([0-9]*\.)?[0-9]+([eE]-?[0-9]+)?/g;
function S(s) {
  return s.match(lt) || [];
}
var ft = /(translate|scale|rotate|skewX|skewY|matrix)\(([\-\s0-9\.eE,]*)\)/g, A = Math.PI / 180;
function ot(s, e) {
  var i = s.getAttribute("transform");
  if (i) {
    i = i.replace(/,/g, " ");
    var t = [], r = null;
    i.replace(ft, function(v, p, h) {
      return t.push(p, h), "";
    });
    for (var a = t.length - 1; a > 0; a -= 2) {
      var f = t[a], l = t[a - 1], n = S(f);
      switch (r = r || z(), l) {
        case "translate":
          Z(r, r, [parseFloat(n[0]), parseFloat(n[1] || "0")]);
          break;
        case "scale":
          q(r, r, [parseFloat(n[0]), parseFloat(n[1] || n[0])]);
          break;
        case "rotate":
          K(r, r, -parseFloat(n[0]) * A, [
            parseFloat(n[1] || "0"),
            parseFloat(n[2] || "0")
          ]);
          break;
        case "skewX":
          var g = Math.tan(parseFloat(n[0]) * A);
          T(r, [1, 0, g, 1, 0, 0], r);
          break;
        case "skewY":
          var y = Math.tan(parseFloat(n[0]) * A);
          T(r, [1, y, 0, 1, 0, 0], r);
          break;
        case "matrix":
          r[0] = parseFloat(n[0]), r[1] = parseFloat(n[1]), r[2] = parseFloat(n[2]), r[3] = parseFloat(n[3]), r[4] = parseFloat(n[4]), r[5] = parseFloat(n[5]);
          break;
      }
    }
    e.setLocalTransform(r);
  }
}
var x = /([^\s:;]+)\s*:\s*([^:;]+)/g;
function D(s, e, i) {
  var t = s.getAttribute("style");
  if (t) {
    x.lastIndex = 0;
    for (var r; (r = x.exec(t)) != null; ) {
      var a = r[1], f = _(d, a) ? d[a] : null;
      f && (e[f] = r[2]);
      var l = _(F, a) ? F[a] : null;
      l && (i[l] = r[2]);
    }
  }
}
function ut(s, e, i) {
  for (var t = 0; t < U.length; t++) {
    var r = U[t], a = s.getAttribute(r);
    a != null && (e[d[r]] = a);
  }
  for (var t = 0; t < L.length; t++) {
    var r = L[t], a = s.getAttribute(r);
    a != null && (i[F[r]] = a);
  }
}
function pt(s, e) {
  var i = e.width / s.width, t = e.height / s.height, r = Math.min(i, t);
  return {
    scale: r,
    x: -(s.x + s.width / 2) * r + (e.x + e.width / 2),
    y: -(s.y + s.height / 2) * r + (e.y + e.height / 2)
  };
}
function Et(s, e) {
  var i = new it();
  return i.parse(s, e);
}
export {
  pt as makeViewBoxTransform,
  Et as parseSVG,
  rt as parseXML
};
