import { __extends as X } from "../../../tslib/tslib.es6.js";
import Z from "../graphic/Path.js";
import m from "../core/PathProxy.js";
import Y from "./transformPath.js";
import { extend as K } from "../core/util.js";
var G = Math.sqrt, R = Math.sin, V = Math.cos, F = Math.PI;
function B(s) {
  return Math.sqrt(s[0] * s[0] + s[1] * s[1]);
}
function I(s, t) {
  return (s[0] * t[0] + s[1] * t[1]) / (B(s) * B(t));
}
function H(s, t) {
  return (s[0] * t[1] < s[1] * t[0] ? -1 : 1) * Math.acos(I(s, t));
}
function U(s, t, a, n, h, d, u, v, D, A, O) {
  var g = D * (F / 180), i = V(g) * (s - a) / 2 + R(g) * (t - n) / 2, r = -1 * R(g) * (s - a) / 2 + V(g) * (t - n) / 2, Q = i * i / (u * u) + r * r / (v * v);
  Q > 1 && (u *= G(Q), v *= G(Q));
  var z = (h === d ? -1 : 1) * G((u * u * (v * v) - u * u * (r * r) - v * v * (i * i)) / (u * u * (r * r) + v * v * (i * i))) || 0, e = z * u * r / v, b = z * -v * i / u, k = (s + a) / 2 + V(g) * e - R(g) * b, q = (t + n) / 2 + R(g) * e + V(g) * b, w = H([1, 0], [(i - e) / u, (r - b) / v]), L = [(i - e) / u, (r - b) / v], S = [(-1 * i - e) / u, (-1 * r - b) / v], o = H(L, S);
  if (I(L, S) <= -1 && (o = F), I(L, S) >= 1 && (o = 0), o < 0) {
    var l = Math.round(o / F * 1e6) / 1e6;
    o = F * 2 + l % 2 * F;
  }
  O.addData(A, k, q, u, v, w, o, g, d);
}
var N = /([mlvhzcqtsa])([^mlvhzcqtsa]*)/ig, W = /-?([0-9]*\.)?[0-9]+([eE]-?[0-9]+)?/g;
function _(s) {
  var t = new m();
  if (!s)
    return t;
  var a = 0, n = 0, h = a, d = n, u, v = m.CMD, D = s.match(N);
  if (!D)
    return t;
  for (var A = 0; A < D.length; A++) {
    for (var O = D[A], g = O.charAt(0), i = void 0, r = O.match(W) || [], Q = r.length, z = 0; z < Q; z++)
      r[z] = parseFloat(r[z]);
    for (var e = 0; e < Q; ) {
      var b = void 0, k = void 0, q = void 0, w = void 0, L = void 0, S = void 0, o = void 0, l = a, C = n, M = void 0, T = void 0;
      switch (g) {
        case "l":
          a += r[e++], n += r[e++], i = v.L, t.addData(i, a, n);
          break;
        case "L":
          a = r[e++], n = r[e++], i = v.L, t.addData(i, a, n);
          break;
        case "m":
          a += r[e++], n += r[e++], i = v.M, t.addData(i, a, n), h = a, d = n, g = "l";
          break;
        case "M":
          a = r[e++], n = r[e++], i = v.M, t.addData(i, a, n), h = a, d = n, g = "L";
          break;
        case "h":
          a += r[e++], i = v.L, t.addData(i, a, n);
          break;
        case "H":
          a = r[e++], i = v.L, t.addData(i, a, n);
          break;
        case "v":
          n += r[e++], i = v.L, t.addData(i, a, n);
          break;
        case "V":
          n = r[e++], i = v.L, t.addData(i, a, n);
          break;
        case "C":
          i = v.C, t.addData(i, r[e++], r[e++], r[e++], r[e++], r[e++], r[e++]), a = r[e - 2], n = r[e - 1];
          break;
        case "c":
          i = v.C, t.addData(i, r[e++] + a, r[e++] + n, r[e++] + a, r[e++] + n, r[e++] + a, r[e++] + n), a += r[e - 2], n += r[e - 1];
          break;
        case "S":
          b = a, k = n, M = t.len(), T = t.data, u === v.C && (b += a - T[M - 4], k += n - T[M - 3]), i = v.C, l = r[e++], C = r[e++], a = r[e++], n = r[e++], t.addData(i, b, k, l, C, a, n);
          break;
        case "s":
          b = a, k = n, M = t.len(), T = t.data, u === v.C && (b += a - T[M - 4], k += n - T[M - 3]), i = v.C, l = a + r[e++], C = n + r[e++], a += r[e++], n += r[e++], t.addData(i, b, k, l, C, a, n);
          break;
        case "Q":
          l = r[e++], C = r[e++], a = r[e++], n = r[e++], i = v.Q, t.addData(i, l, C, a, n);
          break;
        case "q":
          l = r[e++] + a, C = r[e++] + n, a += r[e++], n += r[e++], i = v.Q, t.addData(i, l, C, a, n);
          break;
        case "T":
          b = a, k = n, M = t.len(), T = t.data, u === v.Q && (b += a - T[M - 4], k += n - T[M - 3]), a = r[e++], n = r[e++], i = v.Q, t.addData(i, b, k, a, n);
          break;
        case "t":
          b = a, k = n, M = t.len(), T = t.data, u === v.Q && (b += a - T[M - 4], k += n - T[M - 3]), a += r[e++], n += r[e++], i = v.Q, t.addData(i, b, k, a, n);
          break;
        case "A":
          q = r[e++], w = r[e++], L = r[e++], S = r[e++], o = r[e++], l = a, C = n, a = r[e++], n = r[e++], i = v.A, U(l, C, a, n, S, o, q, w, L, i, t);
          break;
        case "a":
          q = r[e++], w = r[e++], L = r[e++], S = r[e++], o = r[e++], l = a, C = n, a += r[e++], n += r[e++], i = v.A, U(l, C, a, n, S, o, q, w, L, i, t);
          break;
      }
    }
    (g === "z" || g === "Z") && (i = v.Z, t.addData(i), a = h, n = d), u = i;
  }
  return t.toStatic(), t;
}
var j = function(s) {
  X(t, s);
  function t() {
    return s !== null && s.apply(this, arguments) || this;
  }
  return t.prototype.applyTransform = function(a) {
  }, t;
}(Z);
function E(s) {
  return s.setData != null;
}
function J(s, t) {
  var a = _(s), n = K({}, t);
  return n.buildPath = function(h) {
    if (E(h)) {
      h.setData(a.data);
      var d = h.getContext();
      d && h.rebuildPath(d, 1);
    } else {
      var d = h;
      a.rebuildPath(d, 1);
    }
  }, n.applyTransform = function(h) {
    Y(a, h), this.dirtyShape();
  }, n;
}
function p(s, t) {
  return new j(J(s, t));
}
function f(s, t) {
  var a = J(s, t), n = function(h) {
    X(d, h);
    function d(u) {
      var v = h.call(this, u) || this;
      return v.applyTransform = a.applyTransform, v.buildPath = a.buildPath, v;
    }
    return d;
  }(j);
  return n;
}
function aa(s, t) {
  for (var a = [], n = s.length, h = 0; h < n; h++) {
    var d = s[h];
    a.push(d.getUpdatedPathProxy(!0));
  }
  var u = new Z(t);
  return u.createPathProxy(), u.buildPath = function(v) {
    if (E(v)) {
      v.appendPath(a);
      var D = v.getContext();
      D && v.rebuildPath(D, 1);
    }
  }, u;
}
function ra(s, t) {
  t = t || {};
  var a = new Z();
  return s.shape && a.setShape(s.shape), a.setStyle(s.style), t.bakeTransform ? Y(a.path, s.getComputedTransform()) : t.toLocal ? a.setLocalTransform(s.getComputedTransform()) : a.copyTransform(s), a.buildPath = s.buildPath, a.applyTransform = a.applyTransform, a.z = s.z, a.z2 = s.z2, a.zlevel = s.zlevel, a;
}
export {
  ra as clonePath,
  p as createFromString,
  f as extendFromString,
  aa as mergePath
};
